<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB  TODO: move this stuff to standard to be used by all pages*/ ?>
	</head>
	<body style='background: url("<?php echo get_background_path(); ?>") no-repeat center center fixed;'> 
		<!-- table_tree -->
		<script src="js/table.js"></script>
		<script src="table_tree/js/table_tree.js"></script>
		<script src="js/sd.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_camps_div" class='mc_page_body mc_tt_cont ttc_fullscreen tc_single_table'> <!-- NOTE: without this cont appears another horiz scr bar -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
			<!-- camp locations and CAMP_SHOP_CAT -->
			<div id = 'mi_set_country_div' style='display: flex;'> 
				<div id = 'mi_set_country' class='mc_float_left'></div>
				<div id='mi_set_cat_cont' class='hidden'>
					<div id = 'mi_set_cat_div' style='width: 300px;'> </div>
					<div style='display: flex; justify-content: center;'> 
						<div class='mc_btn' style='display: inline-block; margin: 5px;' id='mi_set_cat' >Set</div>
						<div class='mc_btn' style='display: inline-block; margin: 5px;' id='mi_reset_cat'>Reset</div>
					</div>
				</div>
			</div>
		</div>
		<?php echo lang_html_load('html/sd.html' ); ?>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script type="text/javascript">

			
			var is_archive = <?php echo isset($_GET["arch"])?1:0; ?>; // DEF ARCH stuff to archive camps; 
			var alias_name="camps", table_name="camps";

			function in_edit(rec){return true; /*rec.data("camp_state")=="draft"; */} //   DEF EOC edit opened camp; fabr asked to enable edit opened camp; other opers are restricted in on_rec_sel()
			function on_rec_sel(rec){ 
				puh("record_selected");
				// BUL
				if(in_edit(rec)) 
					$(".bul_edit").removeClass("hidden"); 
				else
					$(".bul_edit").addClass("hidden"); 
				if( rec.data("camp_state")=="draft" ) $(".lbsp_open").removeClass("hidden"); else $(".lbsp_open").addClass("hidden"); // in EOC disable only 'open' btn if opened
				if( rec.data("camp_state")=="opened" ) $(".lbsp_close").removeClass("hidden"); else $(".lbsp_close").addClass("hidden"); 
				if( rec.data("camp_state")=="draft" ) $(".lbsp_del").removeClass("hidden"); else $(".lbsp_del").addClass("hidden");
				if(camps.get_active_rec().data("camp_state")=="closed") 
					puh("camp_complete");
			}
			function on_lbs_rec_sel(rec){ 
				var os = get_lbs_state(rec);
				//if(os=="draft") puh("lbs_draft");
				puh("lbs_" + os);
			}
			function set_state(action, sel_ords, sel_apps){
				call_php_sync("contr/main.php", {"action" : action, ids_ords: JSON.stringify(get_data_arr(sel_ords, "id")), ids: JSON.stringify(get_data_arr(sel_apps, "id")) }, 'POST'); 
				if(sel_ords && sel_ords.length) sel_ords.each( function(){ set_camp_rec_state( $(this) ); } );
				if( camps.get_active_rec().hasClass("selected") )
					sel_apps = $(".ap_detail_row").find(".tr-app_lbs"); // if the active rec is selected - need update all inner lbs ONEDET
				if( sel_apps && sel_apps.length )
					update_camp_state( camps.get_active_rec(), sel_apps ); // DEF ONEDET - stuff which works only when one opened detail is possible;
			}
			function get_selection(){ 
				var sel = {camps: camps.get_selection(), apps: apps? apps.get_selection() : $()};
				if(!sel.camps.length && !sel.apps.length)
					sel = {camps: camps.get_active_rec(), apps: apps? apps.get_active_rec() : $()}; // with SINGLE_ACTIVE only one of them is not empty
				return sel;
			}
			function open_camp(){
				var rec = get_curr_camp();
				if(!rec.length) { alert(lp("no_campaign_selected"));return; } // NI
				var id = rec.data("id");
				/* TODO 1 donno if check subjects/shops 
				var im_list = call_php_sync("contr/main.php", {"action" : "get_camp_subs", id: id}, 'POST');
				var sh_list = call_php_sync("contr/main.php", {"action" : "get_camp_shops",id: id}, 'POST'); // TODO not used?
				*/
				if(!rec.data("date_from")){ alert( "'"+lp("validity_date_from") + "' " + lp("not_set") ); return; }
				if(!rec.data("date_till")){ alert( "'"+lp("validity_date_till") + "' " + lp("not_set") ); return; }
				//if(!rec.data("dl_visual")){ alert( "'"+lp("visual_deadline") + "' " + lp("not_set") ); return; }
				//if(!rec.data("dl_produce")){ alert( "'"+lp("produce_deadline") + "' " + lp("not_set") ); return; }
				//if(!rec.data("dl_approve")){ alert( "'"+lp("approve_deadline") + "' " + lp("not_set") ); return; }
				/*
				if(im_list.resp_text.length<3) { alert(lp("no_images_added"));return; } // if no imgs - empty arr is returned "[]"
				if(!sh_list.resp_text) { alert(lp("no_stores_added")); return; }
				*/
				if( id && confirm(lpp("$open$ $campaign$ '$1'?", rec.data("name"))) ){ 
					wait_screen.add_operation("open_camp");
					$.ajax({
						method : 'POST',
						url : 'contr/main.php',
						data: {"action" : "open_camp", id: id}, 
						success: function(res){ 
							alert("Ok");
							camps.refresh(id);
						},
						complete: function(xhr, stat){	wait_screen.remove_operation("open_camp");	},
						error: function(j,e,p){ alert(lp("Error") + ": " + p); }
					});
				}
			}
			function close_camp(){
				var rec = get_curr_camp();
				if(!rec.length) { alert(lp("no_campaign_selected"));return; } // NI
				var id = rec.data("id");
				if( id && confirm(lpp("$close$ $campaign$ '$1'?", rec.data("name"))) ){
					wait_screen.add_operation("close_camp");
					$.ajax({
						method : 'POST',
						url : 'contr/main.php',
						data: {"action" : "close_camp", id: id}, 
						success: function(res){ 
							alert("Ok");
							camps.refresh(id);
						},
						complete: function(xhr, stat){	wait_screen.remove_operation("close_camp");	},
						error: function(j,e,p){ alert(lp("Error") + ": " + p); }
					});
				}
			}
			function show_edit_camp(id=0){
				var nc = call_php_sync("contr/main.php", {"action" : "show_edit_camp", "id" : id}, 'POST'); 
				var tabs = create_tabs([
					{name: "INFO", content: nc.resp_text, classname: "mc_info_tab"},
					// NOT USED IN EVITE{name: "PATH", content: $("#tt_select_folder"), classname: "mc_path_tab"},  // DEF INLINE_PATH: show path in edit camp form (used with STEPS); NOTE: tt_select_folder is added to md_ss and then is re-placed to its former parent (std code of md_ss)
					{name: "LOCATIONS", content: $("#mi_set_country_div"), classname: "mc_country_tab"}
				], on_set_active_tab);
				show_select_string(function(){ return save_camp(id); }, '', tabs, lp("edit_camp"));
				sd.init_form(root_dir); // INLINE_PATH  
				ff_init(tabs);
				// init shops
				shops = new table_tree("locations", '#mi_set_country', "locations");
				shops.set_use_paths(0); // if not use paths - see only subset of locations wich have shops
				shops.hide_plain();
				shops.hide_preview();
				shops.set_show_files(1);
				shops.main_form.find(".tt_exp_btn_div").addClass("hidden"); // hide header
				shops.add_popup_item(lp('rename'), show_rename_dialog, true, true); // RENAME
				shops.set_root_dir(client_code + "/locations/");
				//shops.open_root_dir();				
				shops.set_on_show_tree( function(cont){
					var ids = call_php_sync("contr/main.php", {"action" : "get_camp_shops",id: id}, 'POST').resp_text;
					shops.select_ids( ids.split(",") );
				});
				shops.open_dir_recursive(shops.get_root_item());
				// INLINE_PATH
				$("#nc_path").closest(".mc_sf_row").addClass("hidden"); // TODO: instead, may take path from record data-path
				curr_camp_path = $("#nc_path").val();
				// DEF CAMP_SHOP_CAT    set filter for imgs what may be used in a camp in a location (area)
				var ic = call_php_sync("contr/main.php", {"action" : "get_img_cat", "path": curr_camp_path}, 'POST'); 
				$("#mi_set_cat_div").html( $(ic.resp_text) );
				//ff_init( $("#mi_set_cat_div"), null, false );
				shops.client_show_details_func = function(shop_id){
					$("#mi_set_cat_cont").removeClass("hidden");
					$("#mi_set_cat_cont").data("shop_id", shop_id); // save for set
					var camp_id = camps.get_active_rec().data("id");
					var cond = call_php_sync("contr/main.php", {"action" : "get_camp_shop_cat", shop_id: shop_id, camp_id: camp_id}, 'POST'); 
					if(cond.resp_text)
						ff_set_params( $("#mi_set_cat_div"), JSON.parse( cond.resp_text ) );
					else
						ff_clear( $("#mi_set_cat_div") );
				} // or else calls std which uses show_select_string and closes tabs
				$("#mi_set_cat").click( function(){
					var cond = ff_params(  $("#mi_set_cat_div")  );
					var shop_id = $("#mi_set_cat_cont").data("shop_id");
					var camp_id = camps.get_active_rec().data("id");
					call_php_sync("contr/main.php", {"action" : "set_camp_shop_cat", shop_id: shop_id, camp_id: camp_id, cond: JSON.stringify(cond) }, 'POST'); 
				});
				$("#mi_reset_cat").click( function(){
					ff_clear(  $("#mi_set_cat_div")  );
				});
				//

				//
				if( id && !in_edit( camps.find_rec(id) ) )
					 $("#md_ss_ok").addClass("hidden");
				//$("#nc_path").dblclick(function(){ sd.select_folder( function(dir){ $("#nc_path").val(dir.substr(root_dir.length))  } , root_dir  )   } );
				// DEF STEPS stuff to show tabs as sequence where next tab is shown by "next" btn click
				$("#ms_ss_buttons").prepend( "<button id='md_ss_next' class='md_ss_temp md_ss_btn'>" + lp("next") + "</button>" );
				$("#md_ss_next").click(function(){
					var to = $(".mc_tab_name.active"); 
					var co = to.data("id"), cn; // prev (curr) tab id, new id
					if(co=="mc_info_tab") cn = "mc_path_tab";
					if(co=="mc_info_tab") cn = "mc_country_tab"; // path tabe not used in EVITE
					if(co=="mc_path_tab") cn = "mc_country_tab";
					$("."+co).removeClass("active");
					$("."+cn).addClass("active");
					on_set_active_tab(cn, co);
				});
				$("#md_ss_ok").addClass("hidden");
				// auto name
				$("#nc_season, #nc_camp_year").on("change", function(){
					var s = $("#nc_season").val(); var y = $("#nc_camp_year").val();
					var ss = {"SS": "SPRING", "FW": "AUTUMN"};
					if(s && y) $("#nc_name").val( ss[s] + "_" + y);
				});
			}
			// STEPS
			function on_set_active_tab(new_id, old_id){
				if(new_id=="mc_country_tab"){  
					if(in_edit)
					$("#md_ss_ok").removeClass("hidden");
					$("#md_ss_next").addClass("hidden");
				}else{
					$("#md_ss_ok").addClass("hidden");
					$("#md_ss_next").removeClass("hidden");
				}
				// INLINE_PATH
				if(new_id=="mc_path_tab"){
					if(!sd.get_selected_path() && !curr_camp_path && $("#nc_name").val()){
						curr_camp_path = root_dir + remove_spec_chars($("#nc_name").val()) + "/";
						//call_php_sync("contr/main.php", {"action" : "create_folder", "name" : curr_camp_path, type: "lowres" }, 'POST');
						sd.close_cont(sd.root);
						sd.open_dir(root_dir, sd.root);
						sd.create_folder(remove_spec_chars($("#nc_name").val()));
					}else if(!sd.get_selected_path() && curr_camp_path)
						sd.open_dir_seq(root_dir, curr_camp_path.substr(root_dir.length));
				}
			}
			function save_camp(id){
				var panel = $(".mc_tab_tab.mc_info_tab");
				var fields = ff_params(panel, true);
				fields.countries = shops.find_selection().files.join(";");
				fields["client_id"] = client_id;
				if(!fields.name){
					alert(lp("name_empty"));
					return;
				}
				// INLINE_PATH
				var path = sd.get_selected_path();
				if(!path) path = curr_camp_path;
				if(!path) path = root_dir + remove_spec_chars($("#nc_name").val());
				fields["path"] = path; 
				cc("save_camp", function(){
					camps.refresh();
				}, {id: id, fields: JSON.stringify(fields)} );
			}
			function delete_camp(id, name){
				if(!confirm(lpp("$Delete$ $campaign$ '$1'?", name))) return;
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "delete_camp", id: id},
					"success": function(res, dummy, request){
						camps.refresh();
					}
				});
			}
			// set path
			function set_camp_path(camp_id, dir){
				call_php_sync("contr/main.php", {"action" : "create_folder", "name" : dir, type: "lowres" }, 'POST');
				call_php_sync("contr/main.php", {"action" : "set_camp_path", "id" : camp_id, path: dir.substr(root_dir.length)}, 'POST');
				camps.refresh();
			}
			function show_create_path_dialog(camp_id){
				sd.select_folder( function(dir){set_camp_path(camp_id, dir)}, root_dir  ); 
			}
			function on_show(){
				$("#table-"+alias_name).find(".td-"+alias_name+"-RES_detail").html("<i class='mc_detail_btn far fa-window-maximize'></i>");
				// TODO: not works here $(".td-"+alias_name+"-RES_detail").click( function(){ show_detail_click1( $(this).closest(".data-row").data("id"), camps, show_lowres); } );
				// set camp path
				$("#tt_camps_div").find(".td-camps-path").each(function(){ 
					$(this).html(extract_name(unpend_slash($(this).html())));
					var camp_id = $(this).closest(".data-row").data("id");
					// now used INLINE_PATH $(this).append("<button type='button' class='mc_scp btn btn-primary btn-sm'>...</button>");
					$(this).find(".mc_scp").click( function(){show_create_path_dialog( camp_id  )}  );
					$(this).find(".mc_scp").css("margin-left", "10px");
				});
				$("#table-"+alias_name).find(".td-"+alias_name+"-date_from").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
				$("#table-"+alias_name).find(".td-"+alias_name+"-date_till").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
				$("#table-"+alias_name).find(".td-"+alias_name+"-dl_visual").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
				$("#table-"+alias_name).find(".td-"+alias_name+"-dl_produce").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
				$("#table-"+alias_name).find(".td-"+alias_name+"-dl_approve").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
			}

			/* TODO 1 this not works // upload camp files
			function att_init(sel, path){
				// DEF ATT manage attachments
				lowres = new table_tree("lowres", sel, "lowres", "thumbs");
				lowres.hide_tree();
				lowres.hide_preview();
				lowres.set_show_folders(0);
				lowres.set_paths("", "thumbs/", "thumbs/"); // DEF HRTH
				lowres.set_root_dir(path);
				// lowres.set_show_details(show_edit_client); TODO 1 show preview
				//$(sel).find(".tt_thumbs_header").append("<i class='fas fa-upload mc_upload_att' title='" + lp("upload") + "'></i>");
				$(sel).find(".tt_thumbs_header").remove();
				$(sel).find(".tt_thumbs_section").css("display", "flex"); // TODO: donno why 'flex 1 1 auto' of .mc_page_body not works
				// add
				lowres.set_on_show_plain(function(){
					$(sel).find(".tt_thumbs_section").prepend( $("<div class='lb_add bul_edit'><i class='fa fa-plus'></i> </div>") ); // add new
					$(sel).find(".lb_add").click( function(){
						$("#mi_user_path").val(path); // LOADSUB
						$("#mi_fu_data").val( JSON.stringify({client: "lowres"}) ); 
						show_select_string(	function(){	lowres.refresh() }, '', $("#mi_load_image"), lp("load_files"));
					});
				});
				lowres.add_popup_item(lpp('$download$ $selected$'), function(){lowres.download_selection()}, true, true, true);
				return lowres;
			}
			function show_lowres(camp_id){
				var atts = att_init(".ap_detail_div", camps.get_active_rec("data", "path"));
				atts.refresh();
			} */

			function get_curr_camp(){return camps.get_active_rec();}

			function init_lowres(sel){
					lowres = new table_tree("lowres", sel, "lowres", "thumbs");
					lowres.hide_tree();
					lowres.hide_preview();
					lowres.set_show_folders(0);
					lowres.set_paths("", "thumbs/", "thumbs/"); // DEF HRTH
					$(sel).find(".tt_thumbs_header").remove();
					$(sel).find(".tt_thumbs_section").css("display", "flex"); // TODO: donno why 'flex 1 1 auto' of .mc_page_body not works
					// add
					lowres.set_on_show_plain(function(){
						$(sel).find(".lb_add").remove();
						$(sel).find(".tt_thumbs_section").prepend( $("<div class='lb_add bul_edit'><i class='fa fa-plus'></i> </div>") ); // add new
						$(sel).find(".lb_add").click( function(){
							$("#mi_user_path").val(curr_camp_path + curr_cat_path); // LOADSUB TODO: this seems need call once on detail open and once on cat select
							show_select_string(function(){lowres.refresh()}, '', $("#mi_load_image"), lp("load_files"));
							set_fu_data(); // init
						});
					});
					lowres.add_popup_item(lpp('$download$ $selected$'), function(){lowres.download_selection()}, true, true, true);
					lowres.add_popup_item(lp('delete_selected'), function(){lowres.selection_action("delete_files")}, true, true, true);
					/* now done in on cat click lowres.set_root_dir(curr_camp_path + curr_cat_path);
					lowres.refresh(); */
			}
			//
			function set_fu_data(){
				var data = ff_params($("#fileupload"));
				data.client = "lowres";
				$("#mi_fu_data").val( JSON.stringify(data) ); 
			}
			function show_lowres(rec, cat_path_def=''){
				//var rec = $(this).closest(".data-row");
				var camp_id = rec.data("id");
				curr_camp_path = call_php_sync("contr/main.php", {"action" : "get_camp_path", "id": camp_id}, 'POST').resp_text;
				// IMG_CAT create 3 divs: cat list, images, texts
				var cont = $("<div><div class='mc_cat_list'></div><div class='mc_cat_imgs'></div><div class='mc_cat_txts'></div></div>");
				$(".ap_detail_div").html("");
				$(".ap_detail_div").append(cont);
				// lowres
				var sel = ".ap_detail_div .mc_cat_imgs";
				init_lowres(sel);
				// camp list
				var cat_list = JSON.parse(call_php_sync("contr/main.php", {"action" : "get_camp_cats", "path": curr_camp_path}, 'POST').resp_text);
				if(!cat_path_def && cat_list.length)
					cat_path_def = cat_list[0]+'/';
				for(var i=0;i<cat_list.length;i++){
					var cat_path = cat_list[i];
					var cd = $("<div class='mc_camp_cat mc_tab_name'>" + cat_path + "</div>");
					cont.find(".mc_cat_list").append(cd);
					cd.data("path", cat_path + '/');
					cd.click( function(){ 
						$(".mc_camp_cat").removeClass("active");
						$(this).addClass("active");
						// show imgs of this cat
						curr_cat_path = $(this).data("path");
						lowres.set_root_dir(curr_camp_path + curr_cat_path);
						lowres.open_root_dir();
						// show texts of this cat
						$(".mc_cat_txts").html(""); 
						var texts = JSON.parse(call_php_sync("contr/main.php", {"action" : "get_camp_texts", "path": curr_camp_path + curr_cat_path}, 'POST').resp_text);
						for(var j=0;j<texts.length;j++){
							var tt = $("<textarea class='mc_text'></textarea>");
							$(".mc_cat_txts").append( tt );
							tt.val(  texts[j]  );
						}
						var at = $("<div class='mc_add_text'><i class='fa fa-plus'></i> </div>");
						$(".mc_cat_txts").prepend( at ); // add new
						at.click( function(res){
							var ta = $("<textarea id='mi_lb_text'></textarea>");
							new md_ss( function(res){
								res = $("#mi_lb_text").val();
								call_php_sync("contr/main.php", {"action" : "new_camp_text", "path": curr_camp_path + curr_cat_path, "text": res}, 'POST');
								show_lowres( camps.get_active_rec(), res + "/" );
							},'',ta,lp("new_text") );
						});

					} );
					if(cat_path_def==cat_path+'/')
						cd.click(); // show first or requested cat
				}
				// new cat MACA
				var ncd = $("<div class='mc_new_camp_cat mc_tab_name'><i class='fa fa-plus'></i></div>");
				ncd.prop("title", lp("create_new_category"));
				cont.find(".mc_cat_list").append(ncd);
				ncd.click(function(){
					show_select_string(function(res){
						call_php_sync("contr/main.php", {"action" : "new_camp_cat", "path": curr_camp_path + res + "/"}, 'POST');
						show_lowres( camps.get_active_rec(), res + "/" );
					},'',0,lp("new_category") );
				});
				// DEF IMG_CAT image categories; now it's used to set all additional img data except category, which is set with MACA
				var ic = call_php_sync("contr/main.php", {"action" : "get_img_cat", "path": curr_camp_path}, 'POST'); 
				var mw = $(ic.resp_text);
				mw.find("#sf_uf2").closest(".mc_sf_row").remove(); // cat in MACA
				mw.insertBefore( $(".fileupload-buttonbar") );
				mw.find(".ttc_search_field").on("change", set_fu_data);
			}

			
			var client_id = <?php echo get_client_id(); ?>;
			var alias_name = "camps", table_name = "camps";
			var client_code = '<?php echo get_client_code(); ?>';
			var lowres_sp, sd, root_dir = client_code + "/lowres/";
			var lowres, shops;
			var curr_camp_path; // INLINE_PATH
			var curr_cat_path = ""; // CAMP_CAT
			var lowres;

			$(document).ready( function(){
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				//
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				camps = new Tablo("#tt_camps_div .tt_thumbs_form", $("#tt_camps_div .mc_search_panel"), "camps", fields.list, fields.search, on_rec_sel, function(rec){show_edit_camp(rec.data("id"));}, "camps");
				//cass_init(); // CASS
				camps.ro_set("date_from", "asc");   // FIORD
				camps.on_show = on_show;
				if(client_id)
				camps.set_cond("client_id="+client_id);
				camps.show();

				// CRUD
				//$(".lbsp_rec_actions").append( $('<button type="button" class="lbsp_loadsub btn btn-primary btn-sm hidden"> <i class="fas fa-image mc_page_head" title="'+lp("subjects")+'"></i></button>') );
				//$(".lbsp_loadsub").click( function(){ if(get_rec_id()) show_load_sub( "mini" );	});
				$(".lbsp_rec_actions").append( $('<div class="lbsp_open mc_btn hidden"> <i class="fa fa-play mc_page_head" title="'+lp("open")+'"></i></div>') );
				$(".lbsp_rec_actions").append( $('<div class="lbsp_close mc_btn hidden"> <i class="fa fa-archive mc_page_head" title="'+lp("close")+'"></i></div>') );
				$(".lbsp_open").click( open_camp );
				$(".lbsp_close").click( close_camp );
				$(".lbsp_new").click( function(){show_edit_camp(0)} );
				$(".lbsp_edit").removeClass( "hidden");
				$(".lbsp_edit").click( 
					function(){
						var rec = get_curr_camp();
						if(rec.length==1)
							show_edit_camp( rec.data("id") );
				});
				$(".lbsp_del").click( 
					function(){
						var rec = get_curr_camp();
						if(rec.length==1)
							delete_camp( rec.data("id"), rec.data("name") );
				});

				// select camp path
				lowres_sp = new table_tree("lowres", '#tt_table_tree_div', "lowres", "thumbs"); // init tree table NOTE: set table before (used by def_search_fields) 
				lowres_sp.set_root_dir(root_dir);
				lowres_sp.set_use_paths(1);
				sd = new SD( function (path, cb){
					wait_screen.add_operation("open_dir");
					$.ajax(lowres_sp.acid("open_show_folder", {
						data: {'path': path},  // table_where is for RECSUR
						success: cb,
						complete: function(){ wait_screen.remove_operation("open_dir") }
					}));
				});
				// upload TODO: this must be in on_show
				$("#tt_camps_div .tt_thumbs_form").on("click", ".td-"+alias_name+"-RES_detail", function(){ 
					var rec = $(this).closest(".data-row");
					if(!show_detail_click1(rec)) 
						return; // TODO: this shows or hides detail row.. but if hides - need exit here
					show_lowres(rec); 
				} );
			});
		</script>
	</body>
</html>
