<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="table_tree/js/table_tree.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen tc_single_table'> <!-- NOTE: without this cont appears another horiz scr bar -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
		</div>
		<script type="text/javascript">
			function show_edit_client(id=0){
				var nu = call_php_sync("contr/main.php", {"action" : "show_edit_client", "id" : id, "tt_project": "clients"}, 'POST'); 
				var tabs = create_tabs([
					{name: "INFO", content: nu.resp_text, classname: "mc_info_tab"}
					//,{name: "ORDERS", content: "<div id = 'mi_set_country'></div>", classname: "mc_order_tab"}
				]);
				// TODO: read fields, image
				//
				show_select_string(function(){ return save_client(id); }, '', tabs, lp("edit_client"));
				ff_init(tabs);
				// img DEF USIMA Upload Single IMAge
				$(".mc_tab_body .mc_info_tab").append("<input type='file' name='fileToUpload' id='fileToUpload' style='display: none;'>");
				$(".mc_tab_body .mc_info_tab").append("<div style='flex: 1 1 auto; overflow: auto;'><img  title='' alt='click to upload image' id='mi_upload_image' style='cursor: pointer;max-width:300px;'> </img> </div>");
				var code = $("#nc_code").val();
				if(code)
					$("#mi_upload_image").attr("src", "clients/" + code + "/data/bg");
				$("#mi_upload_image").click( function(){document.getElementById("fileToUpload").click()} );
				document.getElementById("fileToUpload").addEventListener("change", function(){
					document.getElementById("mi_upload_image").src = URL.createObjectURL( document.getElementById("fileToUpload").files[0] );
					document.getElementById("mi_upload_image").onload = function(){ URL.revokeObjectURL(this.src); }
				}, false);
			}
			function save_client(id){
				var panel = $("#md_ss_div");
				var fields = ff_params(panel);
				var img = "";
				// img = document.getElementById("fileToUpload").files[0];  TODO: this not works (can't send img along with other data), error on sending ajax
				var res = true;
				$.ajax({
					"type": "POST",
					"async": false,
					"url": "contr/main.php",
					"data": {action : "save_client", id: id, fields: JSON.stringify(fields)}, // TODO:
					"success": function(res, dummy, request){
						if(document.getElementById("fileToUpload").files.length)
							send_image(document.getElementById("fileToUpload").files[0], "contr/main.php", data={"action": "save_client_logo", "code": $("#nc_code").val()});
						clients.refresh();
					},
					"error": function(jqxhr, settings, thrownError){
						res = false; // using async=false and ret res false to not close the dialog
					}
				});
				// TODO: save fields defs
				return res;
			}
			// TODO:
			function delete_client(id, name){
				// TODO 1  var restr = JSON.parse( call_php_sync("contr/main.php", {"action" : "check_client_delete", id: id}, 'POST').resp_text );
				if(!confirm(lpp("$Delete$ $client$ '$1'?", name))) return;
				//if(restr.groups.length && !confirm(lp("delete_from_groups") + ": " + restr.groups.join(", "))) return;
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "delete_client", id: id},
					"success": function(res, dummy, request){
						clients.refresh();
					}
				});
			}
			var clients;
			var table_name = "clients", alias_name = "clients";
			$(document).ready( function(){
				set_ajax_error_handler();
				//
				clients = new table_tree("clients", '#tt_table_tree_div', "v_clients", "thumbs");
				clients.hide_tree();
				clients.hide_preview();
				clients.set_show_folders(0);
				clients.set_paths("files/", "files/", "files/"); // DEF HRTHP
				clients.open_root_dir();				
				clients.set_on_show_plain(function(){
					$("#tt_table_tree_div .RES_checked").addClass("hidden");
				});
				clients.set_show_details(show_edit_client);
				$(".tt_thumbs_header .lbsp_form").addClass("hidden");
				$(".tt_thumbs_header .mc_sal").remove();
				$(".tt_thumbs_header .tt_emp_explore_menu").remove();
				// commented 24.07.2023 donno what was for $(".tt_thumbs_header").append("<i class='fas fa-envelope'></i>");
				//
				$(".tt_thumbs_header .lbsp_crud").removeClass("hidden");


				// CRUD
				$(".lbsp_new").click( function(){show_edit_client(0);} );
				$(".lbsp_edit").click( 
					function(){
						var rec = clients.get_active_detail();
						if(rec.length==1)
							show_edit_client( rec.data("id") );
				});
				$(".lbsp_del").click( 
					function(){
						var rec = clients.get_active_detail();
						if(rec.length==1)
							delete_client( rec.data("id"), rec.data("name") );
				});
				if(ur_role.role=="ADMIN")
					$(".lbsp_del, .lbsp_edit").removeClass("hidden"); // NOTE: donno why now in html/table.html they are hidden by default
			});
		</script>
	</body>
</html>
