<?php
/*
        Author: Alex Nosurov
        Date: 17.11.23
*/
try{
	ob_start();
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."view/lang.php"); // should be first
	require_once(proj_path."utils/utils.php");
	require_once(proj_path."model/errors.php");
	require_once(proj_path."model/db.php");
	require_once(proj_path."view/apap.php");
	require_once(proj_path."table_tree/view/preview.php");
	ob_clean();

	function mse($var){ return must_be_set($_POST, $var); }
	function gde($var, $def=''){ return get_or_def($_POST, $var, $def); }
	function ise($name){ return isset($_POST[$name]); }
	
	log\set_log_file(log_path."contr.log");

	$action = mse('action');
	log\info("controller action request: $action");
        $cond = gde('cond'); // it's here while many use it; where it's obligatory - must be duplicated with mse()
	//
	if( isset( $_POST['quiet'] ) )
		log\set_log_level('quiet');

	function get_file_info($file_id){
		$file = db\select_record("revisions", "file_id id,path,name,width,height,ws_id,thumb_small", "file_id=$file_id");
		if(!$file){
			$file = db\select_record("files", "id,path,name,dimensions,ws_id,thumb_small", "id=$file_id");
			preg_match("/(\d+)x(\d+)/", $file["dimensions"], $m); $file["width"] = $m[1]; $file["height"] = $m[2];
		}
		return $file;
	}



while(true){ // this is only to use break
	if($action=="ap_image"){
		$id = mse("id");
		$scale_num = mse("scale_num");
		$img = db\select_record("approves_versions", "*", "rev_id=$id"); // APP_VER using rev_id
		if(gde("revision")) $img = db\select_record("approves_versions", "*", "path like '%/".db\escape2(gde("revision")).".jpg'"); // APP_VER; a prev version is identified by path (is_last=1)
		$scales = array("100", "75", "50", "25");
		$scale = $scales[$scale_num];
		$img["url"] = $scale_num==0? get_files_path().$img["path"] : get_files_path().add_suffix($img["path"], "_".$scale );
		$img["width"] = $img["width"]*$scale/100;
		$img["height"] = $img["height"]*$scale/100;
		$img["zoom"] = $scale;
		echo json_encode($img);
		return;
	}
	if($action=="get_app_info"){
		$id = mse("id");
		$lbs = db\select_record("approves_versions", "lbs_id, version", "rev_id=$id"); // APP_VER ; approves_versions contains version
		$app_id = $lbs["lbs_id"];
		$version = $lbs["version"];
		$lbs = db\select_record("app_lbs", "name, lbs_width width, lbs_height height, app_state state, order_id, notes", "app_id=$app_id"); // notes for APREM 
		$order = db\select_record("v_orders", "*", "id=".$lbs["order_id"]);
		$lbs["order_state"] = $order["order_state_lbs"];
		$lbs["order_id"] = $order["id"];
		$lbs["camp_id"] = $order["camp_id"];
		// DEF APP_GROUP navigate to other apps of same group; in ic it's all ws files; in stamps - order files
		$order_id = $lbs["order_id"];
		$ne = db\escape($lbs["name"]);
		$lbs["next"] =  db\select_field("app_lbs", "rev_id", "order_id=$order_id AND name>'$ne'", "name asc", 1);
		$lbs["prev"] =  db\select_field("app_lbs", "rev_id", "order_id=$order_id AND name<'$ne'", "name desc", 1);
		$lbs["version"] = $version;
		echo json_encode( $lbs );
		return;
	}
	// APP_VER ; returns list of file names for scales 
	if($action=="get_revisions"){
		$id = mse("id"); // now = rev_id
		$lbs_id = db\select_field("approves_versions", "lbs_id", "rev_id=$id");
		$revs = db\select_field_to_array("approves_versions", "rev_id", "page=0 AND lbs_id=$lbs_id", "rev_id desc");
		echo json_encode($revs);
		return;
	}
	// NOTE: not used in single-page ver
	if($action=="ap_pages"){
		$rev_id = mse("id");
		$lbs = db\select_record("approves_versions", "lbs_id,version", "rev_id=$rev_id");
		$pages = db\select_to_array("approves_versions", "page,path,rev_id", "lbs_id=".$lbs["lbs_id"]." AND version=".$lbs["version"]); // TODO: thus gives all files with this name; need also check path
		$res = array();
		foreach($pages as $page){
			$res[]= array( "id" => $page["rev_id"], "url" => add_suffix(get_files_path().$page["path"], "_25") );
		}
		echo json_encode($res);
		return;
	}

	if($action=="pin_render_empty"){
		$pin = json_decode( mse("pin") , true);
		$pin["owner"] = get_user_info("name");
		db\execute("insert into pins " . db\compile_insert($pin));
		$pin = db\select_record("pins", "*", "id = " . db\get_last_id() );
		echo pin_render($pin);
		return;
	}

	if($action=="pin_read_all"){
		$pid = mse("app_id");
		$pins = db\select_to_array("pins", "*", "app_id=$pid and txt<>'' and txt is not null");
		foreach($pins as $pin)
			echo pin_render($pin);
		return;
	}

	if($action=="pin_save"){
		$pin = json_decode( mse("pin"), true );
		db\execute("update pins set " . db\compile_update($pin) . "where id = ".$pin["id"]);
		//db\execute("insert into pins " . db\compile_insert($pin));
		return;
	}
	// as new emtpy pin is added on image - also empty rec inserted into db; need del not saved
	if($action=="pin_del_empty"){
		db\execute("delete from pins where txt='' or txt is null");
		return;
	}
	if($action=="pin_delete"){
		db\execute("delete from pins where id = " . mse("id"));
		return;
	}

	if($action=="draw_save"){
		$draw = json_decode( mse("draw"), true );
		$id = $draw["id"];
		unset($draw["id"]);
		if($id)
			db\execute("update draws set " . db\compile_update($draw) . "where id = $id");
		else{
			db\execute("insert into draws" . db\compile_insert($draw));
			echo db\get_last_id();
		}
		return;
	}
	if($action=="draw_read_all"){
		$app_id = mse("app_id");
		echo json_encode( db\select_to_array("draws","*","app_id=$app_id") );
		return;
	}
	if($action=="draw_delete"){
		db\execute("delete from draws where id = " . mse("id"));
		return;
	}
	if($action=="get_dests"){
		echo db\select_field("approves_versions","owner","rev_id=".mse("id"));
		return;
	}
	throw new Exception("Wrong or empty action: $action");

} // end of while

}catch(user_exception $e){
	if($msg=$e->getMessage())
		log\error("user error: '$msg'");
	header($_SERVER['SERVER_PROTOCOL'].' 500 '.$e->getUserMessage(), true, 500);
}catch(Exception $e){
	$code = generate_random_string(4, "123456789"); // just a random code informed to used and written to log; thus user can identify to admin what to search in logs
	log\error("controller error $code; POST dump: ", array_to_str($_POST), $e->getTraceAsString() );
	register_error("Controller error $code: ".$e->getMessage(), "controller", "controller", el_higher);
	header($_SERVER['SERVER_PROTOCOL'].' 500 $unknown_error$ $code$: '.$code, true, 500);
	//return;
}
?>
