<?php
/*
        Author: Alex Nosurov
        Date: 29.08.19
        Description: main data necessary to build a page (like menu/footer...)
        Input: 
                'action': obligatory; specifies which data; values: 'menu'
        Using such scheme allows to use same ajax-call code in the main form for all menu handlers
        menu items codes are defined and used only here
*/
try{
	ob_start();
        require_once(dirname(__FILE__)."/../path.php");
        require_once(proj_path."view/lang.php"); // should be first
        require_once(proj_path."utils/utils.php");
        require_once(proj_path."utils/menu.php");
        require_once(proj_path."utils/view.php");
        require_once(proj_path."utils/filter_fields.php");
        require_once(proj_path."utils/table.php");
        require_once(proj_path."view/metadata.php"); 
        require_once(proj_path."model/errors.php");
        require_once(proj_path."model/db.php");
        require_once(proj_path."model/lb.php");
        require_once(proj_path."model/apap.php");
		require_once(proj_path."model/events.php");
		require_once(proj_path."model/utils.php");
		require_once(proj_path."model/algo.php");
        require_once(proj_path."view/apap.php");
        require_once(proj_path."model/pdf.php");
        require_once(proj_path."model/download.php"); // find_triple_files
		if(isset($_POST["tt_project"]))
			require_once(proj_path."table_tree/share/".$_POST["tt_project"].".php"); // NOTE: cant' include it later, while its defines must preceede those of tt/model/db
        require_once(proj_path."table_tree/view/show_dir.php"); // show_tree_id
        require_once(proj_path."table_tree/model/db.php"); // tt data_fields
	ob_clean();

	function _show_table($table, // name
						$fields, // k->v field name -> caption
						$where='', $order='', $alias='', $limit='', $start=''){
		if( $alias=='' ) $alias = $table; // may be convenient to change source table name
		$fnames = array_keys( $fields );
		array_walk($fnames, function(&$val, $key){ if(starts_with($val, "RES_")) $val = "'' as $val"; }); // CB_SEL_REC_WS: CB_SEL_REC support: cols named RES_* are dummy cols to display checkboxes, so do not fetch data from db for them
		db\select($table, join(',',$fnames), $where, $order, "", $limit, $start); 
		echo render_table($alias, $fields, db\response_to_array() );
	}
	// TODO: move this func to tt/project.php
	function set_table_fields($table, $alias, &$search_fields, &$list_fields){
		global $user_type;
		if($alias=="users"){ global $user_list_fields; $search_fields = get_user_search_fields($user_type); $list_fields = $user_list_fields; }
		if($alias=="clients"){ global $client_search_fields, $client_list_fields; $search_fields = $client_search_fields; $list_fields = $client_list_fields; }
		if($alias=="md"){ global $md_order_search_fields, $md_order_list_fields; $search_fields = $md_order_search_fields; $list_fields = $md_order_list_fields; }
		if($alias=="camps"){ global $camp_search_fields, $camp_list_fields; $search_fields = $camp_search_fields; $list_fields = $camp_list_fields; }
		if($alias=="apv"  ){ global $apf_search_fields,  $apf_list_fields;  $search_fields = $apf_search_fields;  $list_fields = $apf_list_fields; } // TODO: not used now
		if($alias=="app_lbs"){ global $triple_search_fields,  $triple_list_fields;  $search_fields = $triple_search_fields;  $list_fields = $triple_list_fields; } 
		if($alias =="orders"){
			$search_fields = get_order_search_fields( get_order_md () );
			$list_fields = get_order_list_fields(get_order_md ());
		}
		if($alias =="orders_all"){
			$search_fields = get_order_search_fields( get_order_md () , get_client_list());
			$list_fields = get_order_list_fields(get_order_md () , get_client_list());
		}
		//
		if($alias=="groups"){ global $group_list_fields; $list_fields = $group_list_fields; $search_fields=get_user_search_fields($user_type); }
		if($alias=="events"){ global $event_list_fields, $event_search_fields; $list_fields = $event_list_fields; $search_fields=$event_search_fields; }
		if($alias=="user_actions"){$list_fields = fdef_fd_to_list(get_ua_fields(),0,1); $search_fields=fdef_fd_to_fide_all( get_ua_fields(), "sf_" );}
		if($table =="v_order_lbs"){
			$clients_list = db\select_field_to_array("clients","code");
			$defs = get_order_lbs_fields($clients_list);
			$defs = array_merge($defs, fdef_db_to_fd_all(get_md("lbs", shoc_get())), fdef_db_to_fd_all(get_md("locations", shoc_get())));
			$search_fields = fdef_fd_to_fide_all( $defs, "sf_", "S" );
			$list_fields = fdef_fd_to_list($defs,1,1);
		}
		if($alias =="packs"){
			$defs = get_pack_fields(db\select_field_to_array("clients","code"), gde("addresses",[])); // page passes all addrs in selection (should be single one)
			$defs = array_merge($defs, fdef_db_to_fd_all(get_md("packs"))); // static def + courier
			$search_fields = fdef_fd_to_fide_all( $defs, "sf_", "S" );
			$list_fields = fdef_fd_to_list($defs,1,1);
		}
	}

	function mse($var){ return must_be_set($_POST, $var); }
	function gde($var, $def=''){ return get_or_def($_POST, $var, $def); }
	function ise($name){ return isset($_POST[$name]); }
	// DEF SHOWN_CLIENT SHOC: in lbs page show different clients; while now delivery_address is in md - it's added to data only if is set session's client_id; can't pass client_id with req while req is done by table.js; so store it in session
	function shoc_get(){  if($cid = get_client_id()) return $cid; if($cid = gde("client_id")) return $cid; return get_or_def($_SESSION, "shown_client_id"); }
	function shoc_set($client_id){ $_SESSION["shown_client_id"]=$client_id; }

	log\set_log_file(log_path."contr.log");

	$action = mse('action');
	log\info("controller action request: $action");
	$cond = gde('cond'); // it's here while many use it; where it's obligatory - must be duplicated with mse()
	//
	if( isset( $_POST['quiet'] ) )
		log\set_log_level('quiet');
	
	$user_type = is_worker()? "worker" : "client";

	//if(isset($_SESSION['user_id'])){unset($_SESSION['user_id']);	unset($_SESSION['user_name']);}  // TEMP TEST LOGONEXP TODO: not works unset!

while(true){ // this is only to use break
	// LANG  lang funcs may be requested without user, so it must be before user_id check
	// read translations
	if($action=="lang_read"){
		$lang_tr = lang_read();
		echo json_encode( $lang_tr );
		break;
	}
	if($action=="lang_list"){
		global $lang_list;
		$res = array();
		foreach($lang_list as $code => $capt)
			$res[] = array("code" => $code, "name" => $capt, "img" => "img/$code.png");
		echo json_encode($res);
		return;
	}
	if($action=="lang_change"){
		lang_set(mse("lang"));
		if( get_curr_user_id() )
			save_user_settings(  get_curr_user_id(), array( "lang" => mse("lang") ) ) ; // 5/5/2022 save lang in db
		return;
	}
	if($action=="lang_get"){
		echo lang_get(); 
		return;
	}
	if($action=="lang_get_db"){
		$db = lang_get_db(get_curr_user_id()); 
		echo $db? $db : lang_def;
		return;
	}

	$user_id = get_curr_user_id();
	if(!$user_id || session_status()==PHP_SESSION_NONE) // LOGONEXP
		throw new user_exception('no_user');
		//throw new user_exception('$no_user$');
	
        // MAIN MENU
	if( $action=='menu'){
		$is_admin = check_admin($user_id);
		echo render_menu(get_main_menu($is_admin));
		break;
	}
	if( $action=='menu_vert'){
		$role = ur_get_user_role();
		$menu_items = array_intersect_key( get_mainmenu(), array_flip( get_role_pages( $role["role"] ) ) );
		//log\debug(get_role_pages( $role["role"] ));
		echo render_menu_hl($menu_items); // UR
		break;
	}
	if( $action=='mobile_menu_list' ){ // this only issues list (not html); then js builds a standard popup menu; NOTE: TODO:  would be better to use a menu that works both in mobile and desktop mode, only that in momo need incapsulate whole menu in single root item;
		echo json_encode( get_main_menu_mobile() ); break;
	}

	if( $action=='menu_click'){
		$handler = mse('handler');
		echo "$handler was clicked\n";
		break;
	}
	// SET_ADMIN  checks if user is admin
	if($action=="admin"){
		if(session_id() == '')
			session_start();
		echo get_or_def($_SESSION, 'admin', 0)? '1': '0'; break;
	}
	// UR
	if( $action=='ur_get_user_role'){
		echo json_encode(ur_get_user_role());
		break;
	}
	if( $action=='tips'){
		break;
	}
	
	// ----------------------- TT TABLETREE -----------------------------

	if($action=="show_table"){
		$table = mse("table");
		$alias = gde("alias", $table); // eg may use view v_shop_camp_1 but want fields for "shops"; alias must be "shops"
		$where = gde("where"); // json packed k->v array
		set_table_fields($table, $alias, $search_fields, $list_fields);
		if($where){
			$where_arr = json_decode($where, true);
			$where = db\compile_where(  ff_add_values( $search_fields , $where_arr), ff_get_predicate($where_arr) ); // append values to ff arr
		}
		$where = array($where, $cond);
		if(!is_worker() && in_array($table, ["users", "users_users", "groups", "orders", "campaigns", "hires", "lowres"])) $where[]= "client_id=".get_client_id(); // WOC
		if(is_worker() && in_array($table, ["users", "users_users", "groups"])) $where[]= "client_id=".get_client_id(); // WOC TODO: wassis? if worker - client id = 0...
		// TABCOL
		filter_user_cols($list_fields, gde("columns"));
		//
		if(gde("get_count"))
			header("count:".db\select_field($table, "count(*)", $where) );
		// if($table=="shops" && check_unblock_flag("update_shop_roles")) update_shop_roles(); // USR   NOT USED IN SHOP_SINGLE_GROUP version
		echo _show_table($table, $list_fields, $where, gde("order"), $alias, gde("limit"), gde("start") );
		return;
	}

	if($action=="export_csv"){
		$table = mse("table");
		$alias = gde("alias", $table); // eg may use view v_shop_camp_1 but want fields for "shops"; alias must be "shops"
		$where = gde("where"); // json packed k->v array
		$order = gde("order"); 
		set_table_fields($table, $alias, $search_fields, $list_fields);
		if($where){
			$where_arr = json_decode($where, true);
			$where = db\compile_where(  ff_add_values( $search_fields , $where_arr), ff_get_predicate($where_arr) ); // append values to ff arr
		}
		$where = array($where, $cond);
		//if(in_array($alias, ["order_lbs"])) $where[]= "client_id=".get_client_id(); // WOC
		$fnames = json_decode(gde("columns"), true); // TABCOL
		$data = db\select_to_array($table, join(",", $fnames), $where, $order); 
		if( in_array("square", $fnames) )
			foreach($data as &$rec)
				$rec["square"] = str_replace(".", ",", $rec["square"]);
		print_xls($fnames, $data, "orders");
		if( in_array("square", $fnames) ){
			$col = array_search("square", $fnames) + 1;
			$row0 = 1; $row1 = sizeof($data) + 1;
			echo "\nTotal:\t=SUM(INDIRECT(ADDRESS($row0;$col)):INDIRECT(ADDRESS($row1;$col)))";
		}
		return;
	}

	// DEF DEF_PAGE: 31.05.22 found a bug: if def rec isn't on the first page - it's not shown;
	// this call is made to determine page num
	// params: id, table, where, order
	if($action=="get_rec_pos"){
		$table = mse("table");
		$alias = gde("alias", $table); // eg may use view v_shop_camp_1 but want fields for "shops"; alias must be "shops"
		$where = gde("where");
		set_table_fields($table, $alias, $search_fields, $list_fields);
		if($where){
			$where_arr = json_decode($where, true);
			$where = db\compile_where(  ff_add_values( $search_fields , $where_arr ) );
		}
		$cond = gde("cond"); $wc = array(); if($cond) $wc[]="($cond)"; if($where) $wc[]="($where)"; $where=join(" and ", $wc);
		//
		$ids = db\select_field_to_array( mse("table"), "id", $where, gde("order") );
		$pos = array_search( mse("id"), $ids );
		echo $pos? $pos : "0";
		return;
	}
	// converts kv arr (a record) to format which is then acceted by ff_merge_values
	function kv_to_fide($kv, $prefix){ $r=[]; foreach($kv as $k => $v)$r[]=array("id"=>$prefix.'_'.$k, "default" => $v);return $r;}
	// --------------------------- MD_ORDERS ----------------------------------
	if($action=="show_edit_md_order"){
		global $new_md_order_fields;
		$table = "md";
		$table_name = mse("table_name"); // md.table_name field
		$range = preg_split("/;/", mse("range")); // range of field names; defined by table_name structure; if table_name has fields fn1...fn15, range="1;15"
		$id = gde("id"); // if id = 0 => create new; else - edit exiting
		if(!$id){ // need find 1st available field to use
			$values = get_free_field($table_name, mse("client_id"), $range[0], $range[1]);
		}else
			$values = $id? kv_to_fide(db\select_record($table, "*", "id=$id"), "nf") : null;
		echo render_search_form($new_md_order_fields, $values, "plain");
		return;
	}
	if($action=="save_md_order"){
		$table = "md";
		$id = mse("id");
		$table_def = null; // array( "name" => array("length" => 50, "can_truncate"=>1) );
		$fields = json_decode( mse("fields"), true );
		$fields["table_name"] = mse("table_name");
		//if(db\exists($table, "name='".$fields["fname"]."' client_id=$client_id and id<>$id" && caption='".$fields["caption"]."'")) throw new user_exception('$client$ $name_exists$');
		if($id){
			db\execute("update $table set ".db\compile_update($fields, $table_def)." where id='$id'"); 
		}else{
			db\execute("insert into $table ".db\compile_insert($fields, $table_def));
			$id = db\get_last_id();
		}
		echo $id;
		return;
	}
	if($action=="md_order_move"){
		$table = "md";
		$id = mse("id");
		$client_id = mse("client_id");
		$table_name = mse("table_name"); // md.table_name field
		$dir = gde("up")? "-1" : "+1";
		$order = db\select_field($table, "forder", "id=$id");
		$id2 = db\select_field($table, "id", "client_id = $client_id AND table_name = '$table_name' AND forder=$order$dir");
		db\execute("update $table set forder=forder$dir where id=$id");
		db\execute("update $table set forder=$order where id=$id2");
		return;
	}
	if($action=="check_md_order_delete"){ echo "1"; return; } // TODO:
	if($action=="delete_md_order"){
		db\execute("delete from $table where id = ".mse("id"));
		return;
	}
	// --------------------------- CLIENTS ----------------------------------
	if($action=="show_edit_client"){
		$id = gde("id"); // if id = 0 => create new; else - edit exiting
		$client = db\select_record("v_clients", "*", "id=$id");
		$values = $id? kv_to_fide($client, "nc") : null;
		$ncf = get_new_client_fields();
		find_array_key_value($ncf, "field", "manager_id")["keyval"] = db\select_id_field_to_array("users", "id", "name", "worker=1 and ".db\in_list("user_role", "PRODUCTION")); // drop-down list of all productions
		if($id)
		find_array_key_value($ncf, "field", "admin_email")["default"] = db\select_field("users", "email", "id=".$client["admin_id"]);
		echo render_search_form($ncf, $values, "plain");
		return;
	}
	if($action=="save_client"){
		$client_id = mse("id");
		$clients_table = null; // array( "name" => array("length" => 50, "can_truncate"=>1) );
		$fields = json_decode( mse("fields"), true );
		if(db\exists("clients", "name='".$fields["name"]."' and id<>$client_id")) throw new user_exception('$client$ $name_exists$');
		if(db\exists("clients", "code='".$fields["code"]."' and id<>$client_id")) throw new user_exception('$client_code_exists$');
		//
		$admin_email = array_pop_key($fields, "admin_email");
		if($client_id){
			db\execute("update clients set ".db\compile_update($fields, $clients_table)." where id='$client_id'"); 
			db\execute("update users set email = '$admin_email' where id = ".db\select_field("clients","admin_id","id=$client_id")); // for the case when admin wants to change client admin email
		}else{
			db\execute("insert into clients ".db\compile_insert($fields, $clients_table));
			$client_id = db\get_last_id();
			$admin_id =create_client_users($admin_email, $client_id);
			db\execute("update clients set admin_id = $admin_id where id = $client_id");
		}
		echo $client_id;
		return;
	}
	if($action=="save_client_logo"){
		$code = $_REQUEST["code"];
		if(isset($_FILES["fileToUpload"])){
			$from = $_FILES["fileToUpload"]["tmp_name"];
			$to = proj_path.get_background_path($code);
			if(!is_dir(dirname($to)))
				exec_cmd("md", dirname($to)); // www-data can't create dir, so use this (need rec in sudoers: www-data ALL=(ALL:ALL) NOPASSWD:/usr/bin/php md.php * )
			move_uploaded_file($from, $to);
		}
		return;
	}
	if($action=="delete_client"){
		$client_id = mse("id");
		// TODO delete related stuff
		db\execute("delete from users where client_id = $client_id");
		db\execute("delete from lbs where order_id in (select id from orders where client_id = $client_id)");
		db\execute("delete from lbc where order_id in (select id from orders where client_id = $client_id)");
		db\execute("delete from orders where client_id = $client_id");
		db\execute("delete from clients where id = $client_id");
		return;
	}
	// -------------------- USERS --------------------------

	// CRUD USER
	// DEF EDIT_USER stuff to add/edit user
	if($action=="show_edit_user"){
		$id = gde("id"); // if id = 0 => create new; else - edit exiting
		$values = null;
		if($id){
			$usr = db\select_record("users", "*", "id=$id");
			$values = array(
				array("id" => "nu_name", "default" => $usr["name"]),
				array("id" => "nu_email", "default" => $usr["email"]),
				array("id" => "nu_pass", "default" => $usr["pass"]),
				//array("id" => "nu_user_role", "default" => $usr["user_role"])
				array("id" => "nu_user_role", "default" => preg_split("/;/", $usr["user_role"], -1, PREG_SPLIT_NO_EMPTY))  // MULTI_ROLE
			);
			$ugr=db\select_field_to_array("groups", "id", db\in_list("email", $usr["email"]) ); // SEL_GROUP_ROLES
			//$values[]=array("id" => "nu_user_group_role", "default" => $ugr); // SEL_GROUP_ROLES
		}
		$values[]= array("id" => "nu_lang", "default" => lang_get_db($id, lang_def));  // ADM_EDIT_LANG
		echo render_search_form(get_new_user_fields($user_type), $values, "plain");
		return;
	}
	// NOTE: now is used for groups
	if($action=="get_user_shops"){
		$user_id = mse("id");
		$role = mse("role");
		echo  json_encode( get_user_shops($user_id, $role ) );
		return;
	}
	// NOTE: now is used for groups
	if($action=="set_user_shops"){
		$user_id = mse("id");
		$role = mse("role");
		$shops = json_decode( mse("shops"), true );
		$shops = preg_split("/;/", $shops, -1, PREG_SPLIT_NO_EMPTY);
		set_user_shops($user_id, $role, $shops);
		return;
	}

	if($action=="save_user"){
		$user_id = mse("id");
		$users_table = array( "name" => array("length" => 50, "can_truncate"=>1) );
		$fields = json_decode( mse("fields"), true ); // fields got from: show_edit_user <- get_new_user_fields
		//log\debug($fields); return;
		// SEL_GROUP_ROLES
		$ugr = get_or_def($fields, "user_group_role", array());
		unset( $fields["user_group_role"] );
		// ADM_EDIT_LANG
		$lang = get_or_def($fields, "lang", lang_def);
		unset( $fields["lang"] );
		//
		if(isset($fields["user_role"]) && is_array($fields["user_role"]) ) // DEF MULTI_ROLE user may have several roles; js passes as array
			$fields["user_role"] = join(";", $fields["user_role"]);
		if(!isset($fields["user_role"]) ) // js not passes empty role, so it not goes to sql and not emptied
			$fields["user_role"] = "";
		//log\info($fields);
		// TODO 1: add client check at identity check (when use different site names for each client)
		if($user_id){
			update_user($user_id, $fields["name"], $fields["email"], $fields["pass"], $fields["user_role"]);
		}else{
			$user_id = register_user($fields["name"], $fields["email"], $fields["user_role"], get_client_id(), "", $fields["pass"]); // TODO: lang not processed
		}
		echo $user_id;
		return;
	}
	if($action=="delete_user"){
		delete_user(mse("id"));
		return;
	}
	// checks which restriction has deleting user; now returns arr of groups where it partic
	if($action=="check_user_delete"){
		$email = db\select_field("users", "email", "id=".mse("id"));
		$groups = db\select_field_to_array("groups", "name", db\in_list("email", $email) );
		echo json_encode( array("groups" => $groups) );
		return;
	}
	if($action=="send_credentials"){
		send_credentials(mse("id"));
		return;
	}

	// -------------------- SHOP --------------------------

	// CRUD SHOP 

	// DEF EDIT_SHOP stuff to add/edit shop
	if($action=="shop_edit_dialog"){
		$new_shop = get_new_shop_fields( 
			db\select_id_field_to_array("groups", "id", "name", "user_role='LOCAL_VISUAL'", "name"),
			db\select_id_field_to_array("groups", "id", "name", "user_role='PRODUCTION'", "name")
		);
		$id = gde("id");
		$val = null;
		if($id){
			$rec = db\select_record("shops", "*", "id=$id");
			$val = array(); foreach($rec as $fn=>$fv) $val[]=array("id"=>"ns_$fn", "default"=>$fv);
		}
		echo render_search_form($new_shop, $val, "plain");
		return;
	}
	if($action=="locations"){
		echo json_encode( array("area" => 	db\select_field_to_array("shops", "distinct area x", "area is not null", "x"),
								"country" => 	db\select_field_to_array("shops", "distinct country x", "country is not null", "x"),
								"city" => 	db\select_field_to_array("shops", "distinct city x", "city is not null", "x")
							) );
		return;
	}

	// MD_LOCS
	if($action=="show_edit_shop"){
		$table = "locations_files";
		$id = gde("id"); // if id = 0 => create new; else - edit exiting
		//$client_id = gde("client_id", get_client_id());   determined by path
		$shop = array();
		if($id)
			$shop = db\select_record($table, "*", "id=$id");
		$values = kv_to_fide($shop, "ns");
		echo render_search_form($x=get_new_shop_fields(), $values, "plain");
		return;
	}
	if($action=="save_shop"){
		$table = "locations_files";
		$id = mse("id");
		$table_def = array(); // array("camp_id" => array("type" => "number"), "shop_id" => array("type" => "number"));
		$fields = json_decode( mse("fields"), true );
		$fields["client_id"] = get_client_id();
		if($id){
			$name = db\escape2($fields["name"]);
			$path = db\escape2(db\select_field("locations", "path", "id=$id") );
			if( db\exists("locations", "name='$name' and path='$path' and id<>$id") ) // TODO: maybe check if same path
				throw new user_exception('$file_already_exists$'); // no db changes made in this case
			db\execute("update $table set ".db\compile_update($fields, $table_def)." where id='$id'"); 
		}else{
			$fields["path_id"] = get_path_id('locations_paths', $fields["path"]);
			unset($fields["path"]);
			db\execute("insert into $table ".db\compile_insert($fields, $table_def));
		}
		echo $id;
		return;
	}
	if($action=="shop_delete"){
		$id = mse("id");
		db\execute("delete from locations_files where id='$id'"); 
		db\execute("delete from lbc where shop_id='$id'"); 
		// lbs are deleted in DELBS
		return;
	}
	// DOO
	// DEF NUST Not Used in STampa (no shops page)
	if($action=="find_shop_order"){
		$order = db\select_record("v_orders", "id, camp_name", "shop_id=".gde("id"));
		if($order) echo json_encode($order);
		return;
	}
	// on try img del from camp: check if some orders with this img exist
	if($action=="find_img_order"){
		$orders = db\select_field_to_array("v_orders", "id", "shop_id in (select shop_id from v_lbs where img_id=".gde("id").")");
		echo json_encode($orders);
		return;
	}

	if($action=="get_table_fields"){
		set_table_fields(gde("table"), gde("alias"), $search_fields, $list_fields);
		//$fields = array("list" => array_keys($list_fields), "search" => render_search_form($search_fields) );
		$fields = array("list" => $list_fields, "search" => render_search_form($search_fields) );
		echo json_encode($fields);
		return;
	}
	if( $action=='create_shop_camp_view'){
		echo create_shop_camp_view(mse("camp_id"));
		return;
	}

	// APPROVES DEF APAP

	if($action=="get_img_list"){
		$camp_id = mse("camp_id");
		$imgs = db\select_to_array("files", "id,path,name,priority,category", "path like '%/$camp_id/'", "priority desc,name");
		array_unshift($imgs, db\select_record("files", "id,path,name,0 as priority, 'noimage' as category", "id=0")); // DEF NOIMAGE - indicate that img not changes in an order; TODO: show prev images instead
		$res = "";
		foreach($imgs as $img){
			$img["url"] = get_files_path().$img["path"].get_file_thumb_path($img["id"], $img["name"]);
			$img["pri_img"] = str_repeat("<i class='cursor-pointer fas fa-star'></i>", $img["priority"]);
			$res .= lpp_html(replace_keys(file_get_contents(template_path."image"), $img, 3));
		}
		echo $res;
		return;
	}
	if($action=="set_image_priority"){
		db\execute("update files set priority=".mse("priority")." where id = ".mse("id"));
		return;
	}
	if($action=="set_image_category"){
		db\execute("update files set category='".mse("category")."' where id = ".mse("id"));
		echo mse("category"); // if ok - return new val
		return;
	}

	// -------------------- LB LBC ------------------------------
	// create / edit lbc
	if($action=="lb_save"){
		$lb = json_decode(mse("data"), true);
		$id = $lb["id"];
		if($id)
			lb_update($lb, $id);
		else
			$id = lb_create($lb);
		return;
	}
	if( $action=='lb_delete'){
		lb_remove( mse("id") );
		return;
	}
	if($action=="get_shop_lbc"){
		echo json_encode( lb_get_shop(mse("cond")) );
		return;
	}
	if($action=="get_cont_childs"){
		echo json_encode( lb_get_childs(mse("id")) );
		return;
	}
	if($action=="lb_join"){
		lb_join(mse("lb1_id"), mse("lb2_id"), mse("isvert"));
		return;
	}

	if($action=="lbs_create"){
		lbs_create( mse("data") );
		return;
	}
	if($action=="lbs_update"){
		lbs_update_image(mse("id"), mse("img_id") );
		return;
	}
	if($action=="get_lbs"){
		echo json_encode( lbs_get_lb(mse("lb_id"), mse("order_id") ) );
		return;
	}
	if( $action=='lbs_delete'){
		lbs_remove(mse("id"));
		return;
	}

	if($action=="lbs_conf_img"){
		$id = mse("id");
		$img = db\select_record("app_lbs", "width,height,lbs_width,lbs_height,lbi_left,lbi_top,lbi_scale,path,name_mini", "id=$id");
		$img["url"] = get_files_path().$img["path"].$img["name_mini"];
		echo json_encode($img);
		return;
	}
	if($action=="lbi_save"){
		$id=mse("id");
		$left=mse("left");
		$top=mse("top");
		$scale=mse("scale");
		db\execute("update lbs set lbi_left=$left, lbi_top=$top, lbi_scale=$scale where id = $id");
		// create preview
		$lbs = db\select_record("lbs", "t,l,r,b,img_id,order_id", "id=$id");
		$img = db\select_record("lowres", "path,name", "id=".$lbs["img_id"]);
		$w = $lbs["r"] - $lbs["l"] + 1;
		$h = $lbs["b"] - $lbs["t"] + 1;
		$img_path = proj_path."clients/".$img["path"].$img["name"];
		// DEF CROP: using configed image instead of mini; create the jpg representing cropped version; made on base of the mini and has similar size
		$crop_path = proj_path.proj_path_rel_client.get_lbs_path($id); // proj_path."clients/YSL/orders/".$lbs["order_id"]."/$id";
		if(!is_dir($crop_path))
			mkdir($crop_path, dir_perm, true);
		$ap = proj_path."contr/crop.jar";
		exec_log("java -jar $ap \"$img_path\" $w $h $left $top $scale \"$crop_path/crop.jpg\"");
		// create preview preview.jpg
		inbox_img($crop_path."crop.jpg", 200, 200, $crop_path."preview.jpg", $resize_if_smaller=true);
		return;
	}
	if($action=="lb_set_text"){
		$lb_text = db\escape2(mse("lb_text"));
		$id = mse("id");
		db\execute("update lbc set lb_text = '$lb_text' where id = $id");
		return;
	}
	// INUP
	if($action=="lbs_get_text"){
		$lbs_id = mse("id");
		$lb_id = db\select_field("lbs", "lb_id", "id=$lbs_id");
		echo db\select_field("lbc", "lb_text", "id=$lb_id");
		return;
	}

	// SEL_CITY cities 
	if($action=="show_shops"){
		$cond= gde("cond");
		//$group_id=mse("group_id"); $role=mse("group_role"); $field = $role=="LOCAL_VISUAL"? "visual" : "production"; $cond="$field=0 or $field=$group_id";
		$cs = db\select_to_array("locations","*",$cond,"path");
		$cst = explode_tree_id($cs, false); // utils.php
		$csd = array("files" => $cs);
		show_tree_id($cst, $csd, $show_files=true, $show_root=false);
		return;
	}
		
	// -------------------- CAMPAIGN CAMP --------------------------

	// CRUD SHOP 
	// DEF EDIT_SHOP stuff to add/edit camp
	if($action=="show_edit_camp"){
		global $new_camp;
		$id = gde("id");
		$val = null;
		if($id){
			$rec= db\select_record("camps", "*", "id=$id");
			$val = array(); foreach($rec as $fn=>$fv) $val[]=array("id"=>"nc_$fn", "default"=>$fv);
		}
		echo render_search_form($new_camp, $val, "plain");
		return;
	}
	if($action=="save_camp"){
		$id = mse("id");
		$camps_table = array( "name" => array("length" => 50, "can_truncate"=>1) );
		$fields = json_decode( mse("fields"), true );
		global $new_camp;
		correct_date($fields, $new_camp);
		//log\info($fields);
		if($fields["path"])
			get_path_id('lowres_paths', $fields["path"]); // create path
		if($id){
			db\execute("update camps set ".db\compile_update($fields, $camps_table)." where id='$id'"); 
		}else{
			$fields["prev_camps"] = join(";", db\select_field_to_array("camps", "id", "client_id=".$fields["client_id"], "date_from asc, id asc", "", 3)); // IPC
			db\execute("insert into camps ".db\compile_insert($fields, $camps_table));
			$id = db\get_last_id();
		}
		echo $id;
		return;
	}
	// returns kv list of prev camp names n -> name, where n: [1;<3], 1st = latest camp (corresponds to id_img1...); the shown set of lbs should have same camp, naturally
	if($action=="get_prev_camp_names"){
		$id = mse("id");
		echo json_encode(get_prev_camp_names($id));
		return;
	}
	if($action=="set_camp_path"){
		db\execute("update camps set path = '".db\escape2(mse("path"))."' where id=".mse("id"));
		return;
	}
	// when all subjects are added - admin opens camp;
	if($action=="open_camp"){
		/*// COCS create orders on camp start EVITE
		log\info("creating orders...");
		$shops = db\select_field("camps", "countries", "id=$camp_id");
		$shops = preg_split("/;/", $shops, -1, PREG_SPLIT_NO_EMPTY);
		$client_id = get_client_id();
		foreach($shops as $shop_id){
			create_order( ["client_id" => $client_id, "camp_id" => $camp_id, "shop_id" => $shop_id] );
		}*/
		open_camp($camp_id=mse("id"));
		return;
	}
	if($action=="close_camp"){
		close_camp(mse("id"));
		return;
	}
	if($action=="delete_camp"){
		$id = mse("id");
		if(!db\exists("camps", "id=$id AND camp_state='draft'")) return; // TODO: throw
		db\execute("delete from camps where id='$id'"); 
		return;
	}
	if($action=="get_all_camp_fields"){
		echo json_encode(array_keys($camp_list_fields));
		return;
	}

	if($action=="get_camp_subs"){
		$id = mse("id");
		$files = array();
		$hr="";
		$files = db\select_to_array("files f", "path,name,id,category,priority,(select count(*) from lbs where lbs.img_id=f.id) usg", "path like 'campaigns/$id/%'"); // DEF USG show img usage
		foreach($files as &$file) $file["src"] = get_files_path().$file["path"].$file["name"];
		echo json_encode($files);
		return;
	}

	if($action=="delete_camp_sub"){
		db\execute("delete from files where id = ".mse("id"));
		db\execute("delete from lbs where img_id = ".mse("id"));
		return;
	}

	if($action=="get_camps_cb"){
		/*$role = ur_get_user_role["role"];
		if( is_group_role( $role ) )
			$camps = array_filter( $camps, function($camp){ return sizeof(array_intersect( preg_split("/;/", $camp["cities"]), $role["shops"] )); } );*/
		$cs = gde("state", "");
		$client_id = gde("client_id", get_client_id()); // if used by worker (lbs.php) need pass client id manually
		$camps = db\select_id_field_to_array("camps", "id", "name", [$cs? "camp_state='$cs'":"", "client_id=$client_id"], "date_from");
		if($camps){
			//$camps[0] = ""; // no camp
			echo  "<select id='mi_camp'>".render_select_opts($camps, array_key_last($camps) )."</select>";
		}
		return;
	}
	if($action=="get_camp_path"){ echo db\select_field("camps", "path", "id=".mse("id")); return; }
	// TODO: instead list of ids - save camp shops as paths/ids (as was in groups)
	if($action=="get_camp_shops"){
		$shops = get_camp_shops( mse("id") );
		echo sizeof($shops)? join(",", $shops) : "";
		return;
	}

	if($action=="get_last_opened_camp"){
		echo db\select_field("camps","max(id)","camp_state='opened' AND client_id=".mse("client_id"));
		return;
	}

	if($action=="get_shop_maps"){
		echo json_encode(db\select_to_array("shops_maps", "name,path,thumb_small,thumb_medium,id", "shop_id=".mse("id")));
		return;
	}
	if($action=="get_order_atts"){
		$id = mse("id");
		$files = db\select_to_array("order_atts", "name,id", "order_id=$id");
		foreach($files as &$file) $file["src"] = get_files_path()."maps/".$file["name"];
		echo json_encode($files);
		return;
	}

	if($action=="delete_shop_map"){
		db\execute("delete from shops_maps where id = ".mse("id"));
		return;
	}

	// -------------- ORDERS ------------------
	if($action=="show_edit_order"){
		$id = gde("id"); // if id = 0 => create new; else - edit exiting
		$client_id = gde("client_id", get_client_id());
		$curr_path = gde("path"); // to filter shown shops by selected dir
		$order = array();
		if($id)
			$order = db\select_record("orders", "*", "id=$id");
		if(!$id && ($shop_id = gde("shop_id")))
			$order["shop_id"] = $shop_id;
		$values = kv_to_fide($order, "no");
		$cond=[];
		if($curr_path) $cond[]= "path like '".db\escape($curr_path)."%'" ;
		$role_shops = ur_get_user_role()["shops"];
		if(sizeof($role_shops)) $cond[]= db\id_in($role_shops);
		$shops = db\select_id_field_to_array("locations", "id", "name", $cond, "name");
		echo render_search_form($x=get_new_order_fields(get_order_md ($client_id), $shops), $values, "plain");
		return;
	}
	// TODO: not used in stampa
	if($action=="order_create"){
		echo create_order(json_decode( mse("fields"), true ), $user_id);
		return;
	}
	// ----------------------------- REVISIONS ----------------------------------
	// request revise single order
	if($action=="request_revise"){
		echo request_revise_event(mse("id"));
		return;
	}
	// request revise several orders TODO: event not sent; or use request_revise_event or, better, send sigle mail for all orders
	if($action=="request_revise_orders"){
		$orders = json_decode(mse("orders"),true);
		$camp_id = gde("camp_id", "0");
		set_orders_state($orders, "revise", "orders ready for confirmation", $camp_id);
		$group_id = get_curr_role_user_id();
		foreach($orders as $id){
			request_revise($id); // TODO 1: where is mail?
		}
		return;
	}
	// make revise, single order
	if($action=="revise_order"){
		$event_id = revise_order_event(mse("id"), get_curr_role_user_id(), mse("res")=="1"?"confirmed":"rejected", json_decode(mse("msg")), gde("lbs_id") );
		echo $event_id;
		return;
	}
	// make revise, many orders (only confirm, can't declined many orders at a time)
	if($action=="confirm_orders"){
		$orders = json_decode(mse("orders"),true);
		$camp_id = gde("camp_id", "0");
		set_orders_state($orders, "confirmed", "orders confirmed", $camp_id);
		$group_id = get_curr_role_user_id();
		foreach($orders as $id){
			revise_order($id, $group_id, "confirmed");
		}
		return;
	}


	//			 revisions infos
	// get revisions infos for given orders (if an order is confirmed or rejected 
	// no matter by which group // 17.04.2024: seems this is wrong, the check is made only for curr group
	if($action=="get_orders_revise_state"){
		$ids = mse("ids"); // list of orders
		$group_id = get_curr_role_user_id();
		$stage = mse("stage"); // 1/2 pre/post prod approve
		db\execute("select ord.id, if(exists(select 1 from revisions where order_id=ord.id and group_id=$group_id and res='confirmed' and stage='$stage'),1,0) confirmed, if(exists(select 1 from revisions where order_id=ord.id and group_id=$group_id and res='rejected' and stage='$stage'),1,0) rejected from orders ord where ".db\id_in($ids) );
		echo json_encode( array_kv_to_id(db\response_to_array()) );
		return;
	}
	// get revisions infos for the given order (list of all group that made a rev)
	if($action=="get_order_revise_details"){
		$order_id = mse("order_id");
		$client_id = mse("client_id");
		$stage = mse("stage"); // 1/2 pre/post prod approve
		$revs = db\select_to_array("v_revisions", "group_name, res, notes, lbs_id, lbs_name", "order_id=$order_id AND stage=$stage", "id");
		// DONE: maybe add next aprover with res = '' which will result in js in 'next is waiting'
		$next_app = get_next_approver($order_id, $stage);
		if($next_app){
			if($next_app=="LOCAL"){
				$shop_id = db\select_field("orders", "shop_id", "id=$order_id");
				$group_id = db\select_field("locations", "visual_id", "id=$shop_id");
				$next_app.= "(".db\select_field("groups", "name", "id=$group_id").")";
			}
			$revs[]= ["group_name" => $next_app, "res" => "", "notes" => ""];
		}
		echo json_encode($revs);
		return;
	}
	// MUSA
	if($action=="is_next_approver"){
		echo is_next_approver(gde("role",ur_get_name()) , mse("order_id"), mse("stage") )? "1" : "0";
		return;
	}

	//
	if($action=="send_order"){
		$event_id = send_order(mse("id"), $user_id);
		$new_state = get_osc("sent");
		db\execute("update orders set order_state_code = '$new_state' where id = ".mse("id"));
		echo $event_id;
		return;
	}
	// EVITE INUP
	if($action=="redo_lbs"){
		$lbs_id = mse("id");
		db\execute("update lbs set app_statei=4096 where id = $lbs_id");
		$lb_id = db\select_field("lbs", "lb_id", "id = $lbs_id");
		db\execute("update lbc set lb_text = '".db\escape2(mse("lb_text"))."' where id=$lb_id");
		$order_id = db\select_field("lbs", "order_id", "id=$lbs_id");
		send_order($order_id, $user_id);
		return;
	}
	if($action=="clone_order"){
		$order_id = mse("id");
		$order = db\select_record("orders", "camp_id, client_id, shop_id", "id=$order_id");
		$order["notes"] = "Order $order_id clone";
		create_order( $order );
		return;
	}
		
	// temp
	if($action=="save_order"){
		$table = "orders";
		$id = mse("id");
		$table_def = array("camp_id" => array("type" => "number"), "shop_id" => array("type" => "number"));
		$fields = json_decode( mse("fields"), true );
		$fields["order_state_code"] = get_osc("draft"); // TODO: also check if can edit TODO 1: also put in draft if some LBs changed
		if(!$fields["camp_id"]) $fields["camp_id"] = "0";
		if(!$fields["shop_id"]) $fields["shop_id"] = "0"; // no location order
		if($id){
			update_order($id, $fields);
		}else{
			create_order($fields);
		}
		echo $id;
		return;
	}
	if($action=="order_delete"){
		delete_order_email( mse("id") ); // this is called normally by a visual, so need email
		return;
	}
	if($action=="delete_orders"){
		$ids = json_decode( mse("ids"), true);
		foreach($ids as $id){
			log\info("deleting order $id");
			order_delete($id);
		}
		return;
	}
	if($action=="get_lbs_state"){
		echo json_encode( db\select_record("app_lbs", "app_state, app_id", "id=".mse("id")) );
		return;
	}
	if($action=="get_order_rec"){
		echo json_encode( db\select_record("v_orders", "*", "id=".mse("id")) ); // OS1
		return;
	}
	// input: js passes 2 lists: lists of apps (ids) and list of ordrs (ids_ords); output: single array which contains input apps and added apps from input ords
	function get_app_ids(){
		if( gde("id") ){
			$rev_id = gde("id");
			$app_id = db\select_field("approves_versions", "lbs_id", "rev_id=$rev_id");
			$ids = array($app_id);
		}else if( $app_id=gde("app_id") )
			$ids = array( $app_id );
		else
			$ids = json_decode( mse("ids") );
		//
		if( gde("ids_ords") && sizeof($ids_ords = json_decode( gde("ids_ords") ) ) )
			$ids = array_merge($ids, db\select_field_to_array("app_lbs", "id", db\id_in($ids_ords, "", "order_id")));
		return $ids;
	}	
	if($action=="accept_lbs"){
		if(sizeof($ids = get_app_ids()))
			db\execute("update app_lbs set app_statei=".get_osc("accepted")." where app_state='draft' and ".db\id_in($ids));
		return;
	}
	if($action=="approve"){ // ex approve_lbs TODO: Need mail and params?
		$res = [];
		foreach(get_app_ids() as $lbs_id){
			//$event_id = set_lbs_state_event($lbs_id, "approved", lp("lb_approved"), $notes=gde("message"));    // normal YSL version ; yet need it to control in apap.php app/rej btns 
			$order_id = db\select_field("lbs", "order_id", "id=$lbs_id");
			$event_id = revise_order_event($order_id, get_curr_role_user_id(), "confirmed", json_decode(mse("message")), $lbs_id, $stage=2 );
			if($event_id) $res[]= $event_id;
		}
		echo join(";", $res);
		return;
	}
	if($action=="reject"){ // ex reject_lbs 
		$rev_id = mse("id");
		$msg = gde("message");
		// echo reject_lbs(mse("id"), mse("receivers"), gde("subject"), gde("message"));   // normal YSL version ; yet need it to control in apap.php app/rej btns 
		$lbs_id = db\select_field("approves_versions", "lbs_id", "rev_id=$rev_id");
		$order_id = db\select_field("lbs", "order_id", "id=$lbs_id");
		echo revise_order_event($order_id, get_curr_role_user_id(), "rejected", json_decode($msg), $lbs_id/*not used now*/, $stage=2 );
		return;
	}
	if($action=="app_notice"){
		notify_lbs(mse("app_id"), mse("subject"), mse("message"));
		return;
	}
	/* TODO: not used int stampa ; happens when prod-int downloads lbs; that means that lbs gets state 'printed'
	if($action=="print_lbs"){ 
		print_lbs(mse("id"));
		return;
	}*/
	if($action=="get_path_shops"){
		echo join(",", db\select_field_to_array("locations", "id", "path like '".db\escape2(mse("path"))."%'"));
		return;
	}


	// ---------------- GROUPS -------------------------
	if($action=="segr_get_all_users"){
		$where = "client_id=".get_client_id(); // WOC
		echo json_encode( db\select_field_to_array("users_users", "email", $where, "email") );
		return;
	}
	// USR NOTE: this code must be before other group crud actions	if($action=="segr_save" || $action=="segr_remove"){	set_flag("update_shop_roles");	}   NOT USED IN SHOP_SINGLE_GROUP version
	//   /USR
	if($action=="segr_save"){
		$id = gde("id"); $fields = json_decode(mse("fields"), true); // email/name
		$client_id = get_client_id();
		$defs = [ "worker" => ["type" => "number"] ];
		if(db\exists("users", "name='".$fields["name"]."' and id<>$id and $client_id=client_id")) throw new user_exception('$group$ $name_exists$');
		if($id)
			db\execute("update groups set ".db\compile_update($fields, $defs)." where id='$id'"); 
		else{
			$fields["user_type"] = "group";
			$fields["client_id"] = $client_id; // WOC
			$fields["worker"] = is_worker();
			db\execute("insert into groups ".db\compile_insert($fields, $defs));
			$id = db\get_last_id();
		}
		echo $id;
		return;
	}
	if($action=="segr_remove"){
		$id = mse("id");
		reset_user_shops($id);
		db\execute("delete from groups where id=$id");
		return;
	}
	if($action=="read_group"){
		echo json_encode( db\select_record("groups", "*", "id=".mse("id")) );
		return;
	}

	// PREVIEW of lbs
	if($action=="get_img_url"){
		echo get_img_url(mse("id"));
		return;
	}
	if($action=="rename_hires"){
		$id = mse("id");
		$name_new = mse("new_name") ;
		if( db\exists("hires", "id<>$id and name='".db\escape2($name_new)."'") )
			throw new user_exception('$file_already_exists$');
		// actual move
		$file = db\select_record("hires", "path,name", "id=$id"); // remember for the mv cmd
		$path = get_source_path().hires_path_rel;
		$name_old = $file["name"];
		exec_cmd("mv", $path.$name_old, $path.$name_new) ;
		db\execute("update hires set name = '$name_new' where id = $id"); // TODO: check user_dir, move to model
		return;
	}
	// TODO: use same func for all table dels
	if($action=="delete_locations"){
		$files = json_decode(mse("files"));
		$paths = json_decode(mse("paths"));
		//$files = tt_find_selection($start_dir="", json_decode(mse("paths"), true), json_decode(mse("files"), true), "id, path, name" );
		$summary = gde( 'summary' , 1);
		if(!sizeof($files))
			throw new user_exception('$no_file_sel$');
		if($summary)
			echo sizeof($files);
		else{
			foreach($files as $id){
				db\execute("delete from locations_files where id = $id");
				// TODO: delete related stuff; exec_cmd("rm", get_source_path().hires_path_rel.$file["path"].$file["name"]) ;
			}
			foreach($paths as $path){
				db\execute("delete from locations_files where path like '".db\escape($path)."'");
				db\execute("delete from locations_paths where path like '".db\escape($path)."'");
			}
		}
		return;
	}



	// IMG_USAGE TODO in stampa
	if($action=="img_usage"){
		echo json_encode( db\select_to_array("v_lbs", "img_id, count(*) img_count", "camp_id=".mse("camp_id")." and shop_id=".mse("shop_id"), "", "img_id" ) );
		return;
	}

	if($action=="get_event_users"){
		echo json_encode( db\select_field_to_array("v_event_users", "concat(dest_group_role,': ',dest_group) x", "event_id=".mse("event_id"), 'x') );
		return;
	}
	// TODO: quickfix: DEF USER_LINK: links to pages are in event_users; shown is events; can't find way to show link as a field of events (need find the rec corresp to curr user); so decided to use this cb
	if($action=="get_event_links"){
		$ids = json_decode(mse("ids"), true); // ids of events
		$links = array();
		if(sizeof($ids))
			$links = db\select_id_field_to_array("event_users", "event_id", "order_link", db\id_in($ids, "dummy", "event_id")." and dest_group_id=".mse("role_id"));
		echo json_encode($links);
		return;
	}

	function print_camp_stats($camp_id, $camp_name){
		$ch = "";
		$stats = print_user_stats($camp_id);
		if(!$stats) return ""; // TEMP now happens
		$ref = $stats["page_link"];
		$ch .= "<tr> <th class='mc_us_camp'><a href='$ref'>".$camp_name."</a></th></tr>\n";
		foreach( $stats["stats"] as $stat)
			$ch.= "<tr> <td class='mc_us_sd'>".$stat[0].": <a href='".$stat[2]."'>".$stat[1]."</a></td></tr>\n";
		return "<table class='mc_us_cc'>$ch</table>";
	}
	if($action=="stats"){
		$camps = db\select_to_array("camps", "id,name", "camp_state='opened'");
		$res = "";
		foreach($camps as $camp)
			$res .= print_camp_stats($camp["id"], $camp["name"]);
		$res .= print_camp_stats(0, "orders");
		echo "<div class='mc_page_head mc_us_div'>$res</div>";
		return;
	}
	if($action=="get_logged_users"){
		exec_log("sudo /usr/bin/php ".proj_path."contr/lu.php ".get_portal_name(), $o, $r) ;
		//log\debug($o);
		$un = array(); foreach(preg_split("/,/", $o[0], -1, PREG_SPLIT_NO_EMPTY) as $u) $un[]=db\select_field("users", "name", "id=$u"); sort($un);
		$ch = "<tr> <th class='mc_us_camp'>".lp("users")."</th></tr>\n";
		foreach( $un as $user)
			$ch.= "<tr> <td class='mc_us_sd'>$user</td></tr>\n";
		echo "<table class='mc_us_lu'>$ch</table>";
		return;
	}

	// SETTINGS CONTR
	if( $action=='save_user_settings'){
		$sj = mse("settings");
		$settings = json_decode($sj, $convert_to_array=true);
		save_user_settings($user_id, $settings);
		return; 
	}

	if($action=="read_user_settings"){
		$email = mse("email");
		if( $uid = find_email_id($email) )
			echo json_encode( read_user_settings($uid) );
		return;
	}
		
	if($action=="change_user_pass"){
		$params = mse("params");
		$params = json_decode($params, $convert_to_array=true);
		$old = $params["passold"];
		$new = $params["passnew"];
		$old_db = db\select_record("users", "pass", "id=$user_id");
		if($old!=$old_db["pass"])	
			throw new Exception("wrong old password!");
		db\execute("update users set pass='$new' where id = $user_id");
		echo "OK!";
		return;
	}
	// CHANGE_ROLE
	if($action=="ur_get_user_roles"){
		$roles = array();
		foreach( $_SESSION["roles"] as $role)
			$roles[]= $role["role"];
		echo json_encode($roles);
		return;
	}
	if($action=="ur_change_role"){
		try_set_user_role(get_curr_user_id(), mse("role"));
		return;
	}

	///
    // RENAME NOTE: files/folders are also renamed physically, also if is on a mirror; may happen that file is both in archive and mirror; this causes mirror files invalid; 
    // when renamed files will become old and will be deleted from archive , they should already be on mirror (copied again); the only problem is that TODO: need either clean sometimes mirror or delet
    if($action=="rename_file"){
        $id = mse("element");
        $name_new = mse("new_name") ;
		$table = mse("table");
        if( db\exists($table, "id<>$id and name='".db\escape2($name_new)."' and path=(select path from files where id=$id)") )
            throw new user_exception('$file_already_exists$');
        /*// actual move
        $file = db\select_record($table, "path,name", "id=$id"); // remember for the mv cmd
        $source_paths = trar_all_paths($file["path"].$file["name"]);  // find where exists; TODO: throws
        foreach($source_paths as $source_path){
            $path = $source_path.$file["path"];
            $name_old = $file["name"];
            exec_cmd("mv", $path.$name_old, $path.$name_new) ;
        }*/
        // db (alternatively - can just scan again (but need add md5 control to detect move (instead new))
        db\execute("update $table set name = '$name_new' where id = $id"); // TODO: check user_dir, move to model
        return;
    }   
    if($action=="rename_dir"){
		$table = mse("table");
        $user_dir = gde("user_dir"); // dir of ws TODO: check rights
        $path_old = $user_dir.mse("element"); // old internal path+name
        $name_new = mse("new_name"); // only last segm of new path
        $path_new = dirname($path_old).'/'.$name_new; // new internal path+name
		// TODO: maybe tt should add "_paths" in case if use paths=1
        if(! db\rename_dir($table."_paths", "path", $path_old, $name_new, $check_exist=true)) // NOTE: if use_paths $table is a view, but in mysql it works anyway
            throw new user_exception('$file_already_exists$'); // no db changes made in this case
        /*$source_paths = trar_all_paths($path_old);
        foreach($source_paths as $source_path)
            exec_cmd("mv", $source_path.$path_old, $source_path.$path_new) ;*/
        return;
    }   

    //  
    if( $action=='move_files'){
        $files_json = mse("files");
        $files = json_decode($files_json, $convert_to_array=true);
        $folder = gde/*mse*/("user_dir").gde("folder"); // with SEL_FOL_ROOT it may be empty
		$table = mse("table");
		$use_paths = gde("use_paths");
        // need really move them
        $paths = db\select_to_array($table, "path,name", db\id_in($files) );
        foreach($paths as $path_rec){
            $path_rel = $path_rec["path"].$path_rec["name"];
            $source_paths = trar_all_paths($path_rel);
            foreach($source_paths as $source_path){
                $path_to = $source_path.$folder; // full dest path
                if( !is_dir($path_to) )
                    exec_cmd("md", $path_to); // www-data can't create dir, so use this (need rec in sudoers: www-data ALL=(ALL:ALL) NOPASSWD:/usr/bin/php md.php * )
                exec_cmd("mv", $source_path.$path_rel, $path_to);   
            }   
        }   
        // move in db TODO: or just rescan.. but with removing not ex.
		if($use_paths)
			db\execute("update $table"."_files set path_id = ".get_path_id($table.'_paths', $folder)." where ".db\id_in($files)); // NOTE: empty dirs not deleted from paths table automatically
		else
			db\execute("update $table set path = '".db\escape($folder)."' where ".db\id_in($files));
			
        return;
    }   
	//
    if( $action=='move_folder'){
		$user_dir = gde("user_dir");
        $path_old = $user_dir.json_decode(mse("path_old"));
        $path_new = $user_dir.json_decode(mse("path_new"));
		$table = mse("table");
		// $use_paths = gde("use_paths");   only if == true
        // need really move them
		//exec_cmd("mv", rtrim(get_source_path().$path_old, "/"), get_source_path().$path_new); no need to move; locations files are in ../<loc_id> dirs
		db\move_dir($table."_paths", "path",  $path_old, $path_new);
        return;
    }   
	//
	if($action=="create_path"){
		$path = db\escape2(mse("path"));
		$name = db\escape2(mse("name"));
		$pn = $path.$name.'/';
        if( db\exists("locations_paths", "path='$pn'") )
            throw new user_exception('$file_already_exists$'); // no db changes made in this case
		db\execute("insert into locations_paths(path) values('$pn')");
		return;
	}
	if($action=="create_shop"){
		$path = db\escape2(mse("path"));
		$name = db\escape2(mse("name"));
        if( db\exists("locations", "name='$name' and path='$path'") ) // TODO: this seems wrong; paths will contain path, not path+name
            throw new user_exception('$file_already_exists$'); // no db changes made in this case
		$path_id = get_path_id("locations_paths", mse("path"));
		db\execute("insert into locations_files(path_id,name) values($path_id, '$name')");
		return;
	}
	if($action=="edit_shop"){ // dono if a duplicaton TODO
		$id = mse("id");
		$name = db\escape2(mse("name"));
        if( db\exists("locations", "name='$name' and id<>$id") )
            throw new user_exception('$file_already_exists$'); // no db changes made in this case
		db\execute("update locations_files set name = '$name' where id = $id");
		return;
	}
	if($action=="get_client_list"){
		echo "<select id='mi_clients'>".render_select_opts(db\select_id_field_to_array("clients", "id", "name"))."</select>";
		return;
	}

	// ORDERS
	if($action=="get_order_search_fields"){
		// requires tt/share/orders.php
		echo render_search_form( get_order_search_fields( get_order_md () , gde("all")?get_client_list():false) );  // functions of: utils/filter_fields.php, view/metadata.php, model/db.php
		return;
	}
	if($action=="get_order_list_fields"){
		echo json_encode(get_order_list_fields( get_order_md () , true));
		return;
	}

	// HIRES, FILES
	if($action=="create_folder"){
		$path = db\escape2(gde("path"));
		$name = db\escape2(mse("name"));
		$type = mse("type");
		if($type=="hires" || $type=="lowres"){
			$table = $type;
			$sp = source_path.get_client_code()."/$table/";
			if(!get_path_id($table."_paths", $path.$name))
				exec_cmd("md", $sp.$path.$name); // www-data can't create dir, so use this (need rec in sudoers: www-data ALL=(ALL:ALL) NOPASSWD:/usr/bin/php md.php * )
		}
		return;
	}
	if($action=="delete_files"){
		$files = json_decode(mse("files"));
		$paths = json_decode(mse("paths"));
		$table = mse("table");
		global $table_tree; $table_tree = $table; 
		//$all_files = tt_find_selection($start_dir=get_client_code().'/'.$table, json_decode(mse("paths"), true), json_decode(mse("files"), true), "id, path, name" ); // need just to count files
		$all_files = tt_find_selection($start_dir="", json_decode(mse("paths"), true), json_decode(mse("files"), true), "id, path, name" ); // need just to count files
		$summary = gde( 'summary' , 1);
		if(!sizeof($all_files))
			throw new user_exception('$no_file_sel$');
		if($summary){
			echo sizeof($all_files);
		}else{
			foreach($files as $id){
				db\execute("delete from $table"."_files where id = $id");
			}
			foreach($paths as $path){
				$paths_ids = db\select_field_to_array($table."_paths", "id", "path like '".db\escape($path)."%'");
				db\execute("delete from $table"."_files where ".db\id_in($paths_ids, "", "path_id"));
				db\execute("delete from $table"."_paths where ".db\id_in($paths_ids));
			}
		}
		return;
	}



	// ------- WORKLOG ---------
	if($action=="show_edit_todo"){
		$table = "issues_paths";
		$path = gde("path"); // if path empty => create new; else - edit exiting
		$values = null;
		if($path){
			$rec = db\select_record($table, "*", "path='$path'");
			$rec["name"] = mse("name");
			$values = kv_to_fide($rec, "nf");
		}
		echo render_search_form(get_new_todo_fields(), $values, "plain");
		return;
	}


	if($action=="save_todo"){
		$fields = json_decode(mse("fields"), true);
		$name_new = $fields["name"];
		$name_old = gde("name_old");
		$parent_path = gde("parent_path"); // but may be ""
		$path_old = $parent_path.$name_old.'/';
		$id = 0;
		if($name_old){ 
			$id = get_path_id("issues_paths", $path_old); // find path id if editing
			if(!db\rename_dir("issues_paths", "path", $path_old, $name_new, $check_exist=true))
				throw new user_exception("path already exists '$path_old$name_new'");
		}
		// TODO: if new - also need check if exists
		log\debug("Old id: $id");
		$fields["path"] = $parent_path.$name_new.'/'; // new path
		unset($fields["name"]);
		log\debug($fields);
		correct_date($fields, $x=get_new_todo_fields());
		$sr = new save_rec("issues_paths", $fields, $id);
		echo $sr->run();
		return;
	}
	if($action=="show_edit_done"){
		$table = "issues";
		$id = gde("id"); // if id = 0 => create new; else - edit exiting
		$values = $id? kv_to_fide(db\select_record($table, "*", "id=$id"), "nf") : null;
		echo render_search_form(get_new_done_fields(), $values, "plain");
		log\debug($values);
		return;
	}
	if($action=="save_done"){
		$id = gde("id");
		$fields = json_decode(mse("fields"), true);
		if(!$id) // TODO: better have path id in js
			$fields["path_id"] = get_path_id("issues_paths", $fields["path"]);
		unset($fields["path"]);
		$sr = new save_rec("issues_files", $fields, $id);
		echo $sr->run();
		return;
	}

	if($action=="rename_location"){
		db\execute("update locations set name = '".db\escape2(mse("name"))."' where id = ".mse("id"));
		return;
	}

	if($action=="get_app_notice_dest"){
		$users = find_event_users(get_app_client(mse("app_id")), is_worker()? "app_notice" : "app_client_notice"); 
		$emails = db\select_field_to_array("users", "email", db\id_in($users));
		echo join(";", $emails);
		return;
	}

	if($action=="get_path_locations"){
		$path = json_decode(mse("path"));
		echo json_encode( db\select_field_to_array("locations", "concat(path,name)", "path like '".db\escape2($path)."%'") );
		return;
	}
	if($action=="delete_path"){
		$path = json_decode(mse("path"));
		log\info("deleting path '$path' and all its contents");
		/*$id = db\select_field("locations_paths", "id", "path='".db\escape($path)."'");
		if(!$id)
			throw new user_exception("path not exists '$path'");*/
		db\execute("delete from locations_files where path_id in (select id from locations_paths where path like '".db\escape2($path)."%')");
		db\execute("delete from locations_paths where path like '".db\escape2($path)."%'");
		return;
	}

	if($action=="create_ws"){
		$order_id = mse("order_id");
		create_ws_event($order_id);
		return;
	}

	//CAORD
	if($action=="caord_create"){
		$locations = json_decode(mse("locations"), true);
		log\debug($locations);
		$root_dir = mse("root_dir");
		$camp_id = mse("camp_id");
		$client_id = get_client_id();
		global $table_tree; $table_tree = "locations";
		$shops_new  = tt_find_selection($root_dir, $locations["paths"], $locations["files"], "id");
		$shops_old = db\select_field_to_array("orders", "shop_id", "camp_id=$camp_id");
		$defs = db\select_id_field_to_array("md", "fname", "vdef", "client_id=$client_id AND table_name='orders' AND vdef<>'' AND vdef is not NULL");
		$fields = array_merge($defs, ["camp_id" => $camp_id, "client_id" => $client_id]);
		$noc = 0; // new ord cnt
		foreach($shops_new as $shop){
			$shop_id = $shop["id"];
			$fields["shop_id"] = $shop_id;
			if(!in_array($shop_id, $shops_old)){
				create_order($fields);
				$noc++;
			}
		}
		echo $noc;
		return;
	}
	// LBS LBS_PARAMS

	if($action=="get_order_path"){
		echo get_order_path(mse("order_id"), gde("client_code"));
		return;
	}
	// NOTE: not part of absolute path, but relative to proj_path
	if($action=="get_lbs_path"){
		echo get_lbs_path(mse("lbs_id"), gde("order_id"), gde("client_code"));
		return;
	}
	if($action=="get_clients_cb"){
		$clients = db\select_id_field_to_array("clients", "id", "name", null, "name");
		echo  "<select id='mi_client'>".render_select_opts($clients)."</select>";
		return;
	}
	if($action=="show_edit_lbs"){
		global $edit_lbs;
		$table = "lbs";
		$id = gde("id"); // if id = 0 => create new; else - edit exiting
		$values = kv_to_fide(db\select_record($table, "*", "id=$id"), "nf");
		//log\debug(  fdef_db_to_fd_all(get_md("lbs"))  );
		// TODO: ff_merge_values gets id in opts which = rec id, which is wrong, while is compared with field id (which is absent and need use field name, adde UFM)
		$defs = fdef_fd_to_fide_all( array_merge($edit_lbs, fdef_db_to_fd_all(get_md("lbs"))), "nf_", "N");
		echo render_search_form($defs, $values, "plain");
		return;
	}
	if($action=="save_lbs"){
		$id = gde("id");
		$fields = json_decode( mse("fields"), true );
		$lbs_table = array( "need_logo" => array("type" => "number"), "need_tag" => array("type" => "number") );
		db\execute("update lbs set ".db\compile_update($fields, $lbs_table)." where id='$id'"); 
		return;
	}
	if($action=="show_create_pack"){
		// TODO: this code duplicates partly that from set_table_fields
		$addrs = json_decode( mse("addrs") );
		$defs = get_pack_fields([], $addrs); // page passes all addrs in selection (should be single one)
		//$defs = array_merge($defs, fdef_db_to_fd_all(get_md("pack"))); // static def + courier
		$defs = fdef_fd_to_fide_all( $defs, "np_", "N");
		echo render_search_form($defs, null, "plain");
		return;
	}
	if($action=="show_send_pack"){
		$defs = get_pack_fields(); // page passes all addrs in selection (should be single one)
		$defs = array_merge(fdef_db_to_fd_all(get_md("packs")), $defs); // static def + courier
		log\debug(get_md("packs"));
		$defs = fdef_fd_to_fide_all( $defs, "np_", "P"); //
		echo render_search_form($defs, null, "plain");
		return;
	}
	if($action=="save_pack"){
		$client_id = mse("client_id");
		$rec = ["client_id" => $client_id, "delivery_address" => mse("addr")];
		$lbs = json_decode(mse("lbs"), true);
		db\execute("insert into packs ".db\compile_insert($rec));
		$pack_id =db\get_last_id();
		db\execute("update lbs set pack_id = $pack_id where pack_id=0 and ".db\id_in($lbs));
		foreach($lbs as $id)
			set_lbs_state("packed", $id);
		echo $pack_id;
		return;
	}
	if($action=="send_pack"){
		$id = mse("id");
		$table = "packs";
		$fields = json_decode( mse("fields"), true );
		$fields["sent"] = 1;
		$id = mse("id");
		db\execute("update $table set ".db\compile_update($fields)." where id='$id'"); 
		send_pack_event($id);
		return;
	}
	// IPC
	if($action=="get_imgs_thumbs"){
		$ids = json_decode(mse("ids"), true);
		$res = db\select_id_field_to_array("lowres", "id", "thumb_small", db\id_in($ids));
		echo json_encode($res);
		return;
	}

	// FIGU
	if($action=="figu"){
		$table = mse("table");
		$alias = gde("alias", $table); // eg may use view v_shop_camp_1 but want fields for "shops"; alias must be "shops"
		$where = gde("where"); // json packed k->v array
		$cond = gde('cond'); // it's here while many use it; where it's obligatory - must be duplicated with mse()
		$camp_id = mse("camp_id");
		set_table_fields($table, $alias, $search_fields, $list_fields);
		if($where){
			$where_arr = json_decode($where, true);
			$where = db\compile_where(  ff_add_values( $search_fields , $where_arr), ff_get_predicate($where_arr) ); // append values to ff arr
		}
		$where = array($where, $cond);
		if(!is_worker()) $where[]= "client_id=".get_client_id(); // WOC
		figu($camp_id, $where);
		return;
	}

	// for the give lbs_id returns the id of the rec (rev_id) of the most recent ver (also page 0, MPV)
	if($action=="get_rev_id"){ echo db\select_field("approves_versions", "rev_id", "version=0 AND page=0 AND lbs_id=".mse("id")); return; } // pn (page num) for MPV - sel 0 page

	// DEF SPE - user may req send events created during curr session on curr page
	if($action=="send_pending_events"){
		$pe = json_decode(mse("events"), true);
		send_pending_events($pe, $check_sessions=false);
		return;
	}
	// SHOC
	if($action=="shoc_set"){
		shoc_set(mse("id"));
		return;
	}
	// TRIPLE_LIST
	if($action=="get_triple_list"){
		$path = source_path.get_lbs_path( mse("id") );
		$files = find_triple_files($path);
		echo json_encode($files);
		return;
	}
	// used to del a lbs file (except pdf)
	if($action=="triple_list_delete"){
		$path = get_source_path().get_lbs_path( mse("id") );
		$name = json_decode(mse("name"));
		exec_cmd("rm", $path.$name);
		return;
	}

	if($action=="get_camp_shop_cat"){
		$shop_id = gde("shop_id");
		$camp_id = gde("camp_id");
		$cond = db\select_field("camp_shop_cat", "cond", "camp_id=$camp_id AND shop_id=$shop_id");
		echo $cond;
		return;
	}

	if($action=="set_camp_shop_cat"){
		$shop_id = gde("shop_id");
		$camp_id = gde("camp_id");
		$cond = gde("cond");
		db\execute("delete from camp_shop_cat where camp_id=$camp_id AND shop_id=$shop_id");
		db\execute("insert into camp_shop_cat ".db\compile_insert([ "camp_id" => $camp_id, "shop_id" => $shop_id, "cond" => $cond  ]));
		return;
	}


	// CAMP_CAT
	function get_camp_cats($path){
		$res = db\open_dir_db1($path, "lowres_paths", "lowres_paths", "", $cond='', $order='', $what='folders');
		return extract_array_key($res["folders"], "child");
	}
	if($action=="get_camp_cats"){
		$path = mse("path");
		echo json_encode( get_camp_cats($path) );
		return;
	}
	if($action=="new_camp_cat"){
		$path = db\escape2( mse("path") );
		if(!db\exists("lowres_paths", "path='$path'"))
			db\execute("insert into lowres_paths(path) values ('$path')");
		return;
	}
	if($action=="get_camp_texts"){
		$path = db\escape2( mse("path") ); // NOTE: path contains the category
		$pid = db\select_field("lowres_paths","id","path='$path'");
		$res = db\select_field_to_array("etexts", "etext", "path_id='$pid'");
		echo json_encode( $res );
		return;
	}
	if($action=="new_camp_text"){
		$path = db\escape2( mse("path") );
		$text = db\escape2( mse("text") );
		$pid = db\select_field("lowres_paths","id","path='$path'");
		db\execute("insert into etexts(path_id,etext) values ('$pid','$text')");
		return;
	}
	// TODO: old metho, rename
	if($action=="get_img_cat"){
		$defs = get_md("lowres_files", get_client_id() );
		// replace with actual cats
		$path = mse("path");
		$cc = get_camp_cats($path);
		$ai = &find_array_key_val($defs, "fname", "uf2");
		$ai["vlist"] = join(";", $cc);
		$defs = fdef_db_to_fd_all($defs);
		$defs = fdef_fd_to_fide_all( $defs, "sf_", "S" );
		echo render_search_form($defs, $values=null, "plain");
		return;
	}

	//
	if($action=="request_approve"){
		$lbs_id =mse("id");
		set_lbs_state_event($lbs_id, "uploaded", "Order uploaded");
	}

	//----------------------------------------------------------------------------------------------------
        // if here - some wrong action 
	throw new Exception("Wrong or empty action: $action");

} // end of while

}catch(user_exception $e){
	if($msg=$e->getMessage())
		log\error("user error: '$msg'");
	header($_SERVER['SERVER_PROTOCOL'].' 500 '.$e->getUserMessage(), true, 500);
}catch(Exception $e){
	$code = generate_random_string(4, "123456789"); // just a random code informed to used and written to log; thus user can identify to admin what to search in logs
	log\error("controller error $code; POST dump: ", array_to_str($_POST), $e->getTraceAsString() );
	register_error("Controller error $code: ".$e->getMessage(), "controller", "controller", el_higher);
	header($_SERVER['SERVER_PROTOCOL'].' 500 $unknown_error$ $code$: '.$code, true, 500);
	//return;
}
?>
