<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");
	require_once(proj_path."utils/view.php");


?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB */ ?>
	</head>
	<body style='background: url("img/bg_<?php echo get_portal_name(); ?>.jpeg") no-repeat center center fixed;'> 
		<!-- table_tree -->
		<script src="table_tree/js/table_tree.js"></script>
		<script src="js/sd.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen'> <!-- NOTE: without this cont appears another horiz scr bar -->
					</div>
				</div>
				<div class='lb_img_list_cont hidden mc_page_head mc_page_cont'>
					<div class='mc_page_head mc_mwd'>
						<?php echo render_radio_group( array( array("text" => "man", "value" => "man"), array("text" => "woman", "value" => "woman")  ), "man_woman"); ?>
					</div>  <!-- man/woman -->
					<div class='mc_page_head mc_nid'></div>  <!-- NOIMAGE -->
					<div class='lb_img_list_div mc_page_body'>
						<div style='width:100px!important;'></div> <!-- TINY_IMG this stuff used as quick fix: sometimes img div has w=15 -->
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<!-- Dialogs -->
		<div class='hidden'>
			<!-- DEF NEWLB newi/edit lightbox -->
			<div id="lb_new_lb" style='display: flex; flex-direction: row;'>
				<!-- LB  -->
				<div id = "lb_new_table" class='lb_lbc lb_lb' data-width='100' data-height='100'> </div>
				<!-- params -->
				<div id="lb_new_prm"> <!-- LB params -->
					<div><label>name</label></div>
					<div><input type='text' id='lb_new_name'> </div>
					<div><label>dimensions</label></div>
					<div><input type='text' id='lb_new_width' value="100">x<input type='text' id='lb_new_height' value="100"> </div>
					<div><label>container size</label></div>
				</div>
			</div>
		</div>
		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<!-- LB_RESIZE -->
			<div class='lb_resize_div hidden'></div>
			<div class='lb_resize_rect hidden'></div> 
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
			<div id='mi_dima' class='hidden' style='position:absolute;'></div> <!-- DIMA -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script type="text/javascript">

			// -------------------------------------------------------------------------------
			// --------------------------------- SHOPS ---------------------------------------
			// -------------------------------------------------------------------------------

			// DEF SHOPER_VIEW: personal view; for each camp is used its own view v_shop_camp_<id>; thus need re-init tablo on camp change
			function done_on_enter(id){
				if(is_admin) show_edit_done(id,"");
				else show_detail_click(id); // TODO: wassis?
			}
			function create_todo_dialog(parent_path){
				var ntd = $(call_php_sync("contr/main.php", {"action" : "show_edit_todo", tt_project: "issues"}, 'POST').resp_text); 
				show_select_string(function(){ return save_todo(ntd, parent_path); }, '', ntd, lp("create_todo"));
				ff_init(ntd);
			}
			function edit_todo_dialog(path){
				var name = extract_name(unpend_slash(path));
				var parent_path = extract_path(unpend_slash(path), true);
				var ntd = $(call_php_sync("contr/main.php", {"action" : "show_edit_todo", "path" : path, "name": name, tt_project: "issues"}, 'POST').resp_text); 
				show_select_string(function(){ return save_todo(ntd, parent_path, name); }, '', ntd, lp("edit_todo"));
				ff_init(ntd);
			}
			// NOTE: id not used, while tt identificates paths by path (there may be no paths table)
			// to distinguish new or not is used path
			function save_todo(panel, parent_path, name_old=""){
				var fields = ff_params(panel, true);
				cc("save_todo", function(){
					tt.refresh();
				}, {fields: JSON.stringify(fields), tt_project: "issues", parent_path: parent_path, name_old: name_old} );
			}

			// create/edit a done; if create - id = 0; if edit - path empty
			function show_edit_done(id, path){
				var ns = call_php_sync("contr/main.php", {"action" : "show_edit_done", "id" : id, tt_project: "issues"}, 'POST'); 
				var ef = $(ns.resp_text);
				ff_init(ef);
				//show_select_string(function(){ return save_done(id, ef, path); }, '', ef, lp("edit_done"));
				tt.get_preview_div().html("") ;
				tt.get_preview_div().append(ef);
				if(admin){
					var ok = $("<button>Ok</button>"); 
					ok.click( function(){ save_done(id, ef, path); } );
					tt.get_preview_div().append(ok);
				}
				tt.show_preview();
			}
			function on_rec_sel(rec){
				if( detail_shown() && get_detail_id()==rec.data("id") ) return; // avoid situ when user clicks det btn and detail msg overwritten with this msg
				show_img_usage( rec.data("id") );  // IMG_LIST IMG_USAGE
				puh("record_selected");
				set_rec_puh(rec);
			}
			// create/save done; for new one need parent path
			function save_done(id, panel, path){
				var fields = ff_params(panel, true);
				fields.path = path;
				cc("save_done", function(){
					tt.refresh();
				}, {id: id, fields: JSON.stringify(fields), tt_project: "issues"} );
			}
			function done_delete(id, name){
				if(!confirm(lpp("$Delete$ $done$ '$1'?", name))) return;
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "done_delete", id: id},
					"success": function(res, dummy, request){
						dones.clear();
						dones.show();
					}
				});
			}

			function on_show(){
				$("#table-"+alias_name).find(".td-"+alias_name+"-RES_detail").html("<i class='mc_detail_btn far fa-window-maximize'></i>");
				$(".td-"+alias_name+"-RES_detail").click( function(){ show_detail_click( $(this).closest(".data-row").data("id"), dones, show_done_lb); } );
				var table = $("#table-"+alias_name);
				// DEFREC
				if(def_rec_id){
					// rec has already been made active by DR1
					show_detail_click(def_rec_id, dones, show_done_lb);
					def_rec_id = 0; // avoid set def rec on each show
				}
				// TODO 1: create order from here
			}

			// -------------------------------------------------------------------------------
			// -----------------------------------  INIT -------------------------------------
			// -------------------------------------------------------------------------------
			var sd; // select dir
			var tt; // this name is used in space.js
			var def_rec_id = <?php echo get_or_def($_GET,'id',0); ?>; // DEFREC
			var def_camp_id = <?php echo get_or_def($_GET,'cid',0); ?>;
			var stat_cond = "<?php $sc = get_or_def($_GET,'filter',""); global $stat_conds; if($sc) echo $stat_conds[$sc]; ?>"; // STAT

			var table_name="issues", alias_name="issues";
			

			$(document).ready( function(){
				//-------------------  SHOP _---------------------
				admin = true;
				sd = new SD( function (path, cb){
					wait_screen.add_operation("open_dir");
					$.ajax(tt.acid("open_show_folder", {
						data: {'path': path}, 
						success: cb,
						complete: function(){ wait_screen.remove_operation("open_dir") }
					}));
				});
				//
				tt = new table_tree(table_name, '#tt_table_tree_div', table_name, "details"); // init tree table NOTE: set table before (used by def_search_fields) 
				tt.set_show_details(done_on_enter); 
				tt.set_on_select(on_rec_sel);
				tt.ro_set({field: "name", order: "asc"});   // FIORD
				tt.set_on_show_plain(on_show);
				tt.set_use_paths(1);
				tt.open_root_dir();				
				//
				tt.add_popup_item(lp('delete_selected'), function(){tt.selection_action("delete_todos")}, true, true, true);
				tt.add_popup_item(lp('rename'), show_rename_dialog, true, true); // RENAME
				tt.add_popup_item(lpp('$move$ $selected$'), function(){ sd.select_folder( function(dir){ tt.move_files(dir)  }   )   } , true, true, true);
				tt.add_popup_item(lpp('$create$ $todo$'), function(elem){create_todo_dialog(tt.get_data(elem, "path"), "create_todo")}, true, false, true); // create todo, invoked on parent
				tt.add_popup_item(lpp('$edit$ $todo$'), function(elem){edit_todo_dialog(tt.get_data(elem, "path"), "edit_todo")}, true, false, true); // edit todo, invoked on todo
				tt.add_popup_item(lpp('$create$ $done$'), function(elem){show_edit_done(0, tt.get_data(elem, "path"), "create_done")}, false, true, false); // create done
				//
				if(admin){ // else - on set camp (and set camp table)
					$(".lbsp_del, .lbsp_edit").removeClass("hidden");
				}else{
					// buttons
					$(".lbsp_rec_actions").remove();
					//show_sel_camp();	// SETCAMP
				}
				// CRUD
				$(".lbsp_new").click( function(){show_edit_done} ); // TODO NEXT
				$(".lbsp_edit").click( 
					function(){
						var rec = $(".tt_thumbs_form").find(".data-row.active");
						if(rec.length==1)
							show_edit_done( rec.data("id") );
				});
				tt.set_show_details_on_focus(true);
				$(".lbsp_del").click( 
					function(){
						var rec = $(".tt_thumbs_form").find(".data-row.active");
						if(rec.length==1){
							if(!check_order(rec.data("id")))return; // DOO
							done_delete( rec.data("id"), rec.find(".td-" + alias_name + "-name").html() );
						}
				});
			});
		</script>
	</body>
</html>
