class Apap{
	// metadata about all images, array of objects; images are proportional
	// 0 obj - is the biggest image
	// obj:
	// image - jq obj 
	// width_orig, height_orig - original w/h of image file for this scale
	// zoom_orig - size_orig/size_orig_max*100 [0..100]
	// width, height, zoom - w/h/z as currently displayed
	scale_count = 4;
	scales;
	scale = null; // curr scale DEF ANYSCA show any scale

	// POS: the curr pos of screen (normally smaller then image) is stored as displacement of its center from image center in normalized units (100/image_size)
	// SoI: rel pos of screen center on image in % [0:100]; not changes during scale change; 
	SP = {x:50,y:50}; 
	// IoS
	IP; // config of image: dx,dy - real offset (of img lt from cont lt?), kx,ky - len/100 (to convert real size to % and vv
	image = null; // js obj containing image
	// MOVE 
	drag_x;
	drag_y;
	drag_target = null;
	img_id;
	// DEF DRAG on safari drag not works, so use mouse move instead
	drag_thr = 10; // drag threshold
	md_x;
	md_y;
	md_target = null;
	drag_started = false;
	lente_size = 300; // LENTE 
	lente_zoom = 2; // lente shows scale[0] img; this coeff is to multiply the scale additionally
	//
	getScreen(){return $(".ap_image_cont");} // cont of all images; only one is visible at a time

	mouse_down = false;
	draw_wait = false;
	draw_ing= false; // means user has already started painting (after mouse down)
	pen_color = "#000000";
	pen_width = 2;
	draw_delta = 7;
	mode; // one of modes to react on mouse move - move pict / select / draw
	on_set_mode = null; // if apap changes mode by itself (normally done by client) - should inform client calling this cb;
	set_mode(mode){
		if(mode==this.mode)return;
		this.mode = mode;
		if(this.on_set_mode) this.on_set_mode(mode);
		var ic = "grab";  // move mode
		if(mode=="moving") ic = "grabbing";
		if(mode=="note") ic = "context-menu";
		$(".ap_image").css("cursor", ic);
	}
	//SCALE
	scaling = false; // during zoom with scroller it happens to fast and seeps happens overlapping of zoom requests
	getZoom(){ return this.scale.zoom; }
	scroll_offset=0; scroll_offset_max=5; // DEF SCROLL_STEP make scroller less sensible, accummulate offset until threshold
	//
	changed = false; // control changes on exit
	//
	new_draw = null; // remember last inserted draw to be able to change its props CHANGE_NEW_DRAW
	pins_shown = true;
	mouse_click_event = null; // PISDES: the probl is that .ap_move shown on mousedown and on mouseup target is .ap_move instead of pin


	//sss ------------------ INIT --------------------
	constructor(img_id, on_set_mode=null){
		var t = this;
		this.img_id = img_id;
		t.on_set_mode = on_set_mode;
		t.set_mode("move");
		// pins; now need position them
		this.pin_read_all();
		this.draw_read_all();
		//
		this.scales = [];
		// scales are loaded by ajax; at start they are null
		for(var i=0;i<this.scale_count;i++)
			this.scales.push(null);
		//
		this.loadScales(img_id);
		// COMMON EVENTS
		document.addEventListener("mousedown", function(event) {
			t.mouse_click_event = event;
			t.mouse_down = true;
			t.md_x = event.x;
			t.md_y = event.y; // NOTE: donno how, but it works also for PIN_MOVE (although during move happens over ap_move)
			t.md_target = $(event.target).closest(".ap_drag");
			t.drag_started = false;
			// PIN_MOVE
			if( $(event.target).hasClass("ap_pin_title") && t.mode=="move" ){
				t.drag_target = $(event.target)[0]; // remember it here because later becomes hidden by ap_move
				$(".ap_move").removeClass("hidden") ;
			}
		}, false);
		document.addEventListener("mouseup", function(event) {
			if(!t.drag_started) event = t.mouse_click_event;
			t.mouse_down = false;
			if( t.mode=="move" && !t.drag_started && $(event.target).closest(".ap_image_cont").length ){
				if(!event.ctrlKey)
					t.deselect_all(); 
				if(t.pin_hit_test(event));
				else if(t.draw_hit_test(event));
			}
			//if( t.mode=="note" && $(event.target).closest(".ap_image_cont").length ){
			if( t.mode=="note" && $(event.target).hasClass("ap_image") ){
				t.set_mode("move");
				var rect = event.target.getBoundingClientRect();
				var x = event.clientX - rect.left;
				var y = event.clientY - rect.top;
				t.pin_create(x, y);
			}
			if(t.drag_started)
				t.on_move_end();
			$(".ap_move").addClass("hidden"); // PIN_MOVE
		}, false);
		// DRAG
		document.addEventListener("mousemove", function(event) {
			//t.drag_target = null;
			//if(!event.ctrlKey)
			var target = $(event.target).closest(".ap_drag");
			var x = event.x, y = event.y;
			if(t.mouse_down && target.length && target[0]==t.md_target[0] && !t.drag_started || target.hasClass("ap_move") && !t.drag_started /*PIN_MOVE*/){
			if( (Math.abs(x-t.md_x)>t.drag_thr||Math.abs(y-t.md_y)>t.drag_thr/2) || target.hasClass("ap_move")/*PIN_MOVE*/ ){
				if(!target.hasClass("ap_move")) // in PIN_MOVE need remember target before show ap_move
					t.drag_target = target[0];
				t.on_move_start(target, t.md_x, t.md_y);
				t.drag_started = true;
				t.set_mode("moving");
			}}
			//
			if(t.drag_started)
				t.on_move(target, x, y);
			else if(t.mode=="move"){
				t.deselect_all("hilite");
				t.draw_hit_test(event, "hilite");
			}
			//
		}, false);

		// set scale by click
		var t = this;
		$(".ap_scale.rb_item").click( function(){
			var sn = $(this).data("scale");
			t.showScale(sn);
		} );
		// SETTINGS
		// settings: elem -> panel
		// settings panel -> elem
		t.pen_color = $(".ap_set_color").val();
		$(".ap_set_color").change( function(){
			var col = $(this).val();
			t.pen_color = col;
			if(t.mode=="draw" && t.new_draw!=null){ // CHANGE_NEW_DRAW
				t.draw_set_color( t.new_draw, col );
				return;
			}
			// if some pin txt is focused NOT WORKS while color selector gets focused
			//if(document.activeElement.classList.contains("ap_pin_txt")) 	t.pin_set_color( $(document.activeElement) );
			// if some pin selected
			t.pin_set_color( t.pin_get_selection_text(), col );
			// if some draw selected
			t.draw_set_color( t.draw_get_selection(), col );
		});
		// pen width
		t.pen_width = 2;
		$(".ap_pw").click( function(){
			var pw = $(this).data("size");
			t.pen_width = pw;
			if(t.mode=="draw" && t.new_draw!=null)
				t.draw_set_pen_width( t.new_draw, pw ); // CHANGE_NEW_DRAW
			else // if some draw selected
				t.draw_set_pen_width( t.draw_get_selection(), pw );
		});
		// font size
		for(var i=4;i<48;i+=2) $(".ap_set_font_size").append( $("<option value=" + i.toString() + ">" + i.toString() + "</option>") );
		$(".ap_set_font_size").change( function(){
			// TODO: set font size and use when add new pin: t.font_size = $(this).val();
			t.pin_set_font_size( t.pin_get_selection_text(), $(this).val() );
		});

		// SELECT
		// DEF PISDES text get sel and desel on mouse click problem $(".ap_image_cont").on("mousedown", ".ap_pin_txt_cont", function(e){ t.pin_hit_test(e); } );

		// moved to onmouseup $(".ap_image_cont")[0].addEventListener('mousedown', e => {	if(e.target.classList.contains("ap_image") ) t.deselect_all();});

		// DRAW
		$(".ap_canvas")[0].addEventListener('mousedown', e => {
			//if(!t.draw_wait) return;
			var rect = e.target.getBoundingClientRect();
			var x = e.clientX - rect.left; //x position within the element.
			var y = e.clientY - rect.top;  //y position within the element.
			t.draw_begin(x,y);
		});
		$(".ap_canvas")[0].addEventListener('mouseup', e => {
			t.draw_save_new();
			t.draw_ing= false;
		});
		$(".ap_canvas")[0].addEventListener('mousemove', e => {
			if(t.mode!="draw" || !t.mouse_down) return;
			var rect = e.target.getBoundingClientRect();
			var x = e.clientX - rect.left; //x position within the element.
			var y = e.clientY - rect.top;  //y position within the element.
			t.draw_points.push([x,y]);
			t.draw_ing= true;
			t.draw_paint_new();
		});
		// SELECT_RECT
		$(".ap_select")[0].addEventListener('mousedown', e => {
			t.deselect_all();
			$(".ap_select_rect").width(0);
			$(".ap_select_rect").height(0);
			$(".ap_select_rect").removeClass("hidden");
			var rect = e.target.getBoundingClientRect();
			t.drag_x = e.clientX - rect.left;
			t.drag_y = e.clientY - rect.top;
		});
		$(".ap_select")[0].addEventListener('mousemove', e => {
			if(!t.mouse_down)return;
			var rect = e.target.getBoundingClientRect();
			var x = e.clientX - rect.left;
			var y = e.clientY - rect.top;
			t.select_rect(x, y);
		});
		$(".ap_select")[0].addEventListener('mouseup', e => {
			$(".ap_select_rect").addClass("hidden"); 
		});
		// LENTE
		$(".ap_lente_div")[0].addEventListener('mousemove', e => {
			var rect = e.target.getBoundingClientRect();
			var x = e.clientX - rect.left;
			var y = e.clientY - rect.top;
			$(".ap_lente").css("left", x-t.lente_size/2);
			$(".ap_lente").css("top", y-t.lente_size/2);
			//$("#heading_left").html(dx + ", " + dy + "   " + kx);
			// pos of cursor on img
			var xi = x - t.IP.dx, yi = y - t.IP.dy;
			var xi_rel = xi/t.IP.kx, yi_rel = yi/t.IP.ky;
			// find abs pos on scale 0
			var x0 = xi_rel*t.scales[0].width_orig*t.lente_zoom/100;
			var y0 = yi_rel*t.scales[0].height_orig*t.lente_zoom/100;
			$('#ap_lente_img').css("left", t.lente_size/2-x0);
			$('#ap_lente_img').css("top", t.lente_size/2-y0);
		});
		//
		t.move_start(); // def MODE
		// redraw on win resize
		window.addEventListener('resize', function(){t.positionScale();} );
	} // constructor	
	save(){
		this.pin_save_all();
		this.draw_save_all();
		this.changed = false;
	}

	//sss ------------------ MODE --------------------

	// hide all tools
	tools_hide(){
		$(".ap_canvas").addClass("hidden"); 
		$(".ap_select").addClass("hidden");
		$(".ap_select_rect").addClass("hidden");
		$(".ap_move").addClass("hidden"); // MOVE_MOVE
		$(".ap_lente_div").addClass("hidden");
		$(".ap_lente").addClass("hidden");
	}
	// NOTE: use of set_mode not quite correct here, whilethis funcs called by client, so no ned to call on_set_mode
	move_start(){this.tools_hide(); this.set_mode("move"); /* $(".ap_move").removeClass("hidden");not used in PIN_MOVE */ /*MOVE_MOVE*/ } // MOVE
	draw_start(){this.tools_hide(); this.set_mode("draw"); $(".ap_canvas").removeClass("hidden"); this.new_draw=null;}  // enter draw mode
	draw_begin(x,y){ this.draw_points = [[x,y]]; } // start properly painting, add first point TODO: name confusion draw_start/draw_begin
	draw_started(){ return this.mode=="draw"; /*!$(".ap_canvas").hasClass("hidden");*/ } 
	select_start(){
		this.tools_hide();
		this.set_mode("select");
		$(".ap_select").removeClass("hidden");
	}
	// DEF LENTE magnifying glass
	lente_start(){
		this.tools_hide();
		this.set_mode("lente");
		$(".ap_lente_div").removeClass("hidden");
		$(".ap_lente").removeClass("hidden");
	}
	start_note(){
		this.tools_hide();
		this.set_mode("note");
	}

	//sss ------------------ MOVE --------------------
	// reaction on user req to move; dx,y - real displacement
	// screen moves in opposite dir
	move_image(dx,dy){
		var scale = this.scale;
		var img = $(scale.image);
		var dxa = dx/this.IP.kx;
		var dya = dy/this.IP.ky;
		this.SP.x = this.SP.x - dxa;
		this.SP.y = this.SP.y - dya;
		this.positionScale();
	}

	on_move_start(target, x, y){
		var t = this;
		t.drag_x = x;
		t.drag_y = y;
		//if( $(target).hasClass("ap_mover_screen") ) $(target).addClass("mc_hide_drag"); // MOVER_HIDE
	}
	
	on_move(target, x, y){
		var t = this;
		//if(t.mode!="move" || t.drag_target==null) return;
		if(t.mode!="moving" || t.drag_target==null) return;
		if(x==0) return; // TODO: donno why it happens
		var dx = x - t.drag_x;
		var dy = y - t.drag_y;
		t.drag_x = x;
		t.drag_y = y;
		// moving	
		if( $(t.drag_target).hasClass("ap_image") ) 
			t.move_image(dx, dy); // works when MOVE_MOVE disabled
		if( $(t.drag_target).hasClass("ap_pin_btn") )
			t.pin_move(dx, dy);
		if( $(t.drag_target).hasClass("ap_pin_title") )
			t.pin_move_txt(dx, dy);
		if( t.drag_target.classList.contains("ap_draw") )
			t.draw_move(dx, dy);
		if( $(t.drag_target).hasClass("ap_mover_screen") ){
			var co = t.scale.width/$(".ap_mover_cont").width();
			t.move_image(-dx*co, -dy*co);
		}
	}

	on_move_end(){
		var t = this;
		//$(target).removeClass("mc_hide_drag"); // MOVER_HIDE
		t.drag_target = null;
		t.mouse_down = false; // donno why not works document.mouseup
		t.set_mode("move");
		t.drag_started = false; // 13/05/22 found out that it's necessary or else after pin move remains in drag mode
	}

	//sss ------------------ SELECT RECT --------------------
	select_rect(x,y){
		var th = this;
		var x1=th.drag_x, x2=x;
		var y1=th.drag_y, y2=y;
		var l = Math.min(x1,x2)+1, r = Math.max(x1,x2)-1;
		var t = Math.min(y1,y2)+1, b = Math.max(y1,y2)-1;
		$(".ap_select_rect").css("left", l); // left,top may change during move if switch neg/pos rect
		$(".ap_select_rect").css("top", t);
		$(".ap_select_rect").width(r-l);
		$(".ap_select_rect").height(b-t);
		$(".ap_image_cont").find(".ap_draw, .ap_pin_txt_cont").each( function(){
			var e = $(this);
			//var p = e.position();	var l1=p.left, t1=p.top; TODO: not works (for draws only!) shows pos relative to page
			var l1 = parseInt(e.css("left"));	var t1 = parseInt(e.css("top"));
			var r1 = l1+e.width(), b1=t1+e.height();
			if( rect_intersect( t,r,b,l, t1,r1,b1,l1 ) )
				e[0].classList.add("selected");
			else
				e[0].classList.remove("selected");
		});
	}

	//sss ------------------ PIN-DRAW --------------------
	// with given cont offset and scale, position elem using its data-left/top
	positionElem(elem, dx, dy, kx, ky){
		var xr = elem.data('left');
		var yr = elem.data('top');
		if(elem[0].classList.contains("ap_draw")){ xr = elem[0].dataset.left; yr = elem[0].dataset.top; }
		elem.css({top: dy + yr*ky, left: dx + xr*kx});
	}
	deselect_all(cls="selected"){
		// unselet draws (jquery not works)
		this.draw_get_selection(cls).each( function(){ 
			this.classList.remove(cls); // TODO: maybe use draw_deselect() func
		});
		// deselect pins
		this.pin_get_selection().removeClass(cls);
	}
	delete_selection(){
		this.pin_get_selection().each(function(){
			$(this).addClass("deleted");
			$(".ap_pin[data-id="+$(this).data("id")+"]").addClass("deleted"); 
			var lines = document.querySelectorAll(".ap_pin_line");
			for(var i = 0; i< lines.length; i++) if( $(lines[i]).data("id")==$(this).data("id")) lines[i].remove();
		});
		var draws = this.draw_get_selection(); 
		for(var i = 0; i< draws.length; i++) draws[i].classList.add("deleted");
		if( this.pin_get_selection().length || draws.length )
			this.changed = true;
		this.pin_set_list();
	}
	// hide/show all
	toggle_pindraws(show=false){
		this.pins_shown = show;
		$("svg").each( function(){ if(!show) this.classList.add("ap_hidden"); else this.classList.remove("ap_hidden"); } );
		if(!show) 
			$(".ap_pin_txt_cont").addClass("ap_hidden"); 
		else{ 
			$(".ap_pin_txt_cont").removeClass("ap_hidden");
			this.pin_position_all(this.IP.dx,this.IP.dy,this.IP.kx,this.IP.ky); // DEF REPOS; if pins hidden then rescale then reshow - need repaint them
		}
	}
	//sss ------------------ PIN --------------------

	// SELECT
	pin_hit_test(e){
		var txt_cont = $(e.target).closest(".ap_pin_txt_cont");
		if(!txt_cont.length) return false;
		txt_cont.addClass("selected");
		this.pin_show_params( txt_cont.find(".ap_pin_txt") );
		return true;
	}

	pin_show_params(txt){
		$(".ap_set_color").val( rgb_to_hex( txt.css("color") ) );
		var fs = txt.css("font-size"); fs = parseInt(fs);
		$(".ap_set_font_size option[value='" +  fs + "']").prop("selected", true);
	}

	pin_get_selection_text(){ return $(".ap_pin_txt_cont.selected .ap_pin_txt"); }
	pin_get_selection(){ return $(".ap_pin_txt_cont.selected"); }
	pin_get_all(){ return $(".ap_pin_txt_cont"); }
	// this is made to be called when color is changed (not just inited) while adds "changed" class
	pin_set_color(pins_jq, col){ pins_jq.css("color", col); this.changed=true; pins_jq.closest(".ap_pin_txt_cont").addClass("changed"); }
	pin_set_font_size( pins_jq, size ){ pins_jq.css("font-size", size );  this.changed=true; pins_jq.closest(".ap_pin_txt_cont").addClass("changed"); }

	pin_draw_connector(from, to){
		if(!this.pins_shown) return;
		var id = from.data("id");
		$(".ap_pin_line[data-id='" + id + "']").remove(); // remove old line (if any) 
		var x1 = from.position().left + from.width()/2;
		var y1 = from.position().top + from.height()/2;
		var x2 = to.position().left + to.width()/2;
		var y2 = to.position().top + to.height()/2;
		var top = Math.min(y1,y2);
		var left = Math.min(x1,x2);
		var line = $("<svg width=" + Math.abs(x1-x2) + " height=" + Math.abs(y1-y2) + " class='ap_pin_line' data-id='" + id + "'> " + 
			"<line x1='"+(x1-left)+"' y1='"+(y1-top)+"' x2='"+(x2-left)+"' y2='"+(y2-top)+"' stroke-width=3 stroke='green' /></svg>")
		line.css("top", top);
		line.css("left", left);
		$(".ap_image_cont").append( line );
	}

	pin_read_all(){
		var ep = call_php_sync("contr/apap.php", {action: 'pin_read_all', app_id: this.img_id} );
		this.getScreen().append( $(ep.resp_text) );
		this.pin_set_list();
		// NOTE: adding "changed" and saving only "changed" is just to avoid unnecessary queries and not pollute logs
		$(".ap_pin_txt").on("change", function(){ $(this).closest(".ap_pin_txt_cont").addClass("changed"); });
	}
	// absolute coords in curr scale, relative to img
	// saved to db instantly
	pin_create(xa, ya){
		var ip = this.IP;
		var x = xa/ip.kx; // pos on img in % (seems)
		var y = ya/ip.ky;
		var ep = call_php_sync("contr/apap.php", {action: 'pin_render_empty', pin: JSON.stringify({pin_x: x, pin_y: y, txt_x: x+50, txt_y: y+50 }) } );
		var np = $(ep.resp_text);
		np.addClass("changed");
		this.getScreen().append( np );	
		var pin = $(np[0]); var txt_cont = $(np[1]);
		if(!pin){ alert("pin create error"); return; }
		this.positionElem(pin, ip.dx, ip.dy, ip.kx, ip.ky);
		var p = pin.position();
		this.positionElem(txt_cont, p.left, p.top, 1, 1 );
		var t = this;
		np[0].onload = function(){ t.pin_draw_connector($(np[1]), $(np[0])); } // need call it in onload, or else pin has no size
		txt_cont.find(".ap_pin_txt").focus();
		this.pin_set_list();
		this.changed = true;
		this.deselect_all();
		txt_cont.addClass("selected");	
		// pin_show_params(txt_cont.find(".ap_pin_txt")); TODO: Instead use params for new pin?
		puh("pin_inserted");
	}
	pin_delete(id){
		$(".ap_pin[data-id='" + id + "']").addClass("deleted");
		this.pin_set_list();
		this.changed = true;
	}
	pin_save_all(){
		var s = this.getScreen();
		var app_id = this.img_id;
		s.find(".ap_pin_txt_cont.deleted").each( function() {
			call_php_sync("contr/apap.php", {action: "pin_delete", id: $(this).data("id") }); // TODO: use promises
			$(this).remove();
		});
		s.find(".ap_pin_txt_cont.changed").each( function() {
			var txt = $(this);
			var id = $(this).data("id");
			var btn = s.find(".ap_pin_btn[data-id='" + id + "']");
			var pin = {
				id: id,
				app_id: app_id,
				txt_x: txt.data("left"), txt_y: txt.data("top"),
				pin_x: btn.data("left"), pin_y: btn.data("top"),
				txt_w: txt.width(), txt_h: txt.height(),
				txt: txt.find(".ap_pin_txt").val(),
				font_size: txt.find(".ap_pin_txt").css("font-size"),
				font_color: txt.find(".ap_pin_txt").css("color"),
				pin_state: txt.data("state") // PIN_STATE
			}
			call_php_sync("contr/apap.php", {action: "pin_save", pin: JSON.stringify(pin)});
			$(this).removeClass("changed");
		});
		call_php_sync("contr/apap.php", {action: "pin_del_empty"});
	}
	pin_move(dx, dy){
		var pin = $(this.drag_target);
		var dxa = dx/this.IP.kx;
		var dya = dy/this.IP.ky;
		pin.data("left", parseFloat(pin.data("left")) + dxa);
		pin.data("top", parseFloat(pin.data("top")) + dya);
		var ip = this.IP;
		this.positionElem(pin, ip.dx, ip.dy, ip.kx, ip.ky);
		// move also txt
		var p = pin.position();
		var txt = $(".ap_pin_txt_cont[data-id='" + pin.data("id") + "']");
		this.positionElem( txt, p.left, p.top, 1, 1 );
		this.pin_draw_connector(pin, txt);
		this.changed = true;
	}

	pin_move_txt(dx, dy){
		var txt = $(this.drag_target).closest(".ap_pin_txt_cont");
		txt.data("left", parseFloat(txt.data("left")) + dx);
		txt.data("top", parseFloat(txt.data("top")) + dy);
		var pin = $(".ap_pin_btn[data-id='" + txt.data("id") + "']");
		var p = pin.position();
		this.positionElem( txt, p.left, p.top, 1, 1 );
		this.pin_draw_connector(pin, txt);
		this.changed = true;
	}
	pin_position_all(dx,dy,kx,ky){
		var t = this;
		var s = t.getScreen();
		$(".ap_pin_line").remove();
		s.find(".ap_pin_txt_cont").each( function() {
			var txt = $(this);
			var id = $(this).data("id");
			var btn = s.find(".ap_pin_btn[data-id='" + id + "']");
			t.positionElem( btn, dx, dy, kx, ky );
			var p = btn.position();
			t.positionElem( txt, p.left, p.top, 1, 1 );
			t.pin_draw_connector(btn, txt);
		});
	}
	pin_set_list(){
		var t = this;
		$(".ap_pin_list").html("");
		this.pin_get_all().each( function(){
			var pin = $(this);
			var txt = pin.find(".ap_pin_txt").val();
			var id = pin.data("id");
			if(!txt || pin.hasClass("deleted")) return;
			var state = pin.data("state");
			var psc = "ap_ps_" + state;
			var tt="to do";if(state=="done")tt="done";if(state=="nodo")tt="do not";
			var pi = $("<div class='ap_pin_list_item rb_item' data-id='" + id + "'><span>" + txt.substr(0,50) + "</span><i class='fas fa-circle " + psc + "' title='" + tt + "'></i></div>");
			pi.attr("title", pin.data("owner") + "\n" + txt);
			$(".ap_pin_list").append(pi);
			pi.click(function(){
				var id= $(this).data("id"); var btn = $(".ap_pin_btn[data-id='"+id+"']");
				t.SP = {x: btn.data("left"), y: btn.data("top")};
				t.positionScale();
				t.deselect_all();
				$(".ap_pin_txt_cont[data-id='"+id+"']").addClass("selected");
			});
			pi.find(".fa-circle").click( function() { var s,S="done",p=$(".ap_pin_txt_cont[data-id='"+id+"']");s=p.data("state");if(s=="done")S="nodo";if(s=="nodo")S="todo";p.data("state",S); p.addClass("changed");t.pin_set_list(); }); // PIN_LIST
		});
		rb_init(".ap_pin_list .rb_item");
	}
	



	//sss ------------------ DRAW --------------------

	draw_hit_test(e, cls="selected"){
		if(! e.target.classList.contains("ap_draw") && ! e.target.parentElement.classList.contains("ap_draw") ) return false;
		var t = this;
		if(t.scale==null) return false; // not yet inited
		// draw accepts mouse event when cursor is inside its whole rect; here need check if cursor is properly on the line
		var x = e.clientX; //x position within the element.
		var y = e.clientY;  //y position within the element.
		var zc = t.scale.zoom;
		var found = false;
		//console.log(x.toString() + " " + y.toString());
		$(".ap_draw").each( function(){
			if(found) return;
			var draw = $(this);
			var k = draw.data("zoom")/zc;
			var p = draw.position();
			if(t.draw_is_close(draw,(x-p.left)*k,(y-p.top)*k)){
				draw[0].classList.add(cls);
				found = true;
				if(cls=="selected") // TODO: maybe better separate hittest and select
					t.draw_show_params(draw);// DEF SET_TO_OBJ set settings controls according to selected obj
			}
		});
		return found;
	}

	draw_show_params(draw){
		$(".ap_set_color").val( draw.find("path")[0].getAttribute("stroke")  );
		$(".ap_pw").removeClass("selected");
		$(".ap_pw[data-size='"+draw.find("path")[0].getAttribute("stroke-width")+"']").addClass("selected");
	}

	draw_get_selection(cls="selected"){ return $(".ap_draw."+cls); }
	draw_get_active(){ return $(":not(.deleted).ap_draw"); } // all except deleted
	draw_set_color(draws_jq, col){
		draws_jq.each( function(){
				var path = $(this).find("path");
				path.removeAttr("stroke");
				path[0].setAttribute("stroke", col);
				this.classList.add("changed");
			});
		this.changed = true;
	}
	draw_set_pen_width(draws_jq, pw){
		draws_jq.each( function(){
			var path = $(this).find("path");
			path.removeAttr("stroke-width");
			path[0].setAttribute("stroke-width", pw);
			this.classList.add("changed");
		});
		this.changed = true;
	}

	draw_create(path,x0,y0,w,h,pen_color,pen_width,cl,zoom,id=0){
		var wh = (cl=="ap_draw_temp"? ("width='"+w+"' height='"+h+"'") : ("viewBox='0 0 "+w+" "+h+"'")); // when painting temp draw - it's positioned absolutely, need w/h and no viewbox
		return $("<svg class='ap_draw ap_drag "+cl+"' " + wh + " data-zoom='"+zoom+"' data-id='"+id+"' data-left="+x0+" data-top="+y0+" data-width="+w+" data-height="+h+"> " + 
			"<path d='" + path + "' stroke='" + pen_color + "' stroke-width='" + pen_width + "' fill='none'/> </svg>");
	}
	// postion all draws depending on scale and image pos
	// unlike pins, draws contain sizes in real coords (in scale in which were created)
	draw_position_all(sel=".ap_draw"){
		var t = this;
		$(sel).each( function(){ t.draw_position($(this)); });
	}
	draw_position(draw){
		var t = this;
		var zoom = draw.data("zoom");
		var k = t.scale.zoom/zoom;
		t.positionElem( draw, t.IP.dx, t.IP.dy, k, k );
		var w = draw.data("width"), h = draw.data("height");
		draw.removeAttr("width");
		draw[0].setAttribute("width", w*k);
		draw.removeAttr("height");
		draw[0].setAttribute("height", h*k);
	}
	// compile and paint the currently created draw
	draw_paint_new(){
		var t = this;
		if( t.draw_points.length<2 ) return;
		$(".ap_draw_temp").remove();
		var scale = this.scale;
		//var w = scale.width, h = scale.height;
		var w = $(".ap_canvas").width(), h = $(".ap_canvas").height();
		var path = t.draw_compile(w, h, 0, 0, "ap_draw_temp", t.scale.zoom);
		$(".ap_image_cont").append(path);
	}
	// save newly created draw; on create stage it has absolute coords; need convert to relative
	// not saved to db yet, has id = 0
	draw_save_new(){
		var dp = this.draw_points;
		if(!dp || dp.length==0) return;
		var xm=dp[0][0], ym=dp[0][1]; 
		var xM=xm,yM=ym;
		for(var i = 0; i < dp.length; i++){
			var x = dp[i][0], y = dp[i][1];
			xm = Math.min(xm,x);
			xM = Math.max(xM,x);
			ym = Math.min(ym,y);
			yM = Math.max(yM,y);
		}
		var d = this.pen_width;
		for(var i = 0; i < dp.length; i++){
			dp[i][0] = dp[i][0] - xm + d;
			dp[i][1] = dp[i][1] - ym + d;
		}
		var path = this.draw_compile(xM-xm+d+d, yM-ym+d+d, xm-d-this.IP.dx, ym-d-this.IP.dy, "changed", this.scale.zoom);
		this.draw_points = [];
		$(".ap_draw_temp").remove();
		$(".ap_image_cont").append(path);
		this.draw_position(path);
		this.changed = true;
		this.new_draw = path; // CHANGE_NEW_DRAW
		// this.draw_show_params( path ); TODO: instead should use params when create new
		puh("draw_inserted");
	}
	draw_read_all(){
		var ep = call_php_sync("contr/apap.php", {action: 'draw_read_all', app_id: this.img_id} );
		var dl = JSON.parse( ep.resp_text );
		for(var i=0; i<dl.length; i++){
			var dr = dl[i];
			var path = this.draw_create(dr.path,dr.x,dr.y,dr.width,dr.height,dr.color,dr.pen_width,"",dr.zoom,dr.id);
			$(".ap_image_cont").append(path);
		}
	}
	// checks if given point x0 is close to given segm p1-p2 (<=d); d2=d*d
	static draw_segm_is_close(x1,y1,x2,y2,x0,y0,d=10,d2=100){
		if(Math.max( Math.abs(x1-x2), Math.abs(y1-y2) ) <= d) // line points are close - then test point must be close to one of them
			return Math.max( Math.abs(x1-x0), Math.abs(y1-y0) ) <= d || Math.max( Math.abs(x2-x0), Math.abs(y2-y0) ) <= d;
		// need fnd dist to segm not line, so make sure point is in segm rect
		return  x0+d > Math.min(x1,x2) && x0-d < Math.max(x1,x2) && y0+d > Math.min(y1,y2) && y0-d < Math.max(y1,y2) &&	dist_line_point2(x1,y1,x2,y2,x0,y0) <= d2;
	}
	draw_is_close(draw,x0,y0){
		var d = draw.find("path").attr("d");
		var pairs = d.substr(2).split(" L ");
		var points = [];
		for(var i = 0; i < pairs.length; i++){
			var p = pairs[i].split(" ");
			points.push([parseInt(p[0]), parseInt(p[1])]);
		}
		//
		var d = this.draw_delta; var dd = d*d;
		for(var i = 1; i < points.length; i++)
			if(Apap.draw_segm_is_close( points[i-1][0], points[i-1][1], points[i][0], points[i][1], x0, y0, d, dd) ){
				return true;
			}
		return false;
	}
	// new or changed (moved) draws have class 'changed'; news are distinguished from existing by id=0
	draw_save_all(){
		var t = this;
		var draws = document.querySelectorAll(".ap_draw.deleted");
		for(var i = 0; i< draws.length; i++){
			call_php_sync("contr/apap.php", {action: "draw_delete", id: $(draws[i]).data("id") }); // TODO: use promises
			draws[i].remove();
		}
		// save draws
		$(".ap_image_cont").find(".ap_draw.changed").each( function(){
			var draw = $(this);
			var path = draw.find("path");
			var d = path.attr("d");
			var col = path.attr("stroke");
			var pw = path.attr("stroke-width");
			var zoom = draw.data("zoom");
			//var x = draw.data("left"), y = draw.data("top");
			var x = draw[0].dataset.left, y = draw[0].dataset.top;
			var w = draw.data("width"), h = draw.data("height");
			var id = draw.data("id");
			var ds = {app_id:t.img_id,id:id,path:d,x:x,y:y,width:w,height:h,pen_width:pw,zoom:zoom,color:col};
			var req = call_php_sync("contr/apap.php", {action: "draw_save", draw: JSON.stringify(ds)});
			this.classList.remove("changed");
			if(!id) this.setAttribute("data-id", req.resp_text); // to be able to identificate draw if gets changed
		});
	}
	draw_delete(id){
		$(".ap_draw[data-id='" + id + "']").addClass("deleted");
		this.changed = true;
	}
	draw_compile(w, h, x0=0,y0=0,cl,zoom){
		var dp = this.draw_points;
		var path = "M "+ dp[0][0]+" "+dp[0][1];
		for(var i = 1; i<dp.length; i++)
			path += " L "+dp[i][0]+" "+dp[i][1];
		return this.draw_create(path,x0,y0,w,h,this.pen_color,this.pen_width,cl,zoom);
	}
	draw_move(dx,dy){
		var t = this;
		$(".ap_draw.selected").each( function(){
			var draw = this;
			var zoom = $(draw).data("zoom");
			var k = zoom/t.scale.zoom;
			var left = parseFloat(draw.dataset.left) + dx*k;
			var top  = parseFloat(draw.dataset.top)  + dy*k;
			draw.removeAttribute("data-left");
			draw.setAttribute("data-left", left);
			draw.removeAttribute("data-top");
			draw.setAttribute("data-top", top);
			t.draw_position($(draw));
		});
		this.changed = true;
	}

	//sss ------------------ SCALE --------------------
	// MOVER
	setMover(scale){
		var co = scale.width/$(".ap_mover_cont").width(); // mover vs real co
		var s = this.getScreen();
		if(scale.width<s.width() && scale.height<s.height())
			$(".ap_mover_cont").addClass("hidden");
		else
			$(".ap_mover_cont").removeClass("hidden");
		$(".ap_mover_cont").css("height", $(".ap_mover_cont").width()*scale.height/scale.width); // bug on notebook: ap_mover_cont height is 0
		$(".ap_mover_screen").css("width", s.width()/co);
		$(".ap_mover_screen").css("height", s.height()/co);
		$(".ap_mover_screen").css("left", this.SP.x*$(".ap_mover_cont").width()/100-$(".ap_mover_screen").width()/2);
		$(".ap_mover_screen").css("top", this.SP.y*$(".ap_mover_cont").height()/100-$(".ap_mover_screen").height()/2);
	}

	// positions img and all pindraws basing on curr scale, SP; sets IP
	positionScale(){
		var t = this;
		var scale = this.scale;
		var img = $(scale.image);
		
		// have: rel pos of screen on imagei (SoI) ; need: abs pos of image on screen (IoS)
		// _________sssssssssss___ :  -dx + l/2 = sp_x; img is bigger then screen and it's  edge is out of visible area, so dx<0

		// SP % -> real size ; k - is to convert real size to % and vv
		var kx = scale.width/100; // real img size / 100
		var ky = scale.height/100;
		var sp_x = this.SP.x*kx;
		var sp_y = this.SP.y*ky;
		// SP real -> dxy real
		var s = this.getScreen();
		var dx = s.width()/2 - sp_x;
		var dy = s.height()/2 - sp_y;
		this.IP = {dx: dx, dy: dy, kx: kx, ky: ky};
		//$("#heading_left").html(dx + ", " + dy + "   " + kx);
		//img.prop("left", dx);
		//img.prop("top", dy);
		img.css({top: dy, left: dx});
		// position pins
		t.pin_position_all(dx,dy,kx,ky);
		// position pins
		t.draw_position_all();
		//
		this.setMover(scale); // MOVER
	}
	showScale(ind, zoom=0){ 
		var scale = this.scales[ind];
		if(scale==null){
			alert("scale is loading...");
			return;
		}
		if(this.scale!=null)
			$(this.scale.image).addClass("hidden");
		this.scale = scale;
		var img = $(scale.image);
		img.removeClass("hidden");
		$(".ap_scale_num").val(Math.round(zoom?zoom:this.scale.zoom_orig));
		this.scale.setZoom(zoom);
		this.positionScale();
	}
	onLoadScales(scale_num){
		var t = this;
		if(scale_num==this.scale_count-1){
			// MOVER call before showScale which needs mover hite
			var sm = this.scales[this.scale_count-1];
			$(".ap_mover_cont").css("background-image", "url('" + sm.image.src + "')" );
			$(".ap_mover_cont").css("height", $(".ap_mover_cont").width()*sm.height/sm.width );
			// SHOW INITIAL SCALE
			this.showScale(this.scale_count-1);
		}
		// SCROLL
		$(".ap_image").on("wheel", function(e){t.onscroll(e);}); // done for each image load to: enable scroll as soonest, enable for all scales.
		if(scale_num==0){
			t.zoom_to_screen();
		}
	}

	loadScales(img_id){
		for(var i = this.scale_count-1; i>=0; i--)
			this._loadScale(img_id, i);
	}
	// TODO: https://stackoverflow.com/questions/6294733/how-to-load-image-in-background   says that need do it in window.onload 
	_loadScale(img_id, scale_num){
		var t = this;
		var img = new Image();
		img.setAttribute('draggable', false);
		$(img).addClass("ap_image");
		$(img).addClass("hidden");
		$(img).addClass("ap_drag");
		$(img).data("scale", scale_num);
		var img_info = call_php_sync("contr/apap.php", {action: "ap_image", id: img_id, scale_num: scale_num});
		img_info = JSON.parse(img_info.resp_text);
		img.onload = function(){
			t.getScreen().append(img);
			t.scales[scale_num] = {scale_num: scale_num, image: img, width_orig: img_info.width, height_orig: img_info.height, zoom_orig: img_info.zoom};
			t.scales[scale_num].setZoom = function(zoom=0){
				if(zoom==0) zoom = this.zoom_orig; // def
				var k = zoom/this.zoom_orig;
				this.width=this.width_orig*k; this.height=this.height_orig*k; this.zoom=this.zoom_orig*k;
				$(this.image).width(this.width);
				$(this.image).height(this.height);
			};
			t.onLoadScales(scale_num);
			// LENTE
			if(scale_num==0){
				$(".ap_lente").html("<img id='ap_lente_img' src='" + img_info.url + "'></img>");
				$(".ap_lente").width(t.lente_size);
				$(".ap_lente").height(t.lente_size);
				$("#ap_lente_img").width(t.lente_zoom*img_info.width);
				$("#ap_lente_img").height(t.lente_zoom*img_info.height);
			}
		}
		img.src = img_info.url;
	}

	// ANYSCA
	setZoom(zoom){
		var scale = -1;
		for(var i=this.scale_count-1;i>=0;i--)
			if(this.scales[i] && this.scales[i].zoom_orig>=zoom){
				scale=i;
				break;
			}
		if(scale>=0)
			this.showScale(scale, zoom);
		else 
			this.showScale(0, zoom); // DEF OVER100 zoom over 100
			//return -1;
	}
	zoom_to_screen(){
		var border = 10; // DEF VISIBLE_BORDER need border to user sees if is image border
		var zoom_w = ($(".ap_image_cont").width()-border)*100/this.scales[0].width_orig;
		var zoom_h = ($(".ap_image_cont").height()-border)*100/this.scales[0].height_orig;
		this.setZoom(Math.min(zoom_w, zoom_h, 100));
		this.SP.x = 50; this.SP.y = 50;
		this.positionScale();
	}

	setZoomPos(zoom, xi, yi){
		var t = this;
		if(t.scaling) return; t.scaling = true;
		// before
		// find out point coords in image CS (%x, %y) Bi
		var xir = xi*100/t.scale.width;
		var yir = yi*100/t.scale.height;
		// find out point coords in screen CS (real x, real y) Bs
		var p = $(t.scale.image).position();
		var xs = xi + p.left, ys = yi + p.top;
		// change scale
		if(t.setZoom(zoom)==-1) 
			return;
		// after
		// Ai = Ai => Ri (real point coords in image CS)
		var xi1 = xir*t.scale.width/100;
		var yi1 = yir*t.scale.height/100;
		// As = Bs
		var s = t.getScreen();
		var spxr = xi1 - xs + s.width()/2, spyr = yi1 - ys + s.height()/2; //real coords of screen
		//console.log(spxr);
		//console.log(spyr);
		//console.log( Math.abs( spxr*100/t.scale.width - t.SP.x ) );
		t.SP = {x: spxr*100/t.scale.width, y: spyr*100/t.scale.height};
		//console.log(t.SP.x);
		//console.log(t.SP.y);
		t.positionScale();
		t.scaling = false;
	}

	onscroll(e){
		var ims = $(e.target).data("scale");
		if(!this.scale || this.scale.scale_num!=ims)  // bug SCROLL: if this.scale already changed but image not yet - happens inconsistence
			return; 
		this.scroll_offset += -e.originalEvent.deltaY/20; // normally is 2.65
		if(Math.abs(this.scroll_offset)<this.scroll_offset_max) return; // SCROLL_STEP
		//var offset = this.scroll_offset;
		var offset = this.scroll_offset>0?5:-5;
		this.scroll_offset = 0;
		var s = this.getZoom(); 
		var zmin = 5, zmax = 100;
		var s1 = offset<0? Math.max(zmin,s+offset) : Math.min(zmax,s+offset);
		if(s!=s1 && (Math.abs(s-s1)>=2.5 || s1==zmin|| s1==zmax) )
			this.setZoomPos(s1, e.offsetX, e.offsetY);
	}	

	// ----------------------- UTILS ------------------------
	scale_to_image(callback){
		var t = this;
		// need a div which contains both complete image and all drawpins
		$(".ap_image_cont").removeClass("mc_page_body");
		$(".ap_image_cont").css("width", t.scale.width);
		$(".ap_image_cont").css("height", t.scale.height);
		$(".ap_image_cont").css("position", "absolute"); // or else cont width not goes over screen size
		var psp = t.SP;
		t.SP = {x:50, y:50};
		t.positionScale();
		// draw-svg to canvas
		t.draw_get_active().add(".ap_pin_line").each( function(){
			var draw = this;
			var svg_can = document.createElement("canvas");
			svg_can.width = t.scale.width;
			svg_can.height = t.scale.height;
			svg_can.className = "ap_svg_can_tmp";
			var xml = (new XMLSerializer()).serializeToString(this);  //convert SVG into a XML string
			draw.classList.add("ap_hidden");
			xml = xml.replace(/xmlns=\"http:\/\/www\.w3\.org\/2000\/svg\"/, '');   // Removing the name space as IE throws an error
			//draw the SVG onto a canvas TODO: why position() is wrong here?
			var dt = parseInt( $(draw).css("top") );
			var dl = parseInt( $(draw).css("left") );
			$(svg_can).css({position: "absolute", top: dt, left: dl, "z-index": draw.classList.contains("ap_pin_line")? 200 : 50000});
			const ctx = svg_can.getContext('2d');
			var v = canvg.Canvg.fromString(ctx, xml);
			//var v = canvg.Canvg.fromString(ctx, '<svg width="600" height="600"><text x="50" y="50">Hello World!</text></svg>');
			var x = v.start();
			//canvg(svg_can, xml);
			$(".ap_image_cont").append(svg_can);
		});

		html2canvas(document.querySelector(".ap_image_cont")).then(canvas => {
			// h2c not prints svg, do it with canvg
			callback(canvas.toDataURL());
			// restore view
			$(".ap_svg_can_tmp").remove();
			//return;
			$(".ap_image_cont").addClass("hidden");
			$(".ap_image_cont").css("position", "relative");
			$(".ap_image_cont").addClass("mc_page_body");
			$(".ap_image_cont").removeClass("hidden");
			$(".ap_image_cont").css("width", "");
			$(".ap_image_cont").css("height", "");
			t.draw_get_active().add(".ap_pin_line").each( function(){
				this.classList.remove("ap_hidden");
			});
			t.SP = psp;
			t.positionScale();
		});
	}
}

