
/*
DEF SEL_FOL
simplified tt to provide interface to navigate folders and select the target folder
the client needs to supply cb to open folders (now in constr) and cb to be called on folder is selected (now in select_folder)
DEPENDS ON: MD_SS: utils.js: show_select_string, which requires md_ss html to be on page
	std md_ss html is filled with custom content in sd.html
	table_tree/css/style.css
*/

class SD{
	// DEF MFB move files bug, found 26.06; to the contr is passed path without end-slash; firstly, found here that data-path not contains end-slash (not that name may be empty and needs no es), but bug persists
	create_empty_folder(parent_path,name){ var es = name? '/':''; return $("<div class='tree-cont' data-path='" + parent_path + name + es + "'><li class='tree-item tree-item-dir'>" + name + "</li></div>"); }
	cb_open_dir; // callback passed by client to open a dir (ex open_show_folder); has two params: path and another cb which is passed by sd (it's necessary while open dir is ajax call); this cb accepts single param - the html to show
	root; // root elem
	/* example of cb_open_dir
	function cb_open_dir(path, cb){
		wait_screen.add_operation("open_dir");
		xhr = $.ajax(acid("open_show_folder", {
			data: {'path': path},  // table_where is for RECSUR
			success: cb,
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("open_dir");
			}
		}))
	}*/

	//--------------------------------------------------------- SUBSECT SEL_FOL ---------------------------------- TODO: maybe move to utils
	set_active(dir_item){
		$("#tt_select_folder_root_item .tree-item.active").removeClass("active"); 
		dir_item.addClass("active");	
	}
	switch_dir_state(dir_item){ // SEL_FOL
		var cont = dir_item.closest('.tree-cont');
		var path = cont.data("path");
		var opened = dir_item.hasClass("ttc_folder_opened");
		this.set_active(dir_item);
		set_selected_string(path); // MD_SS func; somewhat tricky mechanism to pass res dir to user; md_ss calls passed callback with that val
		if(opened){
			cont.children('.tree-cont').addClass('hidden');
			dir_item.removeClass("ttc_folder_opened");
		}else{
			if(dir_item.hasClass("ttc_folder_once_opened") ){  // opened&closed
				cont.children('.tree-cont').removeClass('hidden'); // show childs (need only .tree-cont of next level) NOTE: in sd need it also because if user creates a dir - need keep it present after close/open
				dir_item.addClass("ttc_folder_opened");
			}else{
				this.open_dir(path, cont);
			}
		}
	}
	find_path_cont(path){
		return $(".tree-cont[data-path='" + path + "']");
	}
	// open a path recursively beginning from the first elem to the last
	open_dir_seq(curr_path, path){ 
		var cont = this.find_path_cont(curr_path);
		var dir_item = cont.find(".tree-item");
		if(!path.replace(/\/$/, "")){ // all already opened
			// if only one elem remains in path - just select it
			if(cont.length)
				this.set_active(cont.find(".tree-item"));
			return;
		}
		this.close_cont(cont); // need it only for the very first elem (and only if it was opend)
		var t = this;
		wait_screen.add_operation("open_dir");
		this.cb_open_dir(curr_path, function(res){
			dir_item.addClass("ttc_folder_opened");
			dir_item.addClass("ttc_folder_once_opened"); // indicates if was opened at least once (and thus contains already info about childs) TODO: to use it need also set it true when showing already opened folders (show_tree)
			if( res.length>2 ){ // empty json may be """"
				cont.append(res);
				cont.find(".col-lg-12").removeClass("col-lg-12"); // TODO: temp LG12
				//
				var path_elems = path.replace(/\/$/, "").split("/");
				var top_path = path_elems[0];
				path_elems.shift();
				var next_path = curr_path + top_path + "/";
				t.open_dir_seq(next_path, path_elems.join("/") + "/");

			}
		})
	}

	open_dir(path, cont){ 
		wait_screen.add_operation("open_dir");
		var dir_item = cont.find(".tree-item");
		this.cb_open_dir(path, function(res){
			dir_item.addClass("ttc_folder_opened");
			dir_item.addClass("ttc_folder_once_opened"); // indicates if was opened at least once (and thus contains already info about childs) TODO: to use it need also set it true when showing already opened folders (show_tree)
			if( res.length>2 ){ // empty json may be """"
				cont.append(res);
				cont.find(".col-lg-12").removeClass("col-lg-12"); // TODO: temp LG12
			}
		})
	}
	close_cont(cont){
		cont.find(".tree-cont").remove();
		cont.find(".tree-item").removeClass("ttc_folder_opened");
		cont.find(".tree-item").removeClass("ttc_folder_once_opened");
	}
	create_folder(name=""){
		if(!name)
			name = document.getElementById("tt_new_folder_text").value; // TODO: disable button if empty (add hint 'insert name')
		if(!name){alert(lp("ins_name"));return;}
		var parent = this.get_selected();
		if(!(parent && parent.length))
			parent = this.root;
			//parent = $("#tt_select_folder_root_item");
		// NOTE: after adding SEL_FOL_ROOT parent must always be not null
		var parent_path = parent && parent.length? parent.data("path") : "";
		var new_fol = this.create_empty_folder(parent_path, name);
		parent.append(new_fol);
		this.set_active(new_fol.find(".tree-item"));
		set_selected_string(parent_path+name+'/'); // MFB, added end-slash
	}
	get_selected(){ var item = $("#tt_select_folder_root_item .tree-item.active"); return item.length? item.closest(".tree-cont") : null; } // used only for STEPS now
	get_selected_path(){ var cont = this.get_selected(); return cont && cont.length? cont.data("path") : ""; }
	// ---------------------------------------------------------------------------------------------------------------
	// ---------------------------------------------INTERFACE---------------------------------------------------------
	// ---------------------------------------------------------------------------------------------------------------
	constructor(cb_open_dir){
		this.cb_open_dir = cb_open_dir;
	}
	init_form(root_dir){
		var t = this;
		$("#tt_select_folder_root_item").html("");
		// SEL_FOL_ROOT : if need move files to root folder - need have it in the dialog
		var rd = root_dir, rn = ''; if(root_dir){ 
			var m = root_dir.match(/^(.*\/)?([^\/]+)\/$/);
			rd = m[1]; rn = m[2];
		}
		this.root = this.create_empty_folder(rd, rn);
		this.root = $(this.root); this.root.find(".tree-item").addClass("mc_root"); // now jus need it to allow client to add css to it
		//this.root.find(".tree-item-dir").addClass("active");
		$("#tt_select_folder_root_item").append(this.root);
		$('#tt_select_folder').attr("onclick", "").unbind("click");
		$('#tt_select_folder').on('click','.tree-item-dir', function(){t.switch_dir_state($(this));});   // NOTE: need it here (although similar is in init but not work when place in init - maybe because div gets att/de-tached)
		// NEW_FOL
		$('#tt_new_folder_btn').attr("onclick", "").unbind("click");
		$("#tt_new_folder_btn").click(function(){t.create_folder()});
	}
	// SEL_FOL INTERFACE funcs
	// callback(selected path or null)
	// TODO: why callback is passed here, not in constr?
	select_folder(callback, root_dir=""){ // SEL_FOL ex show_select_folder
		show_select_string(callback,"",$("#tt_select_folder"));
		this.init_form(root_dir);  // this is in a sep func to be able to use sd without md_ss, on custom form
		this.open_dir(root_dir, this.root);
		this.set_active(this.root);
	}
}
