/*
	9.12.21
	author alex nosurov
	special ver of table_tree.js for simple use in apap
*/

//------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT VARS (getters, setters, simples) -----------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------------------------

// NOTE: it should be path (string, not dom elem)
var tt_holder; // the main cont which contains all html
var current_dir_item = null; // .tree-item CURREL DEF for MH it's necessary to track the current directory (last selected);  note: javascript object (not jquery) NOTE: do not need it actually, may just use $(".tree-item.active")[0]
var current_dir = ""; // added 24.01.20 ; properly path; 
var prev_current_dir_item = null; // .tree-item CURREL DEF for MH it's necessary to track the current directory (last selected);  note: javascript object (not jquery) NOTE: do not need it actually, may just use $(".tree-item.active")[0]
var target_dir = null; // the dir upon which last right click was made (popup target); js (not jquery) elem
var current_item = null; // CURREL NOTE: now it's id; may happen that curr elem not present in tree (show_files=0)

function get_cont(elem){
	return elem.closest('.tree-cont');
}
function get_data(elem, param){
	var res = get_cont(elem).data(param);
	return (typeof res === "undefined")? "" : res;
}
function set_data(elem, param, value){
	get_cont(elem).data(param, value);
}
function get_item(cont){
	return cont.children('.tree-item').first();
}
function get_elem(cont){
	return cont.children('.tree-item').children('.tree-elem').first();
}
function get_parent(cont){
	return cont.parent('.tree-cont');
}
function get_thumb_cont(thumb_child){ // thumb_child is some inner elem - img or ref..
	return thumb_child.closest('.thumb');
}
function get_id_detail(id){
	return detail_view=="thumbs"? tt_holder.find(".thumb[data-id='" + id + "']") : tt_holder.find(".clickable-row[data-id='" + id + "']");
}
function get_id_elem(id){return tt_holder.find('.tree-file.id'+id);} // return elem by file id
function get_path_cont(path){ // DIRTHUMB  find elem in dir-tree corresponding to a folder in thumb panel
	return cont = tt_holder.find(".tree-cont[data-path='" + path + "']");
}
function is_dir(elem){
	return elem.hasClass('tree-dir') || elem.hasClass('thumb-dir'); // latter is for detail elem
}
function is_file(elem){
	return elem.hasClass('tree-file');
}
// 
function dir_opened(cont){ // shows if the cont (from explorer) was opend and then closed; CORRECTION: seems now used to indicate if currently opened; for opened/closed is used opened_closed() 
	return get_item(cont).hasClass("ttc_folder_opened");
}
function set_table(t){ table_tree = t; }
function set_table_files(t){ table_files = t; }
function get_table(){return table_tree;}
function set_where(w=""){ table_where = w; }
function get_where(){return table_where;}
function get_target_dir(){return target_dir;}  //CURREL returns
function set_target_dir(td){ return (target_dir=td); }
function get_curr_dir_item(){return current_dir_item;}  //CURREL returns
function set_curr_dir(path){current_dir=path;}
function get_curr_dir(){return current_dir;}
function set_curr_dir_item(jquery_obj){ prev_current_dir_item = current_dir_item; current_dir_item = jquery_obj[0]; $(".tree-item.active").removeClass("active"); jquery_obj.addClass("active"); set_curr_dir(get_data(jquery_obj, "path"));}
function get_curr_item(){return current_item;}  //CURREL returns
function set_curr_item(item){ current_item = item;} // TODO: need sync curr item table-tree
// SELIN
var on_select = 0;
function set_on_select(f){
	on_select = f;
}
var project_name = ""; // SHARE must equal to the name of php file in ./share/ folder
function set_project_name(pn){project_name=pn;}
var table_tree = "";
var table_files = ""; // corresponds to = of model/db.php
var table_where = ""; // additional condition applied when a node is opened; NOTE: now is applied only for opening and not for find/stat
var files_order = null; // FIORD
var table_tree_path = "table_tree/", contr_path = "table_tree/contr/main.php";
function set_table_tree_path(tp){ table_tree_path = tp; contr_path = tp + "contr/main.php"; }

function tt_get_elem_name(elem){ return elem.hasClass("mc_file")? elem.find(".file-ref").html() : elem.data("path"); }

//--------------------------------------------------- ESECT VARS (getters, setters, simples) -----------------------------------------------------------------


//------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT UTILS  --------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------- SUBSECT ADD_INFO --------------------------------------------------------------------------------
// DEF ADD_INFO stuff used to show some additional info for files/folders; user should provide funcs func(elem) and pass them by add_info_handler; normally user funcs use ajax
// object containing custom callback which is used to display additional info; the client should set the callback for each application
var add_data = {
	// called each time a result is added to the tree; param = parent element;
	// selects not processed file/dir items - <li> elements which contain visual data; calles user defined handlers; marks elements as processed;
	// then does same thing for folders
	run : function(parent_cont){
		parent_cont.find('.tree-item').each(function(index){
			var elem = $(this);
			var processed = elem.data('processed');
			if( typeof processed == 'undefined' || processed == false){ // not yet processed ~ attr 'processed' not yet exists 
				if( elem.hasClass('tree-item-file') )
					add_data.process_file( elem );
				if( elem.hasClass('tree-item-dir') )
					add_data.process_dir( elem );
				set_data(parent_cont, 'processed', true);
			}
		});
	},
	// THIS IS THE PART THAT USER MUST REDEFINE if necessary to add some additional visual data to html (or somehow process each added file/dir)
	// to get some data use get_data: 
	process_file: function(file){return true},
	process_dir : function(dir ){return true}
}
// adds 'additional info handler' - the function which adds some non-standard info about an element
// elem_type = file/dir/all
function add_info_handler(handler, element_type='all'){
	switch(element_type){
		case 'file': add_data.process_file = handler; break;
		case 'dir' : add_data.process_dir  = handler; break;
		case 'all' : add_data.process_file  = handler; add_data.process_dir  = handler;  // TODO: only this is used now;
	}
}

//--------------------------------------------------------- SUBSECT ADD ACTION --------------------------------------------
// DEF AA adding action button 
// action is an obj: {id, handler (function defined in client), caption}
function add_action(action){
	$('#tt_buttons').removeClass('hidden'); // gets visible if at a button added
	var btn = $('#tt_buttons').append('<button type="button" class="btn btn-success btn-sm" id="' + action.id + '">' + action.caption + '</button>&nbsp;');
	// onclick contains some validation logic and then calls user handler, passing to it the list of selected paths
	$('#' + action.id).on('click',function(){
		var selection = find_selection();
		if( selection===0 )
			show_alert(lp("no_file_sel"));
		else
			action.handler(selection.paths, selection.files); // TODO: maybe call it by ajax (wait screen)
	})
	return $("#"+action.id);
}

//--------------------------------------------------------- SUBSECT REQUEST DATA ------------------------------------------------
// DEF RD sometimes it's necessary to repeate request; eg when user requests re-order files
var request_data = null;
function rd_set(data){ request_data = data; }
function rd_get(){ return request_data; }
function rd_run(){
	if(request_data)
	switch(request_data.type){
		case "open": 	open_dir(request_data.path, request_data.cont); break;
		case "open_rec": 	open_dir_recursive(request_data.item); break;
		case "find": 	find_files(request_data.params); break;
		case "refresh_cache": 	refresh_cache(request_data.childs); break;
	}
}

function opened_closed(cont){ // shows if the cont (from explorer) was opend and then closed 
	//return cont.children('.tree-cont:hidden').length > 0; 
	var cache = cont.children('.ttc_file_cache').length > 0;   // use this while ttc_folder_opened is not yet finished (not works for find)  HIDEFILES_CACHE; if PFCA - this suffies
	var hidden = cont.children('.tree-cont:hidden').length > 0; // TODO: this method not usable when emtpy dirs possible (in MH); need add some class to opened dir
	return !get_item(cont).hasClass("ttc_folder_opened") && (cache || hidden);
	//return !get_item(cont).hasClass("ttc_folder_opened") && get_item(cont).hasClass("ttc_folder_once_opened");
}
function close_cont(cont){
	cont.children('.tree-cont').addClass('hidden');
}

//--------------------------------------------------------- SUBSECT UTILS MISC TODO-----------------------------------------

function add_slash(s){ return s[s.length-1]=='/'? s : s+"/"; } // adds slash if not yet contains; at the moment it's disorder with having/not having end-slash
// handle search error situation
function search_error(j,errorS,p){
	var msg = '';	
	if(p == 'abort')
		msg = lp("search_stop");
	else if(j.status == 400 && p.indexOf('max_count')==0)
		msg = lpp("$too_many_found$", p.substring(10));
	else if(j.status == 400 && p.indexOf('not_found')==0)
		msg = lp("no_file_found");
	// some unhandled error
	else msg = lpp(p);
	if(p=="no_user"){ // LOGONEXP
		show_login();
		return;
	}
	// show msg
	show_alert(msg);
	j.done();
	//alert(msg);
}

// elem = js object 
function scroll_top_if_hidden(elem){
	if( typeof scrollIntoViewIfNeeded === 'function' )
		elem.scrollIntoViewIfNeeded(true);
	else
		elem.scrollIntoView(true);
}
// TODO: why not used?
function reset_table_tree(){
	$('#tt_explore_root_item').html("");
	clear_detail();
	si_reset();
}

// usage: when user requests some action on selected items (eg delete selected files); the func finds selection and performs passed action-callback
function selection_action(action, confirm_msg=lpp("$continue$?"), ok_msg="OK", error_msg="error"){
	var sel = find_selection(); // tt funcs
	var snap_info = {'paths': JSON.stringify(sel.paths), 'files': JSON.stringify(sel.files) }; // NOTE: paths are not used now, maybe; need control if selecting folders in thumb form works
	// stat selected files
	wait_screen.add_operation(action);
	xhr = $.ajax({
		type: "POST",
		data: {'action' : action, 'paths' : snap_info.paths, 'files' : snap_info.files, "user_dir": user_dir, 'summary' : 1},
		url: 'contr/main.php',
		success: function(res){
			var count = res;
			if(confirm(lpp("$sel_n_files$, $2", res, confirm_msg))){
				xhr = $.ajax({
					type: "POST",
					data: {'action' : action, 'paths' : snap_info.paths, 'files' : snap_info.files, "user_dir": user_dir, 'summary' : 0},
					url: 'contr/main.php',
					success: function(res){
						alert(ok_msg);
						open_root_dir();
					}})
			}
		},
		complete: function(){
			wait_screen.remove_operation(action);
		}
	})
}

// ---- ALERT _----  TODO: move to a util lib
// 26.03.20 had to give tt_alert up while search panel (which holds it) is hidden normally; also other panels are shown/hidden dynamically, so hard to find some to hold it permanently; note: also search panel now hides upper screen part, so even can't use to container to show alert
function show_alert(msg, id="tt_alert"){
	alert(msg); return;
	var html = '<div class="alert alert-danger" role="alert">';
	html +='<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
	html +='<strong>' + lp('attention') + '!</strong><br>' + msg;
	html +='</div>';
	$('#' + id).html(html);
}
function clear_alert(id="tt_alert"){
	$('#' + id).html("");
}
// DEF SHARE: tricks to allow the same code to use for different projects (like needed in mh - to explore files and explore mails);
// acid (Add Controller Data) is just used to add the data which is sent in each controller call
// NOTE: in js params passed by ref note that sometimes data passed to contr is enormous, so passing to and fro by value would be costful
function acid(action,  params ){
	params.type = "POST";
	params.url = contr_path;
	if(!("data" in params))
		params.data = {};
	params.data.action = action;
	params.data.table = table_tree;
	params.data.table_files = table_files;
	params.data.project = project_name; // SHARE
	params.data.order = ro_to_str(files_order); // FIORD
	params.data.user_dir = user_dir; // MUSD
	if(show_files!==null) params.data.show_files = show_files?1:0; // HIDEFILES
	return params;
}

//--------------------------------------------------- ESECT UTILS  -------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT OPEN / FIND  -------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------- SUBSECT OPEN / FIND MISC  --------------------------------------------------------------
// TODO: this should be counted in SARE?
function open_root_dir(cond=''){ // cond is set when making 'recursive search' 
	set_where(cond); // 3.10.19; added to solve prob: if make search then click 'explore' - keeps using filter; TODO: need bring in order all uses of cond/table_where
	$('#tt_explore_root_item').html('');
	open_dir('', $('#tt_explore_root_item'));
	si_reset();
}
function show_plain(json_list, id=0){ // can pass list of paths or ids (id=true)
	thumbs_list = json_list; // FIRE save thumb list to use to show next portion TODO: id=0/1 => json_list may have different formats, so thumb_list also may have diff. form?.. turns out that 'id' flag arrives always to show_thumbs_portion (but by params); the fact that thumb_list is global while 'id' local - makes some confusion
	// clear_detail(); commented: can't be here: if have 2 requests at same time - they both clear and then both add
	if(detail_view=="thumbs")
		show_thumbs_portion(0, page_size, id); // FIRE next portion
	else
		show_table_portion(); // DETA
}

var thumbs_list; // FIRE
var page_size = 50; // FIRE CASE  after each data fetch this should be re-set to 0;
// this function is called by pager and should call all other funcs which page output of files
function show_page(page){ // FIRE CASE TODO: do not get: now pages work only for DETA (not for thumbs)?
	clear_detail(false);
	show_table_portion((page-1)*page_size, false);
}
// closes removing (not hiding) child elems
function close_dir_recursive(item){
	var cont = get_cont(item);
	cont.children('.tree-cont').remove();
	get_elem(cont).prop('indeterminate', false);
	update_parent_selection(cont);
}
// hides and clears panels
function def_search_fields(){
	var params = acid("search_fields", {}); // normally acid is used to return array for ajax; here is used only .data (while call_php_async takes several params instead of one object)
	var resp = call_php_sync(contr_path, params.data, 'POST'); 
	return resp.resp_text;
}



//--------------------------------------------------------- SUBSECT USER ACTIONS ------------------------------------------------

// e = tree-item; logic of opening a dir: if already was opened - show hidden childs and their thumbs; else - open_dir
function dir_click(e){ // NOTE: input not receives event on name click - it's out of input
	var dir = $(this);
	e.preventDefault();
	if(dir[0]==get_curr_dir_item()) // DBLOPEN
		switch_dir_state( dir , e.ctrlKey, e.shiftKey);
	//
	set_curr_dir_item(dir); // CURREL
}
// 	find files action ; form - jquery obj
function find_files_form_click(form){
	if(ff_empty( form ) ){
		show_alert(lp("no_filter_cond"));
		return false;
	}
	var recursive_search = $("#tt_find_recursive").prop("checked");  // RECSUR
	var params = ff_params(form);
	reset_table_tree(); // new, not checked
	if(recursive_search){ // ex-start_recursive_search()
		var where = compile_search(params);
		open_root_dir(where);
	}else
		find_files(params);
}
function find_files_click(){	find_files_form_click( $("#tt_search_form") );  }

//
function switch_dir_state(dir, ctrl, shift){
	var path = get_data(dir, 'path');
	var level = get_data(dir, 'level');
	var cont = get_cont(dir);
	var opened = dir_opened(cont);
	// special reaction if ctrl pressed - open/close recursively
	if(ctrl){
		if(opened) close_dir_recursive( dir );
		else        open_dir_recursive( dir );
		return;
	}
	// normal open/close
	if(opened){
		close_cont(cont);
	}else{ // not ever opened or opened/closed
		if(opened_closed(cont) ){  // opened&closed
			cont.children('.tree-cont').removeClass('hidden'); // show childs (need only .tree-cont of next level)
		}else // not ever opened
			open_dir(path, cont);
	}
	// DEF SAVEOPEN need a way to say if a folder is opened independently on if it has some childs; reason: in MS diplaying files (=mails) in explorer may be turned off, so the old way "child.count>0" not works
	// TODO: now it's realized only for simple user click case; need also: recursive open; find-, find+ ...
	dir.toggleClass("ttc_folder_opened");
	dir.addClass("ttc_folder_once_opened"); // indicates if was opened at least once (and thus contains already info about childs) TODO: not used now; to use it need also set it true when showing already opened folders (show_tree)
}
function on_select_item(e){ // on_item_click on_click_item
	e.stopPropagation();
	update_item1($(this));
}
function row_order_click(header){
	ro_set(ro_extract(header)); // FIORD
	// TODO: refresh...
	rd_run();
}



//--------------------------------------------------------- SUBSECT SERVER DATA REQUESTS  ------------------------------------------------------------------------

function open_dir(path, cont){ // TODO: by idea cont.data("path") = path, so no need to pass it
	rd_set( {type:"open",path:path,cont:cont} ) ; // DEF SARE Save Request used for FIORD; save data of request to re-run when user requests change show order
	clear_alert();
	wait_screen.add_operation("open_dir");
	xhr = $.ajax(acid("open_dir", {
		data: {'path': path, 'cond' : table_where, 'use_paths': use_paths, 'shm_table_num': shm_table_num},  // table_where is for RECSUR
		success: function(res){
			if( res.length>2 ){ // empty json may be """"
				// show child elems 
				render_childs('show_dir', path, res, cont, false, function(){
					// 20.11.18 select newly opened folders if parent was selected; this also selects thumbs
					if(path!="" && get_elem(cont).prop("checked") )
						set_childs_selected( cont, true ); // here not need yet set thumb state - they are not yet shown
				});
				// show plain 
				//show_plain(res); moved to render_childs
			}
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("open_dir");
		},
		//error: search_error,  commented 13.04.20 - if open empty ws - shows error; this is rather for empty search 
		global: false
	}))
}
function open_dir_recursive(item){
	rd_set( {type:"open_rec",item:item} ) ; // SARE 
	var path = get_data(item, "path");
	var cont = get_cont(item);
	var elem = get_elem(cont);
	clear_alert();
	wait_screen.add_operation("open_dir");
	xhr = $.ajax(acid("open_dir_recursive", {
		data: {'path': path, "cond" : table_where},   // table_where is for RECSUR
		success: function(res){
			render_childs('show_tree', path, res, cont, false, function(){set_childs_selected(cont, elem.prop('checked') );}); // show_tree selects items by default, need deselect them
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("open_dir");
		},
		error: function(j,errorS,p){} // TODO: send 400 on empty res and catch it here
	}))
}
// RECSUR sets table_where; input = array of params (in format of search form); normally controller receives data in raw format (from form) and compiles, but sometimes compiled format is also necessary here (or rather always) 
// TODO: in fact it's called anyway if called find_files_click, so could call it from there, the only exception is that find_files may fail (in this case need table_where still = ''); but may unset where in search_error()
// TODO: the 'compile_search' action in contr uses the standard get_filter_fields() func, so can't be used to compile any search
function compile_search(params){
	var params_compiled_json = call_php_sync(contr_path, {'action' : 'compile_search', 'table' : table_tree, 'params' : JSON.stringify(params), 'project' : project_name}, 'POST');
	return JSON.parse(params_compiled_json.resp_text);
}
// performs search of files (calls php) according to filter form
function find_files(params){
	rd_set( {type:"find",params:params} ) ; // SARE 
// params - conditions from search form (not yet compiled, that is without info from metadata)
	set_where(); // cancel possible prev recursive search RECSUR
	clear_alert();
	wait_screen.add_operation("search");
	xhr = $.ajax(acid("find", {
		data: {'params' : JSON.stringify(params) , 'max_count': 7000, 'shm_table_num': shm_table_num},
		success: function(res){
			set_where( compile_search(params) ); // new 12.03 this is only used when finding statistics   DEF FIND_COND save find params in table_where to use them on folder opers like stats, size (now may select also folders in find res)
			// show tree 
			$('#tt_explore_root_item').html("");
			var renderer = $("#tt_full_view").prop("checked")? "show_tree_complete" : "show_tree"; // tt_full_view - button "+" (search plus)
			render_childs(renderer, "", res, $('#tt_explore_root_item'), true, null, true);
			// show thumbs
			show_plain(res);
		},
		error: search_error,
		complete: function(xhr, stat){
			wait_screen.remove_operation("search");
		}
	}))
}
//--------------------------------------------------------- SUBSECT SERVER VIEW REQUESTS ------------------------------------------------------------------------
//INITIAL VIEW REQUEST (show as tree and call other (plain) views (table/thumbs) ---------------------------------------------------------------------------------

// shows files; input: files list in json format (found previously by open_dir or find_files); output: result html is added to the cont
// TODO: donno why, wait screen show is made only by search_started (not show_started), so need call former before calling render_childs; or need show screen also in show_started (better)
// INC DEF : when files are res of search - that means that a folder childs are (may be) incomplete - exist other, not displayed files of this folder; when a file is deselected and the selected and it's the only file in its folder - the parent folder is set selected by update_parent_selection); that causes wrong selection result: folder is sent as selected and all files in it are included; possible solutions: 1. disable parent selection in 'find mode' or 2: not send at all paths in 'find mode'; may happen that user may want to select the whole folder on purpose, meaning that needs all files from it, thus the (2) not fits, so use (1); Realization: find_files passes further info that folders may be incomplete and the 'incomplete' class is added to files and accounted for in update_parent_selection(). 
var found_count = 0; // FIND_COUNT found in render_childs but used in show_thumbs_portion (while takes much time between these calls and info already fades); TODO: need some better way to sync
// renderer = show_dir/show_tree/show_tree_complete
function render_childs(renderer, path, json_list, cont, close_selected=true, call_back=null, incomplete=false){ // renderer - is the name of contr/main function which should process json list
	wait_screen.add_operation("show_tree");
	xhr = $.ajax(acid(renderer, {
		data: {'path' : path, 'childs' : json_list}, // TODO: was used encodeURI... which not works  TODO: path seems not used; but now use it as "start_path" for the open_dir_recursive (contr/main show_tree/show_tree_id)
		success: function(res){
			cont.children('.tree-cont').remove(); // this may be useful when re-request SARE
			cont.append(res);
			add_data.run(cont);
			found_count = cont.find(".tree-item-file").length; // FIND_COUNT remember count
			if(incomplete) $(".tree-cont").addClass("incomplete");  // INC
			$('.indeterminate').prop("indeterminate", true); // NEW to show half-selected state
			// new 21.09.18 after showing a sub-tree may be convenient not to display contents fully selected nodes; note: can't just call it after render_childs call, the latter is async
			if(close_selected)
				cont.find('.tree-dir:checked').each( function(){  close_cont(get_cont( $(this) ) ) ;	});
			// HIS Hidable Instrument Panel // this event indicates that need close nagiv panel (this happens only on successfull search)
			$(".tt_hide_on_render").addClass("hidden"); // TODO: what is this
			// now used only to select child files in open_dir
			if( call_back ) call_back(); // call it before show_plain, while latter makes selection synch
			// new: show thumbs is here now; othewise selection synch not works (starts when files not yet shown) TODO: bug: before, it wasn't called for case: renderer=show_tree_id - here need call show_plain(list, true)
		},
		complete: function(xhr, stat){
			wait_screen.remove_operation("show_tree");
		}

	}))
}
//--------------------------------------------------- ESECT OPEN / FIND ----------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT SELECTION  -------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------------------------------------------------------------------------

//--------------------------------------------------------- SUBSECT SELECTION BASIC ---------------------------------------------------------------------
// get only selected files; made to be used in apap when tree contains all files
function get_selected_files(){
	var sel_files = [];
	tt_holder.find('.tree-file:checked').each( function(index){  sel_files.push( get_data($(this), 'id') ) })
	return sel_files;
}

// returns lists of selected files folders {paths:, files:} ; performs also exclusion of selected sub-paths
function find_selection(){
	// build list of all paths
	var all_dir = [];
	tt_holder.find('.tree-dir:checked').each( function(index){ 
		if(!get_cont( $(this) ).hasClass("incomplete") )  // INC_CORR  folders are not added if incomplete (only internal files will be added)
			all_dir.push( get_data($(this), 'path') ) })
	// exclude subpaths (if parent selected - all inside is selected (if opened) )	
	all_dir.sort();
	var unique = [];
	var unique_prev = '';
	for(i=0;i<all_dir.length;i++)
		if( unique_prev.length && all_dir[i].startsWith( unique_prev ) 
			&& unique_prev[unique_prev.length-1]=='/' ) // need also check that prev elem is folder; or else may happen one file name contains other (and will be omitted); TODO: not a good way to check if elem is a folder; may happen that paths will be passed without endslash
			continue;
		else
			unique.push(unique_prev = all_dir[i]);
	// select all elems of fil/dir class
	var sel_files = [];
	tt_holder.find('.tree-file:checked').each( function(index){ 
		var path = extract_path(get_data($(this), 'path'), true); 
		for(var i = 0; i<unique.length; i++)
			if( path.startsWith(unique[i])) 
				return;
			sel_files.push( get_data($(this), 'id') )  // TODO: why file path has also name?
	})
	return {"paths": unique, "files": sel_files};
}

// all child elements of selected/deselected element are set to the same (new) state
// selection logic: if some elem is unselected - all chain of its parents is unselected
function update_item1(elem){
	var path = get_data(elem, "path");
	var id = get_data(elem, "id");
	var selected = elem.prop('checked');
 	update_item(id, path, selected, is_dir(elem), get_cont(elem));
}
// the actual action for the onselect event
// NOTE: when no files shown and the target is a file - can't pass target tree-elem, instead find and pass the parent folder (parent_cont)
// used also for SEL_SYNC detail -> tree (called from on_row_select
function update_item(id, path, selected, isdir, cont=null, parent_cont=null){
	if(cont)
		set_childs_selected(cont, selected);
	// NOTE: moved it after sel cache, parent sel should be updated after sel cache is set
	if(cont){
		update_parent_selection(cont);		
	}else if(parent_cont)
		update_parent_selection(parent_cont, false);		
	if( on_select ) // client callback; now used only for SELIN NOTE: could call it from set_childs_selected - but sometimes it's just extra work (when all childs of selected parent are set selected)
		on_select( find_selection() );
}
// set all childs of given cont to give state
function set_childs_selected(cont, selected, call_onchange=true){
	cont.find('.tree-elem').each(function( index ) { // this selects checkbox of the container and its childs
		if(index!=0){ // this is to avoid changing state of the parent-cont itself, which may be undesirable (in open_dir_recursive)
			$(this).prop('checked',selected); // TODO: why need each? if instead: cont.find('.tree-elem').prop('checked', selected);
			$(this).prop("indeterminate", false); // only this was necessary to solve SEL_ANIMALS
			//$(this).trigger("change"); // onchange isn't envoked when state changed by js, so call it here; commented while onchange is for single elem click; besides not always necessary
		}
	});
}

// 9.12.21 this ver is used in apap only; called manually by client
function update_parent_selection(cont, find_parent=true){
	if(!cont) return; // used by on_row_select
	// if( cont.hasClass("incomplete") ) return; // INC parents remain always unselected (only may select manually)    DEF INC_CORR - correction: instead of keep folders 'incomplete' always de-selected - do not add them at all (in find_selection); when a folder selected - all files in it will be selected (and added); thus have same logic as in 'search minus' and other similar; thus can't select whole folder (including files not satisf. cond), which yet may be necessary. for this - need use 'search plus' mode
	var par = find_parent? get_parent(cont) : cont;
	if(!par.length) return;
	// var re = $('#tt_explore_root_item');	if(!par.length)	if(cont[0]==re[0]) // top level reached	return;	else	par = re; thought it would resolve the SEL_ANIMALS, but nope (it's updating of the parent not item itself (no need to update root container))
	// A: check selection state of all immediate childs (files/folders)
	// NOTE: with SELECTION this is used only to check dirs; TODO: when SELECTION tested - need remove checking files from here (use .tree-cont.tree-dir seems)
	var all_sel = true;
	var all_desel = true;
	par.children('.tree-cont').each( function(){
		var elem = get_elem( $(this) );
		var sel = elem.prop('checked')
		var ind = elem.prop('indeterminate')
		all_sel = all_sel && sel && !ind; // here actually ind === false
		all_desel = all_desel && !sel && !ind;
	} );

	// set found selection and recurse to parent
	var par_elem = get_elem(par);
	par_elem.prop('checked',all_sel); // TODO: why need each? if instead: cont.find('.tree-elem').prop('checked', selected);
	par_elem.prop('indeterminate', !all_sel && !all_desel); // TODO: why need each? if instead: cont.find('.tree-elem').prop('checked', selected);
	update_parent_selection( par );
}


function select_all(state=1){ // this would be much easier if having always root element TODO:
	tt_holder.find(".thumb").not(".mc_root").each(function(){
		var elem = $(this);
		if(state) elem.addClass("selected"); else elem.removeClass("selected");
		on_row_select(state, elem.data("id"), elem.data("path"));
	});
}

// TODO: now deselects only tree (not detail)
function deselect_all(){
	$(".tree-elem").prop("checked", false);
	$(".tree-elem").prop("indeterminate", false);
}
//--------------------------------------------------------- SUBSECT SEL_SYNC --------------------------------------------------------
// DEF SEL_SYNC synchronize what's selected/deselected in table view with tree view
// at the moment: is update tree explorer and called update_item, that is: 1. sync thumb->tree 2. call tree.onchange
function set_detail_select(elem, selected=true){
	if(selected)
		elem.addClass('selected');
	else
		elem.removeClass('selected');
}
//--------------------------------------------------- ESECT SELECTION  -------------------------------------------------------------------------------
function tt_get_root(){ return tt_holder.children(".tree-cont").first(); }

function tt_hide_all(){
	var root = tt_get_root();
	root.find(".tree-item-dir").removeClass("ttc_folder_opened");
	root.find(".tree-cont").addClass("hidden");
}

// used when the tree contains recursively (completely) opened branch and need select list of ids
function select_ids(ids){
	if(ids.length)
		tt_holder.find(".tree-cont.mc_file").each( function(){
			var c = $(this);
			if( ids.includes( String(c.data("id")) ) ){
				get_elem(c).prop("checked", true);
				update_parent_selection(c);
			}
		});
}
function select_paths(paths){
	if(paths.length)
		tt_holder.find(".tree-cont.mc_dir").each( function(){
			var c = $(this);
			if( paths.includes( c.data("path") ) ){
				get_elem(c).prop("checked", true);
				set_childs_selected(c, true);
				update_parent_selection(c);
			}
		});
}

// may be useful when need show some selection to user; in this case need open only indeterminate; close all if necessary by tt_hide_all
function tt_open_indeterminate(){
	tt_holder.find(".tree-cont").each( function(){ 
		if ( get_elem($(this)).prop("indeterminate") ) 
			$(this).children('.tree-cont').removeClass('hidden'); // show childs (need only .tree-cont of next level)
	} ); 
}



// --------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT INIT -------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------------------------------------------------

/* 8.12.21 
 	the case when need only explorer
	init_table_tree takes as param "holder" and sets its html which includes also detail
	so need an init func which inits only exporer - tt_explore_root_item
*/
function init_table_tree(holder){
	tt_holder = holder;
	var xhr = ''; // ajax request; need var to be able to abort it TODO: requests may be nested;
	// open/close item
	holder.on('click','.tree-item-dir',dir_click);   // DEF DBLOPEN  first click on a dir (not yet current) only selects it; second - switches state; thus dbl click on non current element switches its state
	// logic of selecting
	holder.on('click','.tree-elem', on_select_item); // TODO: better onchange?
}

