<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB  TODO: move this stuff to standard to be used by all pages*/ ?>
	</head>
	<body style='background: url("<?php echo get_background_path(); ?>") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen tc_single_table'> <!-- NOTE: without this cont appears another horiz scr bar -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script type="text/javascript">

			// TODO: simila to lbs_set_size code
			function fit_img_div(div, img, dw, dh, i_rect){
				div.css("width", dw);
				div.css("height", dh);
				img.css("width", i_rect.w);
				img.css("height", i_rect.h);
				img.css("left",  - i_rect.dw);
				img.css("top",  - i_rect.dh);
			}


			function show_detail(id, re){
				rec = re;
				var dd = $(".ap_detail_div");
				dd.html('<div class="tc_triples_form mc_tt_section mc_page_cont mc_clickable"><div class="tt_thumbs_section"> </div></div>'); // tt wrapper
			}

			// DEF SETCAMP - stuff to set all conds (also camp id) and re-filter records of main table; called from project.js -> show_sel_camp
			function set_camp(id=0){
				var cond = [];
				if(id) cond.push("camp_id="+id); // STAT
				if(client_id) cond.push("client_id="+client_id); // STAT
				apps.set_cond( cond.filter(Boolean).join(" AND ") );
				apps.refresh();
			} 
			
			function on_lbs_rec_sel(rec){ 
				var os = get_lbs_state(rec);
				//if(os=="draft") puh("lbs_draft");
				puh("lbs_" + os);
			}
			// TODO: seems not used
			function get_selection(){ 
				var sel = {orders: orders.get_selection(), apps: apps? apps.get_selection() : $()};
				if(!sel.orders.length && !sel.apps.length)
					sel = {orders: orders.get_active_rec(), apps: apps? apps.get_active_rec() : $()}; // with SINGLE_ACTIVE only one of them is not empty
				return sel;
			}

			function save_pack(sel, client_id, addr){
				var res = call_php_sync("contr/main.php", {"action" : "save_pack", lbs: JSON.stringify(sel), "client_id": client_id, addr: addr}, 'POST'); 
				alert("Pack " + res.resp_text + " created"); // TODO: lp
			}

			function on_show(){
				var rc = $("#table-" + alias_name).find(".td-" + alias_name + "-path").length, rn=0; // RH - resize headers on last rec
				// IPC the view contains path+name for img_id but not contains it for img1,2,3 so find it here in one query and then set thumbs
				var all_img_ids = []; 
				$(".td-" + alias_name + "-img_id1").each( function(){ var id = $(this).html(); if(!all_img_ids.includes(id)) all_img_ids.push(id) } );
				$(".td-" + alias_name + "-img_id2").each( function(){ var id = $(this).html(); if(!all_img_ids.includes(id)) all_img_ids.push(id) } );
				$(".td-" + alias_name + "-img_id3").each( function(){ var id = $(this).html(); if(!all_img_ids.includes(id)) all_img_ids.push(id) } );
				var imgs_thumbs = call_php_sync("contr/main.php", {action : "get_imgs_thumbs", ids: JSON.stringify(all_img_ids) }, 'POST'); 
				imgs_thumbs = JSON.parse(imgs_thumbs.resp_text); // id -> {path,name}
				$("#table-" + alias_name).find(".data-row").each( function(){
					var drec = $(this);
					// show image
					var tdp = drec.find(".td-" + alias_name + "-path");
					var lbs_w = drec.data("r")-drec.data("l")+1, lbs_h = drec.data("b")-drec.data("t")+1; // to find div proportion
					tdp.html("").append( create_img_thumb( drec.data("thumb_small"), lbs_w, lbs_h ) );
					var img = drec.find(".td-" + alias_name + "-img_id1"); var img_id = img.html(); img.html("").append( create_img_thumb( imgs_thumbs[img_id], lbs_w, lbs_h ) );
					var img = drec.find(".td-" + alias_name + "-img_id2"); var img_id = img.html(); img.html("").append( create_img_thumb( imgs_thumbs[img_id], lbs_w, lbs_h ) );
					var img = drec.find(".td-" + alias_name + "-img_id3"); var img_id = img.html(); img.html("").append( create_img_thumb( imgs_thumbs[img_id], lbs_w, lbs_h ) );
					if(++rn==rc){ 
						// IPC ; set headers as camp names ; should be done before fh_init_table
						var cid = get_camp_id();
						if(cid){
							var camp_names = JSON.parse(call_php_sync("contr/main.php", {"action" : "get_prev_camp_names", id: cid}, 'POST').resp_text);
							for(n in camp_names) 
								$(".th-order_lbs-img_id" + n).html( shrink_camp_name(camp_names[n]) );
						}
						fh_init_table( drec.closest(".tc_triples_form") );
					}
					//set_lbs_action(drec);
					//dd.find("table.fh-header").css("top", "20px"); // DEF DET_IMG_OUT - img in detail table stuck out (up); donno now reason; use this quickfix TODO
				});
				// capitals
				$(".mc_field_capt").each( function(){ $(this).html(  $(this).html().toUpperCase() ) } );
				//
				$("#table-"+alias_name).find(".td-"+alias_name+"-date_create").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
				$("#table-"+alias_name).find(".td-"+alias_name+"-date_done").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
			}

			// the result depends on client_id: different set of columns (because of individual md colulmns)
			function create_app_table(){
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", table: table_name, "client_id": client_id}, 'POST').resp_text ); 
				apps = new Tablo(".tt_thumbs_form", $(".mc_search_panel"), table_name, fields.list, fields.search, on_lbs_rec_sel, null, alias_name);
				apps.ro_set("order_id, name", "asc");   // FIORD
				apps.on_show = on_show;
			}
		
			var is_archive = <?php echo isset($_GET["arch"])?1:0; ?>; // DEF ARCH stuff to archive orders; 
			var alias_name = "order_lbs", table_name = "v_order_lbs";
			var is_worker = <?php echo is_worker()?1:0; ?>; // worker may select client 
			var client_id = <?php echo get_client_id(); ?>; // for clients; for workes is set from combo

			$(document).ready( function(){
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				// sel client (for workers)
				if(is_worker){
					var clients = call_php_sync("contr/main.php", {"action" : "get_clients_cb"}, 'POST').resp_text; 
					$(".mc_table_control").append(clients);
					$("#mi_client").on("change", function(){  
						client_id = $("#mi_client").val();
						call_php_sync("contr/main.php", {"action" : "shoc_set", "id": client_id}, 'POST'); 
						create_app_table();
						apps.set_cond("client_id="+client_id ); 
						apps.refresh();
						$("#mi_camp_div").remove();
						show_sel_camp("", ".mc_table_control", client_id);
					});
				}else // if client - just show his camp selector
					show_sel_camp("", ".mc_table_control", client_id);

				create_app_table();
				apps.show();
				//
				$(".ap_detail_div").on("mouseup", ".mc_triple_img", function(){ 
					show_preview( $(this).closest(".tr-" + alias_name).data("img_id") ); 
				} ); // PREVIEW

				$(".mc_download_selection").click( function(){
					var sel = get_selection(); 
					if( sel.orders.length || sel.apps.length){
						var data = {type: "triples", camp_id: get_camp_id(), orders: JSON.stringify(get_data_arr(sel.orders, "id")), apps: JSON.stringify(get_data_arr(sel.apps, "id")) }; 
						var url = extract_path(window.location.href) + "/contr/download.php";
						var ondownload = function(){ update_order_state(sel.orders, sel.apps) } // TODO: would be good to have dl result
						load_file(url, data, "POST", ondownload  );
					}
				});
				// no CRUD for orders
				$(".lbsp_edit, .lbsp_del, .lbsp_new").addClass("hidden");
				$(".lbsp_rec_actions").append("<div class='mc_btn'><i class='mc_new_pack fas fa-box'></i></div>");
				$(".mc_new_pack*").prop("title", lp("create_package"));
				$(".mc_new_pack").click( function(){
					var sel = apps.get_selection(); 
					if(!sel.length){
						alert(lp("no_record_selected"));
						return;
					}
					var addrs = [];
					sel.each(function(){ 
						var addr = $(this).data("delivery_address");
						if(!addrs.includes(addr)) addrs.push(addr);
					});
					var np = $(call_php_sync("contr/main.php", {"action" : "show_create_pack", addrs: JSON.stringify(addrs)}, 'POST').resp_text); 
					show_select_string(function(){ 
						save_pack(get_data_arr(sel, "id"), $("#mi_client").val(), $("#np_delivery_address").val()) 
						}, '', np, lp("create_package"));

				});
				if(!is_worker) $(".lbsp_new").addClass("hidden");
				// dl xls
				$(".lbsp_rec_actions").append("<div class='mc_btn'><i class='mc_dl_xls fas fa-file-excel'></i></div>");
				$(".lbsp_rec_actions").append("<div class='mc_btn'><i class='mc_figu fas fa-file-pdf'></i></div>");
				$(".mc_dl_xls").click( function(){
					var cols = apps.tabcol.visible_columns.filter( c => c!="path" && c!="name_mini" && !c.startsWith("RES") );
					load_file_pro("contr/main.php", {action: "export_csv", table: table_name, alias: alias_name, where: apps.get_where(), cond: apps.get_cond(), "columns": JSON.stringify(cols), order: apps.get_order() }, "POST");
				});
				$(".mc_figu").click( function(){
					load_file_pro("contr/main.php", {action: "figu", table: table_name, alias: alias_name, where: apps.get_where(), cond: apps.get_cond(), "camp_id": get_camp_id() }, "POST");
				});
			});
		</script>
	</body>
</html>
