<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
        require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
	</head>
	<body style='background: url("<?php echo get_background_path(); ?>") no-repeat center center fixed;'> 
                <!-- table_tree -->
                <script src="js/table.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen tc_single_table'> <!-- TODO maybe non need this cont -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
		</div>
		<div id="kladovka" class="hidden">
			<div class="mc_picklist hid mc_sf_row">
				<div><input class='mc_segr_new_user mc_input' title='<?php echo lp("add_user");?>'></div>
				<div class='mc_segr_users' style='flex: 1 1 auto; overflow-y: auto;'></div>
			</div>
		</div>
		<script src="js/treeview.js"></script>
		<script type="text/javascript">
			var user_role;

			function show_picklist(div, values){
				$(".mc_picklist").removeClass("hidden");
                $(".mc_segr_new_user").keypress( function(e){ 
                    if(e.which==13 && $(".mc_segr_new_user").val()){
                        $(".mc_nfd .mc_segr_users").append( $("<div> <input class='mc_input mc_segr_user' value='" + $(this).val() + "'> <i class='mc_segr_user_del fas fa-times'></i> </div>") );
                        $(".mc_segr_new_user").val("");
                    }
                });
				//$(".mc_focused").removeClass("mc_focused"); // or else, if a rec is selected, on enter new
				values = values.split(";");
				$(".mc_segr_users").html("");
				for(var i=0;i<values.length;i++)
					$(".mc_segr_users").append( $("<div> <input class='mc_input mc_segr_user' value='" + values[i] + "'> <i class='mc_segr_user_del fas fa-times'></i> </div>") );
                $(".mc_segr_new_user").focus();
                $(".mc_segr_users").on("click", ".mc_segr_user_del", function(){    $(this).parent().remove();  } );
			}

			// which params visible depends on field type
			function set_new_rec_fields(){
				var md = $(".mc_nfd");
				md.find(".hid").closest(".mc_sf_row").addClass("hidden");
				var ftype = $("#nf_ftype").val();
				if(ftype=="number")
					$("#nf_vmin, #nf_vmax").closest(".mc_sf_row").removeClass("hidden");
				if(ftype=="list"){
					show_picklist(md, $("#nf_vlist").val());
				}
			}
			function show_edit_md_order(id=0){
				if(md_ss_is_shown()) return;
				var md = $(call_php_sync("contr/main.php", {"action" : "show_edit_md_order", "id" : id, "client_id": client_id, "table_name": md_table_name, "range": md_table_range}, 'POST').resp_text); 
				md.addClass("mc_nfd");
				show_select_string(function(){ return save_md_order(id); }, '', md, lp("edit_md_order"));
				ff_init(md);
				$("#nf_ftype").on("change", set_new_rec_fields);
				$("#kladovka .mc_picklist").clone().appendTo(md);
				set_new_rec_fields();
			}
			function save_md_order(id){
				var panel = $("#md_ss_div");
				picks = [];
				panel.find(".mc_segr_user").each(function(){picks.push($(this).val())});
				$("#nf_vlist").val(picks.join(";"));
				var fields = ff_params(panel, true);
				fields["client_id"] = client_id;
				var res = true;
				$.ajax({
					"type": "POST",
					"async": false,
					"url": "contr/main.php",
					"data": {action : "save_md_order", id: id, fields: JSON.stringify(fields), "table_name": md_table_name},
					"success": function(res, dummy, request){
						md_orders.refresh(res);
					},
					"error": function(jqxhr, settings, thrownError){
						res = false; // using async=false and ret res false to not close the dialog
					}
				});
				return res;
			}
			function delete_md_order(id, name){
				var restr = JSON.parse( call_php_sync("contr/main.php", {"action" : "check_md_order_delete", id: id}, 'POST').resp_text );
				if(!confirm(lpp("$Delete$ $md_order$ '$1'?", name))) return;
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "delete_md_order", id: id},
					"success": function(res, dummy, request){
						md_orders.clear();
						md_orders.show();
					}
				});
			}
			function set_client(cl_id){
				client_id = cl_id;
				md_table_name = $("#mi_mdt").val();
				md_table_range = $("#mi_mdt option[value='"+md_table_name+"']").data("range");
				md_orders.set_cond("table_name='"+md_table_name+"' AND client_id="+client_id);
				md_orders.show();
			}
			var md_orders;
			var table_name = "md", alias_name = "md";
			var md_table_name = 'orders';
			var md_table_range = "1;16"; // means the md table uses fields fn1...fn16
			var client_id = <?php echo get_client_id(); ?>;
			$(document).ready( function(){
				set_ajax_error_handler();
				//
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				md_orders = new Tablo(".tt_thumbs_form", $(".mc_search_panel"), table_name, fields.list, null, null, function(rec){show_edit_md_order(rec.data("id"));}, alias_name);
				md_orders.ro_set("forder", "asc");   // FIORD
				md_orders.on_show = function(){ 
					$("#table-"+alias_name).find(".td-"+alias_name+"-RES_email").html("<i class='fas fa-envelope' title='"+lp("send_access_credentials")+"'></i>").click( function(){ send_credentials( $(this).closest(".data-row").data("id") )  } );
					$("#table-"+alias_name).find(".td-"+alias_name+"-forder").html("<i class='fas fa-arrow-up mc_up mc_move' title='"+lp("move_up")+"'></i>");
					$("#table-"+alias_name).find(".td-"+alias_name+"-forder").append("<i class='fas fa-arrow-down mc_down mc_move' title='"+lp("move_down")+"'></i>");
					if(md_orders.get_count()){
						$("#table-"+alias_name+" .td-"+alias_name+"-forder .mc_up").first().remove();
						$("#table-"+alias_name+" .td-"+alias_name+"-forder .mc_down").last().remove();
					}
					$("#table-"+alias_name + " .mc_move").click( function(){ 
						var id = $(this).closest(".data-row").data("id");
						var up = $(this).hasClass("mc_up")?"1":"0";
						$.ajax({
							"type": "POST",
							"url": "contr/main.php",
							"data": {action : "md_order_move", id: id, client_id:client_id, up:up, "table_name": md_table_name},
							"success": function(res, dummy, request){
								md_orders.clear();
								md_orders.show();
							}
						});
						
					} );
				}

				// CRUD
				$(".lbsp_new").click( function(){show_edit_md_order(0);} );
				$(".lbsp_edit").click( 
					function(){
						var rec = $(".tt_thumbs_form").find(".data-row.active");
						if(rec.length==1)
							show_edit_md_order( rec.data("id") );
				});
				$(".lbsp_del").click( 
					function(){
						var rec = md_orders.get_active_rec();
						if(rec.length==1)
							delete_md_order( rec.data("id"), rec.find(".td-md_orders-caption").html() );
				});
				if(ur_role.role=="ADMIN")
					$(".lbsp_del, .lbsp_edit").removeClass("hidden"); // NOTE: donno why now in html/table.html they are hidden by default
				// 
				if(md_table_name=="locations"){ md_table_range = "23;29"; }
				/*cc("get_client_list", function(res){ 
					$(".mc_table_control").append(res) 
					$("#mi_clients").on("change", function(){ set_client($(this).val()) } );
					if( $("#mi_clients").val() )
						set_client($("#mi_clients").val());
				});*/
				
				// 
				$("#heading_left").append("<select id='mi_mdt'></select>");
				$("#mi_mdt").append("<option value='orders' selected data-range='1;16'>"+lp("orders")+"</option>");
				$("#mi_mdt").append("<option value='locations'  data-range='23;29'>"+lp("locations")+"</option>");
				$("#mi_mdt").append("<option value='lbs'  data-range='0;0'>"+lp("lightboxes")+"</option>");
				$("#mi_mdt").append("<option value='packs'  data-range='0;0'>"+lp("packages")+"</option>");
				$("#mi_mdt").append("<option value='lowres_files'  data-range='1;5'>"+lp("visuals")+"</option>");
				$("#mi_mdt").change( function(){set_client(client_id)} );
				//
				set_client(client_id);
			});
		</script>
	</body>
</html>
