<?php
/*
  3.04.2018
  Author: Alex Nosurov
  util functions of the project 'archive'

*/
	require_once(dirname(__FILE__)."/../path.php");

	//function _get_flag_name($resource_name){ return proj_path."flag/$resource_name"; }

	// tries to block during some time (waiting while it unblocks)
	function block_flag($name, $wait_time=0, $contents="", $error_msg=""){
		$flag = flag_path.$name;
		if(!$error_msg)
			$error_msg = "flag '$name' already blocked";
		while ( file_exists($flag) )
			if( $wait_time-- > 0 )
				sleep(1);
			else
				throw new archive_exception($name, 0, state, $error_msg);
		file_put_contents($flag, $contents);
	}
	// quite similar to prev, but witout wait time
	function set_flag($name, $msg='', $rewrite=true){
		$flag = flag_path.$name;
		if(file_exists($flag) && $rewrite)
			unlink($flag);
		if(!file_exists($flag))
			file_put_contents($flag, $msg);
	}
	function unblock_flag($name){
		$flag = flag_path.$name;
		if( file_exists($flag) )
			unlink($flag);
	}
	function check_flag($name){ // return res =  flag exists
		return file_exists( flag_path.$name );
	}
	// shortcut for check_flag, unblock_flag
	function check_unblock_flag($name){
		$res = check_flag($name);
		if($res) unblock_flag($name);
		return $res;
	}
	function read_flag($name){ // return res = resource is free? = flag not exists
		return file_exists( flag_path.$name )? file_get_contents(flag_path.$name) : NULL;
	}
	////////////////////////
	function check_resource($res_name, $res_type, $block_type=""){
		if( $task_id = db\select_field("blocks", "task_id", "res_name='$res_name' and res_type='$res_type'".($block_type? " and block_type='$block_type'":"")) )
			throw new archive_exception($res_name, 57/*$res_type*/, state, "resource is blocked by task $task_id");
	}
	function block_resource($res_name, $res_type, $block_type, $task_id, $block_period="exist"){ // block_period = exist/run; indicates the time when it should exist - only during run or until task cancelled/done (till exists)
		//check_resource($res_name, $res_type, $block_type);
		log\debug("blocking resource: $res_name, $res_type, $block_type; task: $task_id");
		db\execute_to("insert into blocks(res_name, res_type, block_type, task_id, block_period) values ('$res_name', '$res_type', '$block_type', $task_id, '$block_period')");
	}
	function unblock_resource($task_id, $block_period="exists"){
		log\debug("unblocking resources of task $task_id");
		$period = $block_period=="run"? "and block_period='run'" : "";
		db\execute_to("delete from blocks where task_id=$task_id $period");
	}
	// several shortcuts:
	// shortcut for block_resource (pool)
	function block_cache($pool, $task_id){ block_resource( $pool, "cache", "delete", $task_id);}
	// like check_resource (of cache/delete) but not throws; 
	function check_cache_block($pool){ return !db\exists("blocks", "res_name='$pool' and res_type='cache' and block_type='delete'"); }
	// DEF UNTA UNblock TAsks remove blocks of tasks which are not pending any more; in practice it happened only when i deleted manually some test tasks
	function get_all_resource_blocks(){ return db\select_to_array("blocks"); }
?>
