<?php
/*
	Created: 20.02.2018
	Author: Alex Nosurov
	Description: db model functions for the archive
*/
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."utils/db_mysql.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php"); // oder_states
	require_once(proj_path."model/email.php");

	// DEF TEMP_USER: problem: if eg sms is downloaded by link in email - need register event as performed by link-user (may happen that currently used is logged in syst by another account); therefore need a way to supply to funcs, which return curr user info, this temp user info
	// NOTE: first, include the module with var, then set it, then use it
	// note: while there may be diff user/group - temp user must be same as temp group
	$temp_user_id = 0;
	$temp_user_role = "";

	function exec_cmd($cmd, $a, $b="", $c=""){
		exec_log("sudo /usr/bin/php ".proj_path."contr/$cmd.php \"$a\" \"$b\" $c", $o, $r) ;
		return $r;
	}

	function get_client_id($user_id=null){
		//global $is_worker; if(!$is_worker) return 0;  commented 31.1, donno if needed it
		if(!$user_id) $user_id=get_curr_user_id(); 
		$client_id = db\select_field("users", "client_id", "id=$user_id"); 
		/* not using this while client_id maybe also indicates if curr user is a client (not internal) // if(!$client_id){
			$clients = db\select_field_to_array("clients","id");
			if(sizeof($clients)==1)
				$client_id = $clients[0];
		}*/
		return $client_id;
	}
	function get_client_code($user_id=null){if(!$user_id) $user_id=get_curr_user_id(); $clid = db\select_field("users", "client_id", "id=$user_id"); return db\select_field("clients", "code", "id=$clid"); }
	function get_client_list(){return db\select_field_to_array("clients","code");}

	function find_user($name, $pass, $client_code=""){ // used by login controller
		if(!$pass) return false;
		$nc = "name='$name'";
		if($client_code && ($cid=db\select_field("clients", "id", "code='$client_code'")))  // DUP_NAMES
			$nc .= " AND client_id=$cid";
		$user = db\select_record("users","id, pass, pass_temp",$nc);
		if(!$user || !($user["pass"]==$pass || !$user["pass"]&&$user["pass_temp"]==$pass)) // TODO: pass_temp should be used only once
			return false;
		// update last login date
		$now = new DateTime("NOW");
		$now = $now->format( db\get_date_format() );
		db\execute("update users set date_login='$now' where id=".$user["id"]); // save pass in db; this is necessary to connect by imap to user mailbox (now used in delete_old_mails)
		return $user["id"];
	}
	function check_admin($user_id){
		//return db\select_field("users", "admin", "id=$user_id");
		return isset($_SESSION['role']) && role_is_admin( $_SESSION['role'] );
	}
	// $user_id: each role has underlying user (=curr user) or group (=some group of user)
	// teoretically, user may have several groups with same role and they will have different list of shops
	// 4.12.23 BUG: DEF RNC role no changed from popup menu on user click; reason - user id is compared with $_SESSION["roles"][i]["id"], which is id of group (not user); have no idea why need that additional check; roles list contains only roles available for the current user, so seem can pick up any of them, just need make sure before that user is logged in
	function try_set_user_role($user_id, $role){ // set_role set_user_role
		log\debug("HER", $role);
		log\debug($_SESSION["roles"]);
		foreach($_SESSION["roles"] as $r)
			if( 
				$r["id"]==$user_id &&  // 25.04.24 NOTE: it was commented, donno why; thus caused bug: user in two groups with same role (but different shops), was chosen always first one
				$r["role"]==$role){
				set_user_role( $r );
				return true;
			}
		return false;
	}
	// SEL_ROLE ; this should be called only when it's checked that user has $role ; otherwise use try_set_user_role()
	function set_user_role($role){
		if($role["role"]=="SUPERADMIN" && !is_worker()) return; // can't login as superadmin of a client - need select another role SUPER
		$_SESSION['role'] = $role; // array: role => str, shops => array // F_RO
		log\info("user role set to ".$role["role"]);
		log\debug($role);
	}

	function try_set_portal($portal){
		global $portal_list;
		//log\debug("PPP", $portal);
		if(in_array($portal, $portal_list)){
			$_SESSION["portal"] = $portal;
			return true;
		}
		return false;
	}
	// called to setup session for a successfully logged in user
	function setup_user_session($user_id){ // TODO: may be name it function login(){...}
		//session_destroy();
		$user = db\select_record("users","*","id=$user_id");
		$user_name = $user["name"];
		// DEF NO_LOGOUT problem that if have many big files to upload - automatic logout cancells upload
		if(session_status()==PHP_SESSION_NONE){ // or else gives error 'Session ini settings cannot be changed when a session is active' when LOGINOUT 
			ini_set('session.cookie_lifetime', 60 * 60 * 24 * 100);
			ini_set('session.gc_maxlifetime', 60 * 60 * 24 * 100);
		}
		$_SESSION['user_name'] = $user_name;
		$_SESSION['user_id'] = $user_id;
		// SEL_ROLE
		$_SESSION['roles'] = ur_find_roles($user_id); // UR
		log\debug($_SESSION['roles'], "ROLES"  );
		if( sizeof( $_SESSION['roles'] ) == 1 )
			set_user_role($_SESSION['roles'][0]);
		$_SESSION['admin'] = check_admin( $user_id ); // indicates if the uses is admin NOTE: in lightbox need call it after set roles
		$_SESSION['worker'] = $user["worker"];
		/*// need guest to allow to logout (need show initial page with logout icon)
		if( sizeof( $_SESSION['roles'] ) == 0 )
			set_user_role( array("role" => "GUEST", "shops" => array()));*/
		lang_reset();
		lang_get(); // read lang (not using that of curr session, which was used during login)
		log\info("User $user_name $user_id logged in");
		unset($_SESSION["login_fail"]); // LOGIN_FAIL
		// DEF SESCO session presence control; probl is that even if call session_unset/destroy - nothing happens to /var/lib/php/sessions/sid file; so can't use that file; so instead keep my own files in proj_path/sessions/
		exec_log("touch ".proj_path."sessions/".session_id()); 
	}
	function logout(){
		// TODO: better save all user info under one single array-var (to reset with one single assignment)
		$user = get_or_def($_SESSION, 'user_name');
		$sid = session_id();
		global $temp_user_role; $temp_user_role = 0;
		exec_log("rm ".proj_path."sessions/".session_id());  // SESCO
		/*lang_reset();
		unset($_SESSION['user_id']);
		unset($_SESSION['user_name']);
		unset($_SESSION['role']); // DEF SEL_ROLE - stuff to select role (if user has several roles)
		unset($_SESSION['portal']); // PORTAL
		unset($_SESSION['worker']);*/
		session_unset(); // TODO: shit not works
		session_destroy(); // TODO: shit not works
		log\info("Session '$sid' over. User '$user' logged out");
	}
	// needs session started
	function get_curr_user_id(){
		global $temp_user_id; if($temp_user_id) return $temp_user_id; // TEMP_USER
		if(session_id() == '')
			session_start();
		return get_or_def($_SESSION, "user_id");
	}
	// root dir for user (uploaded) files; without end-slash
	function get_user_dir(){
		$user_id = get_curr_user_id();
		return db\select_field("users","email","id=$user_id" )  ;
	}
	function get_user_name(){
		$user_id = get_curr_user_id();
		return db\select_field("users","name","id=$user_id" )  ;
	}
	function get_user_info($param=""){
		if(!($user_id = get_curr_user_id())) return "";
		if(!$param)
			return db\select_record("users","*","id=$user_id" )  ;
		return db\select_field("users", $param, "id=$user_id" )  ;
	}
	// find user by email; while 'find_user' func already exists - need use another name 
	function find_email_id($email){
		//return db\select_field("users", "id", "email='$email'");
		return db\select_field("users", "id", db\in_list("email", $email) ); // version when account may be associated to several emails
	}

	function create_user($name, $email, $pass_temp, $role="", $client_id=0){
		if(user_exists($email, $name))
			throw  new Exception("user '$email'/'$name' already exists"); // TODO: also check not empty?
		db\execute("delete from users where email='$email' and pass is null"); // delete prev registration attempt
		$name = db\escape($name);
		$email = db\escape($email);
		$pass_temp = db\escape($pass_temp);
		$lang = lang_get_curr(); // that which is selected in reg form
		$worker = $client_id? "0" : "1";
		db\execute("insert into users(name,email,pass_temp,user_role,client_id,worker) values('$name', '$email', '$pass_temp', '$role', $client_id, $worker)");
		$id = db\get_last_id();
		save_user_settings($id, array("lang" => $lang));
		ua_register($email, $id, "user", $email, "create", "$email/$name");
		return $id;
	}

	function update_user($user_id, $name, $email, $pass, $role){
		if(user_exists($email, $name, $user_id))
			throw  new Exception("another user '$email'/'$name' already exists"); // TODO: also check not empty?
		$old_email = db\select_field("users", "email", "id=$user_id");
		$name = db\escape($name);
		$email = db\escape($email);
		$pass = db\escape($pass);
		db\execute("update users set name='$name', email='$email', pass='$pass', user_role='$role' where id = $user_id");
		// update groups (ex SEL_GROUP_ROLES, but now check all groups)
		$groups = db\select_id_field_to_array("groups", "id", "email", db\in_list("email", $old_email), "name");
		foreach($groups as $group_id => $group_email){
			$group_email = remove_sep_elem($group_email, $old_email);
			$group_email = add_sep_elem($group_email, $email);
			db\execute("update groups set email = '$group_email' where id = $group_id");
		}
		ua_register($email, $user_id, "user", $email, "update", "$email/$name");
		return $user_id;
	}
	function delete_user($id){
		/* TODO: this is code to delete ws users, for now leave it inactive (admin should del itself)
		$wss = db\select_field_to_array("ws", "id", "owner_id=$id");
		foreach($wss as $ws_id){
			ws_delete($ws_id);
		}*/
		$user = db\select_record("users", "*", "id=$id");
		$old_email = db\select_field("users", "email", "id=$id");
		db\execute("delete from users where id=$id");
		db\execute("delete from settings where user_id=$id");
		$groups = db\select_id_field_to_array("groups", "id", "email", db\in_list("email", $old_email), "name");
		foreach($groups as $group_id => $group_email)
			db\execute("update groups set email = '".remove_sep_elem($group_email, $old_email)."' where id = $group_id");
		ua_register($user["email"], $id, "user", $user["email"], "delete");
	}
	// if id<>0 checks if exists another user with same name/email
	function user_exists($email, $name="", $id=0){return db\exists("users", "email='$email' and name='$name' and id<>$id and pass is not null");}
	function restore_pass($email, $name){ // FORGOT_PASS
		$cond=array(); if($email) $cond[]=db\in_list("email", $email); if($name)$cond[]="name='$name'"; $cond=join(" AND ",$cond);
		if(!$cond || !($users = db\select_to_array("users", "email,name,pass,pass_temp", $cond )))
			throw new user_exception('user_not_exists');
		// send mail
		$settings = get_settings();
		$sm = $settings["alerts"];
		foreach($users as $user){
			if(!$user["pass"]) $user["pass"] = $user["pass_temp"];
			$email = $user["email"];
			$message = lang_html_load("templates/restore_pass", false, array("php_name" => $user["name"], "php_project" => project_name, "php_pass" => $user["pass"], "php_link" => base_url.proj_path_rel."login.php?log_user=".$user["name"]));  //  RESTORE_PASS_NAME version
			send_mail($sm["noreply_email"], "no reply", lp("restoring_password"), $email, $message, $sm, $is_html=true, $img_path="img/");
		}
	}
	function send_credentials($user_id){
		$settings = get_settings();
		$sm = $settings["alerts"];
		$user = db\select_record("users","*","id=$user_id");
		$lang = lang_get_db($user_id, lang_def);
		//log\debug($lang);
		if(!$user["pass"]) $user["pass"] = $user["pass_temp"];
		if(!$user["pass"]) { $pt = generate_random_string(); db\execute("update users set pass_temp = '$pt' where id = $user_id"); $user["pass"] = $pt;}
		$message = lang_html_load("templates/access_credentials", false, array("php_name" => $user["name"], "php_email" => $user["email"], "php_project" => project_name, "php_pass" => $user["pass"], "php_link" => base_url.proj_path_rel."login.php?log_user=".$user["name"], "php_sett" => base_url.proj_path_rel."settings.php", "portal_link" => base_url.proj_path_rel."portal_icon.php?dark"), $lang);
		log\debug($message);
		send_mail($sm["noreply_email"], "no reply", lp("access_credentials"), $user["email"], $message, $sm, $is_html=true, $img_path="img/");
	}
	function register_user($name, $email, $role="", $client_id=0, $location="", $pass_temp=""){
		if(!$pass_temp) $pass_temp = generate_random_string();
		$id = create_user($name, $email, $pass_temp, $role, $client_id);
		// send mail
		$settings = get_settings();
		$sm = $settings["alerts"];
		$message = lang_html_load("html/register_confirm.html", false, array("php_name" => $name, "php_email" => $email, "php_project" => project_name, "php_pass" => $pass_temp, "php_link" => base_url.proj_path_rel."login.php?log_user=$name"));
		send_mail($sm["noreply_email"], "no reply", "registrazione su ".project_name, $email, $message, $sm, $is_html=true, $img_path="img/");
		return $id;
	}
	// check if new login is same that curr login; 
	function same_user($new_user_id, $curr_user_id){
		if($new_user_id==$curr_user_id) return true;
		// only possible case - if curr user is user and new is group that contains it
		$curr_user = db\select_record("users", "*", "id=$curr_user_id");
		if($curr_user["user_type"]!="user") return false;
		$new_user = db\select_record("users", "*", "id=$new_user_id");
		if($new_user["user_type"]!="group") return false;
		return strpos( $new_user["email"].";", $curr_user["email"].";" )!==false;
	}

	function get_mail_settings(){
		$settings = get_settings();
		return $settings = $settings["alerts"];
	}

	function on_end_session(){ // TODO: use it as cb
		exec_log("xx -rf ".proj_path."/fu/server/php/files/".session_id()) ;
	}

	function order_delete($order_id){
		/*foreach(db\select_field_to_array("app_lbs", "id", "order_id=$order_id") as $lbs_id)
			lbs_delete($lbs_id); commented 25.10.22; donno why should del them; lbs is assigned even before order create */
		db\execute("delete from orders where id=$order_id");
	}


	// SETTINGS MODEL
	function read_user_settings($user_id, $param="", $def=null){
		if(!$param)  // all params
			return db\select_id_field_to_array("settings", "pname", "pvalue", "user_id=$user_id");
		$val = db\select_field("settings", "pvalue", "user_id=$user_id AND pname='$param'");
		return $val? $val : $def;			
	}
	function save_user_settings($user_id, $settings){
		foreach($settings as $name => $val){
			if( db\exists("settings", "user_id=$user_id AND pname='$name'") )
				db\execute("update settings set pvalue='".db\escape($val)."' where user_id=$user_id AND pname='$name'");
			else
				db\execute("insert into settings (user_id,pname,pvalue) values ($user_id, '$name', '".db\escape($val)."')");
		}
	}

	// TRAR
    // searches for physical file but only in mirror
    function trar_arch_path($path_rel){
        if(is_file(archive_path1.$path_rel)) return archive_path1;
        if(is_file(archive_path2.$path_rel)) return archive_path2;
        if(is_file(archive_path3.$path_rel)) return archive_path3;
        return ""; 
    }   
    // return all sources containing a path (it may be in all 3 dests while may contain many files)
    function trar_all_paths($path_rel){
        $res = array();
        if(file_exists(source_path.$path_rel)) $res[] = source_path;
        if(file_exists(archive_path1.$path_rel)) $res[] = archive_path1;
        if(file_exists(archive_path2.$path_rel)) $res[] = archive_path2;
        if(file_exists(archive_path3.$path_rel)) $res[] = archive_path3;
        return $res;
    }   

    // DEF TRANSAR trar transparent archive ; if need to download a file - using a mechanism to make it transparent for user, not dependent on if a file is online or need fetch it from a backup
    // the func returns the folder which contains $path_rel (archive or some mirror)
    function trar_src($path_rel, $throw=true){
        if(is_file(source_path.$path_rel))
            return source_path;
        if($ap = trar_arch_path($path_rel))
            return $ap;
        if($throw)
            throw new Exception("trar: file not found: '$path_rel'");
        return ""; 
    }   
    // returns full path where the file exists (path + name)
    function trar_path($path_rel){ return trar_src($path_rel).$path_rel; }

    function trar_path_rel($path){
        if(starts_with($path, source_path)) return substr($path, strlen(source_path));
        if(starts_with($path, archive_path1)) return substr($path, strlen(archive_path1));
        if(starts_with($path, archive_path2)) return substr($path, strlen(archive_path2));
        if(starts_with($path, archive_path3)) return substr($path, strlen(archive_path3));
        return $path;
    }   




	// DEF USER_ACTIONS: stuff to register (log) in db main user actions
	//ua_register($target_user, $target_id, $target_type, $target, $action_type, $action, $action_user);
	function ua_register($target_user, $target_id, $target_type, $target, $action_type, $action="", $action_user=NULL, $size=0){ // action_type: upload/download/
		if($action_user===NULL) $action_user = get_or_def($_SESSION, "user_name");
		$target = substr(db\escape($target), 0, 49);
		$date = db\now();
		try{db\execute("insert into user_actions(date_action, action_user, target_user, action_type, action, target_id, target_type, target, size) values ('$date', '$action_user', '$target_user', '$action_type', '$action', '$target_id', '$target_type', '$target', $size)");}catch(Exception $e){}
	}

	// LINK
	function compile_link($ap_id, $code=""){ return base_url.proj_path_rel."apap.php?id=$ap_id&link=$code"; }
	/* EXLINK function find_link_user($ap_id, $code){
		log\info("searching link $ap_id $code...");
		$email = db\select_field("links", "email", "app_id=$ap_id and code='$code'");
		// TODO: here make check - if already loggin in by another account, maybe force him exit manually
		if(!$email) {
			log\error("link not found $ap_id $code");
			echo "link not valid";
			exit();
		}else
			log\info("link found: $email");
		$user_id = find_email_id($email);
		if(!$user_id){
			log\info("registering new user");
			$user_id = register_user(get_mail_user($email), $email);
		}
		if(session_id() == '')
			session_start();
		setup_user_session($user_id);
		//log\debug($_SESSION);
	}*/

    // SHOPER_VIEW
    function create_shop_camp_view($camp_id){
		// if(!$camp_id) return "shops";
		// LBC from certain camp
		db\execute("CREATE VIEW IF NOT EXISTS v_lbc_camp_$camp_id as SELECT *, (select sum(lb_count) from lbs s where s.camp_id = $camp_id and s.lb_id = c.id)  AS lb_done_count from lbc c where c.istop=1");
		$name = "v_shop_camp_$camp_id";
        $req = "CREATE VIEW IF NOT EXISTS $name as SELECT sh.*, ";
        //$req.= "(select count(*) from lbc where lbc.shop_id = sh.id ) as lbc_count, ";
        //$req.= "(select count(*) from v_lbc_camp_$camp_id where v_lbc_camp_$camp_id.shop_id = sh.id and (lb_done_count is null or lb_done_count<lb_count)) as lbc_todo_count, ";
		// version where lbc_todo_count is 0/1; thus convenient to make filter done/not-done
        $req.= "if((select count(*) from v_lbc_camp_$camp_id where v_lbc_camp_$camp_id.shop_id = sh.id and (lb_done_count is null or lb_done_count<lb_count))>0, 1, 0) as lbc_todo_count, ";
        $req.= "(select count(*) from v_lbc_camp_$camp_id where v_lbc_camp_$camp_id.shop_id = sh.id) as lbc_count, ";
        $req.= "orders.id order_id ";
        $req.= "from shops sh ";
		$req.= " left join orders on orders.shop_id = sh.id and orders.camp_id = $camp_id";
        $req.= " where (select count(*) from v_lbc_camp_$camp_id where v_lbc_camp_$camp_id.shop_id = sh.id) > 0";
		db\execute($req);
		return $name;
	}


	// UR
	// get rights of a certain user
	function ur_find_roles($id, $find_shops=true){
		$roles = array();
		$user = db\select_record("users", "*", "id=$id");
		if($user["user_type"]=="user"){ // has its own rights and from its groups
			// role from users table:  'ADMIN','ENGINEERING','VISUAL_ADMINISTRATOR','GRAPHIC','PRODUCTION_INTERNAL'
			$urs = preg_split('/;/', $user["user_role"], -1, PREG_SPLIT_NO_EMPTY); // now users.user_role is a ';' separated string list of roles
			foreach($urs as $ur){
				if(!$user["worker"] && $ur=="SUPERADMIN") continue; // can't login as client sa SUPER
				$roles[] = array("role" => $ur, "shops" => array(), "id" => $user["id"] );  // F_RO
			}
			// roles from groups table: 'LOCAL_VISUAL','PRODUCTION'
			$email = $user["email"];
			$groups = db\select_to_array("groups", "id, name, user_role", db\in_list("email", $email) ); // TODO: gives false positives for emails like <stuff>$email
		}else{ // user is group => has rights only from this group
			$groups = array($user);
		}
		// NOTE: user's current role may be group's role, so this is the role which belongs to another user (user-group) TODO: why actually need it; seems now it's used for some reason as: get_curr_role_user_id
		foreach($groups as $group){
			$gid = $group["id"];
			$role = array("role" => $group["user_role"], "group" => $group["name"], "id" => $gid ); // DEF F_RO format
			if($find_shops)
				$role["shops"] = get_user_shops($gid, $group["user_role"]);
			$roles[]= $role;
		}
		return $roles;
	}
	// role is array (see ur_find_roles)
	function ur_get_user_role_name(){ global $temp_user_role; return $temp_user_role? $temp_user_role : get_or_def2($_SESSION, "role", "role", "GUEST"); } // TEMP_USER proof
	//function ur_get_user_role_name(){ global $temp_user_role; return $temp_user_role? $temp_user_role : $_SESSION["role"]["role"]; } // TEMP_USER proof
	// returns array with role params: ( role => name, shops =>, id ? )
	function ur_get_user_role(){ return $_SESSION["role"]; } // get_role; call only when logged
	// returns id of user or group which role has been selected on login
	function get_curr_role_user_id(){ global $temp_user_id; if($temp_user_id) return $temp_user_id; $role = ur_get_user_role(); return $role? $role["id"]:0; } // TEMP_USER
	function ur_get_name(){ return isset($_SESSION["role"])? $_SESSION["role"]["role"]:""; } // call only when logged
	//var_dump(ur_find_roles(75));

	// for each role: return list of available pages; 
	// NOTE: each page also has different functions; at the moment each page does it by itself; maybe incapsulate it here too
	function get_role_pages($role){
		if(is_worker()){ // WOC
		if($role=='ADMIN') return array("home","clients","users", "groups");
		if($role=='PRODUCTION') return array("home","clients","orders", "archive", "lbs", "packs"); 
		if($role=='PRINT') return array("packs"); 
		}else{
		if($role=='ADMIN') 	return array("home","campaigns", "shops","users", "groups","md");
		if($role=='IMAGE')	return array("home","ozon","orders", /*"lowres", not used in EVITE*/ "campaigns","shops","archive","lbs");
		if($role=='RETAIL') return array("home","ozon","orders");
		if($role=='LOCAL')	return array("home","ozon","orders");
		}
		return array();
	}
	function get_restricted_pages(){ return array("campaigns","shops","orders","users","groups","hires", "archive"); } // PARC
	// in lightbox it means that if user has access to page - it sees it as admin, eg for shops page - it sees interface to modify shops (not to assign subjects)
	function role_is_admin($role){ return $role=='ADMIN'; }  // TODO 1 : donno if need ENG here
	// get field name of shops table corresponding to given role; role = LOCAL_VISUAL, PRODUCTION
	function is_group_role($role){ return $role=="LOCAL" ; } // OFS


	// NOTE TODO: in SHOP_SINGLE_GROUP this is not used; used only once to move info from groups table to shops table
	// GROUPS  DEF USR
	// now visual/production is saved in groups; yet may need to control shops - which groups are assigned to them
	// this util is used to refresh the cache-field of shops
	function update_shop_roles(){
		update_shop_role("visual_id", "LOCAL");
		//update_shop_role("production_id", "PRODUCTION");
	}
	function update_shop_role($field, $role){
		db\execute("update shops set $field=0");
		$groups = db\select_to_array("groups", "id,shop_paths,shop_ids", "user_role='$role'");
		foreach($groups as $group){
			$sid = $group["shop_ids"]; $sid=str_replace(";",",",$sid);
			$gid = $group["id"];
			if($sid)
				//db\execute("update shops set $field = concat($field,'$name',';') where id in($sid)");
				db\execute("update shops set $field = $gid where id in($sid)");
			$sps = $group["shop_paths"];
			if($sps){
				$sps = preg_split("/;/", $sps, -1, PREG_SPLIT_NO_EMPTY);
				foreach($sps as $path)
					//db\execute("update shops set $field = concat($field,'$name',';') where concat('world/',area,'/',country,'/',city) like '$path%'");
					db\execute("update shops set $field = $gid where concat('world/',area,'/',country,'/',city) like '$path%'");
			}
		}
	}
	function get_shop_group($shop_id, $role){ // get id of group with given role local/prod
		return db\select_field("locations", role_to_field($role), "id=$shop_id");
	}
	// returns email list like email;email... email of all users having given role      //   10.05.2024; donno if dupl
	function find_role_users($role, $client_id){
		$emails = db\select_field_to_array("users", "email", "client_id=$client_id AND ".db\in_list("user_role", $role)); // users and groups (group may have emails like email;email;email
		return get_emails_users( join(";", $emails) );
	}	
	function get_emails_users($emails){
		$emails =  join(",", array_wrap( preg_split("/;/", $emails, -1, PREG_SPLIT_NO_EMPTY), "'", "'") );
		return db\select_field_to_array("users_users", "id", "email in ($emails)");
	}

	// FILE_THUMB ; the way thumb name for a file is made
	function get_file_thumb_path($file_id, $file_name){if(!$file_id) return $file_name;  return $file_id.".jpg"; }
	//function get_file_thumb_path($file_id, $file_name){ return $file_name; } // def case - use file itself

	function get_img_url($img_id){ 
		if( $file = db\select_record("lowres", "path,name", "id=$img_id") )
			return get_files_path().$file["path"].$file["name"];
	}

	// get arr of shops ids
	function get_camp_shops($camp_id){
		$shops =  db\select_field("camps", "countries", "id=$camp_id") ;
		return $shops? preg_split("/;/", db\select_field("camps", "countries", "id=$camp_id"), -1, PREG_SPLIT_NO_EMPTY ) : [];
	}
	//
	function role_to_field($role){ return $role=="LOCAL"? "visual_id" : ""; } 
	function get_user_shops($user_id, $user_role){
		return ($field = role_to_field($user_role))? db\select_field_to_array("locations", "id", "$field=$user_id") : [];
	}
	// works even if group role was changed TOTEST
	function reset_user_shops($user_id){ 
		db\execute("update locations set visual_id=0 where visual_id=$user_id"); 
		//db\execute("update locations set production_id=0 where production_id=$user_id");
	}
	function set_user_shops($user_id, $role, $shops){
		$field = role_to_field($role);
		reset_user_shops($user_id);
		if(sizeof($shops))
			db\execute("update locations set $field=$user_id where ". db\id_in($shops)) ;
	}

	// TODO: replace it with table links
	// role - is which role should be used to enter the link
	function page_link($camp_id, $rec_id=0, $page="orders", $role="", $user_id=0){
		if(!$role) $role = ur_get_user_role_name();
		if(!$user_id) $user_id = get_curr_user_id(); // DEF EMUID: insert user id in link
		$role = get_role_code($role);
		return base_url.proj_path_rel."$page.php?cid=$camp_id&r=$role&p=".get_portal_name().($rec_id?"&id=$rec_id":"")."&uid=$user_id";
	}
	function create_link($target_id, $target_type, $user_id=0){
		$code = generate_random_string();
		db\execute("insert into links(code, target_id, target_type, user_id) values ('$code', $target_id, '$target_type', $user_id)");
		return $code;
	}
	function read_link($code){ return db\select_record("links","*","code='$code'");}

	function get_admin_users(){ return db\select_to_array("users", "*", db\in_list("user_role", "ADMIN")." AND ".db\in_list("user_role", "ENGINEERING") ); }

	function is_worker(){ return get_or_def($_SESSION, "worker"); }

	//function get_background_path(){ return is_worker()? "img/bg.jpeg" : "clients/".get_client_code()."/data/bg"; } // TODO: if no bg?
	// returns bg of given client or, if client not specified, of current client/worker
	function get_background_path($client_code=''){ 
		if(!is_worker() && !$client_code) 
			$client_code = get_client_code();
		return $client_code? "clients/$client_code/data/bg" : "img/KO.png"; 
	} // TODO: if no bg?


	$stat_conds = array(
		"total" => "true",
		"tosel" => "complete=0",
		"toorder" => "order_state_lbs='confirmed'",
		"toacc" => "order_state_lbs = 'sent'",
		"toupl" => "order_state_lbs in ('sent', 'accepted')",
		"reject" => "order_state_lbs = 'rejected'",
		"toapp" => "order_state_lbs = 'uploaded'",
		"tohires" => "order_state_lbs = 'approved'",
		"topack" => "order_state_lbs = 'hires'",
		"tosend" => "order_state_lbs = 'packed'"
	);

	function add_stat_cond($capt, $table, $filter, $link, $cond){
		global $stat_conds;
		$cnt = db\select_field($table, "count(*)", $stat_conds[$filter]." and $cond");
		return array(lpp($capt), $cnt, $link."&filter=$filter"); 
	}
	function print_user_stats($camp_id){
		$role = ur_get_user_role();
		$camp_shops = get_camp_shops($camp_id);
		$user_shops = $role["shops"]; 
		$res = array();
		// 1 VISUALS
		if($role["role"]=="VISUAL"){
			//$user_camp_shops = $role["role"]=="LOCAL_VISUAL"? array_intersect($camp_shops, $user_shops) : $camp_shops;
			$user_camp_shops = $camp_shops;
			if(!sizeof($user_camp_shops)) return ""; // TODO: TEMP happens now.. maybe artefacts
			$view = create_shop_camp_view($camp_id); // seems it contains camp_id condition
			$link = page_link($camp_id, 0, "shops");
			$cond = db\id_in($user_camp_shops);
			$res[]=	add_stat_cond('$total$', $view, "total", $link, $cond);
			$res[]= add_stat_cond('$to_do$', $view, "tosel", $link, $cond);
			$res[]= add_stat_cond('$to_order$',$view, "toorder", $link, $cond);
		}
		// 2 PRODUCTION_INTERNAL (all shops)
		if($role["role"]=="PRODUCTION_INTERNAL"){
			$cond = "camp_id=$camp_id";
			$link = page_link($camp_id, 0, "orders");
			$res[]=	add_stat_cond('$total$', "orders", "total", $link, $cond);
			$res[]=	add_stat_cond('$to_accept$', "v_orders", "toacc", $link, $cond);
			$res[]=	add_stat_cond('$to_upload$', "v_orders", "toupl", $link, $cond);
			$res[]= add_stat_cond('$to_hires$', "v_orders", "tohires", $link, $cond);
			$res[]=	add_stat_cond('$rejected$', "v_orders", "reject", $link, $cond);
		}
		// 3 GRAPHIC (all shops)
		if($role["role"]=="GRAPHIC"){
			$cond = "camp_id=$camp_id";
			$link = page_link($camp_id, 0, "orders");
			$res[]=	add_stat_cond('$total$', "orders", "total", $link, $cond);
			$res[]=	add_stat_cond('$to_approve$', "v_orders", "toapp", $link, $cond);
		}
		// 4 PRODUCTION
		if($role["role"]=="PRINT"){
			//$user_camp_shops = array_intersect($camp_shops, $user_shops); // TODO: actually needn't sel by camp shops - orders with camp_id cont only shops of camp
			if(!sizeof($user_shops)) return ""; // TODO: TEMP happens now.. maybe artefacts
			$link = page_link($camp_id, 0, "orders");
			$cond = db\id_in($user_shops, "", "shop_id")." AND camp_id=$camp_id";
			$res[]=	add_stat_cond('$total$', "v_orders", "total", $link, $cond);
			$res[]= add_stat_cond('$to_pack$', "v_orders", "topack", $link, $cond);
		}
		if($role["role"]=="ADMIN" || $role["role"]=="ENGINEERING"){
			// shops
			if(!sizeof($camp_shops)) return ""; // TODO: TEMP happens now.. maybe artefacts
			$view = create_shop_camp_view($camp_id); // seems it contains camp_id condition
			$link = page_link($camp_id, 0, "shops");
			$cond = db\id_in($camp_shops);
			$res[]=	add_stat_cond('$shops$ $total$', $view, "total", $link, $cond);
			$res[]= add_stat_cond('$shops$ $to_do$', $view, "tosel", $link, $cond);
			$res[]= add_stat_cond('$shops$ $to_order$',$view, "toorder", $link, $cond);
			// orders
			$link = page_link($camp_id, 0, "orders");
			$cond = "camp_id=$camp_id";
			$res[]=	add_stat_cond('$orders$ $total$', 		"orders", 		 "total", $link, $cond);
			$res[]=	add_stat_cond('$orders$ $to_accept$', 	"v_orders", "toacc", $link, $cond);
			$res[]=	add_stat_cond('$orders$ $to_upload$', 	"v_orders", "toupl", $link, $cond);
			$res[]=	add_stat_cond('$orders$ $to_approve$', 	"v_orders", "toapp", $link, $cond);
			$res[]= add_stat_cond('$orders$ $to_print$', 	"v_orders", "topack",$link, $cond);
			$p1 = db\select_field("lbc", "count(*)", "iscont=0 and ".db\id_in($camp_shops, "id", "shop_id"));
			$p2 = db\select_field("app_lbs", "sum(lb_count)", "camp_id=$camp_id and img_id<>0 and shop_id in (select shop_id from v_orders where order_state_lbs='printed')");
			if(!$p2) $p2="0";
			$res[] = array(lp('progress'), "$p2/$p1", $link."&filter=printed");
		}
		return sizeof($res)? array("page_link" => $link, "stats" => $res) : false;
	}
	function get_triple_path($camp_id, $lbs_id){ return camp_path."$camp_id/lbs/$lbs_id/"; }
	function clear_pdf($lbs_id){
		db\execute("delete from draws where app_id = $lbs_id");
		db\execute("delete from pins  where app_id = $lbs_id");
	}

	// MD 
	function get_md($table_name, $client_id=0){ 
		if(!$client_id) $client_id = get_client_id();
		return  db\select_to_array("md", "fname,caption,ftype,forder,vdef,vmin,vmax,vlist,fdata,fusage,multiple", "client_id=$client_id AND table_name='$table_name'"); // there is a rec for workers - courier  NOTE: not need id, or it's used as field id in MDFID
		//return  $client_id? db\select_to_array("md", "*", "client_id=$client_id AND table_name='$table_name'") : array();
	}
	function get_order_md($client_id=0){ 
		$loc = get_md("locations", $client_id); 
		foreach($loc as &$l) $l["fusage"] = str_replace("N", "", $l["fusage"]); // not use location fields when create an order
		return array_merge(get_md("orders", $client_id), $loc); 
	}
	function get_location_md($client_id=0){ return get_md("locations", $client_id); }
	function get_free_field($table_name, $client_id, $from, $to){
		$mo = 	db\select_field("md", "max(forder)", "client_id=$client_id AND table_name='$table_name'");
		$fall = db\select_field_to_array("md", "fname", "client_id=$client_id AND table_name='$table_name'");
		foreach(range($from, $to) as $fn) 
			if(!(in_array("uf$fn", $fall)))
				return [["id" => "nf_fname", "default" =>"uf$fn"], ["id" => "nf_forder", "default" => $mo+1] ];
		return null; // not found, all fields occupied
	}

	// CLIENTS
	function create_group($name, $role, $emails="", $client_id=0){ // user role has role;role format
		db\execute("insert into users(name,email,user_role,client_id,user_type) values ('$name', '$emails', '$role', $client_id, 'group')");
		return db\get_last_id();
	}
	function create_client_users($admin_email, $client_id){
		$cc = db\select_field("clients", "code", "id=$client_id");
		$admin_name = get_mail_user($admin_email);
		$url = base_url.proj_path_rel."login.php?log_user=$admin_name&cc=$cc";
		$admin_id = register_user($admin_name, $admin_email, "ADMIN", $client_id, $url); // create admin and send email
		create_group("administrators", "ADMIN", $admin_email, $client_id);
		create_group("visuals", "VISUAL", "", $client_id);
		create_group("revision", "REVISE", "", $client_id);
		create_group("graphics", "GRAPHIC", "", $client_id);
		return $admin_id;
	}

	$orders_def = array("camp_id" => array("type" => "number"), "shop_id" => array("type" => "number"));
	// fields: client_id, camp_id, shop_id
	function create_order($fields){
		global $orders_def;
		db\execute("insert into orders ".db\compile_insert($fields, $orders_def));
		$id = db\get_last_id();
		if($shop_id=get_or_def($fields,"shop_id"))
			lb_duplicate_shop($shop_id, $id);
		log\info("order $id created");
		return $id;
	}
	function update_order($id, $fields){
		global $orders_def;
		db\execute("update orders set ".db\compile_update($fields, $orders_def)." where id='$id'"); 
	}

	// DEF BIST bit states; instead of using enum - use an int field which contains all states order_states; also use supplementary field order_state which contains only the last/curr state (highest bit) order_state
	function get_osc($os){global $order_states; return array_search($os, $order_states); }
	function os_is($compare,$pattern){ $c=get_osc($compare); $p=get_osc($pattern); if($c==4 || $c==128) return $c==$p; return $c<=$p; } // if decl/rej - states must match exactly; else - check if comp. preceedes pattert

	// DEF IC_ST ic3
	function create_ws($order_id, $owner, $name, $users){
		return send_curl_post("https://ic3.depedrini.com/contr/new_order.php", "order_id=$order_id&owner_email=$owner&users=$users&name=".json_encode($name));
	}

	function make_track_link($code, $courier){ return ""; }

	function get_client_logo($cc){
		$logo = "img/depe_square.png";
		$logo = "clients/YSL/data/bg_logo";
		if($cc && is_file(proj_path."clients/$cc/data/bg")) $logo = "clients/$cc/data/bg_logo";
		//if($cc && is_file(proj_path."img/$cc.png")) $logo = "img/$cc.png";
		return $logo;
	}
	function get_location_path($client_code, $id){ return "$client_code/locations/$id/"; } // relative to source path

	// MUSA
	$app_roles = [
		1 => [0 => "RETAIL", 1 => "IMAGE"],
		2 => [0 => "IMAGE", 1 => "LOCAL", 2 => "RETAIL"]
	];
	function is_approver($role, $stage){ global $app_roles; return in_array($role, $app_roles[$stage]); }
	// is supposed that order is in revise; returns str = role name
	function get_next_approver($order_id, $stage){
		global $app_roles; 
		$roles = $app_roles[$stage];
		$revs = db\select_to_array("v_revisions", "*", "order_id=$order_id AND stage=$stage", "id desc");
		if(!$revs){
			return $roles[0];
		}else{
			$role = $revs[0]["group_role"];
			log\debug("CURR ROLE: $role");
			$ind = array_search($role, $roles);
			return get_or_def($roles, $ind+1, "");
		}
	}
	function is_next_approver($role, $order_id, $stage){ return get_next_approver($order_id, $stage)==$role; }
	/*function is_next_approver($role, $order_id, $stage){
		global $app_roles; 
		$ind = array_search($role, $app_roles[$stage]);
		//log\debug($role, $stage, "HHH", $ind);
		$revs = db\select_to_array("v_revisions", "*", "order_id=$order_id AND stage=$stage", "id desc");
		if($ind==0)
			return sizeof($revs)==0;
		else{
			log\debug($revs);
			return sizeof($revs)>0 && $revs[0]["res"]=="confirmed" && array_search($revs[0]["group_role"], $app_roles[$stage])==$ind-1;
		}
	}*/
	function is_final_role($role, $stage){global $app_roles; return end($app_roles[$stage])==$role; }
	function is_revise_state($state){return $state=="revise" || $state=="uploaded";}
?>
