<?php
/*
	Author: Alex Nosurov
	Date: 06.02.2018
	Description: description of errors and some utils
	NOTE: exception classes are in utils/exception.php; also there is set uncaught_exception_handler 
*/

	require_once(dirname(__FILE__)."/../alerts.php"); // write_alert(), el_medium

	$_FATAL_ON = true; $_FAT_PREV = true;// this is to avoid registering some unnecessary alerts;
	function set_fatal_off(){global $_FATAL_ON, $_FAT_PREV; $_FAT_PREV = $_FATAL_ON; $_FATAL_ON=false;}
	//function set_fatal_on(){global $_FATAL_ON, $_FAT_PREV; $_FATAL_ON=$_FAT_PREV;log\debug("S: '$_FATAL_ON'");} // this in fact not usable, while err is processed not when happens but when all code finishes

	// now used in controllers
	function register_error($msg, $class='', $module='', $gravity=-1){ // TODO1: now it not accepts device name
		log\error("Error in module $module; class: $class; message: $msg");
 		if($gravity<0)
 			$gravity = el_medium;
 		write_alert($msg, $module, $gravity, $class); 
 	}

	// unhandled errors (not same that exceptions)
        register_shutdown_function( "fatal_handler" );

        function fatal_handler() {
		//debug_print_backtrace();
            $errfile = "unknown file";
            $errstr  = "shutdown";
            $errno   = E_CORE_ERROR;
            $errline = 0;

            $error = error_get_last();

            if( $error !== NULL) {
                $errno   = $error["type"];
                $errfile = basename($error["file"]);
                $errline = $error["line"];
                $errstr  = $error["message"];

                $msg = "php fatal error; errno: $errno; errfile: $errfile; errline: $errline; errstr: $errstr";
		global $_FATAL_ON;
		if($_FATAL_ON)
			register_error($msg, "uncaught", $errfile); 
		else
			log\error("Error in module $errfile; class: uncaught; message: $msg");
            }
        }

?>
