<?php
/*
	Created: 20.02.2018
	Author: Alex Nosurov
	Description: db model functions for the archive
*/
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."model/db.php");
	require_once(proj_path."model/email.php");
	require_once(proj_path."model/lb.php");

	// DEF EVENTS register events
	// TODO: add client_id
	function event_create($message, $camp_id, $shop_id=0, $order_id=0, $source_order_link="", $notes="", $lbs_id=0){ // NOTE: msg is used as event type description, while notes are some additional notes, eg reject/approve reason
		$ugr = get_curr_role_user_id(); $uid = get_curr_user_id();
		if(!$uid) $uid = "0"; // TODO: happens in EMAIL_LINK, need yet to pass somehow user who downloads
		$notes = db\escape($notes);
		$sid = session_id(); // BATCH EMAIL, send events created by a user when his session over
		db\execute("insert into events (source_group_id, source_user_id, message, camp_id, shop_id, order_id, source_order_link, notes, lbs_id, session_id) values ($ugr, $uid, '$message', $camp_id, $shop_id, $order_id, '$source_order_link', '$notes', $lbs_id, '$sid')");
		return db\get_last_id();
	}
	// those are users-dests TODO: always need only either link, maybe use single field for them both
	function add_event_user($event_id, $user_id, $link, $link_apap="", $link_triple=""){
		db\execute("insert into event_users(event_id, dest_group_id, order_link, apap_link, triple_link) values ($event_id, $user_id, '$link', '$link_apap', '$link_triple')");
	}

	// find clients of given role and worker responsible for the client
	// res = arr of assoc arr:  [ id, user_role ]
	function find_event_users($client_id, $state, $order=null){ 
		log\debug("ST: $state");
		// NOTE: on open send only to locals (will be called for each order, so good only for EVITE where orders are create autom)
		if($state=="draft"){ // NOTE: not sent on "packed" event (It's just intermediate state)
			return _artul( get_emails_users( db\select_field("groups", "email", "id=".get_shop_group( $order["shop_id"], "LOCAL" ) )  ) , "LOCAL");
		}
		// made by clients, inform worker
		// revision 1 (LOCAL not participates)
		if($state=="revise"){
			$na_role = get_next_approver($order["id"], 1);
			log\debug("NR: $na_role");
			return _artul( find_role_users($na_role, $client_id), $na_role); 
		}
		if($state=="declined")
			return _artul( get_emails_users( db\select_field("groups", "email", "id=".get_shop_group( $order["shop_id"], "LOCAL" ) )  ) , "LOCAL");
		// passed revision 1; now IMAGE should send
		if($state=="confirmed")
			return _artul( find_role_users("IMAGE", $client_id), "IMAGE"); 
		// revision 2
		if($state=="uploaded" || $state=="app_notice"){ // NOTE: not sent on "packed" event (It's just intermediate state)
			//$stage = $order["order_state_lbs"]=="revise"? 1 : 2;
			$na_role = get_next_approver($order["id"], 2);
			return $na_role=="LOCAL"?
				_artul( get_emails_users( db\select_field("groups", "email", "id=".get_shop_group( $order["shop_id"], "LOCAL" ) )  ) , "LOCAL"):
				_artul( find_role_users($na_role, $client_id), $na_role); 
		}
		// new or passed revision 2 TODO: if now no hires - this is final stage and need inform all ('complete')
		if($state=="sent" || $state=="approved" || $state=="rejected" || $state=="app_client_notice")
			return _artul( get_emails_users( db\select_field("groups", "email", "id=".get_client_manager($client_id) )  ) , "PRODUCTION"); // NOTE: works only if manager id is a group id
		// prod sends event to himself
		if($state=="hires")
			return _artul( get_emails_users( db\select_field("groups", "email", "id=".get_shop_group( $order["shop_id"], "LOCAL" ) )  ) , "LOCAL");
		if($state=="packed") // inform postman
			return _artul( find_role_users("PRINT", $client_id), "PRINT"); 
		if($state=="update")
			return _artul( get_emails_users( db\select_field("groups", "email", "id=".get_client_manager($client_id) )  ) , "PRODUCTION"); // NOTE: works only if manager id is a group id
		// all clients (NOTE: in prada ver camp opened by worker, but dests are client
		if($state=="complete") // NOTE: not sent on "packed" event (It's just intermediate state)
			// TODO: as in EVITE orders are created in autom - send to locals links with def ord id
			return db\select_to_array("users", "id, '' user_role", "user_type='user' and client_id=$client_id"); // all users, role=''
	}
	function _artul($ids, $role){ $res=[]; foreach($ids as $id) $res[]=["id" => $id, "user_role" => $role]; return $res;} // convert list of users (ids) to arr of assoc arrs (format requested by event funcs)
	function get_client_manager($client_id){ return db\select_field("clients", "manager_id", "id=$client_id"); }
	/*function get_approvers($stage, $client_id){
		global $app_roles;
		$res = [];
		$roles = $app_roles[$stage];
		foreach($roles as $role)
			$res = array_merge($res, db\select_to_array("users", "id, '$role' user_role", "client_id=$client_id AND ".db\in_list("user_role", $role)));
		return $res;
	}*/
	function open_camp($camp_id){
		$camp_name = db\select_field("camps", "name", "id=$camp_id");
		$event_id = event_create(db\escape2("Campaign started: $camp_name"), $camp_id, 0, 0, page_link($camp_id, 0, "campaigns"));
		$client_id = get_client_id();
		$orders = db\select_to_array("orders", "*", "camp_id=$camp_id");
		foreach($orders as $order){
			$users = find_event_users($client_id, "draft", $order);
			foreach( $users as $user)
				add_event_user($event_id, $user["id"], page_link($camp_id, $order["id"], "ozon", "LOCAL", $user["id"])); // TODO: page depends on role
		}
		email_camp_start($event_id, $camp_id); // EMAIL
		db\execute("update camps set camp_state='opened' where id='$camp_id'"); 
	}
	// ORDERS
	// created by visual, informed to prod int
	//function create_order($fields, $user_id){
	function send_order($order_id, $user_id){
		$order = db\select_record("v_orders", "*", "id=$order_id"); // TODO 1 : donno if need
		$camp_id = $order["camp_id"];
		/* commented 7.5.25 while not sends in case of INUP update if(os_is("sent", $order["order_state"]) ) 
			throw new user_exception("$order_id already sent");  */
		$link = page_link($camp_id, $order_id, "orders");
		$msg = "New order created";
		if(  $order["order_state_lbs"]=="update") $msg = "Update order"; // EVITE INUP
		$event_id = event_create($msg, $camp_id, $order["shop_id"], $order_id, $link);
		$users = find_event_users($order["client_id"], "sent");
		foreach( $users as $user){
			$link = page_link($camp_id, $order_id, "orders", "PRODUCTION", $user["id"] );
			add_event_user($event_id, $user["id"], $link);
		}
		db\execute("update orders set order_state_code=".get_osc('sent')." where id = $order_id");
		//
		$emails = create_order_emails($event_id, $order_id);
		//send_user_emails($emails); // TODO: BATCH
		return $event_id;
	}
	// REQUEST REVISE
	// send revise request to REVISION
	function request_revise($order_id){
		$order = db\select_record("v_orders", "order_state_lbs,complete", "id=$order_id");
		$os = $order["order_state_lbs"];
		if(!$order["complete"] || os_is("revise", $os) && !os_is("declined", $os) ) return false;
		db\execute("delete from revisions where order_id=$order_id");
		db\execute("update orders set order_state_code=".get_osc('revise')." where id = $order_id");
		return true;
	}
	// draft orders; client visual requests confirm (after having filled all LBs of an order)
	function request_revise_event($order_id){
		if(request_revise($order_id)){
			$order = db\select_record("v_orders", "*", "id=$order_id"); // TODO 1 : donno if need
			$camp_id = $order["camp_id"]; // TODO 1
			$link = page_link($camp_id, $order_id, "ozon");
			$event_id = event_create("confirm request", $camp_id, $order["shop_id"], $order_id, $link);
			$users = find_event_users($order["client_id"], "revise", $order);
			foreach( $users as $user){
				$link = page_link($camp_id, $order_id, "ozon", $user["user_role"], $user["id"] );
				add_event_user($event_id, $user["id"], $link);
			}
			$emails = create_order_emails($event_id, $order_id);
			//send_user_emails($emails); // TODO: BATCH
		}
		return $event_id;
	}
	// MAKE REVISE
	// only updates database, revisions table; msg is used as reject reason
	function revise_order($order_id, $group_id, $state, $msg="", $lbs_id=0, $stage=1){
		$order = db\select_record("v_orders", "order_state_lbs,complete,confirmed,approved", "id=$order_id");
		$os = $order["order_state_lbs"];
		if($stage==1)
			if($os==$state || !$order["complete"] || os_is("sent", $os) ) return false;
		if($stage==2 && (os_is("approved", $os) && $state=="confirmed"  || os_is("approved", $os) && $state=="confirmed") ) // MUSA for stage 2 revisions table contains "confirmed" state while in v_orders it's the field "approved"
			return false;
		// DELB: db may contain several revisions only in case if all revs are "reject" and all of single (different) lbs
		// if exists decline whole order - can't decline single lbs
		// conclusion: if lbs_id==0: delete all revs else: delete all but revs with lbs_id<>0 (for security may ad lbs_id<>0 and <>$lbs_id to avoid doubles, but normally js should avoid this)
		if(!$lbs_id) // DELB rev whole order
			db\execute("delete from revisions where order_id=$order_id and group_id=$group_id and stage=$stage");
		else // DELB rev single lbs; normally should be possible when not exists revs of whole orders or of given lbs
			db\execute("delete from revisions where order_id=$order_id and (lbs_id<>0 or lbs_id=$lbs_id) and group_id=$group_id and stage=$stage");
		//
		$final = is_final_role(db\select_field("groups", "user_role", "id=$group_id"), $stage)? 1 : 0;
		db\execute("insert into revisions(order_id, group_id, res, notes, lbs_id, stage, final) values($order_id, $group_id, '$state', '".db\escape($msg)."', $lbs_id, $stage, $final)");
		/*
		// EVITE: no hires, using files uploaded for approve
		if($final && $state=="confirmed" && $stage==2)
			complete_order($order_id);
		*/
		return true;
	}
	function revise_order_event($order_id, $group_id, 
			$state, // confirmed/rejected
			$msg="", $lbs_id=0,
			$stage = 1
			/*DELB*/){
		// update db
		if(!revise_order($order_id, $group_id, $state, $msg, $lbs_id, $stage))
			return;
		// create event
		$order = db\select_record("v_orders", "*", "id=$order_id"); // TODO 1 : donno if need
		$page = $stage==1? "ozon" : "orders";
		$camp_id = $order["camp_id"]; // TODO 1
		$link = page_link($camp_id, $order_id, $page); // common link for all users in events table
		$event_id = event_create("order $order_id $state", $camp_id, $order["shop_id"], $order_id, $link, $msg);
		$users = find_event_users($order["client_id"], $order["order_state_lbs"], $order);
		foreach( $users as $user){
			$link = page_link($camp_id, $order_id, $page, $user["user_role"], $user["id"] );
			add_event_user($event_id, $user["id"], $link);
		}
		//
		$emails = create_order_emails($event_id, $order_id, $lbs_id, $msg);
		//send_user_emails($emails); // TODO: BATCH
		/* commented to send in BATCH
		if($order[$state] || $state="declined") // NOTE: this means the field order.$state=1, that is lbs state = order state (printed/approved)
			send_user_emails($emails);
		*/
		return $event_id;
	}

	function create_ws_event($order_id){
		$state = "hires";
		$order = db\select_record("v_orders", "*", "id=$order_id"); 
		$users = find_event_users( $order["client_id"], $state, $order);
		// create ws link
		$users_emails = db\select_field_to_array("users", "email", db\id_in($users));
		$users_emails = join(";", $users_emails);
		$name = $order["camp_name"].": ".$order["city"].", ".$order["location"];
		$ws_link = create_ws(mse("order_id"), get_user_info("email"), $name, $users_emails);
		$osc = get_osc($state);
		db\execute("update orders set ws_link = '$ws_link', order_state_code=$osc where id = $order_id");
		// create event
		$page = "orders";
		$camp_id = $order["camp_id"]; // TODO 1
		$link = page_link($camp_id, $order_id, $page); // common link for all users in events table
		$event_id = event_create("order $order_id $state", $camp_id, $order["shop_id"], $order_id, $link, $msg=lp("high_resolution_files_uploaded"));
		foreach( $users as $user){
			$link = page_link($camp_id, $order_id, $page, $user["user_role"], $user["id"] );
			add_event_user($event_id, $user["id"], $link);
		}
		// sent from ic3	$emails = create_order_emails($event_id, $order_id, $lbs_id, $msg);
		return $event_id;
	}




	//
	function set_orders_state($orders, $state, $msg, $camp_id){
		$page = os_is($state, "sent")? "orders" : "ozon";
		$link = page_link($camp_id, $order_id=0, $page);
		$cnt = sizeof($orders);
		$event_id = event_create("$cnt orders $state", $camp_id, $shop_id=0, $order_id=0, $link, $msg); // TODO 1 why shop_id 0
		foreach( find_event_users(get_client_id(), $state) as $user){
			$link =	 page_link($camp_id, $order_id=0, $page, $user["user_role"], $user["id"] );
			add_event_user($event_id, $user["id"], $link);
		}
		//
		send_orders_email($event_id, "orders $state", $msg, $camp_id);
	}

	function delete_order_email($order_id){
		$order = db\select_record("v_orders", "*", "id=$order_id");
		$state = $order["order_state_lbs"];
		$page = os_is($state, "sent")? "orders" : "ozon";
		$camp_id = $order["camp_id"]; $shop_id = $order["shop_id"]; 
		// create event EVENTS
		$link = page_link($camp_id, 0, $page);
		$event_id = event_create("Order deleted", $camp_id, $shop_id, $order_id, $link);
		$users = db\select_field_to_array("users", "id", db\in_list("user_role", "ADMIN")." OR ".db\in_list("user_role", "ENGINEERING")." OR ".db\in_list("user_role", "PRODUCTION_INTERNAL") );
		foreach( $users as $user_id)
			add_event_user($event_id, $user_id, $link);
		$event = db\select_record("events", "*", "id=$event_id");
		$subj = "Order $order_id deleted: ".$order["shop_name"];
		$order["user_name"] = db\select_field("users", "name", "id=".get_curr_user_id() );
		$order["camp_name"] = db\select_field("camps", "name", "id=$camp_id" );
		order_delete($order_id);
		$emails = create_order_emails($event_id, $order, $subj, "order_del", "");
		//send_user_emails($emails); // TODO: BATCH
	}
	/* TODO: maybe better cache order_id in lbs table (simpler)
	function get_lbs_order($camp_id, $shop_id){ 
		return $order = db\select_record("v_orders", "*", "camp_id=$camp_id and shop_id=$shop_id");
	}*/

	// done by: client, GRAPHIC
	// sent to: worker, PRODUCTION
	// TODO: $receivers not used
	// NOTE: similar to set_lbs_state_event(.. "rejected"...) but always creates event and mail contains info only of single lbs; (now also converts rev_id to lbs_id
	function reject_lbs($rev_id, $receivers, $subj, $msg){
		$app_id = db\select_field("approves_versions", "lbs_id", "rev_id=$rev_id");
		$lbs = db\select_record("app_lbs", "id, order_id, app_state, name", "app_id=$app_id");
		$order_id = $lbs["order_id"];
		if( $lbs["app_state"]=="rejected" ) return;
		set_lbs_state("rejected", $app_id, $msg);
		$order = db\select_record("orders", "*", "id=$order_id");
		$order_id = $order["id"];
		$shop_id = $order["shop_id"];
		$camp_id = $order["camp_id"];
		$client_id = $order["client_id"];
		// create event EVENTS
		$link = page_link($camp_id, $order_id, "orders");
		$event_id = event_create($subj, $camp_id, $shop_id, $order_id, $link, $msg);
		// send to production responsible for this client
		foreach( find_event_users($order["client_id"], "rejected") as $user){
			$link = 	 page_link($camp_id, $order_id, "orders", $user["user_role"], $user["id"] );
			$link_apap = page_link($camp_id, $rev_id  , "apap", $user["user_role"], $user["id"]);
			add_event_user($event_id, $user["id"], $link, $link_apap);
		}
		//
		$emails = create_order_emails($event_id, $order_id, $app_id, $msg, array("subj_name" => $lbs["name"]) ); // TODO: app_id or lbs_id?
		//send_user_emails($emails); // TODO: BATCH
		// remove old files
		$tp = get_source_path().get_triple_path($camp_id, $app_id);
		foreach(scandir($tp) as $file)
			if(extract_ext($file)=="idml" || extract_ext($file)=="indd") // TODO: TRIPLE
				exec_cmd("rm", $tp.$file);
		return $event_id;
	}
	// it's more simple to create an event and use std way
	function notify_lbs($app_id, $subj, $msg){
		$lbs = db\select_record("app_lbs", "id, order_id, app_state, name", "app_id=$app_id");
		$order_id = $lbs["order_id"];
		$order = db\select_record("orders", "*", "id=$order_id");
		$order_id = $order["id"];
		$shop_id = $order["shop_id"];
		$camp_id = $order["camp_id"];
		$client_id = $order["client_id"];
		$type = is_worker()? "app_notice" : "app_client_notice";
		// create event EVENTS
		$link = page_link($camp_id, $order_id, "orders");
		$event_id = event_create($subj, $camp_id, $shop_id, $order_id, $link, $msg);
		// send to production responsible for this client
		foreach( find_event_users($order["client_id"], $type) as $user){
			$link = 	 page_link($camp_id, $order_id, "orders", $user["user_role"], $user["id"] );
			$link_apap = page_link($camp_id, $app_id  , "apap", $user["user_role"], $user["id"]);
			add_event_user($event_id, $user["id"], $link, $link_apap);
		}
		//
		$emails = create_order_emails($event_id, $order_id, $app_id, $msg, array("subj_name" => $lbs["name"]) ); 
		//send_user_emails($emails); // TODO: app_id or lbs_id?
	}
	// in stampa called only for sent orders; possible states: uploaded, approved, printed (rejected is set by reject_lbs)
	// role seems is the dest role which is to receive the notif (eg order uploaded email goes to graphic); 
	// note: in stampa maybe instead of using reject_lbs + set_lbs_state_event should use another set of funcs, maybe one for clients one for workers
	function set_lbs_state_event($id, $state, $message, $notes=""){
		$lbs = db\select_record("app_lbs", "order_id, app_state", "id=$id");
		$order_id = $lbs["order_id"];
		if( $lbs["app_state"]==$state ) return null;
		set_lbs_state($state, $id, $notes);
		// EVITE approve stage 2
		if($state=="uploaded"){
			if($lbs["app_state"]=="update")
				db\execute("update orders set order_state_code=".get_osc("complete")." where id = $order_id");
			else
				db\execute("delete from revisions where lbs_id=$id");
		}
		// check if order printed completely;
		$order = db\select_record("v_orders","*","id=$order_id"); // TODO: use app_lbs.order_id here and in other places instead
		$camp_id = $order["camp_id"]; $shop_id = $order["shop_id"];
		if($order && $order[$state]		// NOTE: this means the field order.$state=1, that is lbs state = order state (printed/approved)
			|| $lbs["app_state"]=="update" && $state=="uploaded"   // INUP - if was updated
			){ 
			// create event EVENTS
			$link = page_link($camp_id, $order_id, "orders"); // event sent to curr user
			$event_id = event_create($message, $camp_id, $shop_id, $order_id, $link, $notes, $id);
			foreach( find_event_users($order["client_id"], $state, $order) as $user){
				$link = page_link($camp_id, $order_id, "orders", $user["user_role"], $user["id"] );
				if($user["user_role"]=="PRINT")
					$link = page_link($camp_id, $lbs["pack_id"], "packs", $user["user_role"], $user["id"] );
				$tlink="";
				if($state=="hires"){
					$tlink = "contr/download.php?link=".create_link($order_id, "hires_all", $user["id"])."&portal=".get_portal_name();
					$lbs["hurl"] = base_url.proj_path_rel."hires.php?order_id=$order_id"; // this is used to access all hr files
				}
				add_event_user($event_id, $user["id"], $link, "", $tlink );
			}
			$emails = create_order_emails($event_id, $order_id, 0, '', $lbs);
			//send_user_emails($emails);
			return $event_id;
		}else
			return null; // order state not changed, no event/emails created
	}
	function complete_lbs($id){ 
		set_lbs_state_event($id, "complete", lp("lightbox") + " " + lp("completed") ); 
		$order_id = db\select_field("lbs", "order_id", "id=$id");
		if(db\select_field("v_orders", "complete", "id=$order_id")) // TODO: or ==1 ; if null?
			complete_order($order_id);
	}
	// indicate that order is complete
	function complete_order($id){
		db\execute("update orders set date_done='".db\now()."', order_state_code=".get_osc("complete")." where id = $id");
	}

	/* called by cron, closes all expired */
	function close_camps(){
		$now = db\now();
		$ctc = db\select_to_array("camps", "id,name", "camp_state in ('opened','published') and date_till is not null and date_till<'$now'"); 
		foreach($ctc as $camp)
			close_camp($camp["id"]);
	}
	function close_camp($camp_id){
		db\execute("update camps set camp_state = 'closed' where id = $camp_id");
		$event_id = event_create("Campaign closed", $camp_id);
		foreach( get_admin_users() as $user)
			add_event_user($event_id, $user["id"], page_link($camp_id, $rec_id=0, $page="campaigns", $role=$user["user_role"], $user["id"]) );
	}

	// called by cron ARCH
	function archive_camps(){
		$cta = db\select_to_array("camps", "id,name", "camp_state in ('closed')");
		foreach($cta as $camp){
			// TODO: delete images
			db\execute("update camps set camp_state = 'archived' where id = ".$camp["id"]);
			$event_id = event_create("Campaign archived", $camp["id"]);
			// archive lbs
			db\execute("insert into app_lbs_arch select * from app_lbs where camp_id = ".$camp["id"]);
			db\execute("insert into v_orders_arch select * from v_orders where camp_id = ".$camp["id"]);
			db\execute("delete from approves where camp_id = ".$camp["id"]);
			db\execute("delete from lbs where camp_id = ".$camp["id"]); // DELBS
			db\execute("delete from orders where camp_id = ".$camp["id"]);
			// notify
			foreach( get_admin_users() as $user)
				add_event_user($event_id, $user["id"], page_link($camp["id"], $rec_id=0, $page="campaigns", $role=$user["user_role"], $user["id"]) );
		}
	}

	// NOTE: that users added twice - for pack's lbs and for order (if gets completed)
	function send_pack_event($pack_id){
		$camp_id = 0; // TODO 1
		$data = db\select_record("packs","*","id=$pack_id");
		$client_id = $data["client_id"];
		//$link = page_link($camp_id, $order_id, "orders");
		$link = base_url.proj_path_rel."packs.php?id=$pack_id";
		$event_id = event_create($descr="package $pack_id sent", 0, 0, 0, $link); // TODO: set camp if all lbs from same camp
		$users = db\select_field_to_array("users", "id", db\in_list("user_role", "VISUAL")." and client_id = $client_id");
		foreach( $users as $user_id){
			//$link = page_link($camp_id, $order_id, "orders", "VISUAL", $user_id );
			add_event_user($event_id, $user_id, "$link&uid=$user_id");
		}
		//send_order_email($event_id, $order_id, 0, $msg);
		$data["lbs_list"] = db\select_to_array("app_lbs", "id, lb_id, path, img_id, name_mini,l,t,r,b,name name_lbs,thumb_small", "pack_id=$pack_id");
		foreach($data["lbs_list"] as $lbs)
			complete_lbs($lbs["id"]); //will send another event, for order (not pack) if whole order sent (printed)
		$data["track_link"] = make_track_link($data["pack_code"], $data["courier"]); // TODO
		$emails = create_user_emails($event_id, $data, $descr, "pack_info", $descr);
		//send_user_emails($emails);
	}
	
?>
