<?php
/*
	Created: 28.11.2021
	Author: Alex Nosurov
	Description: db model functions for the archive
*/
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."utils/db_mysql.php");
	require_once(proj_path."view/lang.php");

	function lb_create($lb){
		unset($lb["id"]);
		db\execute("insert into lbc " . db\compile_insert($lb)); 
		return db\get_last_id();
	}
	function lb_update($lb, $id){
		db\execute("update lbc set " . db\compile_update($lb) . "where id = $id");
		lb_delete_lbs($id); // if lb size changed - lbs not valid
	}
	function lb_remove($lb_id){
		// if it's a cont - free childs
		$ids = db\select_record("lbc", "lb1_id, lb2_id", "id=$lb_id" );
		$id1 = $ids["lb1_id"]; $id2 = $ids["lb2_id"];
		db\execute("update lbc set istop = true where id = $id1 or id = $id2");
		// remove 
		db\execute("delete from lbc where id = $lb_id");
		lb_delete_lbs($lb_id);
	}
	// get top LBs of a shop ;  $cond: shop_id=x  or order_id=x
	function lb_get_shop($cond){return db\select_to_array("lbc", "*", "istop=1 AND $cond", "name"); }
	function lb_get_childs($id){
		$ids = db\select_record("lbc", "lb1_id, lb2_id", "id=$id" );
		$id1 = $ids["lb1_id"]; $id2 = $ids["lb2_id"];
		$lb1 = db\select_record("lbc", "*", "id=$id1");
		$lb2 = db\select_record("lbc", "*", "id=$id2");
		return array($lb1,$lb2);
	}
	//
	function lb_calc_wh($w1, $h1, $w2, $h2, &$w, &$h, $isvert){$w=$w1;$h=$h1; if($isvert) $h+=$h2; else $w+=$w2;}
	function lb_join($id1, $id2, $isvert=0){
		lb_delete_lbs($id1);
		lb_delete_lbs($id2);
		$lb1 = db\select_record("lbc", "*", "id=$id1");
		$lb2 = db\select_record("lbc", "*", "id=$id2");
		db\execute("update lbc set istop = 0 where id=$id1 or id=$id2");
		lb_calc_wh($lb1["width"], $lb1["height"], $lb2["width"], $lb2["height"], $w, $h, $isvert);
		lb_calc_wh($lb1["width0"], $lb1["height0"], $lb2["width0"], $lb2["height0"], $w0, $h0, $isvert);
		//$shop_id = $lb1["shop_id"];
		$order_id = $lb1["order_id"];
		$name = $lb1["name"].'_'.$lb2["name"];
		$lb_count = $lb1["lb_count"] + $lb2["lb_count"];
		$shop_id = $lb1["shop_id"];
		db\execute("insert into lbc(lb1_id,lb2_id,name,width,height,width0,height0,istop,iscont,isvert,order_id,lb_count,shop_id) values ($id1,$id2,'$name',$w,$h,$w0,$h0,1,1,$isvert,$order_id,$lb_count,$shop_id)");
		return db\get_last_id();
	}

	// delete lbs belonging to a lb
	function lb_delete_lbs($lb_id){ 
		foreach(db\select_field_to_array("lbs", "id", "lb_id=$lb_id") as $lbs_id)
			lbs_delete($lbs_id);
	}

	// ----------------------- LBS ------------------------------------
	function lb_duplicate_shop($shop_id, $order_id){
		$ls = array_kv_to_id(db\select_to_array("lbc", "*", "shop_id=$shop_id"));
		$otn = []; // TODO: wasssis?
		$td = ["lb1_id" => ["type" => "int"],"lb2_id" => ["type" => "int"],"istop" => ["type" => "int"],"iscont" => ["type" => "int"],"isvert" => ["type" => "int"],"lb_count" => ["type" => "int"],"trim" => ["type" => "int"],"order_id" => ["type" => "int"],"width" => ["type" => "int"],"height" => ["type" => "int"],"width0" => ["type" => "int"],"height0" => ["type" => "int"]];
		foreach($ls as $id => $l){
			unset($l["shop_id"]); $l["order_id"] = $order_id;
			$l["src_id"] = $id; // IPC DEF stuff used to show imgs from prev camps
			db\execute( "insert into lbc ".db\compile_insert($l, $td));
			$otn[$id] = db\get_last_id();
		}
	}
	// for full path prefix with proj_path.proj_path_rel_client or with source_path
	function get_order_path($order_id=0, $client_code=""){
		if(!$client_code) $client_code = db\select_field("v_orders", "client_code", "id=$order_id");
		//return proj_path_rel_client."$client_code/orders/$order_id/";
		return "$client_code/orders/$order_id/";
	}

	// for full path prefix with proj_path.proj_path_rel_client or with source_path
	function get_lbs_path($lbs_id, $order_id=0, $client_code=""){
		if(!$order_id) $order_id = db\select_field("lbs", "order_id", "id=$lbs_id");
		return get_order_path($order_id, $client_code)."$lbs_id/";
	}

	function lbs_create($data){
		$lb_id = $data["lb_id"];
		$l = $data["l"];$t = $data["t"];
		$r = $data["r"];$b = $data["b"];
		// delete existing lbs occupying same sell (new lbs always has one sell only), so l=r, t=b
		db\execute("delete from lbs where lb_id=$lb_id and not ( $l>r or l>$r ) and not ( $t>b or t>$b )"); // del if rects intersect (from utils.js)
		// insert
		$data["lb_count"] = sizeof( preg_split("/,/", $data["name"]) ); // name contains comma-sep list of lb names; use it to deduce lb count
		// IPC
		$camp_id = db\select_field("orders", "camp_id", "id=".$data["order_id"]);
		$src_lbc = db\select_record("lbc", "src_id, delivery_address", "id=$lb_id");
		$src_lbc_id = $src_lbc["src_id"];
		$data["delivery_address"] = $src_lbc["delivery_address"]; // TODO: now there are two delivery_address - in lbc and in lbs... donno if wrong, but for now, copy it
		if($src_lbc_id){ // lbc created directly in order have no src
			$prev_camps = preg_split("/;/", db\select_field("camps", "prev_camps", "id=$camp_id"), -1, PREG_SPLIT_NO_EMPTY); // chronological order; max=3
			log\debug($prev_camps);
			if($n=sizeof($prev_camps)){
				$prev_imgs = db\select_id_field_to_array("v_order_lbs", "camp_id", "img_id", "src_id=$src_lbc_id AND ".db\id_in($prev_camps, null, "camp_id")); // camp_id -> img_id .. TODO: problem is that it's not guaranteed that a camp not contains several lbs with same (source) lbc
				log\debug("PI",$prev_imgs);
				$prev_img = get_or_def($prev_imgs, $prev_camps[0], "0");
				// lbs has img_id1,2,3 which is reverse crono order (1st = last)
				foreach($prev_camps as $pc) { $prev_img = get_or_def($prev_imgs, $pc, $prev_img); $data["img_id".($n--)] = $prev_img; } // NOTE: some camp may have this lbs not set -> means uses that of the prev
			}
		}
		// /IPC
		db\execute("insert into lbs " . db\compile_insert($data, array("t" => array("type" => "number"), "l" => array("type" => "number")))); // 29/03/2023 donno wasshit, today instead of 0 began to arrive "" in requests (same shit with camp_id in save_order)
		$lbs_id = db\get_last_id();
		// CROP at this moment there is no crop; so use the mini as the default
		create_def_crop($lbs_id, $data["img_id"], $data["order_id"]);
		// MUSA delete all confirms/rejects
		db\execute("delete from revisions where order_id = ".$data["order_id"]); 
	}
	// creates def files crop.jpg and preview.jpg from mini
	function create_def_crop($lbs_id, $img_id, $order_id=0){
		$mini = db\select_record("lowres", "path,name,thumb_small", "id=$img_id");
		$mini_path = proj_path.get_files_path().$mini["path"].$mini["name"];
		$lbs_path = proj_path.proj_path_rel_client.get_lbs_path($lbs_id, $order_id);
		if(!is_dir($lbs_path))
			mkdir($lbs_path, dir_perm, true);
		exec_log("cp \"$mini_path\" \"$lbs_path"."crop.jpg\"");
		inbox_img($lbs_path."crop.jpg", 200, 200, $lbs_path."preview.jpg", $resize_if_smaller=true);
	}

	function lbs_update_image($id, $img_id){ 
		db\execute("update lbs set img_id = $img_id where id = $id");
		create_def_crop($id, $img_id);
	}
	function lbs_remove($id){ db\execute("delete from lbs where id = $id"); }
	// NOTE: if now lbc are always copied (for each order) needn't use order_id (each order has personal lbc)
	function lbs_get_lb($lbc_id, $order_id){
		$lbs_conf = "width,height,lbs_width,lbs_height,lbi_left,lbi_top,lbi_scale,path,name_mini"; // 2023.09.19 used for LBS_CONF
		$sels = db\select_to_array("app_lbs", "id,lb_id,img_id,t,l,r,b,name, $lbs_conf", "lb_id=$lbc_id and order_id=$order_id");
		foreach($sels as &$sel){
			$file = db\select_record("lowres", "path,name", "id=".$sel["img_id"]);
			//$sel["src"] = get_files_path().$file["path"].get_file_thumb_path($sel["img_id"], $file["name"]);
			$sel["src"] = table_tree_path_rel."thumbs/".db\select_field("lowres","thumb_small","id=".$sel["img_id"]);
		}
		return $sels;
	}
	function lbs_delete($id){
		db\execute("delete from approves where id = $id");
		db\execute("delete from lbs where id = $id");
		// TODO: may also delete files; 
	}
	function set_lbs_state($state, $id, $msg=""){
		$si = get_osc($state);
		db\execute("update lbs set  app_statei=$si, notes='".db\escape($msg)."' where id = $id");
	}
	function get_app_client($app_id){
		$order_id = db\select_field("app_lbs", "order_id", "id=$app_id");
		return db\select_field("orders", "client_id", "id=$order_id");
	}


	// returns array of camps:  num -> name, where num is: 1 - prev camp, 2 - camp before 1, 3 - camp before 2 (ACO order)
	function get_prev_camp_names($id){
		$pc = array_reverse(preg_split("/;/", db\select_field("camps","prev_camps","id=$id"), -1, PREG_SPLIT_NO_EMPTY));
		$names = sizeof($pc)? db\select_id_field_to_array("camps", "id", "name", db\id_in($pc)) : [];
		$res = []; $n=1; foreach($pc as $cid) $res[$n++] = $names[$cid];
		return $res;
	}

