<?php
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."utils/utils.php");
	require_once(proj_path."model/lb.php");
	require_once(lib_path."fpdf/fpdf.php");

/*
	current position: 
		draw commands rely on CP
		after a command pos is changed
			eg Cell moves CP to the right end or to the next line depending on 'ln' param
*/


class PDF extends FPDF{
	// prints multi cell and sets xy to the right after cell; returns cell hite
	function mc($w,$h,$text,$border){
		$px = $this->GetX();
		$py = $this->GetY();
		$this->MultiCell($w,$h,$text,$border);
		$th = $this->GetY() - $py ;
		$this->SetXY($px + $w, $py);
		return $th;
	}
}

function add_img($img_id, $lb_id, &$camp, &$lb_dep){
	$name = $lb_dep[$lb_id];
	$dep = &find_array_key_value($camp, "dep", $name);
	if(!$dep){
		$camp[] = ["dep" => $name, "imgs" => []];
		$dep = &find_array_key_value($camp, "dep", $name);
	}
	$dep["imgs"][]=$img_id;
	//log\debug($dep);
}

function figu($camp_id, $where){
	// params
	$rh = 150; // row hite
	$ass_name = "uf23";
	$tcol_w = 45; // text col width
	$icol_w = 150; // image col width
	$tcol_h = 30; // text col height
	$ih = $tcol_h*0.8;
	// prepare data
	$lbs = db\select_to_array("v_order_lbs", "lb_id,img_id,img_id1,img_id2,img_id3,country,city,location,order_id,$ass_name", $where, "country,city,location");
	$lb_dep = db\select_id_field_to_array("lbc", "id", "department", db\id_in( extract_array_key( $lbs, "lb_id") ) );
	//log\debug($lb_dep);
	$tis = []; 
	foreach($lbs as $l){ 
		if($l["img_id"]) $tis[]=$l["img_id"];
		if($l["img_id1"]) $tis[]=$l["img_id1"];
		if($l["img_id2"]) $tis[]=$l["img_id2"];
		if($l["img_id3"]) $tis[]=$l["img_id3"];
	}
	$ta = db\select_to_array("lowres", "thumb_small,id,dimensions", db\id_in($tis));
	$thumbs = [];  // kv array: img_id -> params arr (url, w, h)
	foreach($ta as $t){
		$p = [];
		$p["url"] = $t["thumb_small"];
		$wh = preg_split("/x/", $t["dimensions"]);
		$p["w"] = $wh[0];
		$p["h"] = $wh[1];
		$thumbs[$t["id"]] = $p;
	}
	//log\debug($thumbs);
	$pcn = get_prev_camp_names($camp_id);
	$pcn[0] = db\select_field("camps","name","id=$camp_id");
	$locs = [];
	foreach($lbs as $l){
		$loc_id = db\select_field("orders", "shop_id", "id=".$l["order_id"]);
		$loc = &find_array_key_value($locs, "lid", $loc_id);
		if(!$loc){
			$locs[] = array_merge($l, ["lid" => $loc_id, "c0" => [], "c1" => [], "c2" => [], "c3" => [] ]);
			$loc = &find_array_key_value($locs, "lid", $loc_id);
		}
		// ci elem = [ di elem ] ; di elem = ["dep" => dep, "imgs" => [img_id] ]
		if($l["img_id" ]) add_img($l["img_id" ], $l["lb_id"], $loc["c0"], $lb_dep);
		if($l["img_id1"]) add_img($l["img_id1"], $l["lb_id"], $loc["c1"], $lb_dep);
		if($l["img_id2"]) add_img($l["img_id2"], $l["lb_id"], $loc["c2"], $lb_dep);
		if($l["img_id3"]) add_img($l["img_id3"], $l["lb_id"], $loc["c3"], $lb_dep);
	}
	log\debug(sizeof($locs));
	log\debug($locs);
	// 
	$pdf = new PDF("L", "mm", "A3");
	$pdf->SetFont('Arial','',12);
	$pdf->SetAutoPageBreak(false);
	$pdf->AddPage();
	// print
	//header
	$pdf->Cell($tcol_w, $tcol_h, "COUNTRY", "B");
	$pdf->Cell($tcol_w, $tcol_h, "CITY", "B");
	$pdf->Cell($tcol_w, $tcol_h, "LOCATION", "B");
	$pdf->Cell($tcol_w, $tcol_h, "ASSORTMENT", "B");
	$img_start_x = $pdf->GetX();
	foreach($pcn as $id => $name)
		$pdf->Cell($icol_w, $tcol_h, $name, "B");
	// rows
	$pdf->Ln();
	$y0=$pdf->GetY(); 
	$x0=$pdf->GetX(); 
	$coly = $y0;
	//log\debug("LLOCC", extract_array_key($locs, "lid"));
	$j=0;
	foreach($locs as $l){
		$j++;
		if($coly + $tcol_h > 250){
			$pdf->Line($img_start_x-2, $y0, $img_start_x-2, $coly);
			$pdf->AddPage();
			$pdf->Ln();
			$coly = $y0;
			log\debug("NP: $y0");
		}
		$x = $x0;
		$pdf->SetX($x0);
		$pdf->SetY($coly);
		log\debug("YYYY: $coly");
		//if($coly + $tcol_h > $pdf->GetPageHeight()){
		log\debug("PPP ", $pdf->GetPageHeight(), " :", $coly + $tcol_h, $l["location"]);
	
		$ck=3;
		$pdf->MultiCell($tcol_w, $tcol_h/$ck, $l["country"], ""); 	$pdf->SetY($coly); $x+=$tcol_w; $pdf->SetX($x);
		$pdf->MultiCell($tcol_w, $tcol_h/$ck, $l["city"], ""); 		$pdf->SetY($coly); $x+=$tcol_w; $pdf->SetX($x);
		$pdf->MultiCell($tcol_w, $tcol_h/$ck, $l["location"], ""); 	$pdf->SetY($coly); $x+=$tcol_w; $pdf->SetX($x);
		$pdf->MultiCell($tcol_w, $tcol_h/$ck, $l[$ass_name], ""); 	$pdf->SetY($coly); $x+=$tcol_w; $pdf->SetX($x);
		// print images
		// need print images of each of curr and prev camp
		for($i=0;$i<=3;$i++){ // i corresponds to a cell=camp
			//log\debug("XXXX", $l["c$i"]);
			if(!isset($pcn[$i])) break; // if prev camps < 3
			$camp_x0 = $img_start_x + $icol_w*$i;
			$pdf->SetX( $camp_x0 );
			$camp_x = $camp_x0; // x = camp_x0 + camp_x
			// imgs: each cell contains several imgs (all images of curr shop)
			foreach($l["c$i"] as $dep){
				$xdep = $camp_x;
				$dep_name = $dep["dep"];
				foreach($dep["imgs"] as $img_id){
					//$pdf->SetX($nx);
					$thumb = $thumbs[$img_id];
					$img_url = proj_path."table_tree/thumbs/".$thumb["url"];
					$iw = $thumb["w"]*$ih/$thumb["h"];
					$pdf->Image($img_url, $camp_x, $coly + 5, $iw, $ih);
					$camp_x += $iw + 1;  // NOTE: TODO: SetX( GetX() + ... ) not works
					//$pdf->SetY($coly); 
				}
				$pdf->Text($xdep + ($camp_x - $xdep-$pdf->GetStringWidth($dep_name))/2, $coly+4, $dep_name);
				$camp_x += 2;
			}
		}
		$coly += $tcol_h;
		$pdf->Line($x0, $coly, 800, $coly);
		//
		//if($j==7)break;
	}
	//
	$pdf->Line($img_start_x-2, $y0, $img_start_x-2, $coly);
	//
	$pdf->Output(); 
}


function print_letter_old($header, $camp, $lb, $params, $bc){
	$pdf = new PDF();
	$pdf->SetFont('Arial','',12);
	$pdf->AddPage();
	$full_w = 180;
	$he = 20;
	$pdf->Cell($full_w, $he, $header, 'LTR');
	$pdf->Ln();
	$he = 15;
	$pdf->Cell($full_w*0.3, $he, lp("Campaign"), 'LB');
	$pdf->Cell($full_w*0.7, $he, $camp, 'BR');
	$pdf->Cell($full_w*0.3, $he, lp("Lightbox"), 'LB');
	$pdf->Cell($full_w*0.7, $he, $lb, 'BR');
	/* two double cells 	$pdf->mc($full_w*0.3, $he/2, "codice\n150", 'TLB');
	$th = $pdf->mc($full_w*0.7, $he/2, "nome\nname", 'TLRB');
	$pdf->Ln($th);*/
	// key vals
	$pdf->SetY($pdf->GetY()+5, true);
	$kw = 40; $vw = 50;
	$h = 8;
	$x0 = $pdf->GetX(); $y0 = $pdf->GetY();
	$th = 0;
	foreach($params as $k => $v){
		// print val first to know its width
		$pdf->SetX($x0 + $kw);
		$h=$pdf->mc($vw, $h, $v, "LTBR");
		$th += $h;
		$pdf->SetX($x0);
		$pdf->Cell($kw, $h, $k, "LTB");
		$pdf->Ln();
		//$pdf->Ln($h);
	}
	//$pdf->Cell($full_w*0.5, 100, $th, 'TLRB');
	$bc_he = 50;
	$pdf->SetXY($x0 + $full_w/2, $y0);
	$image1 = "/st/img/letterina_logo.png";
	$pdf->Cell($full_w*0.5, $th-$bc_he, $pdf->Image($image1, $pdf->GetX()+1, $pdf->GetY()+5, 33.78), 'TRB');
	$image1 = $bc;
	$pdf->Cell($full_w*0.5, $bc_he, $pdf->Image($image1, $pdf->GetX()+1, $pdf->GetY()+5, 33.78), 'TRB');
	//
	$pdf->Output();
}
function print_params($pdf, $params, $x0, $y0, $kw, $vw, $he=8){
	$th = 0; // tot hite
	$kww = $kw + $vw;
	$pdf->SetDrawColor(200,200,200); // line under kw
	foreach($params as $k => $v){
		// print val first to know its width
		$pdf->SetFont('Arial','',12);
		$pdf->SetX($x0 + $kw);
		$h=$pdf->mc($vw, $he, $v, "");
		$th += $h;
		log\debug($th);
		$pdf->SetX($x0);
		$pdf->SetFont('Arial','B',12);
		$k = str_replace("_", " ", $k);
		$pdf->Cell($kw, $h, ucfirst($k).":", "");
		$pdf->SetXY($x0, $th + $y0);
		$pdf->Line($x0, $th + $y0, $x0+$kww, $th + $y0);
	}
	return $th;
}
function print_letter($pdf, $commessa, $code, $id, $params, $bc){
	$pdf->SetAutoPageBreak(true); // may contain several pages
	$ln_right = 0; $ln_next_line_start = 1; $ln_below = 2;
	$pdf->SetDrawColor(0,0,0);
	$pdf->SetFont('Arial','B',12);
	$pdf->AddPage();
	$full_w = 180;
	$x0 = $pdf->GetX();
	// HEADER
	$he = 8;
	$hx0 = $pdf->GetX();
	$hy0 = $pdf->GetY();
	// 1st line - nome commessa
	$pdf->Cell($full_w, $he, $commessa, 'LTRB', $ln_next_line_start, 'C');
	// 2nd line, 2 cols, each 2 lines
	$x = $pdf->GetX();
	$y = $pdf->GetY();
	$pdf->MultiCell($full_w*0.5, $he, "Codice commessa\n$code", 'LB', 'C');
	$pdf->SetXY($x + $full_w*0.5, $y);
	$pdf->MultiCell($full_w*0.5, $he, "Nome Unita\n$id", 'LBR', 'C');
	// frame around header
	$pdf->SetXY($hx0-0.5, $hy0-0.5);
	$pdf->Cell($full_w+1,($hehe=$he*3)+1,"","LTRB");
	$pdf->SetXY($hx0, $hy0);

	// BODY = VALUES + LOGO
	$by0 = $hy0+$hehe+2;
	$pdf->SetXY($hx0, $by0);
	// VALUES
	$he=15;
	$kww = $full_w/2-4;
	$pdf->Cell($kww, $he, "Copy instruction", '', $ln_next_line_start, 'C');
	// key vals
	$kw = $kww*0.4; $vw = $kww*0.6;
	$he = 8;
	$kwy0 = $pdf->GetY();
	$kwx0 = $x0+2;
	print_params($pdf, $params, $kwx0, $kwy0, $kw, $vw);
	$kwy1 = max($pdf->GetY(), 200);
	// frames around kw
	//kw
	$pdf->SetDrawColor(0,0,0); // line under kw
	$pdf->SetXY($x0, $by0);
	$pdf->Cell($kww+4,($bohe=$kwy1-$kwy0),"","LTRB");
	//imgs
	$pdf->SetXY($x0+$kww+4, $by0);
	$pdf->Cell($full_w/2,$bohe,"","LTRB");
	// second frame over body
	$pdf->SetXY($x0-0.5, $by0-0.5);
	$pdf->Cell($full_w+1,$bohe+1,"","LTRB");
	// images
	$bc_he = 50;
	$image1 = "/st/img/letterina_logo.png";
	log\debug($pdf->GetY());
	$pdf->Image($image1, $x0+$kww+10, $by0+10, 70);

	$image1 = $bc;
	$bcw = 50; $bch = 50;
	$pdf->Image($image1, $x0 + $full_w - $bcw-5, $kwy1 - $bch, $bcw);

}

function print_pack($pdf, $pack, $bc, $lbs){
	$pdf->AddPage();
	$full_w = 180;
	$x0 = $pdf->GetX();
	$y0 = $pdf->GetY();
	// pack params
	$bcw = 50;
	$bch = 50;
	$kvw = $full_w - $bcw;
	$kw = $kvw*0.4; $vw = $kvw*0.6;
	print_params($pdf, $pack, $pdf->GetX(), $pdf->GetY(), $kw, $vw);
	// pack barcode
	$pdf->Image($bc, $x0 + $kvw + 10, $y0 + 10, $bcw);

	// lbs list
	$yc = $pdf->GetY() + 20;
	$he = 8;
	foreach($lbs as $lb){
		$pdf->Image($lb["img"], $x0, $yc, 0, $bch*0.7);
		$pdf->Text($x0 + $bcw + 10, $yc + ($bch-$he)/2, $lb["name"]);
		$pdf->Image($lb["bc"], $x0 + $full_w - $bcw + 10, $yc + 15, $bcw);
		$yc += $bch + 10;
	}
	//$pdf->Output(); return;
}

function print_codes($pdf, $lbs){
	$pdf->SetFont('Arial','',12);
	$pdf->AddPage();
	$full_w = 180;
	$x0 = $pdf->GetX();
	$y0 = $pdf->GetY();
	// pack params
	$bcw = 50;
	$bch = 30;
	$kvw = $full_w - $bcw;
	$kw = $kvw*0.6; $vw = $kvw*0.4;
	// 
	$yc = $pdf->GetY();
	$he = 8;
	foreach($lbs as $lb){
		$pdf->Image($lb["bc"], $x0, $yc, $bcw, 0);
		$pdf->Text($x0 + $bcw + 10, $yc + ($bch-$he)/2, $lb["name"]);
		$yc += $bch + 10;
	}
	//$pdf->Output(); return;
}

try{ 
	$camp_id = 29;
	$where = "camp_id=$camp_id AND client_id=19";
	//figu($camp_id, $where); 
}catch(Exception $e){ 
	log\debug($e->getTraceAsString(), $e->getMessage()); 
}
