<?php
/* simplest upload file to test upload speed */
require_once(dirname(__FILE__)."/../path.php");
require_once(proj_path."utils/log.php");
require_once(proj_path."model/db.php");
require_once("/usr/share/php/fpdf.php");

try{
	log\set_log_file(log_path."upload.log");

	$target_dir = proj_path."tmp/";

	$img = $_POST["imgBase64"];
	$img = str_replace('data:image/png;base64,', '', $img);
	$img = str_replace(' ', '+', $img);
	$fileData = base64_decode($img);
	$to = $target_dir.generate_random_string(4, "123456789").".png";
	//saving
	file_put_contents($to, $fileData);
	log\info("file saved to '$to'");
	// pdf
	$pdf = new FPDF($_POST["dpdf_orient"], "mm", $_POST["dpdf_size"]);
	$pdf->AddPage();
	$width = $_POST["width"];
	$height = $_POST["height"];
	$pw = $pdf->getPageWidth(); $ph = $pdf->getPageHeight();
	$k = ($width/$pw > $height/$ph)? $pw/$width : $ph/$height;
	log\debug($k, $pw, $ph, $k*$width, $k*$height);
	$pdf->Image($to, 0, 0, $k*$width, $k*$height);
	//$pdf->Image($to, 0, 0, 100, 0);
	unlink($to);
	$tmp_pdf_name = "tmp/".generate_random_string().".pdf";
	$pdf->Output("F", proj_path.$tmp_pdf_name);
	echo $tmp_pdf_name;
}catch(user_exception $e){
	if($msg=$e->getMessage())
		log\error("user error: '$msg'");
	header($_SERVER['SERVER_PROTOCOL'].' 500 '.$e->getUserMessage(), true, 500);
}catch(Exception $e){
	$code = generate_random_string(4, "123456789"); // just a random code informed to used and written to log; thus user can identify to admin what to search in logs
	log\error("controller error $code; POST dump: ", array_to_str($_POST), $e->getTraceAsString() );
	register_error("Controller error $code: ".$e->getMessage(), "controller", "controller", el_higher);
	header($_SERVER['SERVER_PROTOCOL'].' 500 $unknown_error$ $code$: '.$code, true, 500);
	//return;
}
?>
