<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB  TODO: move this stuff to standard to be used by all pages*/ ?>
	</head>
	<body style='background: url("<?php echo get_background_path(); ?>") no-repeat center center fixed;'> 
                
		<script src="js/table.js"></script>    <!-- table_tree -->
		<script src="js/shops.js"></script>   <!-- used only refresh funcs -->
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_orders_div" class='mc_page_body mc_tt_cont ttc_fullscreen tc_single_table'> <!-- NOTE: without this cont appears another horiz scr bar -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<div id="mi_send_emails" class="hidden" title="send pending events" onclick="ppee_send()"><label class='mc_center'></label></div> <!-- PPEE -->

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script type="text/javascript">

			<?php $od=isset($_GET["id"]) && ($id=$_GET["id"]) && !db\exists("orders","id=$id") && db\exists("events","order_id=$id"); $id=$od?0:get_or_def($_GET,'id',0);
			echo "var def_rec_id = $id;\n";  // DEFREC
			echo "var order_deleted = ".($od?$_GET["id"]:0).";\n";
			?>
			// DD
			var def_camp_id = <?php echo get_or_def($_GET,'cid',0); ?>;
			var stat_cond = "<?php $sc = get_or_def($_GET,'filter',""); global $stat_conds; if($sc) echo $stat_conds[$sc]; ?>"; // STAT
			var files_path = "<?php echo get_files_path(); ?>";

			var rec,drec; // RD
			function get_order_state(rec){ return rec.find(".td-"+alias_name+"-order_state_lbs").html(); }
			function get_lbs_state(rec){return rec.find(".td-"+detail_alias_name+"-app_state").html();}
			function get_lbs_order(lbs_rec){ return lbs_rec.closest(".ap_detail_row").data("id"); }
			// update order and lbs state (after some event which caused state change)
			function update_order_state(order_list, lbs_list=$() ){
				// if whole order is affected - all its lbs affected
				if( orders.get_active_rec().hasClass("selected") )
					lbs_list = lbs_list.add(".ap_detail_row .tr-app_lbs");
				// if some order's lbs is  affected - the order is affected
				lbs_list.each(function(){ order_list = order_list.add( orders.find_rec(get_lbs_order($(this)) ));	} );
				// update
				lbs_list.each( function(){update_lbs_rec_state(  $(this) ); } );
				order_list.each( function(){update_lbs_done(  $(this) ); } );
			}
			function update_lbs_rec_state(lbs_rec){
				var lbs = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_lbs_state", id: lbs_rec.data("id") }, 'POST').resp_text );
				lbs_rec.find(".td-app_lbs-app_state").html( lbs.app_state);
				lbs_rec.data("app_id", lbs.app_id);
				lbs_rec.data("app_state", lbs.app_state);
				set_lbs_action(lbs_rec);
			}

			function show_load_triple(){
				drec = $(this).closest(".data-row");
				var lbs_id = drec.data("id");
				var order_id = get_detail_id();
				var client_code = orders.find_rec(order_id).data("client_code");
				set_upload_path( contr_req("get_lbs_path", {client_code: client_code, order_id: order_id, lbs_id: lbs_id} ) ); // user_path
				set_upload_data({client: "triple"});  // set_fu_data
				var rec = orders.find_rec( drec.closest(".ap_detail_row").data("id") );
				show_select_string(function(){update_order_state(rec, drec);}, '', $("#mi_load_image"), lp("load_triples"));
				$("#mc_fu_custom_content").html("");
				$("#mc_fu_custom_content").append(  "<div>"+drec.find(".td-app_lbs-name_mini").html()+"</div>"  );
				$("#mc_fu_custom_content").append(  drec.find(".td-app_lbs-path").html()  );
			}
			function request_approve(){
				drec = $(this).closest(".data-row");
				var rec = orders.find_rec( drec.closest(".ap_detail_row").data("id") );
				call_php_sync("contr/main.php", {"action" : "request_approve", id: drec.data("id") }, 'POST');
				update_order_state(rec, drec);
			}
			// HREN
			function show_load_hires(){
				drec = $(this).closest(".data-row");
				var lbs_id = drec.data("id");
				var order_id = get_detail_id();
				var client_code = orders.find_rec(order_id).data("client_code");
				set_upload_path(client_code + "/hires/" + get_detail_id() + "/"); // user_path; all hires in same folder = 'order_id/'
				$("#mi_fu_data").val( JSON.stringify( {client: "hires", lbs_id: lbs_id} ) );  // set_fu_data; need assoc hr file name with lbs, so pass lbs id
				var rec = orders.find_rec( drec.closest(".ap_detail_row").data("id") );
				show_select_string(function(){update_order_state(rec, drec);}, '', $("#mi_load_image"), lp("load_hires"));
				$("#mc_fu_custom_content").html("");
				$("#mc_fu_custom_content").append(  "<div>"+drec.find(".td-app_lbs-name_mini").html()+"</div>"  );
				$("#mc_fu_custom_content").append(  drec.find(".td-app_lbs-path").html()  );
			}
			// DEF TRIPLE_LIST in rotation there may be any set of files, so need interf to show/manage them
			var triple_list;
			function show_triple_list(lbs_id, approved, can_edit){  
				var triple_list = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_triple_list", id: lbs_id }, 'POST').resp_text ); // [name]
				var html = "";
				for(var i=0;i<triple_list.length;i++){
					if( triple_list[i].endsWith(".pdf" ) && approved ) // can't delete approved pdf
						html += "<div><label>" + triple_list[i] + "</label><i class='mc_dtc fas fa-check' data-index='" + i + "'></i></div>";
					else // normal
						html += "<div><label>" + triple_list[i] + "</label><i class='mc_dtr fas fa-times' data-index='" + i + "'></i></div>";
				}
				if(!triple_list.length)
					html = "<label>" + lp("no_files_found") + "</div>";
				html = $("<div class='mc_dtl'>" + html + "</div>");
				if(!can_edit)
					html.find(".mc_dtr").remove();
				show_select_string(null, '', html, lp("manage_triples"));
				html.on("click", ".mc_dtr", function(){ 
					var path = triple_list[ $(this).data("index") ];
					call_php_sync("contr/main.php", {"action" : "triple_list_delete", "id": lbs_id, name: JSON.stringify(path) }, 'POST');
					$(this).parent().remove();
					if( !$(".mc_dtl").find(".mc_dtr,.mc_dtc").length)
						$(".mc_dtl").append( "<label>" + lp("no_files_found") + "</div>" );
				});
			}
			function on_show(){
				$("#table-"+alias_name).find(".td-"+alias_name+"-RES_detail").html("<button class='btn btn-primary mc_detail_btn'><i class='fas fa-caret-right'></i></button>");
				$(".td-"+alias_name+"-RES_detail").click( function(){ show_detail_click( $(this).closest(".data-row").data("id") ); } );
				var table = $("#table-"+alias_name);
				// DEFREC
				if(def_rec_id){
					// rec has already been made active by DR1
					show_detail_click(def_rec_id);
					def_rec_id = 0; // avoid set def rec on each show
				}
				if(!$("#table-"+alias_name).find(".data-row").length)
					alert(lp("no_order_created"));
				//
				$("#table-"+alias_name).find(".tr-"+alias_name).each(function(){set_rec_state_columns($(this)); } );
				$("#table-"+alias_name).find(".td-"+alias_name+"-date_create, .td-"+alias_name+"-date_done").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable

				if(ur_role.role=='PRODUCTION') // gl bzik sent -> new
					$("#table-"+alias_name).find(".td-"+alias_name+"-order_state_lbs").each( function(){ 
						if( $(this).html().toLowerCase()=="sent")
							$(this).html("NEW");
					});
			}

			// TODO: simila to lbs_set_size code
			function fit_img_div(div, img, dw, dh, i_rect){
				div.css("width", dw);
				div.css("height", dh);
				img.css("width", i_rect.w);
				img.css("height", i_rect.h);
				img.css("left",  - i_rect.dw);
				img.css("top",  - i_rect.dh);
			}

			var apap_r, apap_dr; function apap_cb(){ update_order_state(apap_r, apap_dr); } // COF
			function show_approve(){
				var id = $(this).data("app_id");
				id = call_php_sync("contr/main.php", {"action" : "get_rev_id", id: id}, 'POST').resp_text;	 // APP_VER use rev_id instead of app id
				var apap = window.open( "apap.php?id=" + id, '_blank');
				apap_r = rec, apap_dr = $(this).closest(".data-row");
				// apap.on_action = function(){ update_order_state(r,dr); }   TODO: DEF NCF no child funcs, ch fu not accessible; use COF call opener funcs instead
			}

			// now used to download whole order (pdf or hires)
			function set_order_actions(rec){
				var tda = rec.find(".td-"+alias_name+"-RES_action").html("");
				var order_id = rec.data("id");
				var os = rec.data("order_state_lbs");
				var url = extract_path(window.location.href) + "/contr/download.php?id="+order_id;
				var ondownload = function(){ update_order_state( rec ); } ; 
				if(!os_is("uploaded",os))
					tda.append( $("<i title='"+lp("download_order")+"' class='fas fa-download'></i>").click( function(){ load_file(url+"&type=mini_all", null, "GET", ondownload  ) } ) );
				if(os_is("uploaded",os) && !os_is("hires",os))
					tda.append( $("<i title='"+lp("download_pdf")+"' class='fas fa-download'></i>").click( function(){ load_file(url+"&type=triple_all", null, "GET", ondownload  ) } ) );
				if(os_is("hires",os))
					tda.append( $("<i title='"+lp("download_hires")+"' class='fas fa-download'></i>").click( function(){ load_file(url+"&type=hires_all", null, "GET", ondownload  ) } ) );
				// IC_ST
				var ws_link = rec.data("ws_link");
				if(ur_role.role=='PRODUCTION' && os_is("approved",os) && !ws_link)
					tda.append( $("<i title='"+lp("create_download_link")+"' class='fas fa-link'></i>").click( function(){create_ws(order_id);} ) );
				if(ur_role.role=='PRODUCTION' && os_is("approved",os) && ws_link){
					var ws_link = "https://ic3.depedrini.com/ws.php?outbox&c=" + ws_link + "&log_user=" + user_email;
					tda.append("<a target='_blank' href='" + ws_link + "'><i title='"+lp("open_download_link")+"' class='fas fa-link'></i></a>" );
				}
				// TODO: cloned from ozon (but stage=2) // show rev details
				if(  (os=='uploaded' || os=="rejected") ){
					var tos = rec.find(".td-"+alias_name+"-order_state_lbs");
					tos.mouseover(function(){
						if(!rec.data("ts")){
							cc("get_order_revise_details", function(res){
								var state = JSON.parse( res );
								var notes = [];
								for(var i=0;i<state.length;i++){
									var r = state[i].res;
									var n = state[i].notes;
									notes.push(state[i].group_name+": "+(r?r:"waiting")+(n&&n.trim()?" ("+n+")":""));
								}
								tos.prop("title", notes.join("\n"));
								rec.data("ts",1);
							}, {order_id: order_id, client_id: client_id, stage: 2});
						}
					});
				}
				// DEF CLONE_ORDER when order complete - may req redo EVITE
				if( ur_role.role=="LOCAL" || ur_role.role=="RETAIL" )
				if(os_is("complete",os))
					tda.append( $("<i title='"+lp("clone_order")+"' class='fas fa-copy'></i>").click( function(){ 
						if(confirm(lp("clone_order") + "?")){
							call_php_sync("contr/main.php", {"action" : "clone_order", id: order_id}, 'POST');
							alert("Ok");
						}
					} ) );

			}

				// DETAIL_ROW
			// action buttons and color
			function set_lbs_action(drec){
				if(is_archive) return; // ARCH
			// TODO: can use also flags uploaded/approvved along with state?
				var tda = drec.find(".td-"+detail_alias_name+"-RES_action").html("");
				var lbs_state = drec.data("app_state");
				var lbs_id = drec.data("id");
				// prod may upload if not yet uploaded or already rejected
				if(ur_role.role=='PRODUCTION' && ( !os_is("approved", lbs_state) ||  os_is("update", lbs_state)/*INUP*/ ) ){
					tda.append( $("<i class='fas fa-upload' title='"+lp("upload")+"'></i>").click(show_load_triple) );
					tda.append( $("<i class='fas fa-play' title='"+lp("request_approve")+"'></i>").click(request_approve) );
				}
				//if(os_is("uploaded", lbs_state)) it was before DEF MAUP  manual upload ; not set uploaded automatically, instead prod clicks request_approve btn
				// if(os_is("sent", lbs_state))
					tda.append( $("<i class='fas fa-list' data-app_id='" + lbs_id + "' title='"+lp("show_files")+"'></i>").click( function(){show_triple_list(lbs_id, approved, can_edit);} ) );
				// DEF HREN hire new - personal hr file for each
				// now to upload hr is used IC_ST if(ur_role.role=='PRODUCTION' && os_is("approved", lbs_state)) 		tda.append( $("<i class='fas fa-upload mc_upload_hr' title='"+lp("upload_high_resolution")+"'></i>").click(show_load_hires) );
				// donwload single lbs; anyone may download if have been uploaded - any state but draft
				var dl_type = "crop"; // CROP
				if(os_is("uploaded", lbs_state)) dl_type = "triple";
				if(os_is("hires", lbs_state)) dl_type = "hires";
				var ondownload = function(){ update_order_state( orders.get_active_rec(), drec); } ; // TODO: may add check if need update
				var url = extract_path(window.location.href) + "/contr/download.php?type=" + dl_type + "&id="+lbs_id;
				var title = dl_type; if(title=="triple") title = "pdf";
				if(dl_type=="hires"){
					var ws_link = "https://ic3.depedrini.com/download.php?c=" + drec.data("hr_name");
					tda.append("<a target='_blank' href='" + ws_link + "'><i title='"+lp("download_hires")+"' class='fas fa-download'></i></a>" );
				}else
					tda.append( $("<i title='"+lp("download")+" "+title+"' class='fas fa-download'></i>").click( function(){ load_file(url, null, "GET", ondownload  ) } ) );
				// may call apap to approve/disprove (client) or to view notes (production)
				var is_next_approver = is_approver && call_php_sync("contr/main.php", {"action" : "is_next_approver", "order_id": orders.get_active_rec().data("id"), "stage": 2 }, 'POST').resp_text=="1"; // MUSA
				if((is_next_approver || ur_role.role=='PRODUCTION') && os_is("uploaded", lbs_state)) // prod may watch apap if lbs has been uploaded ; DEF REAPP - if approved/rejected - graphic may change state until order closed
					tda.append( $("<i class='fas fa-eye' data-app_id='" + lbs_id + "' title='"+lp("inspect")+"'></i>").click(show_approve) );
				// PROD may accept if yet in draft
				if(ur_role.role=='PRODUCTION' && !os_is("accepted", lbs_state))
					tda.append( $("<i class='fas fa-check' data-app_id='" + lbs_id + "' title='"+lp("accept")+"'></i>").click( function(){set_state("accept_lbs", $([]), drec);} ) );
				// color
				drec.find(".td-"+detail_table_name+"-app_state").css("background-color", order_state_colors[lbs_state]);   // uses global arr of colors
				// TRIPLE_LIST 
				var approved = os_is("approved", lbs_state);
				var can_edit = ur_role.role=='PRODUCTION';
				// INUP
				if( ur_role.role=="LOCAL" || ur_role.role=="RETAIL" )
				if(os_is("approved", lbs_state))
					tda.append( $("<i class='fas fa-redo' data-app_id='" + lbs_id + "' title='"+lp("date_update")+"'></i>").click( function(){
						var lb_text = call_php_sync("contr/main.php", {"action" : "lbs_get_text", id: lbs_id}, 'POST').resp_text;
						show_select_string(  function(new_text){
							call_php_sync("contr/main.php", {"action" : "redo_lbs", id: lbs_id, lb_text: new_text}, 'POST');
							update_order_state(orders.get_active_rec(), drec); 
						}, lb_text, null, lp("change_date_time") );
				} ) );
			}

			function show_detail(id, re){
				rec = re;
				var dd = $(".ap_detail_div");
				dd.html('<div class="tc_triples_form mc_tt_section mc_page_cont mc_clickable"><div class="tt_thumbs_section"> </div></div>'); // tt wrapper
				if(fields_det=="")
					fields_det = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: "app_lbs"}, 'POST').resp_text ); 
				apps = new Tablo(".tc_triples_form", null, detail_table_name, fields_det.list, null, on_lbs_rec_sel, null, detail_alias_name);
				apps.ro_set("name", "desc");   // FIORD
				//apps.set_cond("camp_id="+rec.data("camp_id")+" AND shop_id="+rec.data("shop_id") + " AND img_id<>0" /*NOIMAGE*/);
				apps.set_cond("order_id="+rec.data("id") + " AND img_id<>0" /*NOIMAGE*/);
				var order_path = "clients/" + contr_req("get_order_path", {client_code: client_code, order_id: id} );
				apps.on_show = function(){
					var rc = $("#table-app_lbs").find(".td-app_lbs-path").length, rn=0; // RH - resize headers on last rec
					$("#table-app_lbs").find(".data-row").each( function(){
						var drec = $(this);
						// show image
						var tdp = drec.find(".td-app_lbs-path");
						var div = $('<div class="mc_triple_div"></div>');
						var img = new Image();
						//img.src = files_path + tdp.html() + drec.data("name_mini"); // TODO: use here get_file_thumb_path
						//img.src = "table_tree/thumbs/" + drec.data("thumb_small"); // TODO: use here get_file_thumb_path
						img.src = order_path + drec.data("id") + "/preview.jpg";
						img.classList.add("mc_triple_img");
						img.onload = function(){
							var H = 70; // all imgs of same height
							var lbs_w = drec.data("r")-drec.data("l")+1, lbs_h = drec.data("b")-drec.data("t")+1; // to find div proportion
							var div_h = H, div_w = H*lbs_w/lbs_h;
							var rect = fit_rect2( img.width, img.height, div_w, div_h); 
							fit_img_div(div, $(img), div_w, div_h, rect);
							if(++rn==rc) 
								fh_init_table( drec.closest(".tc_triples_form") );
						}
						div.append(img);
						tdp.html("").append(div);
						drec.find(".td-app_lbs-RES_category").each( function(){  
							// for PROD camp not set, each rec may havve its own camp... $(this).html( drec.data("path").substr(camp_path.length) ) ; 
							$(this).html( extract_name(unpend_slash( drec.data("path") ))  ) ; // suppose all lbs have a categ
						});
						set_lbs_action(drec);
						dd.find("table.fh-header").css("top", "20px"); // DEF DET_IMG_OUT - img in detail table stuck out (up); donno now reason; use this quickfix TODO
						// EVITE text
						drec.find(".td-app_lbs-lb_text").each( function(){
							var txt = $(this).html();
							$(this).html("<textarea></textarea>");
							$(this).find("textarea").val(txt);
						});
					});
				}
				apps.show();
				$(".ap_detail_div").on("mouseup", ".mc_triple_img", function(){ 
					var row = $(this).closest(".tr-"+detail_table_name);
					var size = "<label>"+lp("Size")+": </label>"+row.data("lbs_width")+"x"+row.data("lbs_height");
					var tsize = "<label>"+lp("Trim_size")+": </label>"+row.data("twidth")+"x"+row.data("theight");
					show_preview( $(this).closest(".tr-app_lbs").data("img_id"), "<div><div>"+size+"</div><div>"+tsize+"</div></div>" ); 
				} ); // PREVIEW
				scroll_to_view(dd[0]);
			}

			// DEF SETCAMP - stuff to set camp id and re-filter records of main table; called from project.js -> show_sel_camp
			function set_camp(id){
				var cond = ["(camp_id="+id+")"];
				// UR
				if(ur_role.shops && ur_role.shops.length)
					cond.push( "shop_id in (" + ur_role.shops.join(",") + ")" );
				// LOCAL_VISUAL sees all orders  (if at all needs to see them; LV works with shops)
				// GRAPHIC also sees from first stage
				// if(ur_role.role=="GRAPHIC") cond += " and uploaded=1";   fab detto graph must se all; besides if one lbs rejected - order is in 'created' and not visib for graph DEF GSA
				// printers see only orders to print; TODO: not a proper place to set this cond
				if(ur_role.role=="PRINT")
					cond.push("approved=1");
				if(stat_cond) cond.push(stat_cond); // STAT
				orders.set_cond( cond.filter(Boolean).join(" AND ") );
				orders.clear();
				orders.show(0, def_rec_id);  // DR1 DEFREC
				camp_path = call_php_sync("contr/main.php", {"action" : "get_camp_path", "id": id}, 'POST').resp_text;  // used for EVITE category
			} 

			function set_action_buttons(){
				if(ur_role.role!="PRODUCTION") $(".mc_accept_selection").addClass("hidden");
				if(!is_approver) $(".mc_approve_selection").addClass("hidden");
				$(".mc_approve_selection").addClass("hidden");// not used in EVITE 
			}
			
			var is_archive = <?php echo isset($_GET["arch"])?1:0; ?>; // DEF ARCH stuff to archive orders; 
			var detail_alias_name = "app_lbs", detail_table_name = is_archive? "app_lbs_arch" : "app_lbs"; // ARCH
			var fields_det="";

			function on_rec_sel(rec){ 
				puh("record_selected");
				if(get_order_state(rec)=="complete") 
					puh("order_complete");
			}
			function on_lbs_rec_sel(rec){ 
				var os = get_lbs_state(rec);
				//if(os=="draft") puh("lbs_draft");
				puh("lbs_" + os);
			}
			// sends update req to server and updates affected records
			function set_state(action, sel_ords=$(), sel_apps=$() ){
				// action
				call_php_sync("contr/main.php", {"action" : action, ids_ords: JSON.stringify(get_data_arr(sel_ords, "id")), ids: JSON.stringify(get_data_arr(sel_apps, "id")) }, 'POST'); 
				// update
				update_order_state( sel_ords, sel_apps ); // DEF ONEDET - stuff which works only when one opened detail is possible;
			}
			function get_selection(){ 
				var sel = {orders: orders.get_selection(), apps: apps? apps.get_selection() : $()};
				if(!sel.orders.length && !sel.apps.length)
					sel = {orders: orders.get_active_rec(), apps: apps? apps.get_active_rec() : $()}; // with SINGLE_ACTIVE only one of them is not empty
				return sel;
			}
			function show_edit_order(id=0){
				var no = $(call_php_sync("contr/main.php", {"action" : "show_edit_order", "id" : id, tt_project: "orders"}, 'POST').resp_text); 
				show_select_string(function(){ return save_order(id, no); }, '', no, lp("edit_order"));
				ff_init(no);
			}
			function save_order(id, panel){
				var fields = ff_params(panel, true);
				fields["client_id"] = client_id;
				cc("save_order", function(){
					order.refresh();
				}, {id: id, fields: JSON.stringify(fields)} );
			}
			function unset_camp(){
				orders.set_cond("");
				orders.refresh(); 
			} 
			function create_ws(order_id){
				cc("create_ws", function(){alert("ok");update_lbs_done( orders.find_rec(order_id) );}, {order_id: order_id} );
			}
			
			var orders, apps = null;
			var client_id = <?php echo get_client_id(); ?>;
			var alias_name = "orders_all", table_name = "orders";
			var client_code = '<?php echo get_client_code(); ?>';
			var order_state_colors = {"sent" : "c5d9ed", "accepted" : "4f94d4", "uploaded" : "f5e6ab", "approved" : "b8e6bf", "rejected" : "ff8085", "hires" : "00a32a", "packed" : "117a65", "complete" : "117a65", "update":"EB984E"};
			var user_email = '<?php echo get_user_info("email"); ?>'; // IC_ST
			var camp_path;

			$(document).ready( function(){
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				//
				var sf =  call_php_sync("contr/main.php", {"action" : "get_order_search_fields", client_id: client_id, tt_project: "orders", all: 1}, 'POST').resp_text; 
				var ac =  call_php_sync("contr/main.php", {"action" : "get_order_list_fields", client_id: client_id, tt_project: "orders", all: 1}, 'POST').resp_text; 
				//orders = new Tablo("#tt_orders_div .tt_thumbs_form", $("#tt_orders_div .mc_search_panel"), "orders_sent", JSON.parse(ac), sf, on_rec_sel, function(rec){show_edit_order(rec.data("id"));}, "orders_all");
				orders = new Tablo("#tt_orders_div .tt_thumbs_form", $("#tt_orders_div .mc_search_panel"), "orders_sent", JSON.parse(ac), sf, on_rec_sel, function(rec){ show_detail_click( rec.data("id") ); }, "orders_all");
				//cass_init(); // CASS
				orders.ro_set("date_create", "desc");   // FIORD
				orders.on_show = on_show;
				if(client_id)
					orders.set_cond("client_id="+client_id); // show will be called from set_camp()
				else
					orders.show();

				// MUSA
				is_approver = <?php echo is_approver(ur_get_name(), 2)? "1" : "0"; ?>;

				// order actions
				$(".lbsp_rec_actions").append( $('<div class="mc_btn mc_approve_selection"> <i class="fas fa-thumbs-up mc_page_head" title="'+lp("approve_selected_subjects")+'"></i></div>') );
				// DEF ACCORD accept order; field order_state is used now in fact as flag 'accepted' but technically has two states 'draft'/'accepted'; thus in future may extend set of states
				$(".lbsp_rec_actions").append( $('<div class="mc_btn mc_accept_selection"> <i class="fas fa-check mc_page_head" title="'+lp("accept_selected_subjects")+'"></i></button>') );
				$(".mc_accept_selection").click( function(){
					var sel = get_selection(); 
					if( (sel.orders.length || sel.apps.length) && confirm(lpp("$accept_orders_lbs$", sel.orders.length, sel.apps.length)) ){
						set_state("accept_lbs", sel.orders, sel.apps );
					}else
						alert("no_record_selected");
				});
				$(".mc_approve_selection").click( function(){
					var sel = get_selection(); 
					if( (sel.orders.length || sel.apps.length) && confirm(lpp("$approve_orders_lbs$", sel.orders.length, sel.apps.length)) ){
						//set_state("approve_lbs", sel.orders, sel.apps ); // TODO: this action not exits now (use used "approve" instead, called from apap.php)
						set_state("approve", sel.orders, sel.apps );
					}else
						alert("no_record_selected");
				});
				$(".lbsp_del").click( function(){
					var sel = get_selection(); 
					if( (sel.orders.length) ){
						if( confirm(lpp("$delete_orders$", sel.orders.length)) ){
							call_php_sync("contr/main.php", {"action" : "delete_orders", ids: JSON.stringify(get_data_arr(sel.orders, "id")) }, 'POST'); 
							location.reload();
						}
					}else
						alert("no_record_selected");
				});
				// DALL ; now made only for triples, so role must be P; TODO: put dl type to title (NOTE: similar code is in set_lbs_action() )
				if(ur_role.role=="PRINT")
					$(".lbsp_rec_actions").append( $('<button type="button" class="mc_download_selection btn btn-primary btn-sm"> <i class="fas fa-download mc_page_head" title="'+lp("download_selected_subjects")+'"></i></button>') );
				$(".mc_download_selection").click( function(){
					var sel = get_selection(); 
					if( sel.orders.length || sel.apps.length){
						var data = {type: "triples", camp_id: get_camp_id(), orders: JSON.stringify(get_data_arr(sel.orders, "id")), apps: JSON.stringify(get_data_arr(sel.apps, "id")) }; 
						var url = extract_path(window.location.href) + "/contr/download.php";
						var ondownload = function(){ update_order_state(sel.orders, sel.apps) } // TODO: would be good to have dl result
						load_file(url, data, "POST", ondownload  );
					}
				});
				set_action_buttons();
				// no CRUD for orders
				$(".lbsp_edit, .lbsp_del, .lbsp_new").addClass("hidden");
				// who can delete
				if(ur_role.role=="IMAGE") // DEF ORDER_DEL del orders if necessary 14.10.22
					$(".lbsp_del").removeClass("hidden");
				if(order_deleted)
					alert(lpp("$order_deleted$", order_deleted));
				// new temp
				if(ur_role.role=="LOCAL"){
					$(".lbsp_new").click( function(){show_edit_order(0);} );
					// not used in EVITE $(".lbsp_new").removeClass("hidden");
				}
				// camps
				show_sel_camp();
				if(def_camp_id){
					$("#mi_camp").val(def_camp_id);
					set_camp(def_camp_id); // calls show() and sets def rec
				}else if(client_id) {  // TODO: should also show sel camp cb from internal (PROD)
					// PRECA
					if( false && $(".camp").length>1 ){ // DISABLED - just select last camp by def in SLD
						$(".campdiv").removeClass("hidden");
						$(".camp").on("click", function(){     set_camp( $(this).data("cid") ); $(".campdiv").remove();   }  );
					}else{ // SLD
						var last_camp = $('#mi_camp option:last-child').val();
						if(last_camp)
							set_camp(last_camp);
						else
							alert(lp("no_campaigns_found")+"!");
					}
				}
					// TODO: need it? $("#mi_camp").val(null);

			});
		</script>
	</body>
