<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB  TODO: move this stuff to standard to be used by all pages*/ ?>
		<style>
			#tt_orders_div .tt_thumbs_form {width: 100%;}
			#tt_lowres_div .lbsp_form{align-items: flex-start;}
			#tt_lowres_div {
				height: 100%;
				position: relative; /* else search pan out of this panel */
			}
			#tt_orders_div{
				border-left: 7px solid var(--active_col);
				border-right: 7px solid var(--active_col);
			}
			/* DEF AUTOHIDE AH - side panels hidden and shown on mouse over */
			.mc_ah_panel{
				position: absolute;
				top: 0px;
				z-index: 200;
				height: 100%;
				overflow: auto; /* TODO: temp solution to fit list to window; problem is that hides menu on scroll*/
			}
			.mc_ah_hider{
				width: 30px;
				background-color: var(--active_col);
				color: white;
				font-size: 20px;
				padding: 5px;
				display: flex;
				align-items: center;
			}
			#mi_shops{
				left: 0px;
			}
			#mi_lowres{
				max-width: 30%;
				right: 0px;
			}
			.mc_body{
				position: relative;
			}
			.hide {
			opacity: 0;
				transition: opacity 1s linear;
				-webkit-transition: opacity 1s linear;
				-moz-transition: opacity 1s linear;
				-o-transition: opacity 1s linear;
			}
			.show {
				opacity: 1;
				transition: opacity 1s linear;
				-webkit-transition: opacity 1s linear;
				-moz-transition: opacity 1s linear;
				-o-transition: opacity 1s linear;
			}
			/* PRECA */
			.camp{
				font-size: 60px;
				padding: 20px;
				margin: 20px;
				background-color: white;
			}
		</style>
	</head>
	<body style='background: url("<?php echo get_background_path(); ?>") no-repeat center center fixed;'> 
		<!-- table_tree -->
		<script src="table_tree/js/table_tree.js"></script>
		<!-- table_tree -->
		<script src="js/table.js"></script>
		<script src="js/shops.js"></script>

		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor mc_body" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_head" id="mi_shops">
					<div id="tt_shops_div" class='mc_page_body mc_tt_cont ttc_fullscreen'></div> <!-- NOTE: without this cont appears another horiz scr bar -->
				</div>
				<div class="" id="mi_show_shops"><i class="fas fa-play fa-flip-horizontal"></i></div> <!-- AH -->
				<div class="mc_page_body mc_page_cont">
					<div id="tt_orders_div" class='mc_page_body mc_tt_cont ttc_fullscreen'>
						<?php echo lang_html_load('html/table.html' ); ?>
					</div> <!-- NOTE: without this cont appears another horiz scr bar -->
				</div>
				<div class="mc_page_head" id="mi_lowres">
					<div id="tt_lowres_div" class='mc_page_body mc_tt_cont ttc_fullscreen'></div> <!-- NOTE: without this cont appears another horiz scr bar -->
				</div>
				<div class="" id="mi_show_lowres"><i class="fas fa-play "></i></div> <!-- AH -->
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<div id="mi_send_emails" class="hidden" title="send pending events" onclick="ppee_send()"><label class='mc_center'></label></div> <!-- PPEE -->

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<!-- DEF NEWLB newi/edit lightbox -->
			<?php echo lang_html_load('html/lb.html',0,["mu" => measure_unit]); ?> <!-- LOADSUB -->
			<!-- LB_RESIZE -->
			<div class='lb_resize_div hidden'></div>
			<div class='lb_resize_rect hidden'></div> 
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
			<div id='mi_dima' class='hidden' style='position:absolute;z-index:1000'></div> <!-- DIMA -->
		</div>

		<div class="overlay campdiv">
			<div class="img-overlay">
				<?php  // DEF PRECA pre sel camp
					$camps = db\select_id_field_to_array("camps", "id", "name", "camp_state='opened'", "date_from");
					foreach($camps as $id => $name)
						echo "<div class='camp' data-cid='$id'>$name</div>";
				?>
			</div>
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script type="text/javascript">

			<?php $od=isset($_GET["id"]) && ($id=$_GET["id"]) && !db\exists("orders","id=$id") && db\exists("events","order_id=$id"); $id=$od?0:get_or_def($_GET,'id',0);
			echo "var def_rec_id = $id;\n";  // DEFREC
			echo "var order_deleted = ".($od?$_GET["id"]:0).";\n";
			?>
			var def_camp_id = <?php echo get_or_def($_GET,'cid',0); ?>; // DD
			var stat_cond = "<?php $sc = get_or_def($_GET,'filter',""); global $stat_conds; if($sc) echo $stat_conds[$sc]; ?>"; // STAT
			var lowres_path = "<?php echo get_files_path(); ?>";
			var order_state_colors = {"draft" : "c5d9ed", "revise" : "f5e6ab",  "confirmed" : "b8e6bf", "declined" : "ff8085", "sent" : "00a32a"};



			var rec,drec; // RD
			function get_lbs_state(rec){return rec.find(".td-"+detail_alias_name+"-app_state").html();}
			function get_lbs_order(lbs_rec){ return lbs_rec.closest(".ap_detail_row").data("id"); }
			// if user requests some action on order: do the action and update rec
			function update_state(action, sel_ords){
				call_php_sync("contr/main.php", {"action" : action, orders: JSON.stringify(get_data_arr(sel_ords, "id")), camp_id: get_camp_id()}, 'POST'); 
				sel_ords.each( function(){ update_lbs_done( $(this) ); } );
			}
			function set_order_actions(rec){ // TODO: better add it as disabled if order not yet sent
				// if order sent - no buttons; if not sent but filled - visual may reject or send it
				var td = rec.find(".td-" + shops_alias + "-RES_action");
				td.html("");  // NOTE the func may be set to refresh td, so td not always empty
				var os = rec.data("order_state_lbs");
				var id = rec.data("id");
				var filled = rec.data("complete")=="1";
				var empty = rec.data("lbc_total_count")?false:true;
				if( os_is('sent', os)){
					td.html( "<i class='fas fa-check' title='order sent'></i>" );
					return;
				}
				var is_next_approver = is_approver && call_php_sync("contr/main.php", {"action" : "is_next_approver", "order_id": id, "stage": 1 }, 'POST').resp_text=="1"; // MUSA
				
				// if all lbc filled and not yet conf/rej - may conf/rej
				if(is_next_approver && os_is('revise',os) && filled) // TODO 1 need check if this group has already approved/rejected
					td.html("<i class='fas fa-thumbs-down mc_reject "+(revs[id].rejected=='1'?"mc_ch":"")+"' title='reject'></i><i class='fas fa-thumbs-up mc_approve "+(revs[id].confirmed=='1'?"mc_ch":"")+"' title='approve'></i>");
				// if confirmed - may send
				if( ur_role.role=="IMAGE" && os_is('confirmed',os) && !os_is("sent",os) ) // WSH1
					td.html( "<i class='fa fa-play mc_send' title='send'></i>" ); // TODO: code?
				// if rejected - need a btn to re-send 'ready to be confirmed' event to revisors
				// when user may req approve
				if( ur_role.role=="LOCAL" && filled && !empty && (!os_is("revise",os) || os_is("declined", os)) ) // filled and not yet put in revision or declined
					td.html( "<i class='fas fa-eye mc_req_app "+(os=='declined'?"mc_rejected":"")+"' title='request approve"+(os=='declined'?" (rejected)":"")+"'></i>" );
				// TODO: if confirmed - can't update lbs
				if( ur_role.role=="LOCAL" && os=='revise' )
					td.html( "<i class='far fa-clock' title='waiting approve'></i>" );
				// show rev details
				if(  (os=='revise' || os=="declined") ){
					var tos = rec.find(".td-"+alias_name+"-order_state_lbs");
					tos.mouseover(function(){
						if(!rec.data("ts")){
							cc("get_order_revise_details", function(res){
								var state = JSON.parse( res );
								var notes = [];
								for(var i=0;i<state.length;i++){
									var r = state[i].res;
									var n = state[i].notes;
									notes.push(state[i].group_name+": "+(r?r:"waiting")+(n&&n.trim()?" ("+n+")":""));
								}
								tos.prop("title", notes.join("\n"));
								rec.data("ts",1);
							}, {order_id: id, client_id: client_id, stage: 1});
						}
					});
				}
			}

			var revs; // contains rev info for all orders for current group/stage
			function get_reva(){
				// DEF REVA control curr revisor actions
				var ids = []; $("#table-"+alias_name).find(".data-row").each(function(){ids.push($(this).data("id"))});
				var res = call_php_sync("contr/main.php", {"action" : "get_orders_revise_state", "ids": ids, "stage": 1 }, 'POST'); 
				return JSON.parse(res.resp_text);
				//revs = []; for(var i=0;i<res.length;i++) revs[res[i].id] = {confirmed: res[i].confirmed, rejected: res[i].rejected};
			}
			function on_show(){
				$(".td-"+alias_name+"-RES_detail").click( function(){ show_detail_click_ozon( $(this).closest(".data-row").data("id")); } );
				var table = $("#table-"+alias_name);
				// DEFREC
				if(def_rec_id){
					// rec has already been made active by DR1
					show_detail_click_ozon(def_rec_id);
					def_rec_id = 0; // avoid set def rec on each show
				}
				// MUSA
				if(is_approver)
					revs = get_reva(); // appr state for all recs: id -> [comfirmed,rejected] NOTE: used in OS1

				// DEF POB pers ord btn: visible if order not yet created, enabled if todo cnt = 0; need set it on show and on lbs done cnt change; on create order is replaced by ord num;
				$("#table-" + alias_name).find(".tr-" + alias_name).each(function(){ set_rec_state_columns($(this)); } ); // OS1
				// send order
				$("#table-"+alias_name).on("click", ".mc_send", function(){ send_order( $(this).closest(".data-row") ); } );
				$("#table-"+alias_name).on("click", ".mc_req_app", function(){ request_revise( $(this).closest(".data-row") ); } );
				$("#table-"+alias_name).on("click", ".mc_approve", function(){ revise_order( $(this).closest(".data-row"), "1" ); } );
				$("#table-"+alias_name).on("click", ".mc_reject", function(){ var rec = $(this).closest(".data-row"); show_select_string( function(msg){revise_order( rec, "0" , msg); }, "", null, "reject order") } );
				//
				$("#table-"+alias_name).find(".td-"+alias_name+"-date_create").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
				$("#table-"+alias_name).find(".td-"+alias_name+"-date_done").each( function(){ $(this).html( correct_date_format( $(this).html() ) ) } ); // DEF DATE_FORMAT correct mysql format to user preferable
			}
			function send_order(rec){
				var eid = call_php_sync("contr/main.php", {"action" : "send_order", "id": rec.data("id") }, 'POST'); 
				ppee_add(eid.resp_text);
				update_lbs_done(rec);
				alert("Ok");
			}

			function request_revise(rec){
				var eid = call_php_sync("contr/main.php", {"action" : "request_revise", "id": rec.data("id") }, 'POST'); 
				ppee_add(eid.resp_text);
				update_lbs_done(rec);
				alert("Ok");
			}

			function revise_order(rec, res, msg='', lbs_id=0){
				var eid = call_php_sync("contr/main.php", {"action" : "revise_order", "id": rec.data("id"), res: res, msg: JSON.stringify(msg), lbs_id: lbs_id }, 'POST'); 
				ppee_add(eid.resp_text);
				update_lbs_done(rec);
				alert("Ok");
			}

			// TODO: simila to lbs_set_size code
			function fit_img_div(div, img, dw, dh, i_rect){
				div.css("width", 	dw);
				div.css("height", 	dh);
				img.css("width", 	i_rect.w);
				img.css("height", 	i_rect.h);
				img.css("left",    -i_rect.dw);
				img.css("top",     -i_rect.dh);
			}

			var apap_r, apap_dr; 

			// DEF SETCAMP - stuff to set camp id and re-filter records of main table; called from project.js -> show_sel_camp
			function set_camp(id){
				// shops
				var cond = [];
				if(ur_role.shops && ur_role.shops.length) cond.push( "id in (" + ur_role.shops.join(",") + ")");  // used for LV TODO: may happen that a user (lv) has no shops
				var shops_ids = call_php_sync("contr/main.php", {"action" : "get_camp_shops",id: id}, 'POST').resp_text;
				$(".lbsp_caord").addClass("hidden"); // CAORD
				if(shops_ids.length){
					cond.push("id in (" + shops_ids + ")");
					shops.set_user_cond( cond.filter(Boolean).join(" AND ") );
					shops.open_dir_recursive(shops.get_root_item());
					$(".lbsp_caord").removeClass("hidden"); // CAORD
				}
				//
				cond = ["(camp_id="+id+")"];
				if(ur_role.shops && ur_role.shops.length) cond.push( "shop_id in (" + ur_role.shops.join(",") + ")");  // used for LV TODO: may happen that a user (lv) has no shops
				orders.set_cond( cond.join(" AND ") );
				orders.refresh(); 
				var path = call_php_sync("contr/main.php", {"action" : "get_camp_path", "id": id}, 'POST').resp_text; 
				if(lowres)
					lowres.set_root_dir(path); // TODO: this is new, 2.05.24 and maybe not allows to navigate super folders
					//lowres.open_path(lowres.get_root_dir() + path);
				// PRECA EVITE
				//lowres.cancel_search(lowres.get_search_form());
				if(sel_cat && ur_role.role=="LOCAL" && ur_role.shops.length==1 ){
					// check if cond was set in camps page CAMP_SHOP_CAT
					var cond = call_php_sync("contr/main.php", {"action" : "get_camp_shop_cat", shop_id: ur_role.shops[0], camp_id: id}, 'POST').resp_text; 
					if(cond) // use cond from db
						set_cat(JSON.parse(cond));
					else{ // ask user now
						var ic = call_php_sync("contr/main.php", {"action" : "get_img_cat"}, 'POST'); 
						var mw = $(ic.resp_text);
						show_select_string( function(){ set_cat( ff_params( $("#md_ss_content_custom") ) ) }, null, mw, null, function(){ lowres.cancel_search(lowres.get_search_form());  return true;} );
					}
				}else if(lowres)
					lowres.open_root_dir();
			} 
			function set_cat(params){
				ff_set_params( $("#tt_lowres_div .tt_search_form"), params );
				lowres.find_files_click(); 
			}
			function unset_camp(){
				orders.set_cond("");
				orders.refresh(); 
				lowres.open_root_dir();
				shops.set_user_cond("");
				shops.open_root_dir();
				$(".lbsp_caord").addClass("hidden"); // CAORD
			} 


			var is_archive = <?php echo isset($_GET["arch"])?1:0; ?>; // DEF ARCH stuff to archive orders; 
			var alias_name, table_name, detail_alias_name = "app_lbs", detail_table_name = is_archive? "app_lbs_arch" : "app_lbs"; // ARCH
			var fields_det="";

			function on_rec_sel(rec){ 
				puh("record_selected");
				var os = rec.data("order_state_lbs");
				if(os=="complete") 
					puh("order_complete");
				 $(".lbsp_edit").prop("disabled", os_is("sent", os));
			}
			function on_lbs_rec_sel(rec){ 
				var os = get_lbs_state(rec);
				//if(os=="draft") puh("lbs_draft");
				puh("lbs_" + os);
			}
			function get_selection(){ 
				var sel = {orders: orders.get_selection(), apps: apps? apps.get_selection() : $()};
				if(!sel.orders.length && !sel.apps.length)
					sel = {orders: orders.get_active_rec(), apps: apps? apps.get_active_rec() : $()}; // with SINGLE_ACTIVE only one of them is not empty
				return sel;
			}
			function show_edit_order(id=0){
				var active = shops.get_active_item(); // dir or file
				var shop_id = 0, path = ''
				if(shops.is_dir(active))
					path = shops.get_curr_dir();
				else
					shop_id = shops.get_curr_item_id();
				/* allow create shopless order if(!id && !shop_id){alert(lp("shop_not_selected"));return;} */
				var no = $(call_php_sync("contr/main.php", {"action" : "show_edit_order", "id" : id, "shop_id": shop_id, path: path, tt_project: "orders"}, 'POST').resp_text); 
				// TODO: check if custom fields exist; if not - needn't show the form
				var shop_name = "";// shops.get_data(shops.get_id_elem(shop_id), "name");
				show_select_string(function(){ return save_order(id); }, '', no, shop_name);
				ff_init(no);
			}
			function save_order(id){
				var panel = $("#md_ss_div");
				var fields = ff_params(panel, true);
				fields["client_id"] = client_id;
				// now shop id saved in select if(!id)fields["shop_id"] = shops.get_curr_item_id(); // if new order -pass shop id
				fields["camp_id"] = get_camp_id();
				//
				cc("save_order", function(){
					orders.refresh();
				}, {id: id, fields: JSON.stringify(fields)} );
			}
			
			var client_id = <?php echo db\select_field("users", "client_id", "id=".get_curr_user_id()); ?>;
			var client_code = '<?php echo get_client_code(); ?>';
			var alias_name = "orders", table_name = "orders";

			function show_shop_orders(id, path){
				var conds;
				if(id)
					conds = ["shop_id = " + id];
				else{
					var pc = call_php_sync("contr/main.php", {"action" : "get_path_shops", path: path}, 'POST').resp_text;
					if(!pc) pc = "0";
					conds = ["shop_id in (" + pc + ")"];
				}
				if(get_camp_id())
					conds.push("camp_id = " + get_camp_id());
				orders.set_cond(conds.join(" AND "));
				orders.refresh();
			}

			// TODO 1 : this seems was intended to be generalized and put to tt
			function show_rename_dialog(elem){ 
				var id = shops.get_data(elem, "id");
				var name = shops.get_data(elem, "name");
				show_select_string(
					function(new_name){
						$.ajax({
							"type": "POST",
							"url": "contr/main.php",
							//"data": {"action": "rename_" + table_name, "id": id, "new_name": new_name},
							"data": {"action": "rename_location", "id": id, "name": new_name},
							"success": function(res){shops.open_root_dir()}
						})
					},
					name);
			}
			// CAORD
			function caord_create(){
				var sel = shops.find_selection();
				if(!sel.files.length && !sel.paths.length){
					alert(lp("no_shops_selected"));
					return;
				}
				cc("caord_create", function(res){ alert(res + " " + lp("orders_created")); orders.refresh(); }, {camp_id: get_camp_id(), locations: JSON.stringify(sel), root_dir: shops.get_root_dir()});
			}

			// show_detail_click wrapper for ozon
			function show_detail_click_ozon(id=null){ 	show_detail_click(id, orders, show_shop_lb); 	}
			function update_detail_ozon(){ 	update_detail(show_shop_lb); 	}

			var orders, apps = null;
			var shops, lowres;
			var clod_to = 2000; var clod_tm; // DEF CLOD close delay; close shops panel not instantly
			var is_approver;
			var use_ah = 0; // AH
			var sel_cat = false; // a flag to avoid show sel cat dialog during init EVITE PRECA
			$(document).ready( function(){
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				// ORDERS
				var sf =  call_php_sync("contr/main.php", {"action" : "get_order_search_fields", client_id: client_id, tt_project: "orders"}, 'POST').resp_text; 
				var ac =  call_php_sync("contr/main.php", {"action" : "get_order_list_fields", client_id: client_id, tt_project: "orders"}, 'POST').resp_text; 
				orders = new Tablo("#tt_orders_div .tt_thumbs_form", $("#tt_orders_div .mc_search_panel"), "orders_draft", JSON.parse(ac), sf, on_rec_sel, function(rec){ show_detail_click_ozon( rec.data("id") ); }, "orders");
				//cass_init(); // CASS
				orders.ro_set("date_create", "desc");   // FIORD
				orders.on_show = on_show;
				orders.set_cond("client_id="+client_id); /// NOTE: this not used in fact; con is set in set_camp
				// SHOPS
				shops = new table_tree("locations", '#tt_shops_div', "locations");
				//shops.set_on_select(show_shop_orders); // TODO: check invoked on tree item sel
				shops.set_use_paths(0); // if not use paths - see only subset of locations wich have shops
				shops.hide_plain();
				shops.hide_preview();
				shops.set_show_files(1);
				shops.set_item_click(show_shop_orders);
				//shops.main_form.find(".tt_exp_btn_div").addClass("hidden"); donno if hide expl header
				shops.add_popup_item(lp('rename'), show_rename_dialog, true, true); // RENAME
				shops.set_root_dir(client_code + "/locations/");
				shops.open_root_dir();				
				// FILES
				if(ur_role.role=="LOCAL"){
					lowres = new table_tree("lowres", '#tt_lowres_div', "lowres", "thumbs");
					lowres.set_use_paths(1);
					lowres.hide_tree();
					lowres.hide_preview();
					//lowres.set_paths("files/" + client_code + "/lowres/", "files/" + client_code + "/lowres_thumb/", "files/" + client_code + "/lowres_thumb/" ); // DEF HRTHP
					lowres.set_paths("", "thumbs/", "thumbs/" ); // DEF HRTHP
					lowres.set_root_dir(client_code + "/lowres/");
					lowres.open_root_dir();				
				}
				//
				$("#tt_orders_div").find(".mc_table_control").parent().addClass("mc_bg_second");

				/*var cid = def_camp_id? def_camp_id : get_camp_id(); // TODO: as def camp may be passed a closed camp
				if(cid){
					$("#mi_camp").val(cid);
					set_camp(cid); // calls show() and sets def rec
				}else
					alert(lp("no_campaigns_found")+"!");
				*/

				// order actions
				// MUSA
				is_approver = <?php echo is_approver(ur_get_name(), 1)? "1" : "0"; ?>;



				// confirm several orders
				if(ur_role.role=="RETAIL" || ur_role.role=="IMAGE")
					$(".lbsp_rec_actions").append( $('<div class="mc_approve_selection mc_btn"> <i class="fas fa-thumbs-up mc_page_head" title="'+lp("confirm_selected_subjects")+'"></i></div>') );
				$(".mc_approve_selection").click( function(){
					var sel = get_selection(); 
					if( (sel.orders.length || sel.apps.length) ){
						if(confirm(lpp("$confirm_orders$", sel.orders.length)) )
						update_state("confirm_orders", sel.orders);
					}else
						alert("no_record_selected");
				});
				// request confirm for several orders
				if(ur_role.role=="NOT USED IN EVITE"){
					$(".lbsp_rec_actions").append( $('<div class="mc_request_confirm_selection mc_btn"> <i class="fas fa-eye mc_page_head" title="'+lp("request_confirm_selected_subjects")+'"></i></div>') );
					$(".mc_request_confirm_selection").click( function(){
						fh_init_table( orders.mainform ); return;
						var sel = get_selection(); 
						if( (sel.orders.length || sel.apps.length) ){
							if(confirm(lpp("$request_confirm_orders$", sel.orders.length)) )
							update_state("request_revise_orders", sel.orders);
						}else
							alert("no_record_selected");
					});
				}
				// no CRUD for orders
				$(".lbsp_del, .lbsp_new").addClass("hidden");
				$(".lbsp_edit").removeClass("hidden");
				$(".lbsp_edit").prop("disabled", true);
				$(".lbsp_edit").click(function(){
					show_edit_order(orders.get_active_rec().data("id"));
				});
				if(ur_role.role=="VISUAL") // DEF ORDER_DEL del orders if necessary 14.10.22 ; TODO: 2 phase del
					$(".lbsp_del").removeClass("hidden");
				$(".lbsp_del").click( function(){
					var sel = get_selection(); 
					if( (sel.orders.length) ){
						if( confirm(lpp("$delete_orders$", sel.orders.length)) ){
							call_php_sync("contr/main.php", {"action" : "delete_orders", ids: JSON.stringify(get_data_arr(sel.orders, "id")) }, 'POST'); 
							location.reload();
						}
					}else
						alert("no_record_selected");
				});
				// check def_rec_id order
				if(order_deleted)
					alert(lpp("$order_deleted$", order_deleted));
				// new temp
				if(ur_role.role=="VISUAL"){ // DEF ORDER_DEL del orders if necessary 14.10.22 ; TODO: 2 phase del
					$(".lbsp_new").removeClass("hidden");
					// DEF CAORD CAmp ORDers; create orders for all shops of the campaign
					$(".lbsp_rec_actions").append( $('<div class="lbsp_caord mc_btn hidden"> <i class="fa fa-folder-plus mc_page_head" title="'+lp("create_orders_for_selected_locations")+'"></i></div>') );
					$(".lbsp_caord").click( caord_create );
				}
				$(".lbsp_new").click( function(){show_edit_order(0);} );
				// send order
				$(".lbsp_rec_actions").append("<div class='mc_order_send bul_edit'><i class='fas fa-caret-right'></i> </div>");
				//
				shops_lb_init();
				// camps
				show_sel_camp();
				var loc = call_php_sync("contr/main.php", {"action" : "get_last_opened_camp", client_id: client_id}, 'POST'); 
				if(loc.resp_text){
					$("#mi_camp").val(loc.resp_text);
					set_camp(loc.resp_text);
				}else
					$("#mi_camp").val(null);
				orders.show();
				// AH
				if(use_ah){
					$("#mi_shops,#mi_lowres").addClass("mc_ah_panel");
					$("#mi_show_shops,#mi_show_lowres").addClass("mc_ah_hider");
					$(".mc_ah_panel").fadeOut();
					$("#mi_show_shops").on("click", function(){ // NOTE: can't use mouseover while it prevents using side menu
						$("#mi_shops").fadeIn("slow");
					});
					$("#mi_shops").on("mouseenter", function(){
						clearTimeout(clod_tm);
					});
					$("#mi_shops").on("mouseleave", function(){
						clod_tm = setTimeout(  function(){  $("#mi_shops").fadeOut("slow") }, clod_to ) ;
					});
					$(".tt_thumbs_section").click( function(){
						 $("#mi_shops").fadeOut("slow");
					});
					$("#mi_show_lowres").on("mouseenter", function(){
						$("#mi_lowres").fadeIn("slow");
					});
					$("#mi_lowres").on("mouseleave", function(){
						$("#mi_lowres").fadeOut("slow");
					});
				}
				// not use shops in EVITE
				$("#mi_shops").addClass("hidden");
				//
				sel_cat = true;
				// PRECA
				if( $(".camp").length<2 )
					$(".campdiv").remove();
				else{
					$(".camp").on("click", function(){     set_camp( $(this).data("cid") ); $(".campdiv").remove();   }  );
				}
			});
		</script>
	</body>
</html>
