<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB  TODO: move this stuff to standard to be used by all pages*/ ?>
	</head>
	<body style='background: url("<?php echo get_background_path(); ?>") no-repeat center center fixed;'> 
                
                <script src="js/table.js"></script>    <!-- table_tree -->
				<script src="js/shops.js"></script>   <!-- used only refresh funcs -->
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_packs_div" class='mc_page_body mc_tt_cont ttc_fullscreen tc_single_table'> <!-- NOTE: without this cont appears another horiz scr bar -->
						<?php echo lang_html_load('html/table.html' ); ?>
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>

		<script type="text/javascript">

			var def_rec_id = <?php echo get_or_def($_GET,'id',0);?>;  // DEFREC
			// DD
			var def_camp_id = <?php echo get_or_def($_GET,'cid',0); ?>;
			var files_path = "<?php echo get_files_path(); ?>";

			var rec,drec; // RD
			function get_pack_state(rec){ return rec.find(".td-"+alias_name+"-order_state_lbs").html(); }
			function get_lbs_state(rec){return rec.find(".td-"+detail_alias_name+"-app_state").html();}
			function get_lbs_pack(lbs_rec){ return lbs_rec.closest(".ap_detail_row").data("id"); }
			// update pack and lbs state (after some event which caused state change)
			function update_pack_state(pack_list, lbs_list=$() ){
				// if whole pack is affected - all its lbs affected
				if( packs.get_active_rec().hasClass("selected") )
					lbs_list = lbs_list.add(".ap_detail_row .tr-app_lbs");
				// if some pack's lbs is  affected - the pack is affected
				lbs_list.each(function(){ pack_list = pack_list.add( packs.find_rec(get_lbs_pack($(this)) ));	} );
				// update
				lbs_list.each( function(){update_lbs_rec_state(  $(this) ); } );
				pack_list.each( function(){update_lbs_done(  $(this) ); } );
			}
			function update_lbs_rec_state(lbs_rec){
				var lbs = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_lbs_state", id: lbs_rec.data("id") }, 'POST').resp_text );
				lbs_rec.find(".td-app_lbs-app_state").html( lbs.app_state);
				lbs_rec.data("app_id", lbs.app_id);
				lbs_rec.data("app_state", lbs.app_state);
				set_lbs_action(lbs_rec);
			}

			function show_load_triple(){
				drec = $(this).closest(".data-row");
				var lbs_id = drec.data("id");
				var pack_id = get_detail_id();
				var client_code = packs.find_rec(pack_id).data("client_code");
				set_upload_path(client_code + "/packs/" + pack_id + "/" + lbs_id + "/"); // user_path
				$("#mi_fu_data").val( JSON.stringify( {client: "triple"} ) );  // set_fu_data
				var rec = packs.find_rec( drec.closest(".ap_detail_row").data("id") );
				show_select_string(function(){update_pack_state(rec, drec);}, '', $("#mi_load_image"), lp("load_triples"));
				$("#mc_fu_custom_content").html("");
				$("#mc_fu_custom_content").append(  "<div>"+drec.find(".td-app_lbs-name_mini").html()+"</div>"  );
				$("#mc_fu_custom_content").append(  drec.find(".td-app_lbs-path").html()  );
			}
			// HREN
			function show_load_hires(){
				drec = $(this).closest(".data-row");
				var lbs_id = drec.data("id");
				var pack_id = get_detail_id();
				var client_code = packs.find_rec(pack_id).data("client_code");
				set_upload_path(client_code + "/hires/" + get_detail_id() + "/"); // user_path; all hires in same folder = 'pack_id/'
				$("#mi_fu_data").val( JSON.stringify( {client: "hires", lbs_id: lbs_id} ) );  // set_fu_data; need assoc hr file name with lbs, so pass lbs id
				var rec = packs.find_rec( drec.closest(".ap_detail_row").data("id") );
				show_select_string(function(){update_pack_state(rec, drec);}, '', $("#mi_load_image"), lp("load_hires"));
				$("#mc_fu_custom_content").html("");
				$("#mc_fu_custom_content").append(  "<div>"+drec.find(".td-app_lbs-name_mini").html()+"</div>"  );
				$("#mc_fu_custom_content").append(  drec.find(".td-app_lbs-path").html()  );
			}
			function on_show(){
				$("#table-"+alias_name).find(".td-"+alias_name+"-RES_detail").html("<button class='btn btn-primary mc_detail_btn'><i class='fas fa-caret-right'></i></button>");
				$(".td-"+alias_name+"-RES_detail").click( function(){ 
					show_detail_click( $(this).closest(".data-row").data("id") );
				} );
				var table = $("#table-"+alias_name);
				// DEFREC
				if(def_rec_id){
					// rec has already been made active by DR1
					if(show_detail_click(def_rec_id))
						$("#mi_bcr").val("");
					def_rec_id = 0; // avoid set def rec on each show
				}
				if(!$("#table-"+alias_name).find(".data-row").length)
					alert(lp("no_pack_created"));
				//
				$("#table-"+alias_name).on("click", ".mc_send", function(){ show_send_pack( $(this).closest(".data-row").data("id") ); } );
				$("#table-"+alias_name).find(".tr-"+alias_name).each(function(){set_pack_actions($(this)); } );
				// print
			}

			// TODO: simila to lbs_set_size code
			function fit_img_div(div, img, dw, dh, i_rect){
				div.css("width", dw);
				div.css("height", dh);
				img.css("width", i_rect.w);
				img.css("height", i_rect.h);
				img.css("left",  - i_rect.dw);
				img.css("top",  - i_rect.dh);
			}

			var apap_r, apap_dr; function apap_cb(){ update_pack_state(apap_r, apap_dr); } // COF

			// now used to download whole pack (pdf or hires)
			function set_pack_actions(rec){
				var tds = rec.find(".td-"+alias_name+"-sent").html("");
				var pack_id = rec.data("id");
				var sent = rec.data("sent");
				if( ur_role.role=="PRINT" && !sent )
					tds.html( "<i class='fa fa-play mc_send' title='send'></i>" );
				if(sent)
					tds.html( "<i class='fas fa-check' title='sent'></i>" );
				// print
				rec.find(".td-"+alias_name+"-RES_print").html( $("<i title='"+lp("print_letter")+"' class='fas fa-print'></i>").click( function(){ window.open( "print_letter.php?pid=" + rec.data("id"), '_blank') } ) );
			}

				// DETAIL_ROW
			// action buttons and color
			function set_lbs_action(drec){
			// TODO: can use also flags uploaded/approvved along with state?
				var tda = drec.find(".td-"+detail_alias_name+"-RES_action").html("");
				var lbs_state = drec.data("app_state");
				var ws_link = "https://ic3.depedrini.com/download.php?c=" + drec.data("hr_name");
				tda.append("<a target='_blank' href='" + ws_link + "'><i title='"+lp("download_hires")+"' class='fas fa-download'></i></a>" );
				// color
				drec.find(".td-"+detail_table_name+"-app_state").css("background-color", pack_state_colors[lbs_state]);   // uses global arr of colors
				// print letter
				tda.append( $("<i title='"+lp("print_letter")+"' class='fas fa-print'></i>").click( function(){ window.open( "print_letter.php?id=" + drec.data("id"), '_blank') } ) );
			}

			var courier_codes = {1:"BRT",2:"UPS",3:"DHL",4:"SDA",5:"TNT",6:"NONE"};
			var bc_enter = "3141592651";
			var bc_clear = "3141592652";
			function check_selection(){
				// send btn; on sel rec handler (same stuff is done on mi_cbr handler
				if( $(".tr-app_lbs").length == $(".tr-app_lbs.selected").length )
					show_send_pack( get_detail_id() );
					//$(".tr-packs."+get_detail_id()).find('.td-packs-RES_send').html("<button class='btn'><i class='fas fa-paper-plane'></i></button>");
			}

			function show_detail(id, re){
				rec = re;
				var dd = $(".ap_detail_div");
				dd.html('<div class="tc_triples_form mc_tt_section mc_page_cont mc_clickable"><div class="tt_thumbs_section"> </div></div>'); // tt wrapper
				if(fields_det=="")
					fields_det = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: "app_lbs"}, 'POST').resp_text ); 
				apps = new Tablo(".tc_triples_form", null, detail_table_name, fields_det.list, null, on_lbs_rec_sel, null, detail_alias_name, check_selection);
				apps.ro_set("name", "asc");   // FIORD
				//apps.set_cond("camp_id="+rec.data("camp_id")+" AND shop_id="+rec.data("shop_id") + " AND img_id<>0" /*NOIMAGE*/);
				apps.set_cond("pack_id="+rec.data("id") + " AND img_id<>0" /*NOIMAGE*/);
				apps.show();
				apps.on_show = function(){
					var rc = $("#table-app_lbs").find(".td-app_lbs-path").length, rn=0; // RH - resize headers on last rec
					$("#table-app_lbs").find(".data-row").each( function(){
						var drec = $(this);
						//							TODO: to project utils
						// show image
						var tdp = drec.find(".td-app_lbs-path");
						var div = $('<div class="mc_triple_div"></div>');
						var img = new Image();
						//img.src = files_path + tdp.html() + drec.data("name_mini"); // TODO: use here get_file_thumb_path
						img.src = "table_tree/thumbs/" + drec.data("thumb_small"); // TODO: use here get_file_thumb_path
						img.classList.add("mc_triple_img");
						img.onload = function(){
							var H = 70; // all imgs of same height
							var lbs_w = drec.data("r")-drec.data("l")+1, lbs_h = drec.data("b")-drec.data("t")+1; // to find div proportion
							var div_h = H, div_w = H*lbs_w/lbs_h;
							var rect = fit_rect2( img.width, img.height, div_w, div_h); 
							fit_img_div(div, $(img), div_w, div_h, rect);
							if(++rn==rc) 
								fh_init_table( drec.closest(".tc_triples_form") );
						}
						tdp.html("").append(div);
						div.append(img);
						set_lbs_action(drec);
						dd.find("table.fh-header").css("top", "20px"); // DEF DET_IMG_OUT - img in detail table stuck out (up); donno now reason; use this quickfix TODO
					});
				}
				$(".ap_detail_div").on("mouseup", ".mc_triple_img", function(){ 
					var row = $(this).closest(".tr-"+detail_table_name);
					var size = "<label>"+lp("Size")+": </label>"+row.data("lbs_width")+"x"+row.data("lbs_height");
					var tsize = "<label>"+lp("Trim_size")+": </label>"+row.data("twidth")+"x"+row.data("theight");
					show_preview( $(this).closest(".tr-app_lbs").data("img_id"), "<div><div>"+size+"</div><div>"+tsize+"</div></div>" ); 
				} ); // PREVIEW
				scroll_to_view(dd[0]);
			}

			// DEF SETCAMP - stuff to set camp id and re-filter records of main table; called from project.js -> show_sel_camp
			function set_camp(id){
				var cond = ["(camp_id="+id+")"];
				// UR
				if(ur_role.shops.length)
					cond.push( "shop_id in (" + ur_role.shops.join(",") + ")" );
				// LOCAL_VISUAL sees all packs  (if at all needs to see them; LV works with shops)
				// GRAPHIC also sees from first stage
				// if(ur_role.role=="GRAPHIC") cond += " and uploaded=1";   fab detto graph must se all; besides if one lbs rejected - pack is in 'created' and not visib for graph DEF GSA
				// printers see only packs to print; TODO: not a proper place to set this cond
				if(ur_role.role=="PRINT")
					cond.push("approved=1");
				if(stat_cond) cond.push(stat_cond); // STAT
				packs.set_cond( cond.filter(Boolean).join(" AND ") );
				packs.clear();
				packs.show(0, def_rec_id);  // DR1 DEFREC
			} 

			function on_rec_sel(rec){ 
				puh("record_selected");
				if(get_pack_state(rec)=="complete") 
					puh("pack_complete");
			}
			function on_lbs_rec_sel(rec){ 
				var os = get_lbs_state(rec);
				//if(os=="draft") puh("lbs_draft");
				puh("lbs_" + os);
			}
			// sends update req to server and updates affected records
			function set_state(action, sel_ords=$(), sel_apps=$() ){
				// action
				call_php_sync("contr/main.php", {"action" : action, ids_ords: JSON.stringify(get_data_arr(sel_ords, "id")), ids: JSON.stringify(get_data_arr(sel_apps, "id")) }, 'POST'); 
				// update
				update_pack_state( sel_ords, sel_apps ); // DEF ONEDET - stuff which works only when one opened detail is possible;
			}
			function get_selection(){ 
				var sel = {packs: packs.get_selection(), apps: apps? apps.get_selection() : $()};
				if(!sel.packs.length && !sel.apps.length)
					sel = {packs: packs.get_active_rec(), apps: apps? apps.get_active_rec() : $()}; // with SINGLE_ACTIVE only one of them is not empty
				return sel;
			}
			function show_send_pack(id=0){
				var no = $(call_php_sync("contr/main.php", {"action" : "show_send_pack", "id" : id}, 'POST').resp_text); 
				show_select_string(function(){ return send_pack(id, no); }, '', no, lp("send_package"));
				ff_init(no);
				// relate courier code ~ name
				$("#np_courier_code").focus();
				$("#np_courier_code").on("input", function(e){
					var txt = $(this).val();
					if(txt.length==10){
						var bc = /(\d)0+(\d+)/.exec(txt); // type 000 id
						if(bc==null) return;
						var type = bc[1], id = bc[2];
						if(type=="5"){ // a courier code 
							if(id in courier_codes){
								$("#np_courier").val(courier_codes[id] ).trigger("change");
								//$("#np_courier").select2("val", courier_codes[id] );
								//$("#np_courier").select2('data', { id:"DHL", text: "DHL"});
								$("#np_pack_code").focus();
							}
						}
					}
				});
				$("#np_courier").on("change", function(){
					for(c in courier_codes)
						if(courier_codes[c]==$("#np_courier").val()){
							$("#np_courier_code").val("500000000" + c);
							$("#np_pack_code").focus();
						}
				});
				// input "enter" from barcode reader
				$("#np_pack_code").on("input", function(e){
					var text = $("#np_pack_code").val();
					if(text.endsWith(bc_enter)){
						$("#np_pack_code").val( text.substr(0, text.length-10) );
						send_pack(id, no);
					}
				});
			}
			function send_pack(id, panel){
				var fields = ff_params(panel, true);
				delete fields.courier_code;
				wait_screen.add_operation("sending");
				cc("send_pack", function(){
					wait_screen.remove_operation("sending");
					packs.refresh();
					$("#md_ss_div").addClass("hidden"); // for the case if sent not on ok click but from code
					alert(lp("package_sent"));
				}, {id: id, fields: JSON.stringify(fields)}, function(){  wait_screen.remove_operation("sending"); } );
			}
			// DEF SETCAMP - stuff to set camp id and re-filter records of main table; called from project.js -> show_sel_camp
			function set_camp(id){
				packs.set_cond( "(camp_id="+id+")");
				packs.refresh(); 
			} 
			function unset_camp(){
				packs.set_cond("");
				packs.refresh(); 
			} 
			
			var packs, apps = null;
			var client_id = <?php echo db\select_field("users", "client_id", "id=".get_curr_user_id()); ?>;
			var alias_name = "packs", table_name = "v_packs";
			var detail_alias_name = "app_lbs", detail_table_name = "app_lbs";
			var fields_det="";
			var client_code = '<?php echo get_client_code(); ?>';
			var pack_state_colors = {"sent" : "c5d9ed", "accepted" : "i4f94d4", "uploaded" : "f5e6ab", "approved" : "b8e6bf", "rejected" : "ff8085", "hires" : "00a32a", "packed" : "005c12", "complete" : "005c12"};
			var user_email = '<?php echo get_user_info("email"); ?>'; // IC_ST

			$(document).ready( function(){
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				//
				var fields = JSON.parse( call_php_sync("contr/main.php", {"action" : "get_table_fields", alias: alias_name, table: table_name}, 'POST').resp_text ); 
				packs = new Tablo(".tt_thumbs_form", $(".mc_search_panel"), table_name, fields.list, fields.search, null, function(rec){show_send_pack(rec.data("id"));}, alias_name);
				packs.ro_set("date_create", "desc");   // FIORD
				packs.on_show = on_show;
				packs.show();
				//
				var clients = call_php_sync("contr/main.php", {"action" : "get_clients_cb"}, 'POST').resp_text; 
				$(".mc_table_control").append(clients);
				$("#mi_client").on("change", function(){  
					packs.set_cond("client_id="+$("#mi_client").val() ); 
					packs.refresh();
				});
				// DEF BCR BarCode Reader
				$(".tt_thumbs_form").prepend("<div class='mc_bcr_div'><input type='text' id='mi_bcr'></input></div>");
				$("#mi_bcr").on("input", function(e){
					//var txt = $(this).val() + e.key;
					var txt = $(this).val();
					if(txt.length==10){
						var bc = /(\d)0+(\d+)/.exec(txt); // type 000 id
						if(bc==null) return;
						var type = bc[1], id = bc[2];
						if(type=="1"){ // a pack
							// can't call it directly, rec may be on another page; show_detail_click(id);
							packs.clear();
							packs.show(0, def_rec_id=id);  // DR1 DEFREC; def_rec_id will be used in show_detail_click
						}
						if(type=="2"){ // a lbs 
							if( $(".tr-app_lbs[data-id='" + id + "']").length ){
								$(".tr-app_lbs[data-id='" + id + "']").addClass("selected");
								$("#mi_bcr").val("");
								check_selection(); // send btn
							}else
								alert(lp("record_not_found"));
						}
					}
				});
				$("#mi_bcr").focus();
			});
		</script>
	</body>
</html>
