<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."model/pdf.php");

	// returns string like  nn000iddd num + 000 + id filled with 0s up to len
	// codes: 1 - order, 2 - lbs
	function gen_bc($id, $num, $len=10){ 
		$bcid = $num.str_repeat("0", $len - strlen($id) - strlen($num)).$id; 
		$bcp = proj_path."tmp/$bcid.jpg"; // TODO exec_cmd not returns output but exit code
		if(!file_exists($bcp))
			exec_cmd("bc", $bcid, $bcp); // create barcode img in tmp dir
		return $bcp;
	}

	function prepare_print_pack($pdf, $pack_id){
		// PACK
		$pack = db\select_record("v_packs", "client_name, date_create, delivery_address, courier, notes", "id=$pack_id");
		$lbs = db\select_to_array("app_lbs", "id, name, thumb_small", "pack_id=$pack_id");
		foreach($lbs as &$lb){
			$lb["bc"] = gen_bc($lb["id"], "2");
			$lb["img"] = proj_path."table_tree/thumbs/".$lb["thumb_small"];
		}
		print_pack($pdf, $pack, gen_bc($pack_id, "1"), $lbs);
		// PRINT LETTERINI
		$lbs = db\select_to_array("app_lbs", "*", "pack_id=$pack_id");
		foreach($lbs as $lb){
			prepare_print_letter($pdf, $lb);
		}
	}

	function prepare_print_letter($pdf, $lb){
		$lbs_id = $lb["id"]; unset($lb["id"]);
		$order_id = $lb["order_id"];
		$order = db\select_record("v_orders", "client_id, location, country, area, camp_name, camp_id", "id=$order_id");
		$client = db\select_field("clients", "name", "id=".$order["client_id"]);
		$lb["client"] = $client;
		$header = $order["area"].", ".$order["camp_name"]; // TODO: commessa
		$season = db\select_field("camps", "season", "id=".$order["camp_id"]);
		$camp_id = $order["camp_id"];
		$code = "$camp_id-$season";
		$lb["trim_size"] = $lb["twidth"]."x".$lb["theight"];
		$lb["visible_size"] = ($lb["r"]-$lb["l"]+1)."x".($lb["b"]-$lb["t"]+1);
		$lb["order_no"] = $lb["name_triple"];
		$lb = array_merge($lb, $order);
		print_letter($pdf, $header, $code, $lbs_id, arr_filter_keys($lb,["client", "name","order_no", "camp_name", "need_logo", "need_tag", "location", "country", "trim_size", "visible_size", "notes"]), gen_bc($lbs_id, "2"));
	}
		
	//
	$pdf = new PDF();
	if(isset($_GET["pid"]))
		prepare_print_pack( $pdf, $_GET["pid"] );
	if(isset($_GET["id"])){
		prepare_print_letter( $pdf, db\select_record("app_lbs", "*", "id=".$_GET["id"]) );
	}
	if(isset($_GET["codes"])){
		$codes = [];
		$codes[]= ["name" => "BRT", "bc" => gen_bc(1,5)];
		$codes[]= ["name" => "UPS", "bc" => gen_bc(2,5)];
		$codes[]= ["name" => "DHL", "bc" => gen_bc(3,5)];
		$codes[]= ["name" => "SDA", "bc" => gen_bc(4,5)];
		$codes[]= ["name" => "TNT", "bc" => gen_bc(5,5)];
		$codes[]= ["name" => "NONE","bc" => gen_bc(6,5)];
		$codes[]= ["name" => "ENTER", "bc" => gen_bc("141592651",3)];
		print_codes($pdf, $codes);
	}
	$pdf->Output();
?>

