<?php
	/*
		Author: Alex Nosurov
		Created: 1.09.23 
		DEF LBS_CONF - configurate lbs
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");

?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<style type="text/css">
			/* in apap md ss gets under canvas */
			#md_ss_div{
				z-index: 10000;
			}
			.BGD{
				position: absolute;
				left: 100px;
				right: 100px;
			}
			.BGI{
				opacity: 50%;
			}
			.FGD{  
				overflow: hidden;
				background-color: red;
			}
			.FGI{  
				position: absolute;
			}
			.SCENE{  
				width: 100%;
				height: 100%;
				z-index: 100;
				opacity: 0%;
			}
			body{overflow: hidden;}
		</style>
	</head>
	<body> 
	
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<!-- MAIN -->
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class='BGD'></div>
				<div class='FGD mc_center'></div>
				<div class='SCENE'></div>
			</div>
			<div class="mc_page_head" style='display: flex; justify-content: center; padding: 10px;'>
				<button class='mc_lbi_save' style='z-index: 3000;'>save</button>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

	
		<script type="text/javascript">
			var ap_id = <?php echo $_GET["id"]; ?>;
			//var owner = <?php echo "'".db\select_field("approves","owner","id=".$_GET["id"])."'"; ?>;
			//var user  = <?php echo "'".get_user_info("email")."'"; ?>;
			// approve/reject available until whole order approved
		
			var apap;
			var lbs_name;
			var img_info;
			
			//moving
			var mouseDown = false;
			var x0, y0;
			var ix0, iy0;
			var mode = "move";
			var w0, h0;
			var lbd_w, lbd_h;
			var fgX, fgY, bgX, bgY, fgW, fgH;

			function positionImg(x,y){
				$(".BGD").css("left", bgX=x);
				$(".BGD").css("top", bgY=y);
				//
				$(".FGI").css("left", fgX = x-$(".FGD").position().left); // = xx;  x = xx + -$(".FGD").position().left+5
				$(".FGI").css("top", fgY = y-$(".FGD").position().top);
			}
			function positionImg1(x,y){
				$(".FGI").css("left", fgX = x);
				$(".FGI").css("top", fgY = y);
				//
				$(".BGD").css("left", bgX = x+$(".FGD").position().left);
				$(".BGD").css("top", bgY = y+$(".FGD").position().top);
			}
			function scaleImg(newW, newH){
				$(".FGI").css("width", newW);
				// var k = w0/newW;
				newH = h0*newW/w0;
				$(".FGI").css("height", newH);
				$(".BGI").css("width", fgW = newW);
				$(".BGI").css("height", fgH = newH);
			}

			function onscroll(e){
				// mouse pos in bgi, in %
				var mx = e.clientX, my = e.clientY; // NOTE: should have used offsetX, but while bgX is incorrect (includes menu height) use clientX
				var xr = (mx - bgX)/fgW;
				var yr = (my - bgY)/fgH;
				//
				var dz = -(e.originalEvent.deltaY/20); // delta size logical; has range about 1 .. 5
				var newW = (100 + dz)/100*fgW;
				var newH = (100 + dz)/100*fgH;
				scaleImg(newW, newH);
				// correct pos to have same mouse pos
				positionImg( mx - fgW*xr, my - fgH*yr );
			}

			function init_size(){
				w0 = $(".BGI").width(); //img_info.width;
				h0 = $(".BGI").height(); //img_info.height;

				// FG (the LB-window); need position it so that it has optimal size relatively to the main window size
				var k = Math.max( img_info.lbs_width/$(".SCENE").width(), img_info.lbs_height/$(".SCENE").height())*2;
				lbd_w = img_info.lbs_width/k, lbd_h = img_info.lbs_height/k;
				$(".FGD").css("width", lbd_w);
				$(".FGD").css("height", lbd_h);
				$(".FGD").append("<img src='" + img_info.url + "' class= 'FGI'></img>");

				// initial img layout 
				if(parseFloat(img_info.lbi_scale)){ // check if img layout has already been defined (and saved in db)
					// if saved - used it to init the img layout
					scaleImg(lbd_h*img_info.lbi_scale*w0/h0, lbd_h*img_info.lbi_scale); // scale is in % relatively to LB size
					positionImg1( lbd_w*img_info.lbi_left, lbd_h*img_info.lbi_top);
				}else{
					// if not - set the default layout (minimal size which covers whole LB)
					if( w0/lbd_w > h0/lbd_h ){ // wide image
						var lbsW = w0 * lbd_h / h0; // 
						scaleImg(lbsW, lbd_h);
						positionImg1( -(lbsW-lbd_w)/2, 0 );
					}else{
						var lbsH = h0 * lbd_w / w0;
						scaleImg(lbd_w, lbsH);
						positionImg1( 0, -(lbsH-lbd_h)/2 );
					}
				}
			}

			$(document).ready( function(){
				// pen width selector
				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty
				/*
				var ap_menu = create_popup_div("ap_image_menu");
				init_popup(ap_menu, "ap_image");
				add_popup_item( ap_menu, "create pin", pin_create);
				*/
				img_info = call_php_sync("contr/main.php", {action: "lbs_conf_img", id: ap_id});
				img_info = JSON.parse(img_info.resp_text);
				var img = new Image();
				img.classList.add("BGI");
				img.src = img_info.url
				img.onload = init_size;
				//$(".BGD").append("<img src='" + img_info.url + "' class= 'BGI'></img>");
				$(".BGD").append(img);

				$(".SCENE").on("mousedown", function(e){
					mouseDown = true;
					e = e.originalEvent;
					x0 = e.clientX; y0 = e.clientY;
					ix0 = $(".BGD").position().left;
					iy0 = $(".BGD").position().top;
				});
				$(".SCENE").on("mousemove", function(e){
					if(mouseDown){
						var xc = e.clientX, yc = e.clientY;
						e = e.originalEvent;
						var dx = xc-x0, dy = yc-y0;
						if(Math.abs(dx)<5 && Math.abs(dy)<5) return;
						if(mode=="move"){
							positionImg(ix0+dx, iy0+dy);
						// resize
						}else{
							var newW = $(".FGI").width() + dx;
							var newH = $(".FGI").height() + dy;
							if(e.ctrlKey)
								newW = newW + 0;
							x0 = xc; y0=yc;
							//console.log(x0 + " " + y0 + " " + xc + " " + yc + " " + $(".FGI").width() + " " + $(".FGI").height() + " " + dx  + " " + dy);
							scaleImg(newW, newH);
						}
					// check if entered resize area
					}else{
						var ir = $(".BGD").position().left + $(".FGI").width();
						var ib = $(".BGD").position().top + $(".FGI").height();
						e = e.originalEvent;
						var x = e.clientX; y = e.clientY;
						if( Math.abs(ir-x)<20 && Math.abs(ib-y)<20 ){
							$(".SCENE").css("cursor", "move");
							mode = "resize";
						}else{
							$(".SCENE").css("cursor", "default");
							mode = "move";
						}
					}
				});
				$(".SCENE").on("mouseup", function(e){
					mouseDown = false;
				});

				// save
				// db: lbi_left - img pos in % of 
				$(".mc_lbi_save").click(function(){
					var scale = parseInt($(".FGI").css("height"))/lbd_h; // scale determined by height relation
					var left = $(".FGI").position().left/lbd_w;
					var top = $(".FGI").position().top/lbd_h;
					call_php_sync("contr/main.php", {action: "lbi_save", id: ap_id, left: left, top: top, scale: scale});
					if (typeof window.opener!== "undefined")
						window.opener.update_detail_ozon();
					window.close();
				})

				$(".SCENE").on("wheel", onscroll); // done for each image load to: enable scroll as soonest, enable for all scales.


				window.onkeydown = function(e){
					e = e || window.event;
					var code = e.keyCode;
					var fe = document.activeElement;
					if( !(fe && $(fe).hasClass("ap_pin_txt")) && code==46)
						apap.delete_selection();
				};
				//
			});
		</script>
	</body>
