<?php
	/*
		Author: Alex Nosurov
		Created: 13.01.20 
	*/
	
	require_once(dirname(__FILE__)."/path.php");
	require_once(proj_path."view/lang.php");
	require_once(proj_path."view/metadata.php");
	require_once(proj_path."contr/login.php");
	require_once(proj_path."utils/menu.php");
	require_once(proj_path."utils/view.php");


?>
<html lang="en">
	<head>
		<?php echo lang_html_load('html/standard_head.html', false, array("title" => project_title, "icon" => project_icon)); ?>
		<link href = 	"table_tree/css/style.css" rel="stylesheet">
		<link href = 	"table_tree/css/search.css" rel="stylesheet">
		<link href = 	"css/apap.css" rel="stylesheet">
		<link href = 	"css/table.css" rel="stylesheet">
		<?php echo lang_html_load('fu/index_head.html'); /* LOADSUB */ ?>
	</head>
	<body style='background: url("<?php echo get_background_path(); ?>") no-repeat center center fixed;'> 
		<!-- table_tree -->
		<script src="table_tree/js/table_tree.js"></script>
		<script src="js/table.js"></script>
		<script src="js/sd.js"></script>
		<script src="js/shops.js"></script>
	
		<div class='bg_cover'></div>
		<?php echo file_get_contents('html/standard_scripts.html'); ?>
		<div class="mc_page_cont" style="height: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
			<!-- header: row: logo, menu, login  -->
			<div class="mc_page_head">
				<?php echo lang_html_load('html/standard_body_start.html' ); ?>
			</div>
			<div class="mc_page_body mc_page_cont_hor" style="width: 100%;">  <!-- if put height to mc_page_cont - preview shown male -->
				<div class="mc_page_head mc_menu" id="mi_main_menu_vert"></div>
				<div class="mc_page_body mc_page_cont">
					<div id="tt_table_tree_div" class='mc_page_body mc_tt_cont ttc_fullscreen'> <!-- NOTE: without this cont appears another horiz scr bar -->
					</div>
				</div>
				<div class='lb_img_list_cont hidden mc_page_head mc_page_cont'>
					<div class='mc_page_head mc_mwd'>
						<?php echo render_radio_group( array( array("text" => "man", "value" => "man"), array("text" => "woman", "value" => "woman")  ), "man_woman"); ?>
					</div>  <!-- man/woman -->
					<div class='mc_page_head mc_nid'></div>  <!-- NOIMAGE -->
					<div class='lb_img_list_div mc_page_body'>
						<div style='width:100px!important;'></div> <!-- TINY_IMG this stuff used as quick fix: sometimes img div has w=15 -->
					</div>
				</div>
			</div>
			<div class="mc_page_head mc_puh_div mc_page_cont_hor hidden"><div class='mc_puh_msg mc_page_body'></div><i class='mc_puh_close fas fa-times'></i></div>  <!-- DEF PUH Pop Up Help: shown as user does sms; depends on curr user action -->
		</div>

		<div id = 'kladovka' class='hidden'> <!-- just a div to hide stuff which is shown only temporarily; seems not nec, while add hidden instead -->
			<!-- DEF NEWLB newi/edit lightbox -->
			<?php echo lang_html_load('html/lb.html',0,["mu" => measure_unit]); ?> <!-- LOADSUB -->
			<!-- LB_RESIZE -->
			<div class='lb_resize_div hidden'></div>
			<div class='lb_resize_rect hidden'></div> 
			<div id = "mi_load_image">  <?php echo lang_html_load('fu/index_html.html'); ?> </div> <!-- LOADSUB -->
			<div id='mi_dima' class='hidden' style='position:absolute;'></div> <!-- DIMA -->
		</div>

		<?php echo lang_html_load('fu/index_script.html'); /* LOADSUB */ ?>
		<?php echo lang_html_load('html/sd.html' ); ?>

		<script type="text/javascript">

			var def_rec_id = <?php echo get_or_def($_GET,'id',0); ?>; // DEFREC
			var stat_cond = "<?php $sc = get_or_def($_GET,'filter',""); global $stat_conds; if($sc) echo $stat_conds[$sc]; ?>"; // STAT

			var table_name="locations", alias_name="locations";
			
			// -------------------------------------------------------------------------------
			// --------------------------------- SHOPS ---------------------------------------
			// -------------------------------------------------------------------------------

			// DEF MD_LOCS custom fields for locations
			// if new - parent_path is set; if edit - id is set;
			function show_edit_shop(id=0, parent_path=''){
				/* allow create shopless order if(!id && !shop_id){alert(lp("shop_not_selected"));return;} */
				var user_path = parent_path? parent_path.substring( tt.get_root_dir().length ) : "";
				var name = id? tt.find_rec(id).data("name") : "";
				var ns = $(call_php_sync("contr/main.php", {"action" : "show_edit_shop", "id" : id, tt_project: "locations"}, 'POST').resp_text); 
				// TODO: check if custom fields exist; if not - needn't show the form
				show_select_string(function(){ return save_shop(id, parent_path); }, '', ns, id? lp("edit_location") + " '" + name + "'" : lp("create_location_of") + " '" + user_path + "'" );
				ff_init(ns);
			}
			function save_shop(id, path){
				var panel = $("#md_ss_div");
				var fields = ff_params(panel, true);
				if(!id)
					fields["path"] = path;
				cc("save_shop", function(){
					tt.rd_run();
				}, {id: id, fields: JSON.stringify(fields)} );
			}
			// NEXT define in contr: show_edit_shop, save_shop, menu items
			


			// DEF SHOPER_VIEW: personal view; for each camp is used its own view v_shop_camp_<id>; thus need re-init tablo on camp change
			function shop_on_enter(id){
				//if(ur_role.is_admin) 
					show_edit_shop(id);
				//else show_detail_click(id);
			}
			function show_create_dialog(parent_elem, action){
				var parent_path = parent_elem && parent_elem.length? tt.get_data(parent_elem, "path") : tt.get_root_dir();
				var user_path = parent_path.substring( tt.get_root_dir().length );
				show_select_string(
					function(new_name){ $.ajax({
						"type": "POST",
						"url": "contr/main.php",
						"data": {"action": action, "path": parent_path, "name": new_name},
						"success": function(res){tt.rd_run();}
					})  }
					, "NEW", null, user_path? "Create child folder of '" + user_path + "'": "Create top folder");
			}
			function delete_path(elem){
				var path = tt.get_data(elem, "path");
				if(confirm("delete path '" + tt.unroot(path) + "'?"))
				var shops = call_php_sync("contr/main.php", {"action" : "get_path_locations", path: JSON.stringify(path) }, 'POST').resp_text;
				shops = JSON.parse(shops);
				if(shops.length){
					var sls=''; for(var i=0;i<shops.length;i++) sls+=tt.unroot(shops[i])+"\n"; // var sls = shops.join("\n");
					if(!confirm("Following locations will be deleted:\n" + sls + "\nContinue?"))
						return;
				}
				cc("delete_path", function(){
					tt.rd_run();
				}, {path: JSON.stringify(path)} );
			}
			function init_shop_table(visual, admin){
				var root_dir = client_code + "/locations/";
				sd = new SD( function (path, cb){
					wait_screen.add_operation("open_dir");
					$.ajax(tt.acid("open_show_folder", {
						data: {'path': path}, 
						success: cb,
						complete: function(){ wait_screen.remove_operation("open_dir") }
					}));
				}, root_dir);
				//
				tt = new table_tree(table_name, '#tt_table_tree_div', table_name, "details"); // init tree table NOTE: set table before (used by def_search_fields) 
				tt.set_show_details(shop_on_enter); 
				tt.set_on_select(on_rec_sel);
				tt.ro_set({field: "name", order: "asc"});   // FIORD
				tt.set_on_show_plain(on_show);
				tt.set_use_paths(1);
				tt.set_root_dir(root_dir);
				tt.open_root_dir();				
				//
				tt.add_popup_item(lp('delete_selected'), function(){tt.selection_action("delete_locations")}, true, true, true);
				tt.add_popup_item(lp('rename'), show_rename_dialog, true, true); // RENAME
				tt.add_popup_item(lpp('$move$ $selected$ $files$'), function(){ sd.select_folder( function(dir){ tt.move_files(dir)  } , tt.get_root_dir()  )   } , true, true, true);
				tt.add_popup_item(lpp('$move$ $folder$'), function(){ 
					var path_old = tt.get_data($(tt.get_target_dir()), "path"); 
					sd.select_folder( function(dir){ tt.move_folder(path_old, dir)  } , tt.get_root_dir()  )   
				} , false, true, false);
				tt.add_popup_item(lpp('$create$ $child$ $folder$'), function(elem){show_create_dialog(elem, "create_path")}, true, true, false); // create location 
				tt.add_popup_item(lpp('$create$ $top$ $folder$'), function(){show_create_dialog(null, "create_path")}, false, false, true); // create location 
				tt.add_popup_item(lpp('$create$ $location$'), function(elem){show_edit_shop(0, tt.get_data(elem, "path"))}, false, true); // create shop
				tt.add_popup_item(lpp('$delete$ $folder$'), delete_path, false, true); // create shop
				//
				if(admin || ur_role.role=="IMAGE"){ // else - on set camp (and set camp table)
					$(".lbsp_crud").removeClass("hidden");
					$(".lbsp_del, .lbsp_edit").removeClass("hidden");
				}
				if(visual){
					$(".mc_table_control").append( $('<button type="button" class="lbsp_make_order btn btn-primary btn-sm disabled"> <i class="fa fa-play mc_page_head" title="create order"></i></button>') );
					$(".lbsp_make_order").click( order_create_click );
				}
				// CRUD
				$(".lbsp_new").addClass("hidden");
				$(".lbsp_edit").click( 	function(){
					var rec = $(".tt_thumbs_form").find(".data-row.active");
					if(rec.length==1){
						show_edit_shop( rec.data("id") );
					}else if(rec.length==0){
						alert("select a record");
					}else{
						alert("only one record must be selected");
					}
				});
				$(".lbsp_del").click( 
					function(){
						var rec = $(".tt_thumbs_form").find(".data-row.active");
						if(rec.length==1){
							if(!check_order(rec.data("id")))return; // DOO
							shop_delete( rec.data("id"), rec.find(".td-" + alias_name + "-name").html() );
						}
				});
			}
			function set_shop_autocomplete(){
				var locations = JSON.parse( call_php_sync("contr/main.php", {"action" : "locations"}, 'POST').resp_text );
				$("#ns_area").parent().addClass("autocomplete"); autocomplete($("#ns_area")[0], locations.area);
				$("#ns_country").parent().addClass("autocomplete"); autocomplete($("#ns_country")[0], locations.country);
				$("#ns_city").parent().addClass("autocomplete"); autocomplete($("#ns_city")[0], locations.city);
				$("#ns_area").attr("autocomplete", "off");
				$("#ns_country").attr("autocomplete", "off");
				$("#ns_city").attr("autocomplete", "off");
			}
			function shop_create_dialog(){
				var ns = call_php_sync("contr/main.php", {"action" : "shop_edit_dialog"}, 'POST'); 
				var ef = $(ns.resp_text);
				show_select_string(function(){ return shop_save(0); }, '', ef, lp("create_store"));
				ff_init(ef);
				set_shop_autocomplete();
			}
			function shop_edit_dialog(id){
				var ns = call_php_sync("contr/main.php", {"action" : "shop_edit_dialog", "id" : id}, 'POST'); 
				var ef = $(ns.resp_text);
				ff_init(ef);
				show_select_string(function(){ return shop_save(id); }, '', ef, lp("edit_store"));
				set_shop_autocomplete();
			}
			function on_rec_sel(rec){
				if( detail_shown() && get_detail_id()==rec.data("id") ) return; // avoid situ when user clicks det btn and detail msg overwritten with this msg
				show_img_usage( rec.data("id") );  // IMG_LIST IMG_USAGE
				puh("record_selected");
				set_rec_puh(rec);
			}
			function set_rec_puh(rec){
				if(ur_role.is_visual){
					var nd = need_do_order(rec);
					$(".lbsp_make_order").prop("disabled", !nd);
					if(nd) puh("need_create_order");
					if(order_done(rec)) puh("order_complete");
				}
			}
			// TODO: not used; use if need edit some shop fields (not only name)
			function shop_save(id){
				var panel = $("#md_ss_div");
				var fields = ff_params(panel, true);
				if(!fields.visual_id) fields.visual_id = "0"; if(!fields.production_id) fields.production_id = "0"; // TODO: normally ff_params not passes null values; added include_empty param to do it; still need a way to provide valid def (empty) val for a field (here need 0 instead of null)
				var res = true;
				$.ajax({
					"type": "POST",
					"async": false,
					"url": "contr/main.php",
					"data": {action : "shop_save", id: id, fields: JSON.stringify(fields)},
					"success": function(res, dummy, request){
						shops.clear();
						shops.show(0, res);
					},
					"error": function(jqxhr, settings, thrownError){
						//alert(lpp(thrownError));
						res = false; // using async=false and ret res false to not close the dialog
					}
				});
				return res;
			}
			function shop_delete(id, name){
				if(!confirm(lpp("$Delete$ $store$ '$1'?", name))) return;
				$.ajax({
					"type": "POST",
					"url": "contr/main.php",
					"data": {action : "shop_delete", id: id},
					"success": function(res, dummy, request){
						tt.rd_run();
					}
				});
			}

			function on_show(){
				$("#table-"+alias_name).find(".td-"+alias_name+"-RES_detail").html("<i class='mc_detail_btn far fa-window-maximize'></i>");
				$(".td-"+alias_name+"-RES_detail").click( function(){ show_detail_click( $(this).closest(".data-row").data("id"), shops, show_shop_lb); } );
				var table = $("#table-"+alias_name);
				// DEFREC
				if(def_rec_id){
					// rec has already been made active by DR1
					show_detail_click(def_rec_id, shops, show_shop_lb);
					def_rec_id = 0; // avoid set def rec on each show
				}
				// TODO 1: create order from here
			}

			// -------------------------------------------------------------------------------
			// -----------------------------------  INIT -------------------------------------
			// -------------------------------------------------------------------------------
			var sd; // select dir
			var tt; // this name is used in space.js
			var client_code = '<?php echo get_client_code(); ?>';

			$(document).ready( function(){
				// TODO: ur_role is set in onload in archive.js, is it secured that called before this?
				ur_role.is_visual = ur_role.role=="IMAGE"; // UR in prev syst there are 2 diff roles va & lv which are in fact the same;
				ur_role.is_admin = ur_role.role=="ADMIN";  // who has right to edit shops

				set_ajax_error_handler(); // def err handler for ajax   ; 24.12.19 pass empty  because DEF FIND_ERR_MSG shows alert when find res empty

				//-------------------  SHOP _---------------------
				init_shop_table(ur_role.is_visual, ur_role.is_admin);
				on_hide_detail = function(){hide_img_list(); puh_close();}

				// TODO: add clear wait_screen on ajax done

				if( ur_role.is_visual || ur_role.is_admin)
					shops_lb_init("shops");
				// tutto maiuscolo
				$("#md_ss_content_input").on("input", function(){ $(this).val( $(this).val().toUpperCase() ) }); // input on change
			});
		</script>
	</body>
</html>
