<?php
	ob_start();
	$_PD = dirname(__FILE__)."/..";   // %s/dirname(__FILE__)\."\/\.\./"$_PD/gc
	require_once("$_PD/path.php");
	require_once(proj_path."utils/utils.php");
	require_once(proj_path."utils/filter_fields.php");
	//SHARE put it after all includes
	$project_name = get_or_def($_POST, "project", "");
	log\debug($_POST);
	log\debug("PPPP", "$_PD/share/$project_name.php");
	if( file_exists("$_PD/share/$project_name.php") )
		include("$_PD/share/$project_name.php");
	//include(table_tree_path."share/client.php");
	//
	require_once("$_PD/model/db.php");
	require_once("$_PD/view/show_dir.php"); // show_dir (opened dir)
	require_once("$_PD/view/show_thumbs.php");
	require_once("$_PD/view/metadata.php"); 
	require_once("$_PD/model/shm.php");
	require_once("$_PD/view/preview.php");
	require_once(proj_path."model/block.php"); // to use check_flag()
	require_once(proj_path."model/db.php"); // EI SEFIR get_curr_user_id
	require_once(table_tree_path."model/zip.php"); // tt_create_files_zip cdr1
	require_once(proj_path."model/errors.php"); // register_error
	require_once(proj_path."view/lang.php"); // EI LANG
	require_once(proj_path."view/fields.php"); // EI LANG
	ob_clean();

	define('paths_trivial', 1);


	// TODO: SEFIR (show only user files); need realize it for all request types)


	function mse($var){ return must_be_set($_POST, $var); }
	function gde($var, $def=''){ return get_or_def($_POST, $var, $def); }
	function ise($name){ return isset($_POST[$name]); }

	if(session_id() == '')
		session_start();

	log\set_log_file(log_path."contr.log");

$action = mse('action');
global $table_tree;
global $table_files;
$table_tree = gde('table', 'table_tree');
$throw_on_empty = false;

// USD     DEF MUSD Multiple USD ; in SPACE may happen that a user views another user's files (space); thus js sends which usd is requested; php needs to check if the requested usd is allowed
$user_id = get_curr_user_id();
if(!$user_id) // LOGONEXP
	throw new user_exception('no_user'); // not translated, just error_code

$user_dir = gde("user_dir", get_def_user_dir($user_id));
if( !user_dir_allowed($user_id, $user_dir) )
	throw new user_exception('$dir_access_denied$', "access denied for user '$user_id' to directory '$user_dir'");

$cond = gde('cond');  // this is tt.table_where; TODO: should use more specific name, while used only for RECSUR
// 17.01.23: tt hasn't had analog of tablo.cond (table_where is used for specific purpose - search-)
$path_cond = $user_dir? "path like '$user_dir%'" : ""; // ex $user_cond; unlike user_cond (what is now cond in tt) it shouldn't be applied when open_dir (has no sense)
$user_cond = gde("user_cond"); // this is used as additional user cond (similar to tablo.cond) and should be applied both in open_dir/find 

function _prepend(&$path){global $user_dir; if($user_dir) $path = $user_dir.$path; }// USD TRUNC
function _trunc_k(&$f,$add_slash=true){ // truncate key = path
	global $user_dir;$start = strlen($user_dir); if(!$start) return $f; 
	$res=array(); foreach($f as $k => $v) {$p = substr($k, $start); if(!$p)$p=""; $res[ $p ] = $v;} return $res; // NOTE: that $p empty check is necessary while otherwise $p is ... 0! instead of "";
}
function _trunc_f(&$f,$key=""){
	global $user_dir;$start = strlen($user_dir); if(!$start) return $f; 
	array_walk($f, function (&$item, $key, $param){ $item["path"] = substr($item["path"], $param); }, $start);
}
function trunc_ff(&$ff){ array_walk($ff, "_trunc_f"); }

// now only explodes path/name fields TODO: maybe better incapsulate this functionality to ff; add eg ff param explode="+"
// TODO: not used, replaced with FFEX
function ff_correct($params){
	if( isset($params['sf_path']) ){
		/* normal version: separator = whitespace, unless within double quotes
		preg_match_all('/"(?:\\\\.|[^\\\\"])*"|\S+/', $params['sf_path'], $matches);// https://stackoverflow.com/questions/2202435/php-explode-the-string-but-treat-words-in-quotes-as-a-single-word
		$path = array(); // without "
		foreach($matches[0] as $param) $path[] = trim($param,'"');
		$params['sf_path'] = $path; // it's already an array and will be treated by db.php as array (or-join)
		*/
		// fabro-bzik; wants to use '+' as separator
		$params['sf_path'] = explode("+", $params['sf_path']);  
	}
	if( isset($params['sf_name']))  // TODO: in ws it's named differently: sf_ws_name
		$params['sf_name'] = explode("+", $params['sf_name']);  // PATH/NAME
	return $params;
}


// DEF HIDEFILES : not show files in explorer (only folders); first was used in MS
// DEF HIDEFILES_CACHE  not showing files gives a problem: have no cache of files on client side, so can'r re-show already opened folders; to solve it (it's esp difficult for a find result) - id's of files are cached in data-files_cache param of the folder
$show_files = gde("show_files");  
//
//$table_files = gde('table_files', 'files');
$table_files = gde('table_files', $table_tree);

// FIND_SHM  returns array: name,oper,val,name,oper,val.... (consequent triples)
function compile_where_shm($find_array){
	$res = array();
	foreach($find_array as $crit)
		if( !is_array( $crit['value'] ) )
			$res[] = array( $crit['field'], $crit['operation'], $crit['value'] );
		else
			foreach($crit['value'] as $val)
				$res[] = array( $crit['field'], $crit['operation'], $val );
	return $res;
}
if( ise("quiet") )
	log\set_log_level('quiet');

log\info("table_tree controller action request: $action");

if( $action=='render' ){
	echo lang_html_load("$_PD/html/table_tree.html", true) ;
	return;
}

// just build where condition (from search form) used for RECSUR
if($action=="compile_search"){
	$params = json_decode(mse('params'), $convert_to_array=true);
	$where = db\compile_where(  ff_add_values( get_filter_fields(), $params), ff_get_predicate($params) ); // append values to ff arr
	echo( json_encode( $where ) );
	return;
}
//
//checks if shm is running
if($action=='shm_state'){
	if(!shm_enabled)
		echo 'disabled';
	else if( ping_shm() )
		echo 'ok';
	else 
		echo 'error';
	return;
}
// OPF
if( $action=='open_dir' || $action=='find'){
	$shm_ok = false; // shows if shm has been used
	$shm_table_num = gde( 'shm_table_num', -1); // the client should know such details; also this indicates whether use shm or not (in this particular call), which also should know the client
	$try_use_shm = shm_enabled;
	$cache_is_sync = !check_flag("check_path") && !check_flag("files_changed");   // NEW 3.1.19; if some refresh flag exists - means changes are made but not yet in cache; can't use shm/paths 
	log\debug("shm table num: $shm_table_num; try use shm: $try_use_shm; cache is sync: '$cache_is_sync'");
}

if( $action=='find' ){
	// here goes OPF - mutual part for find/open_dir

	$params_json = mse('params');
	$params = json_decode(mse('params'), $convert_to_array=true);
	$max_count = gde('max_count', 0);
	$order = gde("order");
	// FINDSHM
	if($try_use_shm && $cache_is_sync && $shm_table_num>=0 ) try{
		if( strpos($params_json,'%')!==FALSE ) throw new Exception("cphp not supports % yet: $params_json"); // TODO: it may be + instead %
		$shm = new SHM();
		$res_shm = $shm->open_dir($shm_table_num, compile_where_shm( ff_add_values(  $params, get_filter_fields() )  ), $find=true);
		unset($shm);
		$files = get_basic_file_info( $res_shm['files'] ); 
		$shm_ok = true;
		log\debug("found with shm");
	}catch(Exception $e){
		log\error("shm error: ".$e->getMessage()); // TODO: why this isn't displayed
	}
	//
	if(!$shm_ok){ // usual way
		$where = db\compile_where(  ff_add_values( get_filter_fields(), $params), ff_get_predicate($params) ); // append values to ff arr
		log\debug("finding without shm...");
		// NOTE: can't use FIORD here (NO_FIORD), while here res must be sorted by path... or can be? in open_dir_db1 order by path is used only when select dirs
		$order = gde("order"); // TODO: realize for other find modes
		$where = [$where, $path_cond, $user_cond];  // USD TODO: it's not correct (at least for TRUNC); path conditions should be applied to truncated path (or else may be false positives when user_dir satisfies the request)
		$files = find_files( $where, $order);  // TODO: saving in var instead of passing directrly to json_encode may have overhead; so if not use count check - pass directly
	}
	// check res
	$count = count($files);
	if($max_count>0 and $count>$max_count){
		/*http_response_code('400'); // bad request
		echo 'overflow '.count($files) ); this would never work, guess*/
		header("HTTP/1.0 400 max_count $count");
		return; // not necessary
	}else if( $count==0 ){
		header('HTTP/1.0 400 not_found');
		return; // not necessary
	}else{
		_trunc_f($files);
		$_SESSION["open_result"] = array("files" => $files, "folders" => array()); // USD TRUNC; this is used to show thumbs right after search (any folder not yet clicked)
		echo json_encode( array("files" => $files, "folders" => array()) ); // according to OPEN_ALL_BUG should use this
	}
	return;
}
//OD
if( $action=='open_dir' ){
	// here goes OPF - mutual part for find/open_dir

	$parent_dir = gde( 'path' );
	_prepend($parent_dir); // USD
	$order = gde("order", "name");
	$childs = array();
	//  RECSUR TODO: now cond works only with open_dir();  thus need force not using it if cond is provided; need make it work with other functions, or at least some optimization needed
	$use_only_open_dir = $cond || $user_cond;  
	if($try_use_shm && !$use_only_open_dir && $cache_is_sync && $shm_table_num>=0) try{
		$shm = new SHM();
		$res_shm = $shm->open_dir($shm_table_num, rtrim($parent_dir,"/")); // TODO: better path to shm with slash (just for uniformity) TODO: anyway it should return paths with slash
		$childs = array("folders" => get_open_dir_info_path_list( $res_shm["paths"] ),
				"files"   => get_basic_file_info( $res_shm["files"] ) );
		unset($shm);
		$shm_ok = true;
		log\debug("dir opened with shm");
	}catch(Exception $e){
		log\error("shm error: ".$e->getMessage()); // TODO: why this isn't displayed
	}
	// if opening withiout shm - still have 2 choices: with paths table or not
	if(!$shm_ok){
		log\debug("opening without shm...");
		// paths can't be used in 2 cases: 1. table's data is not acutal; 2. $table_tree doesn't correspond to paths (paths are meant to be cache of whole files table, not of subsets like files_to_restore/backup)
		// the client should know the (1); as for the (2) - it may be passed by client or may keep $table_tree => $table_paths correspondence here
		// can use paths also for b/r tables - but some folders may be empty
		// $use_paths = !file_exists(proj_path.'flag/check_path');  could use this to check if paths table is refreshed but this is by idea just a library which doesn't depend on the client, so shouldn't know its internals
		/*log\debug("use paths: $use_paths");  commented 9.01.20; with PATH/NAME no much sense to use paths table
		if($use_paths && !$use_only_open_dir && $cache_is_sync)
			$childs = open_dir_paths_simple($parent_dir); 
		else*/
		$use_paths = gde( 'use_paths', 1); // presently use_paths is true only for 'files' table (because in this case no need to make 'not empty folder' check
		if(!$use_paths)
			$childs = open_dir($parent_dir, [$cond, $user_cond], $order); // now used (only) in ps.php, snaps.php FIORD: added order, but for open oper the order is done by view order (in ms)
		else
			$childs = open_dir_pv($parent_dir, [$cond, $user_cond], $order);
	}
	// result
	if( $throw_on_empty && !sizeof($childs["files"]) && !sizeof($childs["folders"]) )  // this is possible with recursive search
		header('HTTP/1.0 400 not_found');

	//log\debug( dump(($childs["folders"])) );
	//$x = trunc_ff($childs);
	//log\debug( dump($x) );
	//echo json_encode($childs);
	trunc_ff($childs);  // USD TRUNC
	$_SESSION["open_result"] = $childs;
		log\debug("c: ", sizeof( $_SESSION["open_result"]["files"] ) );
	if(isset($_SESSION["open_result"])) echo "okkk"; else echo "nope"; // TODO: this is necessary TEMP while js waits for rest = str > 2 symb
	log\debug("ok");
	return;
}

if( $action=='open_dir_recursive' ){
	$parent_dir = mse('path');
	_prepend($parent_dir); // USD
	$files = db\select_to_array($table_tree, field_list_basic, ["path like '".db\escape($parent_dir)."%'", $cond, $user_cond], "path");  // NOTE without path sort show_tree_comlete not works
	_trunc_f($files);
	if( count($files)==0 ){
		header('HTTP/1.0 400 not_found');
	}else
		//$_SESSION["open_result"] = array("files" => $files, "folders" => array());
		echo json_encode( array("files" => $files, "folders" => array()) );  // USD TRUNC   why not save in session? - because of OPEN_ALL_BUG
	return;
}

if( $action=='open_path' ){
	$parent_dir = mse('path');
	$root = mse('root');
	_prepend($root); // USD
	$whar = ["path = '".db\escape2($root)."'"];
	//$whar = [];
	$dirs = preg_split("/\//", $parent_dir, -1, PREG_SPLIT_NO_EMPTY);
	$dir = "";
	foreach($dirs as $d){
		$dir .= $d.'/';
		$whar[] = "path = '".db\escape2($root.$dir)."'";
	}
	// TODO 1: add folders from paths table (for the case if some empty folders present)
	$files = db\select_to_array($table_tree, field_list_basic, [$cond, join(" OR ", $whar)], "path");  // NOTE without path sort show_tree_comlete not works
	_trunc_f($files);
	if( count($files)==0 ){
		header('HTTP/1.0 400 not_found');
	}else{
	//log\debug($root.$dir);
	//log\debug($files);
		$_SESSION["open_result"] = array("files" => array_filter($files, function($f) use($root,$dir) {return $f["path"]==$root.$dir;}), "folders" => array()); // only content of extreme dir
		//log\debug($_SESSION["open_result"]);
		echo json_encode( array("files" => $files, "folders" => array()) );  // USD TRUNC   why not save in session? - because of OPEN_ALL_BUG
	}
	return;
}

//
if( $action=='show_dir' ){
	/* input: 
		checked = ...
		childs = json, list of child folders
	*/
	$checked = gde('checked', false); 
	//$childs_json = mse('childs'); // THIS IS THE OUTPUT OF 'open_dir' (once passed to main and then returned)
	//$childs = json_decode($childs_json, $convert_to_array=true);
	if(!isset($_SESSION["open_result"]))
		throw new Exception("no open result");
	//log\debug($_SESSION["open_result"]);
	show_childs($_SESSION["open_result"], $checked, $show_files);  // TODO: pass only_folders as param
	return;
}
//
if($action=='show_thumbs' || $action=='show_details_table'){
	// DEF FIRE FIles REmaining - show files (here thumbs) by portion
	$start_file = gde('start', 0);  $max_files = gde('max_count', NULL);
	$files = array(); $folders = array();
	/*if(ise("childs") && mse("childs")!="okkk"){ // the old way, used when need show initial set of thumbs (all thumbs) after search/ commented; sometimes childs are passed as only ids, so if wanna use it - need call get_basic_file_info
		$files = json_decode(mse("childs"), true)["files"];
		log\info(dump($files));
		log\info('her');
	}else{*/
	if(!isset($_SESSION["open_result"]))  // DEF CASE CAche in SEssion
		throw new Exception("no open result");
	$files_all = $_SESSION["open_result"]["files"]; // all files (of the curr dir), no only the portion to be shown
	$files_size_total = sizeof($files_all);  // remember tot file size before truncating
	$files = array_slice($files_all, $start_file, $max_files);
	$folders = $_SESSION["open_result"]["folders"];
	//}
	//header("count: ". sizeof($files));
	header("count: ". $files_size_total); // 19.09.21 changed files to files_size_total
        if($start_file || $max_files){ $remain = $files_size_total - $start_file - sizeof($files); if($remain>0) header("remain: $remain"); log\debug("remain: $remain");} // FIRE inform caller how much remain

}
if($action=='show_thumbs'){
	$show_folders = gde("show_folders", true);
	if($show_folders && $start_file==0) // folders are show all and only when showing first portion
		show_folders($folders, gde("path"), /*FCT*/$files_all); // path is for THUMB_UP
		//log\debug(dump($files));
	show_thumbs($files, gde("thumb_small_path", thumb_small_path)); // print by view  
	log\debug("ok");
	return;
}
if($action=='show_details_table'){
	/*
	// DETA note: unlike show_thumbs, this info is not appendable (can't add table to another table); besides, while it not contains images - not so heavy; so pass all info without FIRE and do client-side paging	
	$childs_json = mse( 'childs' ); // THIS IS THE OUTPUT OF 'open_dir' (once passed to main and then returned)
	$is_id = gde( "id", false); // lists of files/folders may be passed by id or itself (path)
	log\debug("id: '$is_id'");
	$childs = json_decode($childs_json, $convert_to_array=true); // array('folders'=>array, 'files'=>array);   order matters, folders first
	$ids = $is_id? $childs["files"] : extract_array_key( $childs["files"], "id" );  // NOTE: if id=false - files already contain basic info, but may need more info
	$fields = basic_fields_captions();
	$files   = get_basic_file_info( $ids, join(",", array_keys($fields)) ); // just replace each id with fields-array
	show_details_table($files, $fields);
	*/
	$user_cols = ($json=gde("visible_columns"))? json_decode($json, true) : null; // TODO: what is interesting, is that js reads it from here with action visible_columns.. what for?
	show_details_table($files, filter_visible_columns($user_cols) ); // only sets table_name to tt_detail and calls render_table
	log\debug("ok");
	return;
}
// DEF DEF_PAGE: 31.05.22 found a bug: if def rec isn't on the first page - it's not shown;
// this call is made to determine page num
// params: id, table, where, order
// TODO: use table (personal open_result for each table
if($action=="get_rec_pos"){
	echo find_array_key_value_index( $_SESSION["open_result"]["files"], "id", mse("id") );
	return;
}
/* commented, while now js filters itself which cols are visible
// TABCOL to return to tt list of alll columns that may be visible; not tested yet
if($action=='visible_columns'){
	echo json_encode(visible_columns());
	return;
}*/

if($action=="table_fields"){
	echo json_encode(basic_fields_captions());
	return;
}

//
if( $action=='file_thumb' ){
	$id = mse( 'id' );
	$thumb = db\select_field($table_files, 'thumb_medium', "id=$id");
	echo $thumb? table_tree_path_rel.gde("thumb_medium_path", thumb_medium_path).$thumb: table_tree_path_rel.'img/no_image_small.png';
	return;
}
//
function __cmp($a,$b){ return strcmp($a["path"], $b["path"]); }
if( $action=='show_tree_complete' || $action=='show_tree_complete_id'){
	$childs_flat = $_SESSION["open_result"]["files"];
	usort($childs_flat, "__cmp"); // explode_tree_id needs array sorted by path
	// now get the tree structure
	$childs_array = explode_tree_id($childs_flat); // returns special tree structure
	// complete with missing folders
	$childs_full_array = et_folder();
	$files_info = array("folders"=>array(), "files"=>array());
	log\info("complete tree..");
	complete_tree($files_info, $childs_full_array, $childs_array); // appends same level childs to all present folders (thus allowing full navigation)
	// and show it
	show_tree_id($childs_full_array, $files_info, $show_files);
	return;
}

// new version (uses new format, displays multiple files with same name)
if( $action=='show_tree' || $action=='show_tree_id'){
	// DEF OPEN_ALL_BUG 17.04.20 bug in cloud proj; the problems (seems) is that open_result is also used for the tree-explorer; if open_all - it should contain only the first level
	$childs = json_decode(mse("childs"), true) ; // OPEN_ALL_BUG
	//$childs = get_or_def2( $_SESSION, "open_result", "files"); // = select_to_array("mails","*",..)   	commented OPEN_ALL_BUG; donno why it was here open res contains res of simple open; need use instead childs (which was obtained by special open_dir_recursive call) ; ... 27.04.20 uncommented, do not understand why can't save in session
	//if(!$childs) return; // TODO: or throw
	//$childs = $_SESSION["open_result"]["files"];
	$childs = $childs["files"];
	usort($childs, "__cmp"); // explode_tree_id needs array sorted by path
	//log\debug("CHILDS");log\debug( dump($childs) );
	// now get the tree structure
	$childs_array = explode_tree_id($childs, false); // returns special tree structure
	//log\debug("CHILDS TREE");log\debug( dump($childs_array) ) ;
	// prev func finds path semantically, need extract info about paths from db
	$details = array(
		//'folders' => extract_paths_info_from_et($childs_array), 
		'folders' => paths_trivial? $childs_array : extract_paths_info_from_et($childs_array), 
		'files' => $childs 
	);
	// this is added to show only sub-branch (the tree thus may have a chain-appendix before the tree, say par1->par2->rest_of_tree (each chain elem contains only one child elem-folder) )
	// NOTE: 21.04.20: using presence of $start_path as indicator that path is relative; thies means not need root elem; otherwise need keep it (to have possib. to select all) and rename to  '..'
	if($start_path=gde("path")){
		if( isset($childs_array["folders"]) && sizeof($childs_array["folders"]) ) // NI
			$childs_array = $childs_array["folders"][0]; // else - error
		while($childs_array['path']!=$start_path){
			if( !sizeof( $childs_array['folders'] ) )
				throw new Exception("start path '$start_path' not found in show_tree");
			$childs_array = $childs_array['folders'][0];
		}
	}else
		$childs_array["path"] = "..";
	// appends 'selected' 0/2 to folders/files
	//set_files_selected($childs_array);  commented after INC_CORR
	//
	// now $childs_array is the root elem of the tree; it has empty name; if need show it - then need set up some name (show root may be useful to be able to select whole tree in web-int)
	//log\debug(dump($childs_array));
	show_tree_id($childs_array, $details, $show_files, $show_root=false);
	return;
}
// input - list of ids; need refresh cache with details
if($action=="update_open_cache"){   //  CACHE_REFRESH
	$order = gde("order", "path");
	$childs = json_decode(mse("childs"), $convert_to_array=true); // array('folders'=>array, 'files'=>array); TODO: for now, only files are used
	$childs["files"]   = get_basic_file_info( $childs["files"], field_list_basic, $order); // just replace each id with fields-array
	$childs["folders"] = get_basic_path_info( $childs["folders"] );
	_trunc_f($childs["files"]); // USD TRUNC only files; paths are re-received from js, already truncated
	$_SESSION["open_result"] = $childs;
	return;
}

//
// search fields; moved here from contr/main.php (of client)
if( $action=='search_fields'){
	// call the view func of table tree;
	echo render_search_form( get_filter_fields() );  // functions of: utils/filter_fields.php, view/metadata.php, model/db.php
	return;
}

if( $action=='open_show_folder'){ // SEL_FOL
	$parent_dir = gde( 'path' );
	_prepend($parent_dir); // USD
	$use_paths = gde( 'use_paths', 1); // presently use_paths is true only for 'files' table (because in this case no need to make 'not empty folder' check
	if(!$use_paths)
		$childs = open_dir($parent_dir, $cond, "path", "folders"); // now used (only) in ps.php, snaps.php FIORD: added order, but for open oper the order is done by view order (in ms)
	else
		$childs = open_dir_pv($parent_dir, $cond, "path", "folders"); // now used (only) in ps.php, snaps.php FIORD: added order, but for open oper the order is done by view order (in ms)
	trunc_ff($childs); // USD TRUNC
	show_childs($childs, $checked=false, $show_files=false);
	return;
}

if($action=='find_path_ids'){
	$path = gde('path', ""); // has end slash
	_prepend($path); // USD
	// array_walk($paths, function (&$item, $key, $param){ $item = $param."/".$item; }, $user_dir);   was used for path array
	global $table_tree; $table_tree = gde("table", "files");
	$ids = find_path_ids($path, $cond);
	$ids = _trunc_k($ids); // USD TRUNC
	//log\debug("TT ", dump($ids));
	echo  json_encode($ids); // NOTE: data is set before
	return;
}

if($action=="print_preview"){
	$id = mse("id");
	$params = db\select_record($table_tree, implode(",", array_keys($detail_captions)), "id=$id");
	echo print_preview($params, gde("thumb_medium_path", thumb_medium_path));
	return;
}
if($action=="get_thumb_url"){
	$type = gde("type", "medium");
	$table = gde("table", "files");
	//echo "table_tree/thumb_medium_".get_portal_name()."/".db\select_field("hires", "thumb_medium", "id=".mse("id"));
	echo table_tree_path_rel.gde("thumb_medium_path", thumb_medium_path).db\select_field($table, "thumb_$type", "id=".mse("id"));
	return;
}

// DEF CDR; to resolve the problem: when need dl some subset of files - need pass them in POST, so can't use normal dl link (which uses GET) but 
// need use utils.php: download_file_path() which for some reason doesn't trigger download (progress bar not shown in bro)
// NOTE: actually the probl is caused by js func load_file which creates http req wich returns blob (this is the delay) and then link is created/clicked
// to avoid that - do dl in 2 phases: pass data in POST, save in SESSION and then use normal dl link with dl req id
if($action=="cdr"){
	if(!isset($_SESSION["downloads"]))
		$_SESSION["downloads"] = array();
	$dl_id = 1; foreach( $_SESSION["downloads"] as $id => $dl)	$dl_id = max($dl_id, $id + 1); // generate dl id
	$data =json_decode(mse("data"), true); $data["files"] = json_decode($data["files"], true);$data["paths"] = json_decode($data["paths"], true);
	$_SESSION["downloads"][$dl_id] = $data;
	echo $dl_id;
	log\info( $data );
	return;
}
if($action=="cdr1"){
	$data = json_decode(mse("data"), true);
	$files = json_decode($data["files"], true);
	$paths = json_decode($data["paths"], true);
	$files_path = $data["files_path"];
	global $table_tree;
	$table_tree = $data["table"];
	$files_all = tt_find_selection($user_dir, $paths, $files, "id,path,name", "path" );
	echo $dlname = tt_create_zip($user_dir, $files_all, "", $files_path);
	return;
}


throw new Exception("Wrong or empty action: $action");

?>
