<?php 
        // DEF LOADEML stuff to download source eml on request

try{
        ob_start();
        require_once(dirname(__FILE__)."/path.php");
        require_once(dirname(__FILE__)."/model/db.php");  // tt_find_selection
        require_once(dirname(__FILE__)."/model/zip.php");  // tt_create_files_zip
        require_once(proj_path."path.php"); // sourche path
        require_once(proj_path."model/errors.php");  // register_error
        require_once(proj_path."utils/db_mysql.php");
        require_once(proj_path."utils/utils.php");  // download_file_stream
        require_once(proj_path."model/db.php"); // get_curr_user_id

	log\set_log_file(log_path."download.log");

	//log\debug(dump($_POST));

        function mse($var){ return must_be_set($_POST, $var); }
        function gde($var, $def=''){ return get_or_def($_POST, $var, $def); }
        function ise($name){ return isset($_POST[$name]); }

	// TODO: user and dir checks were used in ic3; but now ic3 uses its own func, so these are not necessary
        if(session_id() == '') 
                session_start();
        $user_id = get_curr_user_id();
        if(!$user_id)
		throw new Exception("not logged in");

	if( isset( $_GET["cdr1"] ) ){
		$dlname = $_GET["cdr1"];
		ob_clean();
		download_file_path( $dlname, basename($dlname) );
		unlink($dlname); 
		return;
	}

	$start_dir = gde("user_dir"); // dir of ws
	$files_path = gde("files_path"); // if files somewhere inside source path, but this path is not reflected in db;
	if(!user_dir_allowed($user_id, $start_dir))
		throw new Exception("access denied");

	$files = ise("files")? json_decode(mse("files"), true) : array();
	$paths = ise("paths")? json_decode(mse("paths"), true) : array();
	
	global $table_tree;
	$table_tree = gde("table", "files"); // 26.06.22: found out that tt_find_selection was the only that used "files" instead of table_tree and that caused problems in hires

	// CDR
	if( isset( $_GET["cdr"] ) ){
		log\info("download cdr");
		if( ! ( $data = get_or_def2( $_SESSION, "downloads", $dl_id=$_GET["cdr"] ) ) )
			throw new Exception("download request $dl_id not found");
		log\debug($data);
		extract( $data ); // files, paths, table, files_path
		$table_tree = $table;
		unset( $_SESSION["downloads"][$dl_id] );
	}

	//log\debug(dump($files));log\debug(dump($paths));

	// TODO: files_all are used now only for log msg; dlc_register not used;
	$files_all = tt_find_selection($start_dir, $paths, $files, "id,path,name", "path" );
        log\info("downloading ".sizeof($files_all)." files from '$start_dir' for user $user_id");
	//
	$need_zip = sizeof($files_all)>1;
	if($need_zip)
		$dlname = tt_create_zip($start_dir, $files_all, "", $files_path);
	else if( sizeof($files_all)==1 )
		$dlname = source_path.$files_path.$files_all[0]["path"].$files_all[0]["name"];
	//
	ob_clean();
	if( is_file($dlname) ){
		download_file_path( $dlname, basename($dlname) );
	}else
		throw new Exception("zip not found");
	if($need_zip)
		unlink($dlname); // uncommented 18.09.20; donno why was commented;
}catch(Exception $e){
	log\error($e->getMessage(), "controller error; POST dump: ", array_to_str($_POST) );
        ob_clean();
	register_error("Download zip error (tt): ".$e->getMessage(), "controller", "controller", el_higher);
	header($_SERVER['SERVER_PROTOCOL']." 500 Controller error: ".$e->getMessage(), true, 500);
	//return;
}
?>
