/*
	21.09.18 aggiungo selezione parziale
	se una cartella viene de/selezionata - devo aggiornare a) tutti i descendenti (incluse se stesso);  b) la catena dei parenti
	a) i descendenti perdono 'indeterminate" e ottengono lo stato schelto
	b) il parente e': 
		- selezionato se tutti i child sono selezionati (quindi determinati)
		- de-selezionato se tutti sono deselezionati
		- de-selezionato e indeterminato se i primi due non veri
	se un elemento si cambia - deve essere aggiornato il parente (con algo precedente), cioe' ricorsivamente
 */
/*
 * .tree-cont - div containing <li>; contains data
 * 		.tree-item (tree-item-file, tree-item-dir) - <li> which receives folder onclick event
 * 			.tree-elem (tree-file, tree-dir) - <input> checkbox, contains 'checked' state, receives check/uncheck events

  tree is tree of nested .cont, the root is ul.tt_explore_root_item (instead of div)
*/


// TODO 1: separate interface from methods
// DEF CV - class version

// DEPENDENCIES: wait_screen, archive.js, popup.js, utils.js

/*
	SEL_SYNC SS
	theory
	there are two kinds of sync:
		vertical sync: sync sel state of parents/childs
		horizontal sync: sync tree <-> detail
	normally the task is quite trivial, but complicated with HIDEFILES: files in tree may be hidden, pages/show more: not all thumbs/rows are shown, tree (may be) hidden;
	yet those problems maybe could be avoided by VYSWIG approach: what is selected must be represented by some visual elems (no elems - no selection)
	alternative: what is shown (in detail) on folder sel (in tree): whole subtree or only immediate items? at least if search res is shown - need show all files; donnow what is in cm, but guess ideally need differ two situations: navigate or show search res
	VERSYNC DEF SSV:
		tree: DEF SSV_T normally just logic of no/yes/partial selection; HIDEFILES has no effect (no files, no need to sync)
		detail SSV_D:
			table: just VYSWIG or could consider that 'sell all' cb means select whole dir
			thumbs: the only sync which is necessary is to sync 'curr folder' <-> thumbs selection; this requires to know all folder files or at least to know if all thumbs are shown.
	HORSYNC DEF SSH:
		tree -> detail: DEF SSH_TD if file - sel corresp detail, if folder - sel all shown which belongs to folder; if new portion of detail is shown - consider what is selected in tree and detail folders
		detail -> tree: DEF SSH_DT if file: need to track 'folder selected'; this is for each folder need to know all its (immediate) files; need check if all immediate files and all imm subfolders selected; this may need files cache for HIDEFILES mode
		show portion: just set sel to parent folder sel

	NOTE: selection may be found by joining tree/detail selection
	NOTE: which is order VS/HS? VS is to be made in both, so to avoid double work should make VS (once) and the HS; so VS calls HS

	onselect: 
		files cache should be somewhere (maybe in each folder) TODO: add this cache to detail-thumb (in tree already present)
		may need fetch some data from php (list of all files), therefore sync is made in cb passed to ss_refresh_cache which checks if need sync, makes it and calls cb

	problems: 
		if select folder in expl - it means that if show next page with elems of that folder - they appear selected; if then deselect 1 item (path elem goes into 'indeterminate') and return to prev page - all is desel (becaus indeterm not causes selection)

*/

//------------------------------------------------------------------------------------------------------------------------------------------------------------
//--------------------------------------------------- SECT VARS (getters, setters, simples) -----------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------------------------------------------

class table_tree{
	main_form;
	popup_div;
	name; // should be passed unique name to distinguish from other instances
	project_name = ""; // SHARE must equal to the name of php file in ./share/ folder
	detail_view = "thumbs"; // to switch thumbs/details;  = [thumbs,details] TODO: what is 'details' - table view?
	list_view_on = false; // indicates if LIST_VIEW is on; works only for detail_view = thumbs mode
	// NOTE: it should be path (string, not dom elem)
	current_dir_item = null; // .tree-item CURREL DEF for MH it's necessary to track the current directory (last selected);  note: javascript object (not jquery) NOTE: do not need it actually, may just use $(".tree-item.active")[0]
	root_dir = ""; // sometimes it's necessary to restrict access to upper dirs; eg each user has it's own dir and can't go further up; must hide '..' to upper dirs; also avoid processing upper dirs in selection/cache routines
	set_root_dir(dir){this.root_dir = dir; this.get_root_item().data("path", dir); }
	get_root_dir(){return this.root_dir;}
	unroot(dir){return dir.substring(this.get_root_dir().length);}
	current_dir = ""; // added 24.01.20 ; properly path; 
	prev_current_dir_item = null; // .tree-item CURREL DEF for MH it's necessary to track the current directory (last selected);  note: javascript object (not jquery) NOTE: do not need it actually, may just use $(".tree-item.active")[0]
	target_dir = null; // the dir upon which last right click was made (popup target); js (not jquery) elem
	current_item_id = null; // CURREL NOTE: now it's id; may happen that curr elem not present in tree (show_files=0)
	// NOTE: now use_paths in fact is equivalent to: 'allow show empty folders' (= do not check if a folder is empty (to hide it))
	use_paths = 0; // indicates how open folder: using paths table (open_dir_paths) or usual way (open_dir)
	set_use_paths(val){ this.use_paths=val; }
	shm_table_num = 0; // '0' now means not use shm
	set_shm_table_num(num){this.shm_table_num=num;}
	show_files = null;   // HIDEFILES indicates if need show files in tree view; (in MS normall only folders are shown)
	set_show_files(sf=true){this.show_files=sf;} // client should call it to set up if show files (def is yes (in contr))
	show_folders = 1;
	set_show_folders(sf){this.show_folders=sf;}
	on_show_plain=null; // client callback to call after show plain
	on_show_tree =null; // client callback to call after show tree ; added 4.4.23 for camps
	set_on_show_plain(f){this.on_show_plain = f;} // ex-set_on_show_table
	set_on_show_tree(f){this.on_show_tree= f;}
	user_dir = ""; // 14.01.20 MUSD    
	set_user_dir(sd){this.user_dir = sd;} 
	get_user_dir(){return this.user_dir;}
	// used in space: hide tree explorer
	table_tree = "";
	alias = "";
	set_alias(a){this.alias = a;}
	table_files = ""; // corresponds to = of model/db.php
	table_where = ""; // additional condition applied when a node is opened; NOTE: now is applied only for opening and not for find/stat (that is seems only for RECSUR)
	user_cond = ""; // this is used for both open/find (similar to tablo.cond)
	set_user_cond(c){this.user_cond=c;}
	files_order = null; // FIORD
	table_tree_path = "table_tree/";
	contr_path = "table_tree/contr/main.php";
	xhr = null; xhr_render = null; // TODO: used to control active requests? not realized now, seems (.. used in .tt_search_cancel_btn)
	client_show_details_func; // DEF CLIENTSHOWDET allso client to set its own show_details function; params: (file_id); used in mailstore to show mail contents in an inline panel
	tree_hidden = false; // CV: seems this indicates if explorer is shown (if not - there is no info about folder struct and no need to sync explorer with detail )
	plain_hidden = false;
	// TODO: files_path used now only by client, tt has no its built-in func to download selection (although download_zip is under tt folder)
	files_path; thumb_small_path = ""; thumb_medium_path = ""; // SHARE 30.08.2022 ; allows to set individual source and th. paths for each proj; if not set - used default (in table_tree/contr/main.php); NOTE: src path is where files are physically; that is full path = src path + path from db
	set_paths(src,sm,me){ this.files_path = src; this.thumb_small_path = sm; this.thumb_medium_path = me;}
	pager = null; // use var to hold it while create_counter requests id which is unique
	def_rec_id; // the rec to be shown; now used only for table-view; while show_table_portion is not called directly, so save it in a var (instead of passing through all func calls)
	set_def_rec_id(id){this.def_rec_id=id;}
	clear_pager(){if(this.pager && this.pager.length)this.pager.remove();this.pager=null;}
	hide_tree(){
		this.tree_hidden = true;
		this.set_show_files(false); // thus shrink data exchange
		this.get_tree_form().addClass("hidden");
		this.main_form.find(".tt_exp_btn_div .musd").detach().appendTo(this.main_form.find(".tt_thumbs_header"));  // move buttons to thumb sect
	}
	hide_preview(){ this.main_form.find(".tt_preview_form").addClass("hidden"); } 
	show_preview(){ this.main_form.find(".tt_preview_form").removeClass("hidden"); } 
	//hide_plain(){ this.plain_hidden=true; this.get_thumb_form().addClass("hidden");} // shit not works
	hide_plain(){ this.plain_hidden=true; this.get_thumb_form().remove();}
	get_root_item(){ return $(this.main_form.find('.tt_explore_root_item')[0]); }  // TODO 1: this elem present in old ver but here not
	get_tree_form(){ return $(this.main_form.find(".tt_explore_form")[0]); }
	get_thumb_sect(){return $(this.main_form.find(".tt_thumbs_section")[0]); } // contains thumbs (is cleared/filled on show)
	get_thumb_form(){return $(this.main_form.find(".tt_thumbs_form")[0]); } // contains get_thumb_sect and other detail controls
	get_preview_div(){ return $(this.main_form.find(".tt_preview_body")[0]); }
	get_before_detail(){return $(this.main_form.find(".tt_before_detail")[0]); } 
	get_search_form(){ return $(this.main_form.find(".tt_search_form")[0]); }
	get_quick_search_form(){ return $(this.main_form.find(".lbsp_form")[0]); }
	get_cont(elem){
		return elem.closest('.tree-cont');
	}
	get_data(elem, param){
		//var res = this.get_cont(elem).data(param);
		var res = elem.closest(".tree-cont,.thumb,.data-row").data(param);
		return (typeof res === "undefined")? "" : res;
	}
	set_data(elem, param, value){
		this.get_cont(elem).data(param, value);
	}
	get_item(cont){
		return cont.children('.tree-item').first();
	}
	get_elem(cont){
		return cont.children('.tree-item').children('.tree-elem').first();
	}
	// returns jq elem or empty object
	// works for tree elems (explorer)
	get_parent(cont){
		if(!cont.length) return $();
		var res = cont.parent('.tree-cont');
		var pl = res.length && res.data("path")? res.data("path").length : 0; // 23.07.23 happened that res.length>0 but data-path undefined TODO: donno if normal
		if(pl < this.root_dir.length) return $(); // if go further allowed dir
		return res;
	}
	get_thumb_cont(thumb_child){ // thumb_child is some inner elem - img or ref..
		return thumb_child.closest('.thumb');
	}
	get_detail_class(){return this.detail_view=="thumbs"? "thumb" : "clickable-row";}
	get_id_detail(id){	return this.get_thumb_form().find("." + this.get_detail_class() + "[data-id='" + id + "']"); }
	get_path_detail(path){	return this.get_thumb_form().find("." + this.get_detail_class() + "[data-path='" + path + "']"); }
	get_id_elem(id){return this.get_tree_form().find('.tree-file.id'+id);} // return elem by file id   find_elem find_item
	// use get_path_cont get_path_elem(path){	return this.get_elem(this.get_tree_form().find(".mc-dir.tree-cont" + "[data-path='" + path + "']")); }
	get_detail(id=0,path=""){	var is_dir = !id || id=="0";	return is_dir? this.get_path_detail(path) : this.get_id_detail(id); }
	get_thumb_elem(thumb){
		var id = this.get_thumb_cont(thumb).data('id');
		return this.get_tree_form().find('.tree-file.id'+id);
	}
	// DIRTHUMB  find elem in dir-tree corresponding to a folder in thumb panel
	// note the trick: for a file this gives parent elem, for a dir - itself (while for files path is only path without name)
	get_path_cont(path){ return this.get_tree_form().find(".mc_dir.tree-cont[data-path='" + path + "']");	}
	// NOTE: TODO: seems is_dir is applied only for elems (checkboxes) which have tree-dir/tree-file, while items (li) have other classes tree-item-dir tree-item-file
	is_dir(elem){
		if( !elem.hasClass("tree-elem") && !elem.hasClass("thumb") /*may be called on detail thumb*/ ) elem = this.get_elem(this.get_cont(elem)); // if sms wronw (item instead elem) was passed
		//return elem.hasClass('tree-dir') || elem.hasClass('thumb-dir'); // latter is for detail elem
		//return elem.hasClass('mc_dir') || elem.hasClass('thumb-dir');  prev was commented and this used; but mc_dir is in a cont, so when called on elem not works, so check both
		return elem.hasClass('tree-dir') || elem.hasClass('mc_dir') || elem.hasClass('thumb-dir');
	}
	// use is_dir is_file(elem){		return elem.hasClass('tree-file');	}
	// 
	dir_opened(cont){ // shows if the cont (from explorer) was opend and then closed; CORRECTION: seems now used to indicate if currently opened; for opened/closed is used is_opened_closed() 
		return this.get_item(cont).hasClass("ttc_folder_opened");
	}
	set_table_files(tf){ this.table_files = tf; } // by def is same that table_tree
	get_table(){return this.table_tree;}
	set_where(w=""){ this.table_where = w; } // TODO: shouldn't it be private? seems used only internally
	get_where(){return this.table_where;}
	get_target_dir(){return this.target_dir;}  //CURREL returns
	set_target_dir(td){ return (this.target_dir=td); }
	get_curr_dir_item(){return this.current_dir_item;}  //CURREL returns
	set_curr_dir(path){this.current_dir=path;}
	get_curr_dir(){return this.current_dir;}
	// tree item click handler: indicate visually active item and save in var (what for?)
	set_curr_dir_item(jquery_obj){ 
		this.prev_current_dir_item = this.current_dir_item;
		this.current_dir_item = jquery_obj[0];
		this.main_form.find(".tree-item.active").removeClass("active");
		jquery_obj.addClass("active");
		this.set_curr_dir(this.get_data(jquery_obj, "path"));
	}
	get_curr_item_id(){return this.current_item_id;}  //CURREL returns curr (active) file id; ex get_curr_item
	// NOTE: this actually sets id, not item
	set_curr_item(item){ 
		var item = this.get_item( this.get_cont(item) ); // donno what exactly is passed here
		this.main_form.find(".tree-item.active").removeClass("active");
		item.addClass("active");
		this.current_item_id = this.get_data(item, 'id');
	} // TODO: need sync curr item table-tree ; seems used only for files (not dirs)
	find_rec(id){ return this.main_form.find(".tr-"+this.alias+"[data-id='" + id + "']"); } // alias
	// TODO: some confusion in active/target dir/elem ; seems no way to get properly active element (either dir or file) so add get_active_item
	get_active_item(){ return this.main_form.find(".tree-item.active"); }
	find_all_thumbs(){return this.get_thumb_form().find('.'+this.get_detail_class());}
	// find thumb with is a dir WITH given path
	find_path_thumb(path){ var t = this; return this.find_all_thumbs().filter( function(ind){ var e = $(this); return t.is_dir(e) && t.get_data(e, "path")==path; } ); } // find a detail elem representing a dir with given path
	// find thums UNDER given path; all files/dirs of a path (in detail); NOTE: while detail shows only single level, this may be replaced with a func which returns all elems except dots
	find_path_thumbs(path){
		var t = this;
		if(!path)
			return this.find_all_thumbs().filter( function(ind){ var e = $(this); var path = t.get_data(e, "path"); return t.is_dir(e)? p && !t.get_parent_path(e) : !path} ); // if path empty - get_parent_path not works properly, returns "" for dirs
		else
			return this.find_all_thumbs().filter( function(ind){ return t.get_parent_path( $(this) )==path } );
	};

	// TODO: need unite these two?
	get_active_rec(){ return this.main_form.find(".active.tr-" + this.alias); } //alias seems DEPRECATED
	//get_active_detail(){ return this.get_thumb_sect().find(".active.thumb"/* + this.alias*/); } // TODO: use tr for table-view ;; not checked
	get_active_detail(){ return this.get_thumb_sect().find(".active." + this.get_detail_class()); } // TOTEST

	ro_set(fo){this.files_order = {"field" : fo.field, "order" : fo.order}; } // added 3.10.19 for MS; allow custom sort order; this func must be called by client;  DEF FIORD NOTE: actually more likely will be called innerly by table column click
	// CLIENTSHOWDET 
	set_show_details( shd ){
		this.client_show_details_func = shd;
	}
	// SELIN
	on_select = 0;
	set_on_select(f){
		this.on_select = f;
	}

	custom_item_click = null;
	set_item_click(cc){this.custom_item_click=cc;}
	set_name(pn){this.name=pn;}
	set_table_tree_path(tp){ this.table_tree_path = tp; this.contr_path = tp + "contr/main.php"; }

	// TODO 1: how related with mc_focused?
	set_active_section(sel){
		this.main_form.find(".mc_tt_section").removeClass("mc_tt_active_section");
		this.main_form.find(sel).addClass("mc_tt_active_section");
	}
	tt_get_elem_name(elem){ return elem.hasClass("mc_file")? elem.find(".file-ref").html() : elem.data("path"); }
	// set tree elem sel state TODO: Use it
	set_elem_sel(elem, sel, ind=false){
		elem.prop('checked',sel);
		elem.prop("indeterminate", ind); 
	}
	// set detail elem sel state TODO: Use it
	set_detail_select(elem, sel=true){
		if(sel) elem.addClass('selected');
		else elem.removeClass('selected');
	}
	show_details_on_focus = false; // 2023; used for issues: need show details on focus; here wasn't possible... (only in list view)
	set_show_details_on_focus(bla){this.show_details_on_focus=bla;}

	//--------------------------------------------------- ESECT VARS (getters, setters, simples) -----------------------------------------------------------------


	//------------------------------------------------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------- SECT UTILS  --------------------------------------------------------------------------------------------
	//------------------------------------------------------------------------------------------------------------------------------------------------------------

	//--------------------------------------------------------- SUBSECT ADD_INFO --------------------------------------------------------------------------------
	// DEF ADD_INFO stuff used to show some additional info for files/folders; user should provide funcs func(elem) and pass them by add_info_handler; normally user funcs use ajax
	// object containing custom callback which is used to display additional info; the client should set the callback for each application
	add_data;
	// adds 'additional info handler' - the function which adds some non-standard info about an element
	// elem_type = file/dir/all
	add_info_handler(handler, element_type='all'){
		switch(element_type){
			case 'file': this.add_data.process_file = handler; break;
			case 'dir' : this.add_data.process_dir  = handler; break;
			case 'all' : this.add_data.process_file  = handler; this.add_data.process_dir  = handler;  // TODO: only this is used now;
		}
	}

	//--------------------------------------------------------- SUBSECT TABCOL ----------------------------------------------------------------
	// DEF TABCOL setting up visible table columns
	columns_cookie_name = "";
	tabcol; // obj that holds info and funcs to handle show/hide a visible col
	//repeate_show_table(){  this.show_page(this.pager? get_counter_val( this.pager ) : 0) }
	tabcol_click(){
		setCookie(this.columns_cookie_name, this.tabcol.get_visible_columns().join("+"), 1000);
		this.rd_run();
		//this.repeate_show_table();
	}
	// set initially visible columns and create popup to add/rem a col
	tabcol_init(ac=null){
		var t = this;
		if(!ac){ // deprecated
			ac = call_php_sync(t.contr_path, {'action' : 'table_fields', 'project' : t.project_name}, 'POST'); // means all possibly visible columns, CDF format
			ac = JSON.parse(ac.resp_text); // by default all cols visible (if no cookie)
		}
		t.columns_cookie_name = "visible_columns" + this.alias; //   the name of the cookie to save user cols; it's individual for each table; 
		var vc = getCookie(this.columns_cookie_name);
		vc = vc? vc.split("+") : ""; // DEF TABCOL_WS_COOKIE saving cols in cookie; note: not cdf, simple arr of val format
		this.tabcol = new TabCol2(vc, ac, function(){t.tabcol_click()}, "mc_field_capt"+'.'+this.alias);   // TABCOL_WS  ; ALIAS
	}

	//--------------------------------------------------------- SUBSECT FIORD ---------------------------------------------  
	ro_extract(_header){ // used to find out (possible new) order field; this singled out to be used by others, TODO: maybe move to utils
		var header = _header.closest(".fh_header");
		var field_name = $(header).data("fhid");
		var new_dir = $(header).hasClass("mc_desc")? "asc" : "desc" ; // TODO: more correctly is to find dir so: if new_field==old_field => !old_order; else => asc (=def)
		return {"field" : field_name, "order" : new_dir};
	}
	ro_show_order(parent_, tname, order){ // called once after table is shown, adds the corresp class to order-field (to show it)
		// $(".th-tt_detail-" + files_order.field).data("order", files_order.order); // also may use '#tt_thumbs_form .fh-header th[data-fhid]=<field>' (not checked) ; TODO: not works.. data attr change (run-time) - css not works
		if(order)
			parent_.find(".th-" + tname + "-" + order.field).addClass("mc_" + order.order);
	}
	ro_to_str(files_order){ return files_order? files_order.field + " " + files_order.order : ""; }

	//--------------------------------------------------------- SUBSECT ADD ACTION --------------------------------------------
	// DEF AA adding action button 
	// action is an obj: {id, handler (function defined in client), caption}
	add_action(id, handler, caption=''){
		var t = this;
		var bd = this.main_form.find('.tt_buttons');
		bd.removeClass('hidden'); // gets visible if at a button added
		var btn = bd.append('<button type="button" class="btn btn-success btn-sm" id="' + id + '">' + caption + '</button>&nbsp;');
		// onclick contains some validation logic and then calls user handler, passing to it the list of selected paths
		btn.on('click',function(){
			var selection = t.find_selection();
			if( selection===0 )
				t.show_alert(lp("no_file_sel"));
			else
				handler(selection.paths, selection.files); // TODO: maybe call it by ajax (wait screen)
		})
		return btn;
	}

	//--------------------------------------------------------- SUBSECT REQUEST DATA ------------------------------------------------
	// DEF RD sometimes it's necessary to repeate request; eg when user requests re-order files
	request_data = null;
	rd_set(data){ this.request_data = data; }
	rd_get(){ return this.request_data; }
	rd_run(){
		if(this.request_data)
		switch(this.request_data.type){
			case "open": 	this.open_dir(this.request_data.path, this.request_data.cont); break;
			case "open_rec": 	this.open_dir_recursive(this.request_data.item); break;
			case "open_path": 	this.open_path(this.request_data.path); break;
			case "find": 	this.find_files(this.request_data.params); break;
		}
	}

	//--------------------------------------------------------- SUBSECT CLEAR -----------------------------------------
	// DEF H&B - to make flex work - table elems (header and body) must be on same level with other elems (header and pager), so can't just replace whole html, but need remove old stuff and add new (after marker)
	clear_detail(clear_pager=true){ // TODO: check how works for both details
		this.get_thumb_form().find(".fh-elem").remove(); // remove table header/body  note: with MTS not necessary
		this.get_thumb_sect().html("");
		if(clear_pager)
			this.clear_pager();
		this.get_preview_div().html(""); 
	}
	close_cont(cont){
		cont.children('.tree-cont').addClass('hidden');
	}

	//--------------------------------------------------------- SUBSECT POPUP (PUMA) ----------------------------------

	// PUMA this wrapper only encapsulates popup_div id; is to be used by client  ex tt_add_popup_item
	add_popup_item(caption, action, files=true, folders=true, notarget=false, custom_class=""){ // TODO: notarget is used to perform ops with selection; here also need control if there are some selected
		var cl = (files?"ttc_pu_file ":"") + (folders?"ttc_pu_folder ":"") + (notarget?"ttc_pu_notarget":"") + " " + custom_class;
		return add_popup_item( this.popup_div, caption, action).addClass(cl);
	}
	/* hides/shows items depending on item classes; user should add classes 
		ttc_pu_notarget: shown if clicked on empty place
		ttc_pu_file: showed only if target is file
		ttc_pu_dir: showed only if target is dir  
	*/
	set_pu_items(target, popup_div){
		if( $(target).closest("#md_ss_div").length ){ this.popup_div.addClass("hidden"); return; } // TODO: quickfix not to show pm in SEL_FOL
		if( $(target).hasClass("tt_emp_explore_menu") ){ // if user clicked menu icon (not folder/file item) - then use active elem  DEF PM_EMB   NOTE: in momo first select then click menu; TODO: quite tricky, may do it without pm
			target = this.get_curr_dir_item();
			set_popup_target(target);
		}
		var td = $(target).closest(".mc_dir");
		var is_dir = td.length;
		if(is_dir)
			this.set_target_dir(td[0]); 
		var tf = $(target).closest(".mc_file");
		var is_file = tf.length; 
		if(is_file)
			this.set_target_dir(tf[0]); 
		var is_tree = $(target).closest(".tree-cont").length;  // OPEN_ALL_TREE
		this.popup_div.find(".ttc_pu_item").each( function() { 
			if($(this).hasClass("ttc_pu_notarget") || is_dir && $(this).hasClass("ttc_pu_folder") || is_file && $(this).hasClass("ttc_pu_file") ) // NOTE: some items visible only if have active file/folder
				$(this).removeClass("hidden");
			else
				$(this).addClass("hidden");
			if($(this).hasClass("mc_tree_only") && !is_tree) // DEF OPEN_ALL_TREE: open/close all must be enabled only if invoked on a tree elem
				$(this).addClass("hidden");
		} );
	}

	//--------------------------------------------------------- SUBSECT UTILS MISC TODO-----------------------------------------

	add_slash(s){ return s[s.length-1]=='/'? s : s+"/"; } // adds slash if not yet contains; at the moment it's disorder with having/not having end-slash
	// return parent elem path; in cm a file's path is full path without name (with endslash), a dir's path is its full path with endslash
	// returns file's path for a file and removes last segment for a dir
	get_parent_path(elem){
		var path = this.get_data(elem, "path");
		if(!path) return ""; // NI
		if(!this.is_dir(elem)) return path;
		var pa = path.split("/");
		pa.pop(); pa.pop(); // cut last empty; cut last elem
		return pa.join("/") + "/";
	}
	// handle search error situation
	search_error(j,errorS,p){
		var msg = '';	
		if(p == 'abort')
			msg = lp("search_stop");
		else if(j.status == 400 && p.indexOf('max_count')==0)
			msg = lpp("$too_many_found$", p.substring(10));
		else if(j.status == 400 && p.indexOf('not_found')==0)
			msg = lp("no_file_found");
		// some unhandled error
		else msg = lpp(p);
		if(p=="no_user"){ // LOGONEXP
			show_login();
			return;
		}
		// show msg
		show_alert(msg);
		j.done();
		//alert(msg);
	}

	// elem = js object 
	scroll_top_if_hidden(elem){
		if( typeof scrollIntoViewIfNeeded === 'function' )
			elem.scrollIntoViewIfNeeded(true);
		else
			elem.scrollIntoView(true);
	}
	// TODO: why not used?
	reset_table_tree(){
		this.get_root_item().html("");
		this.clear_detail();
	}
	show_search_panel(){
		var sp = this.main_form.find(".mc_search_panel"); sp.css({'top': (this.main_form.offset().top + 'px') }); sp.removeClass("hidden");
	}
	hide_search_panel(){
		this.main_form.find(".mc_search_panel").addClass("hidden");
	}
	show_folder_search(item){
		$(".ttc_filter_path").val( get_data(item, "path") );
		show_search_panel();
	}	

	// ex tt_download_file
	download_file(){
		var id = this.get_curr_item_id();
		if(!id){ alert(lp("no_file_sel")); return;}
		download_file(this.table_tree_path + "download_file.php?id=" + id + "&t=" + this.table_tree);
	}

	// usage: when user requests some action on selected items (eg delete selected files); the func finds selection and performs passed action-callback
	selection_action(action, confirm_msg=lpp("$continue$?"), ok_msg="OK", error_msg="error"){
		var sel = this.find_selection(); // tt funcs
		var snap_info = {'paths': JSON.stringify(sel.paths), 'files': JSON.stringify(sel.files) }; // NOTE: paths are not used now, maybe; need control if selecting folders in thumb form works
		// stat selected files
		wait_screen.add_operation(action);
		var t = this;
		this.xhr = $.ajax({
			type: "POST",
			data: {'action' : action, 'paths' : snap_info.paths, 'files' : snap_info.files, "user_dir": t.user_dir, 'summary' : 1, table: t.table_tree},
			url: 'contr/main.php',
			success: function(res){
				var count = res;
				if(confirm(lpp("$sel_n_files$, $2", res, confirm_msg))){
					t.xhr = $.ajax({
						type: "POST",
						data: {'action' : action, 'paths' : snap_info.paths, 'files' : snap_info.files, "user_dir": t.user_dir, 'summary' : 0, table: t.table_tree},
						url: 'contr/main.php',
						success: function(res){
							alert(ok_msg);
							t.open_root_dir();
						}})
				}
			},
			complete: function(){
				wait_screen.remove_operation(action);
			}
		})
	}

	// used in REDI ; note: would be better to get file cache of curr dir, but wihtout root item (another reason to have always root item) it may be null
	get_all_shown_thumbs(){return this.get_thumb_sect().find(".thumb.mc_file");}
	set_thumb_add_info(thumb, html, title=''){ thumb.append( $("<div class='ttc_thumb_add_info' title='" + title + "'>" + html + "</div>") ); }
	reset_thumb_add_info(){this.get_thumb_sect().find(".ttc_thumb_add_info").remove();}

	// ---- ALERT _----  TODO: move to a util lib
	// 26.03.20 had to give tt_alert up while search panel (which holds it) is hidden normally; also other panels are shown/hidden dynamically, so hard to find some to hold it permanently; note: also search panel now hides upper screen part, so even can't use to container to show alert
	show_alert(msg, sel=".tt_alert"){
		alert(msg); return;
		var html = '<div class="alert alert-danger" role="alert">';
		html +='<button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
		html +='<strong>' + lp('attention') + '!</strong><br>' + msg;
		html +='</div>';
		this.main_form.find(sel).html(html);
	}
	clear_alert(sel=".tt_alert"){
		this.main_form.find(sel).html("");
	}
	// DEF SHARE: tricks to allow the same code to use for different projects (like needed in mh - to explore files and explore mails);
	// acid (Add Controller Data) is just used to add the data which is sent in each controller call
	// NOTE: in js params passed by ref note that sometimes data passed to contr is enormous, so passing to and fro by value would be costful
	acid(action,  params ){
		params.type = "POST";
		params.url = this.contr_path;
		if(!("data" in params))
			params.data = {};
		params.data.action = action;
		params.data.table = this.table_tree;
		params.data.table_files = this.table_files;
		params.data.project = this.project_name; // SHARE
		params.data.order = this.ro_to_str(this.files_order); // FIORD
		params.data.user_dir = this.user_dir; // MUSD
		params.data.user_cond = this.user_cond;
		if(this.show_files!==null) params.data.show_files = this.show_files?1:0; // HIDEFILES
		if(this.show_folders!==null) params.data.show_folders= this.show_folders?1:0;
		params.data.thumb_small_path = this.thumb_small_path;// SHARE
		params.data.thumb_medium_path = this.thumb_medium_path;
		return params;
	}

	//--------------------------------------------------- ESECT UTILS  -------------------------------------------------------------------------------

	//------------------------------------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------- SECT OPEN / FIND  -------------------------------------------------------------------------
	//----------------------------------------------------------------------------------------------------------------------------------------------

	//--------------------------------------------------------- SUBSECT OPEN / FIND MISC  --------------------------------------------------------------

	thumbs_list; // FIRE
	page_size = 30; // FIRE CASE  after each data fetch this should be re-set to 0;

	// TODO: this should be counted in SARE?
	open_root_dir(cond=''){ // cond is set when making 'recursive search' 
		var t = this;
		$.when(this.xhr, this.xhr_render).done(function(){
			t.set_where(cond); // 3.10.19; added to solve prob: if make search then click 'explore' - keeps using filter; TODO: need bring in order all uses of cond/table_where
			t.get_root_item().html(''); 
			t.open_dir(t.root_dir, t.get_root_item());
		});
	}
	refresh(){
		if(this.request_data)
			this.rd_run();
		else
			this.open_root_dir();
	}
	show_plain(
		json_list,  // FIRE only for thumb-view; save thumb list to use to show next portion 
		is_id=0) // TODO: is_id=0/1 => json_list may have different formats, so thumb_list also may have diff. form?.. turns out that 'is_id' flag arrives always to show_thumbs_portion (but by params); 
				// the fact that thumb_list is global while 'is_id' local - makes some confusion
	{
		this.thumbs_list = json_list;
		// clear_detail(); commented: can't be here: if have 2 requests at same time - they both clear and then both add
		if(this.detail_view=="thumbs"){
			this.show_thumbs_portion(0, this.page_size, is_id); // FIRE next portion
		}else{
			this.clear_detail();
			this.show_table_portion(); // DETA
		}
	}
	/* PAGE_SIZE*/
	set_page_size(ps){ 
		this.page_size=ps; 
		this.set_def_rec_id(this.get_active_rec().length? this.get_active_rec().data("id") : 0);
		this.show_table_portion();
	} 
	// this function is called by pager and should call all other funcs which page output of files
	show_page(page){ // FIRE CASE TODO: do not get: now pages work only for DETA (not for thumbs)?
		this.clear_detail(false);
		this.show_table_portion((page-1)*this.page_size, false);
	}
	// closes removing (not hiding) child elems
	close_dir_recursive(item){
		var cont = this.get_cont(item);
		cont.children('.tree-cont').remove();
		this.get_elem(cont).prop('indeterminate', false);
		this.ssv_t_up(cont);
	}
	show_panels(){
		if( !this.tree_hidden && this.get_tree_form().find('.tree-cont').length )
			this.get_tree_form().removeClass('hidden');
		if( this.get_thumb_form().html()!="" )
			this.get_thumb_form().removeClass('hidden');
	}
	// hides and clears panels
	hide_panels(hideTree=false){
		// return; TODO: commented this; why it was here?
		if(hideTree){
			this.get_tree_form().addClass('hidden');
			this.get_root_item().html('');
		}
		if(!this.tree_hidden)
			this.get_thumb_form().addClass('hidden');
		this.clear_detail();
	}
	def_search_fields(){
		var params = this.acid("search_fields", {});
		var resp = call_php_sync(this.contr_path, params.data, 'POST'); // returns html 
		return resp.resp_text;
	}



	//--------------------------------------------------------- SUBSECT USER ACTIONS ------------------------------------------------

	// EVENT HANDLERS EXPLORER
	// explorer: dir click
	// e = tree-item; logic of opening a dir: if already was opened - show hidden childs and their thumbs; else - open_dir
	dir_click(e){ // NOTE: input not receives event on name click - it's out of input
		//var dir = $(this);
		var dir = $(e.target); // TEST
		e.preventDefault();
		if(dir[0]==this.get_curr_dir_item()) // DBLOPEN
			this.switch_dir_state( dir , e.ctrlKey, e.shiftKey); // also calls rerender_childs if have already been opend
		else if( this.dir_opened( this.get_cont(dir) ) )
			this.rerender_childs(this.get_cont(dir) ); // need show thumbs; not like at firs open - now find all ids and send to php TODO: it now uses HIDEFILES_CACHE, so maybe may be used even if !dir_opened 
		//
		this.set_curr_dir_item(dir); // CURREL
		if(this.custom_item_click)
			this.custom_item_click(0,this.get_data(dir, "path"));
	}

	file_click(e){
		var t = this;
		var file = $(e.target); // TEST
		e.preventDefault();
		var file_id = t.get_data(file, 'id');
		t.set_curr_item(file);  // added it 20.03.23; found out that while dir_click calls set_curr_dir_item, for the file it not happens; so to have active item need this; or better TODO: find item dinamically by .active class and need add arrow handling for tree
		if(t.custom_item_click)
			t.custom_item_click(file_id);
		else
			t.show_details(file_id);
	}

	//--------------------------------------------------------- SEARCH ------------------------------------------------
	
	search_init(search_fields_html){
		if(!search_fields_html){
			this.get_quick_search_form().remove();
			return;
		}
		var t = this;
		// SEARCH
		t.get_search_form().prepend(search_fields_html);
		ff_init(t.get_search_form(), function(){t.find_files_click()} , false); // false means do not search on select/date change 
		this.main_form.find('.tt_search_btn').click( function(){t.find_files_click()} );
		this.main_form.find('.tt_search_clear_btn').on('click',function(){ 	ff_clear( t.get_search_form() );})
		this.main_form.find('.tt_show_search_btn').on('click', function(){t.show_search_panel()}); // TODO: should be visible only if quick search hidden
		this.main_form.find('.tt_search_close_btn').on('click', function(){t.hide_search_panel()}); // note: wrap in func to avoid pass event obj as param 
		this.main_form.find('.tt_search_cancel_btn').on('click',function(){ t.cancel_search(t.get_search_form()) })
		// LBSP
		ff_init(t.get_quick_search_form(), function(){ t.find_files_quick_click(); } , false); // false means do not search on select/date change 
		t.main_form.find(".lbsp_search_btn").click( function(){ t.find_files_quick_click(); } );
		t.main_form.find(".lbsp_cancel_btn").click( function(){t.cancel_search(t.get_quick_search_form())} );
		t.main_form.find(".lbsp_expand").click( function(){ t.show_search_panel(); } );
	}
	  // RECSUR TODO 1 where is .tt_find_recursive?
	find_files_click(){ this.find_files_by_form(	this.get_search_form(), this.main_form.find(".tt_find_recursive").prop("checked") ); }
	find_files_quick_click(){ this.find_files_by_form(this.get_quick_search_form()); }
	// 	find files action
	find_files_by_form(form, recursive_search=false){
		if(ff_empty( form ) ){
			this.show_alert(lp("no_filter_cond"));
			return false;
		}
		var params = ff_params(form);
		this.reset_table_tree(); // new, not checked
		if(recursive_search){ // ex-start_recursive_search()
			var where = this.compile_search(params);
			this.open_root_dir(where);
		}else
			this.find_files(params);
	}
	// TODO 1: this actually can't be called by btn click during search, while during search there is a wait screen (should realize eg esc btn)
	cancel_search(form){
		if(this.xhr && this.xhr.readyState!=4)
			this.xhr.abort(); // TODO: at the moment it may be empty
		ff_clear( form );
		this.open_root_dir();
	}

	row_order_click(header){
		this.ro_set(this.ro_extract(header)); // FIORD
		// TODO: refresh...
		this.rd_run();
	}

	is_opened_closed(cont){ 
		var cache = cont.children('.ttc_file_cache').length > 0;   // use this while ttc_folder_opened is not yet finished (not works for find)  HIDEFILES_CACHE; if PFCA - this suffies
		var hidden = cont.children('.tree-cont:hidden').length > 0; // note: when emtpy dirs possible (in MH) may be opened without files-chiles; need add some class to opened dir - ttc_folder_opened; TODO: seems this was used before intro of ttc_folder_opened, now not necessary
		return !this.get_item(cont).hasClass("ttc_folder_opened") && (cache || hidden);
	}
	// explorer: open or just reshow depending on if have already been once opened (and now is just hidden)
	// NOTE: cont may be absent; it happens when called from on_row_focus and the root dir is requested which is not present in tree explorer
	open_reopen(path, cont){
		if(!cont.length){ // eg may happen when open '..' dir wichi si root dir and not present in tree
			this.open_root_dir();
		}else if(this.is_opened_closed(cont) ){  // opened&closed
			this.rerender_childs(cont); // reshows plain and refreshes php cache
		}else // not ever opened
			this.open_dir(this.get_data(cont, "path"), cont);
	}

	// dir - explorer element
	switch_dir_state(dir, ctrl, shift){
		var path = this.get_data(dir, 'path');
		var level = this.get_data(dir, 'level');
		var cont = this.get_cont(dir);
		var opened = this.dir_opened(cont);
		// special reaction if ctrl pressed - open/close recursively
		if(ctrl){
			if(opened) this.close_dir_recursive( dir );
			else        this.open_dir_recursive( dir );
			return;
		}
		// normal open/close
		if(opened){
			this.close_cont(cont);
			this.hide_panels(false); // hide only thumbs panel
		}else{ // not ever opened or opened/closed
			this.open_reopen(path, cont);
		}
		// DEF SAVEOPEN need a way to say if a folder is opened independently on if it has some childs; reason: in MS diplaying files (=mails) in explorer may be turned off, so the old way "child.count>0" not works
		// TODO: now it's realized only for simple user click case; need also: recursive open; find-, find+ ...
		dir.toggleClass("ttc_folder_opened");
		dir.addClass("ttc_folder_once_opened"); // indicates if was opened at least once (and thus contains already info about childs) TODO: not used now; to use it need also set it true when showing already opened folders (show_tree)
	}

	// SS
	//--------------------------------------------------------- SUBSECT SEL_SYNC --------------------------------------------------------
	// sync selection tree -> detail
	// NOTE: need call it even if selection was made by detail (clickable -> on_row_select -> sync to explorer -> sync to detail (again) ); 
		// this is necessary because explorer may have made cascade selections (if eg thumb is clicked and whole dir gets selected - need set "." folder to fully selected state ecc)
	// TODO: guess need realize it also for thumbs while they also are shown in portions
	// elem: explorer item; is passed from folder onchange - need deselect files of this folder if it gets unchecked (may be other details selected not of this folder)
	// NOTE: seems need call it only when tree shown; if not: if table-view - guess no need to select other page rows; so maybe in thumb view: yet need select newly shown thumbs
		// on "show more" if '.' dir is selected, so in this case just set sel to '.' sel
	// NOTE: if tree show, what is in detail may be find result, so may contain many different folders, so this func is needed
	// NOTE: now used only when show a portion of thumbs/rows; for thumbs it syncs not only t->d but actually td->d while  thumb panel may have already contained some selected folders (new portion is appended to them and may represent some sub-files)
	ssh_td_all(elem=null){
		//if(this.tree_hidden) return; // added 16.06.22; this func duplicates and breaks the work of make_clickable
		var detail_class = "."+this.get_detail_class();
		// X new 28.01.20 ; need first deselect all, or else sync not works on deselect sms in tree
		this.get_thumb_form().find(detail_class + ".selected").removeClass("selected"); // DEAL
		//
		var sel = this.find_selection(); // retrieves sel files as from tree as from si_
		this.get_thumb_form().find(detail_class).each(function(){
			var path = $(this).data("path");
			var id = $(this).data("id").toString();
			if( id && id!="0" && sel.files.includes(id) )
				$(this).addClass("selected");
			else
				for(var i=0;i<sel.paths.length;i++)
					if( path.startsWith( sel.paths[i] ) )
						$(this).addClass("selected");
		});
	}
	// used when the tree contains recursively (completely) opened branch and need select list of ids
	select_ids(ids){
		var t = this;
		if(ids.length)
			this.get_tree_form().find(".tree-cont.mc_file").each( function(){
				var c = $(this);
				if( ids.includes( String(c.data("id")) ) ){
					t.get_elem(c).prop("checked", true);
					t.ssv_t_up(c);
				}
			});
	}

	// selection logic: if some elem is unselected - all chain of its parents is unselected
	// NOTE: when no files shown and the target is a file - can't pass target tree-elem (path?), instead find and pass the parent folder (parent_cont)
	// this func is called when the target elem has already been updated and it's necessary to update sel state of childs/parents
	// this func is called only if tree_hidden = false (because uses update_parent_selection which relies upon tree); but maybe show_files = false 
	// TODO: when called from open_dir - no need to exec if dir sel=false;
	// TODO: when called from open_dir - no need to do ssh
	// ------------------ NOTE: if detail=table - the row must contain data-path (modify field def in metadata) -------------------
	ssv_t(elem){
		var path = this.get_data(elem, "path");
		var id = this.get_data(elem, "id");
		var selected = elem.prop('checked');
		var is_dir = this.is_dir(elem);
		// update childs
		var cont = this.get_path_cont(path); // note that if is_dir - this is the parent, if file - elem itself
		var parent_cont = is_dir? this.get_parent(cont) : cont;
		// cascade down: set childs of a dir in same state 
		if(is_dir) 
			this.ssv_t_down(cont, selected );
		// cascade up: update stalk;   some old NOTE: moved it after sel cache, parent sel should be updated after sel cache is set
		this.ssv_t_up(parent_cont, false);		
	}
	// set all childs of given cont to given state
	// ex-set_childs_selected TODO: check usage
	ssv_t_down(cont, selected){
		var t = this;
		cont.find('.tree-elem').each(function( index ) { // this selects checkbox of the container and its childs
			if(index!=0){ // this is to avoid changing state of the parent-cont itself, which may be undesirable (in open_dir_recursive)
				t.set_elem_sel($(this), selected);
				//$(this).trigger("change"); // onchange isn't envoked when state changed by js, so call it here; commented while onchange is for single elem click; besides not always necessary
			}
		});
	}
	// 

	// used only if tree_hidden = false while uses tree struct
	// find_parent false allows to update selection of passed elem (not of parent); used (maybe temp) in on_row_select
		// ex-update_parent_selection TODO: check usage 
	ssv_t_up(cont, find_parent=true){
		if(!cont) return; // used by on_row_select
		var t = this;
		// if( cont.hasClass("incomplete") ) return; // INC parents remain always unselected (only may select manually)    DEF INC_CORR - correction: instead of keep folders 'incomplete' always de-selected - do not add them at all (in find_selection); when a folder selected - all files in it will be selected (and added); thus have same logic as in 'search minus' and other similar; thus can't select whole folder (including files not satisf. cond), which yet may be necessary. for this - need use 'search plus' mode
		var par = find_parent? this.get_parent(cont) : cont;
		if(!par || !par.length) return;
		// var re = $('#tt_explore_root_item');	if(!par.length)	if(cont[0]==re[0]) // top level reached	return;	else	par = re; thought it would resolve the SEL_ANIMALS, but nope (it's updating of the parent not item itself (no need to update root container))
		// A: check selection state of all immediate childs (files/folders)
		// NOTE: with SELECTION this is used only to check dirs; TODO: when SELECTION tested - need remove checking files from here (use .tree-cont.tree-dir seems)
		var all_sel = true;
		var all_desel = true;
		par.children('.tree-cont').each( function(){
			var elem = t.get_elem( $(this) );
			//commented 5.4.23; there is no "C" now.. and elem has changed its state...           if(t.is_dir(elem)) // 10.01.20; found out that counting files here makes bug: tree elem hasn't yet changed its state, so disinforms; besides, files are counted in "C"
			{
				var sel = elem.prop('checked')
				var ind = elem.prop('indeterminate')
				all_sel = all_sel && sel && !ind; // here actually ind === false
				all_desel = all_desel && !sel && !ind;
			}
		} );
		// if files are hidden - need compare list of all files with filese selected in detail
		if(!t.show_files){
			var cache_files = [];
			this.get_file_cache_arr(par, cache_files); // all files
			var sel_files = this.find_selection();
			all_sel = all_sel && sel_files.files.length==cache_files.length;
			all_desel = all_desel && sel_files.files.length==0;
		}
		// old comments:
		// C NEW: need also count selected recs (when HIDEFILES) 1. find all selected 2. filter those of curr fold (by idea table shows only active folder)
		// NOTE: by idea this func is called only when 'par' is already opened, thus has file cache
		// NOTE: used only to check immediate files (not folders); TODO: may instead check all selection files of path/* - in this case do not need check dir selection state ( A ).. but thus will need to find path/* childs for each path elem (slow)

		// set found selection and recurse to parent
		var par_elem = this.get_elem(par);
		this.set_elem_sel(par_elem, all_sel, !all_sel && !all_desel);
		// go up
		this.ssv_t_up( par );
	}

	ssh_dt(selected, id, path){
		var det = this.get_detail(id, path);
		if(!this.tree_hidden && (this.is_dir(det) || this.show_files) ){ // if expl hidden - no need to sync; if shown - only if elem present in expl
			var item = this.is_dir(det)? this.get_elem(this.get_path_cont(path)) : this.get_id_elem(id); // path not contains name
			if(item.length){
				//this.set_elem_sel(item, elem.hasClass("selected") );
				this.set_elem_sel(item, selected );
				this.ssv_t_down(item);
			}
		}
		// NOTE: not call ssv_t directly because there may be no corresp item in tree (if files hidden); in such case down sync not called, up sync called on parent
		if(path && !this.tree_hidden)
			this.ssv_t_up(this.get_path_cont(this.get_parent_path(det)), false); // need this even if no hor sync happened; ef files are hidden but yet need update parent dir
	}	
	ssh_td(item){
		var path = this.get_data(item, "path");
		var elem = this.is_dir(item)? this.get_path_detail(this.get_data(item, "path")) : this.get_id_detail(this.get_data(item, "id"));
		if(elem.length){
			var selected = item.prop('checked');
			if(selected) elem.addClass("selected"); else elem.removeClass("selected");
			this.ssv_d(selected, this.get_data(elem, "id"), this.get_data(elem, "path") );
		}
	}
	ssv_d(selected, id, path){
		var t = this;
		var is_dir = !id || id=="0";
		var elem = is_dir? t.get_path_detail(path) : t.get_id_detail(id);
		var detail_class = "."+this.get_detail_class();
		var sel = this.find_selection();
		// 1 UP find parent folder and refresh its sel state; folder is sel if all its folders and files sel
		// NOTE: if either elem was desel before or is desel now, so anyway it's parent can't be selected
		if(!elem.hasClass("mc_root")){ // any file/dir may have parent folder except '.'
			var parent_path = this.get_parent_path(elem);
			var parent = this.find_path_thumb(parent_path); // NOTE: detail contains only one level items, so this can be only "." elem
			if(parent.length){
				var unsel_dirs = t.find_path_thumbs(parent_path).not(".selected");
				var all_sel = unsel_dirs.length==0;
				if(all_sel){
					var sel = t.find_selection();
					var all_childs = [];
					t.get_file_cache_arr(parent, all_childs);
					all_sel = sel.files.length==all_childs.length;
					//all_sel = arrayIncludes(sel.files, all_childs.files);
				}
				if(all_sel) parent.addClass("selected");
				else parent.removeClass("selected");
			}
		}
		// 2 DOWN if dir - set its childs to same state
		if(t.is_dir(elem)){
			t.find_path_thumbs(path).each(function(){
				var child = $(this);
				if(selected) child.addClass("selected");
				else child.removeClass("selected");
				t.ssh_dt(selected, t.get_data(child, "id"), t.get_data(child, "path"));
			});
		}
	}

	// TODO1 next: manage table cb sel all and sel range

	// callbacks passed to clickable table
	// make_clickable does basic work, these callbacs perform sync with explorer (maybe call client callbacks)
	// on checkbox select in detail
	// TODO: change name to more general eg on_detail_select
	on_row_select(selected, id, path){
		this.ssv_d(selected, id, path);
		this.ssh_dt(selected, id, path);
		// 27.07.22 ; found out that on_select not called when select thumb	
		if( this.on_select ) 
			this.on_select( this.find_selection() );
	}

	// on focus: by mouse click or by arrove move
	// TODO: change name to more general eg on_detail_focus
	on_row_focus(elem){
		var path = elem.data("path");
		var cont = this.get_path_cont( path );
		if( this.is_dir(elem) ){
			if(!this.tree_hidden)  // 17.10; found bug DEF TREH: open_reopen() tries to ind tree elem with given path
				this.open_reopen(path, cont);
			else
				this.open_dir(path, cont);
			this.set_curr_dir(path);  // B open_dir(path, cont); replaced with A ; 
		}else{
			var id = elem.data("id");
			if(this.list_view_on || this.show_details_on_focus)
				this.show_details(id, false);
			this.set_curr_item(elem);
		}
		if(cont.length) // DEF HIDETREE in space version explorer not shown ; need forsee situations when it not exists
			this.scroll_top_if_hidden(elem[0]);
	}

	// when check box in explorer selected
	on_select_item(e){ // on_item_click on_click_item
		e.stopPropagation();
		var item = $(e.target);
		this.ssv_t( item ); // TODO: use better get target?
		this.ssh_td( item );
		if( this.on_select ) // client callback; now used only for SELIN NOTE
			this.on_select( this.find_selection() );
	}

	// NOTE on_row_enter not realized

	//--------------------------------------------------------- SUBSECT SERVER DATA REQUESTS  ------------------------------------------------------------------------
	// ODI
	open_dir(path, cont){ // TODO: by idea cont.data("path") = path, so no need to pass it
		this.rd_set( {type:"open",path:path,cont:cont} ) ; // DEF SARE Save Request used for FIORD; save data of request to re-run when user requests change show order
		this.clear_alert();
		this.clear_detail();
		// not works this._path = path; this._cont = cont; // DEF ACCP a ajax concurr call problem: happens confusion of variables
		//this.hide_panels(false);  // _HP 18.01.23 donno what was for
		wait_screen.add_operation("open_dir");
		var t = this;
		this.xhr = $.ajax(this.acid("open_dir", {
			data: {'path': path, 'cond' : this.table_where, 'use_paths': this.use_paths, 'shm_table_num': this.shm_table_num},  // table_where is for RECSUR
			async: false,
			success: function(res){
				if( res.length>2 ){ // empty json may be """"
					// show child elems 
					t.set_curr_dir(path); // need it in case when first dir is opened on init (no dir was clicked)
					t.render_childs('show_dir', path, res, cont, false, function(){
						// 20.11.18 select newly opened folders if parent was selected; this also selects thumbs OD1
						if(  /* 17.10.222 TREH*/ !t.tree_hidden  &&  path!="" && t.get_elem(cont).prop("checked") )
							t.ssv_t_down( cont, true ); // here not need yet set thumb state - they are not yet shown  OD2
							// TODO: OD1 controverses OD2? 
					});
				}
			},
			complete: function(xhr, stat){
				t.main_form.find(".tt_thumbs_header").removeClass("hidden"); // TODO: quickfix because of _HP no header visible if no data received
				wait_screen.remove_operation("open_dir");
				// show_panels();  TODO: wrong place for this: show_childs/thumbs only fire ajax which will be called asyncr.
			},
			//error: search_error,  commented 13.04.20 - if open empty ws - shows error; this is rather for empty search 
			global: false
		}))
	}
	open_dir_recursive(item){
		this.rd_set( {type:"open_rec",item:item} ) ; // SARE 
		var path = this.get_data(item, "path");
		var cont = this.get_cont(item);
		var elem = this.get_elem(cont);
		var checked = elem.length? elem.prop('checked') : false;
		this.clear_alert();
		this.hide_panels(false); 
		wait_screen.add_operation("open_dir");
		var t = this;
		this.xhr = $.ajax(this.acid("open_dir_recursive", {
			data: {'path': path, "cond" : this.table_where},   // table_where is for RECSUR
			success: function(res){
				t.render_childs('show_tree', path, res, cont, false, function(){t.ssv_t_down(cont, checked );}); // show_tree selects items by default, need deselect them
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("open_dir");
			},
			error: function(j,errorS,p){} // TODO: send 400 on empty res and catch it here
		}))
	}
	open_path(path){
		this.rd_set( {type:"open_path",path:path} ) ; // SARE 
		var cont = this.get_root_item();
		this.clear_alert();
		this.hide_panels(false); 
		wait_screen.add_operation("open_dir");
		var t = this;
		this.xhr = $.ajax(this.acid("open_path", {
			data: {'path': path.substr(this.root_dir.length), "cond" : this.table_where, root: this.root_dir},   // table_where is for RECSUR
			success: function(res){
				t.render_childs('show_tree', path, res, cont, false); // show_tree selects items by default, need deselect them
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("open_dir");
			},
			error: function(j,errorS,p){} // TODO: send 400 on empty res and catch it here
		}))
	}
	// RECSUR sets table_where; input = array of params (in format of search form); normally controller receives data in raw format (from form) and compiles, but sometimes compiled format is also necessary here (or rather always) 
	// TODO: in fact it's called anyway if called find_files_click, so could call it from there, the only exception is that find_files may fail (in this case need table_where still = ''); but may unset where in search_error()
	// TODO: the 'compile_search' action in contr uses the standard get_filter_fields() func, so can't be used to compile any search
	compile_search(params){
		var params_compiled_json = call_php_sync(this.contr_path, {'action' : 'compile_search', 'table' : this.alias, 'params' : JSON.stringify(params), 'project' : this.project_name}, 'POST');
		return JSON.parse(params_compiled_json.resp_text);
	}
	// performs search of files (calls php) according to filter form
	find_files(params){
		var t = this;
		this.rd_set( {type:"find",params:params} ) ; // SARE 
	// params - conditions from search form (not yet compiled, that is without info from metadata)
		this.set_where(); // cancel possible prev recursive search RECSUR
		this.clear_alert();
		this.hide_panels(true);
		wait_screen.add_operation("search");
		this.xhr = $.ajax(this.acid("find", {
			data: {'params' : JSON.stringify(params) , 'max_count': 7000, 'shm_table_num': this.shm_table_num},
			success: function(res){
				t.set_where( t.compile_search(params) ); // new 12.03 this is only used when finding statistics   DEF FIND_COND save find params in table_where to use them on folder opers like stats, size (now may select also folders in find res)
				// show tree 
				t.get_root_item().html('');
				var renderer = $("#tt_full_view").prop("checked")? "show_tree_complete" : "show_tree"; // tt_full_view - button "+" (search plus)   TODO 1: tt_full_view not use here, from arch?
				t.render_childs(renderer, "", res, t.get_root_item(), true, null, true);
				// 8.1.23: found out that this call is duplicate, called also from render_childs; t.show_plain(res); // show thumbs
			},
			error: this.search_error,
			complete: function(xhr, stat){
				wait_screen.remove_operation("search");
			}
		}))
	}

	//--------------------------------------------------------- SUBSECT SERVER VIEW REQUESTS ------------------------------------------------------------------------
	//INITIAL VIEW REQUEST (show as tree and call other (plain) views (table/thumbs) ---------------------------------------------------------------------------------

	// shows files; input: files list in json format (found previously by open_dir or find_files); output: result html is added to the cont
	// TODO: donno why, wait screen show is made only by search_started (not show_started), so need call former before calling render_childs; or need show screen also in show_started (better)
	// INC DEF : when files are res of search - that means that a folder childs are (may be) incomplete - exist other, not displayed files of this folder; when a file is deselected and the selected and it's the only file in its folder - the parent folder is set selected by update_parent_selection); that causes wrong selection result: folder is sent as selected and all files in it are included; possible solutions: 1. disable parent selection in 'find mode' or 2: not send at all paths in 'find mode'; may happen that user may want to select the whole folder on purpose, meaning that needs all files from it, thus the (2) not fits, so use (1); Realization: find_files passes further info that folders may be incomplete and the 'incomplete' class is added to files and accounted for in update_parent_selection(). 
	found_count = 0; // FIND_COUNT found in render_childs but used in show_thumbs_portion (while takes much time between these calls and info already fades); TODO: need some better way to sync
	// renderer = show_dir/show_tree/show_tree_complete
	render_childs(renderer, path, json_list, cont, close_selected=true, call_back=null, incomplete=false){ // renderer - is the name of contr/main function which should process json list
		// TODO 1: how is checks tree_hidden
		wait_screen.add_operation("show_tree");
		var t = this;
		this.xhr_render = $.ajax(this.acid(renderer, {
			data: {'path' : path, 'childs' : json_list}, // TODO: was used encodeURI... which not works  TODO: path seems not used; but now use it as "start_path" for the open_dir_recursive (contr/main show_tree/show_tree_id)
			async: false,
			success: function(res){
				cont.children('.tree-cont').remove(); // this may be useful when re-request SARE
				cont.append(res);
				t.add_data.run(cont);
				t.found_count = cont.find(".tree-item-file").length; // FIND_COUNT remember count
				if(incomplete) $(".tree-cont").addClass("incomplete");  // INC
				$('.indeterminate').prop("indeterminate", true); // NEW to show half-selected state
				// new 21.09.18 after showing a sub-tree may be convenient not to display contents fully selected nodes; note: can't just call it after render_childs call, the latter is async
				if(close_selected)
					cont.find('.tree-dir:checked').each( function(){  t.close_cont(get_cont( $(this) ) ) ;	});
				// HIS Hidable Instrument Panel // this event indicates that need close nagiv panel (this happens only on successfull search)
				$(".tt_hide_on_render").addClass("hidden"); // TODO: what is this
				// now used only to select child files in open_dir
				if( call_back ) call_back(); // call it before show_plain, while latter makes selection synch
				if(t.on_show_tree) t.on_show_tree(cont);
				// new: show thumbs is here now; othewise selection synch not works (starts when files not yet shown) TODO: bug: before, it wasn't called for case: renderer=show_tree_id - here need call show_plain(list, true)
				var is_id = renderer=="show_tree_id" || renderer=="show_tree_complete_id"? 1 : 0; // show_plain need to know what is in list - full info or ids TODO: temp solution
				t.show_plain(json_list, is_id);
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("show_tree");
				t.show_panels();
			}

		}))
	}

	// FIRE need two separate funcs: one which resets fire, other - which proceeds STP
	show_thumbs_portion(from, cnt, is_id=0){ // can pass list of paths of ids (id=true) TODO 1: changed id -> is_id; seems it's not used now at all; if used change data name to is_id
		wait_screen.add_operation("show_thumbs");
		var t = this;
		var rd = this.rd_get();
		var path = "path" in rd? rd["path"] : ""; // THUMB_UP need pass the opened path (is null in find)	
		this.xhr = $.ajax(this.acid("show_thumbs", {
			data: {'childs': this.thumbs_list, 'id': is_id, "start" : from, "max_count" : cnt, "path" : path}, // TODO with server cache no need of thumbs_list, id
			success: function(res, bla, request){
				t.set_active_section(".tt_thumbs_form"); // TOGSCT
				if(from==0) t.clear_detail();
				t.get_thumb_sect().append(res)
				t.ssh_td_all(); // select recs/thumbs depending on selected folders
				t.show_panels();
				// FIRE
				var remain = request.getResponseHeader("remain"), mtd = t.main_form.find('.tt_more_thumbs_div');
				if(remain) mtd.removeClass("hidden"); else mtd.addClass("hidden");
				if(remain)
					t.main_form.find('.tt_more_thumbs').data("from", from+cnt).data("count", cnt).data("id", is_id);
				// hide '..' if it's over top dir
				var level_up = t.get_thumb_sect().find(".mc_level_up");
				if( level_up.length && level_up.data("path").length < t.root_dir.length)  // new 21.06.22; restrict shown level
					level_up.remove();
				if(this.list_view_on)
					list_view();
				if(t.on_show_plain)
					t.on_show_plain();
			},
			complete: function(xhr, stat){
				wait_screen.remove_operation("show_thumbs");
				// TODO 1: show_info needs #tt_info_div
				if(t.found_count>t.page_size) show_info(lpp("$found_n_files$", t.found_count)); t.found_count=0; // FIND_COUNT TODO: uses a function of archive.js ; need inject some function instead
			}
		}))
	}
	// DEF LIST_VIEW ; enable show thumbs as list; the solution is js-side; modify thumbs to look like list; problem is that conversion thumb-list keeps selection/active where as list-thumb needs refresh
	list_view(){
		this.get_thumb_sect().addClass("mc_list_view");
		this.get_thumb_sect().css("display", "flex");
		this.get_thumb_sect().css("flex-direction", "column");
		this.get_thumb_sect().css("flex-wrap", "wrap");
		//this.get_thumb_sect().css("align-items", "baseline");
		this.main_form.find(".thumb").each( function(){
			$(this).css("display", "flex");
			$(this).css("border-width", "0px");
			$(this).css("margin", "0px 5px 5px 5px");
			$(this).find(".RES_checked").css("position", "unset"); // -relative
			$(this).find(".RES_checked").css("margin-right", "5px"); // -relative
			$(this).find(".mc_thumb_image").remove();
			// avoid that item occupies whole width
			// thus all have different width $(this).css("max-width", "max-content"); $(this).css("padding-right", "30px"); // because download btn not belongs to content but needs space
			$(this).css("max-width", "370px");
		} );
	}
	thumb_view(){
		this.get_thumb_sect().removeClass("mc_list_view");
		this.get_thumb_sect().css("display", "block");
		this.rd_run();
	}

	more_thumbs_click(){var mt = this.main_form.find('.tt_more_thumbs'); this.show_thumbs_portion(mt.data("from"), mt.data("count"), mt.data("id"));} 
	// DETA show details as table STP
	show_table_portion(start = 0, first_time=true){ 
		wait_screen.add_operation("show_table");
		var t = this;
		var page_num = 1;
		var def_rec_id = t.def_rec_id; t.def_rec_id=0; 
		// DEF_PAGE ; if need find a rec - need know the page
		if(t.def_rec_id){ // DEF RER refind rec
			var pos = call_php_sync(t.contr_path, {"action" : "get_rec_pos", "id": t.def_rec_id, "table": t.table_tree}).resp_text;   
			page_num = Math.trunc(pos/t.page_size) + 1;
			start = (page_num-1)*t.page_size;
		}
		this.xhr = $.ajax(this.acid("show_details_table", {
			data: {"start" : start, "max_count" : this.page_size, "visible_columns" : JSON.stringify(this.tabcol.get_visible_columns())},
			success: function(res, bla, request){
				if(res){
					t.get_thumb_sect().html(res); // DEF MTS: move table to th.s. to allow to show also th.header //$(res).insertAfter(t.get_before_detail());
					t.set_active_section(".tt_thumbs_form"); // TOGSCT
					t.get_thumb_form().find(".fh-header tr").addClass("mc_section_header"); // height/color
					t.show_panels();
					//cbsr_class(t.main_form, "td-" + t.alias + "-RES_checked", "th-" + t.alias + "-RES_checked"); // call before make_clickable
					cbsr_class(t.main_form, "td-" + t.alias + "-RES_checked", "th-" + t.alias + "-RES_checked"); // call before make_clickable
					if(def_rec_id)
						set_active( t.find_rec( def_rec_id ) , function(elem){	t.on_row_focus(elem) });
					// FIXHEAD necessary only for DETA need call it after show_panels()
					t.ro_show_order(t.get_thumb_form(), "tt_detail", t.files_order);
					t.get_thumb_form().find(".td-tt_detail-date_mod").each( function(){ $(this).html( shrink_date( $(this).html() ) );  }  );
					// make_clickable( on_row_select, on_row_focus);  // SEL_SYNC  commented 26.02; now should work that call in init()
					if(t.on_show_plain)
						t.on_show_plain(); // 22/11/19 add user callback; used to show attachment image
					fh_init_table( t.get_thumb_form() );
					t.get_thumb_form().find(".fh-header").addClass("tt_demo_hidden"); // DEHO
					t.ssh_td_all(); // select recs/thumbs depending on selected folders
				}
				if(first_time){
					var count = request.getResponseHeader("count"); // total count; server returns only portion
					t.clear_pager();
					var max = Math.trunc( parseInt(count)/t.page_size + 0.99999);
					//if(max>1) commented while need pager even if only single page - to change page size (TODO: maybe disable navigate btns in pager)
					{ // if need pager
						t.pager = create_counter("tt_pager_"+t.name, function(p){ t.show_page(p); }, page_num, max, 1, function(ps){t.set_page_size(ps);}); 
						t.pager.addClass(".ttc_pager");
						t.get_thumb_form().append( t.pager ); 
						t.pager.find(".uc_ps").val(t.page_size);
					}
				}
			},
			complete: function(xhr, stat){ // TODO: guess need move some stuff to 'success:'
				wait_screen.remove_operation("show_table"); 
			}
		}))
	}

	show_details(file_id, modal=true){
		if(this.client_show_details_func){
			this.client_show_details_func(file_id);
			return;
		}
		var t = this;
		//window.open(table_tree_path + 'show_file_details.php?id='+file_id + t, "File details"); // here better use files table (default) (not some view)
		//document.getElementById('tt_preview_body').src = table_tree_path + 'show_file_details.php?id='+file_id; // show in same tab but in another frame
		if(modal){
			var content = $("<div style='max-width:500px;max-height:500px;'></div>");
			var url = call_php_sync(this.contr_path, {"action" : "get_thumb_url", id: file_id, thumb_medium_path: this.thumb_medium_path, table: this.table_tree}, 'POST').resp_text;
			var img = create_boxed_image(url, 500, 500);
			$(img).removeClass("ap_detail_elem");
			content.append(img);
			show_select_string(null, '', content, name); // TODO: works only if on the page is present md_ss html
			
		}else{
			this.main_form.find(".tt_preview_form").removeClass("hidden");
			this.get_preview_div().html( call_php_sync(this.contr_path, {"action": "print_preview", "id": file_id, "table": this.table_tree, "thumb_medium_path": this.thumb_medium_path}).resp_text) ;
			this.main_form.find(".tt_preview_close").click( function(){ t.main_form.find(".tt_preview_form").addClass("hidden") } );
		}
	}

	//--------------------------------------------------- ESECT OPEN / FIND ----------------------------------------------------------------------------------

	//--------------------------------------------------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------- SECT SELECTION  -------------------------------------------------------------------------------
	//--------------------------------------------------------------------------------------------------------------------------------------------------------------

	//--------------------------------------------------------- SUBSECT SEL_CACHE ---------------------------------------------------------------------
	/* DEF SEL_CACHE SI_ 31.12.19 ; problems at the moment:
		- if folder in explorer selected and show next page - files of next page not selected (in detail);
		- page selection not saved (if show next page)
	  to resolve that - need add selection cache; need save selection independently on shown items (page) ; 
	  also convenient to save folder content in cache (or else need re-query... or use selection cache?
	  NOTE: if a file is present in detail - that means exists its immediate parent folder in explorer (but if explorer hidden? - exists anyway?)
	  NOTE: selection may be changed by both explorer and thumbs; probably in both cases that should affect first the si cache and then update both (or only the other)
	  NOTE: why not use two cache arrays - paths and ids; eg if path is selected and then one file de-selected - in this case anyway need request all path ids and then remove that deselected
	  	yet here is a problem: sometimes need to know if a path is completely selected, so TODO 1: DEF CSP maybe also save in si completely selected paths (si_path_list); also use this in si_get_selection
		CSP maybe may save traffic if there are folders with huge num of files (in arch they are millions);
		but a complex situation: eg there is a tree of folders and top dir is sel and then some file is desel: means instead of one sel dir there will be maybe many sel subdir, and many indeterminate subdir; it prob should be managed to explorer
	*/
	si_list_all = {}; // same struct as si_list; cache of all ids (not only selected); need to detect if dir completely selected (in situation when an id added to selection)

	//--------------------------------------------------------- SUBSECT SELECTION BASIC ---------------------------------------------------------------------

	// returns lists of selected files folders {paths:, files:} ; performs also exclusion of selected sub-paths
	// as source, uses the tree and also si_list
	// TODO 1: seems no SEL_CACHE used only on select in detail; need use also when select in explorer, so that could rely only on SEL_CACHE to find selection
	// TODO: need use si_find_all instead?
	find_selection(include_active=false){
		var t = this;
		// get what is selected in explorer
		var sel_paths = [], sel_files = [];
		this.get_tree_form().find(".tree-dir:checked").each( function(index){ sel_paths.push( t.get_data($(this), 'path')); }) // TODO: DEF PTI Path To Id - use path_id instead of path;
		this.get_tree_form().find(".tree-file:checked").each( function(index){sel_files.push( t.get_data($(this),   'id')); }) // 
		// stuff from detail
		this.get_thumb_form().find(".selected."+this.get_detail_class()).each(function(){
			var elem = $(this);
			if(t.is_dir(elem) && !sel_paths.includes( elem.data("path") ) ) sel_paths.push( elem.data("path") );
			if(!t.is_dir(elem) && !sel_files.includes( elem.data("id") ) ) sel_files.push( elem.data("id") );
		})
		// TODO: is it necessary to exclude duplicate (paths which belongs to other paths) paths?
		if(include_active && !sel_paths.length && !sel_files.length && t.get_active_detail().length)
			sel_files = [t.get_active_detail().data("id")];
		//	
		return {"paths": sel_paths, "files": sel_files};
	}

	// TODO: not used
	select_all(state=1){ // this would be much easier if having always root element TODO:
		this.get_thumb_form().find(".thumb").not(".mc_root").each(function(){
			var elem = $(this);
			if(state) elem.addClass("selected"); else elem.removeClass("selected");
			on_row_select(state, elem.data("id"), elem.data("path"));
		});
	}

	// HIDEFILES_CACHE for the given folder (cont) finds its files saved in cache (cache is a hidden html elem stored in tree, returned by php)
	// NOTE: seems this mechanism replaced simple 'show hidden elems' because files may be hidden HIDEFILES (not shown in tree), while the detail may show only part of them (a page)
	// ouputs to the output param 'files'; return res = 'some files present' TODO 1: now used only in update_parent_selection and should be replaced with si_ 
	// TODO: recursive not used
	get_file_cache_arr(cont, files, recursive=false){ // NOTE: designed to be used for find_opened_childs, so files is the output param
		var file_cache =  cont.children(".ttc_file_cache");
		if(file_cache.length){ // NOTE: can't just concat - it returns new array; TODO: actually useless conversion, need pass string to server
			var nf = file_cache.html().split(",");
			for(var i=0;i<nf.length;i++)
				if(nf[i]!="")
					files.push(parseInt(nf[i]));
		}
		if(recursive){
			var childs = cont.find(".tree-item-dir");
			for(i=0;i<childs.length;i++)
				this.get_file_cache_arr( childs[i], files, recursive);
		}
		return files.length>0;
	}
	// find childs of already opened dir; if recursive - returns childs of all branch (not only immediate)
	// TODO: PIT paths are passed itself (not ids) while do not know if can have id in all cases
	find_opened_childs(cont, folders, files, recursive=false){ // DIRTHUMB: added folders
		var t = this;
		var files_hidden = t.get_file_cache_arr(cont, files); // NEW: get files from cache ( when HIDEFILES, files are not present (hidden) in the folder, just store them in cache  HIDEFILES_CACHE;
		cont.children('.tree-cont').each( function(a,b){ 
			var child_cont = $(this);
			if( !t.is_dir(t.get_elem(child_cont)) ){ // item is file  // TODO: may add here && not file_cache.length
				if(!files_hidden) //  !PFCA
					files.push(child_cont.data('id')); 
			}else{ // item is dir
				folders.push(child_cont.data('path')); 
				if (recursive)
					t.find_opened_childs(child_cont, folders, files, recursive);
			}
		} )
	}
	// show thumbs of an opened&closed folder (not shows tree items)
	// TODO: here also must select what show - thumbs/table NOTE: 27.04.20 seems it not shows thumbs, only refreshes cache, so TODO: rename to on_select_opened
	rerender_childs(cont){
		// re-show tree items TODO: actualy do not need it when dir is already open
		cont.children('.tree-cont').removeClass('hidden'); // show childs in explorer (need only .tree-cont of next level)
		// reshow plain
		this.rd_set( {type:"open",path:cont.data("path"),cont:cont} ) ; // if open folder by unhiding data - anyway need set request data DEF BACK_UP: if click thumb-folder to go level up - r.d. contains invalid data, so need save it
		var folders = [];
		var files = [];
		this.find_opened_childs(cont, folders, files, false);
		var json_list = JSON.stringify({"folders": folders, "files": files});
		// DEF CACHE_REFRESH: normally, if user requests some data (open/find) happens following: 
		// 1. data request to server (data saved in cache) 2. view request to server (data taken from session cache and view is built); (2) may be done several times (eg for different views); 
		// thus server cache represents "current data" to be shown; but may happen that dir is changed without (1) (so php not sets the cache)
		// it happens when user re-opens folder and data is taken from local cache; in this case need first force update server cache
		var t = this;
		t.xhr = $.ajax(t.acid("update_open_cache", { // update the server open_result data
			data: {'childs' : json_list}, 
			success: function(res){
				t.show_plain( json_list, 1 ); // DIRTHUMB added folders
			}
		}))
		// TODO: need call ssh_td()?
	}


	//--------------------------------------------------- ESECT SELECTION  -------------------------------------------------------------------------------

	// 3.1.23 stuff moved from space.js
    // TODO: repeated from ms index.php
	// move selected files (NOTE: selected dirs not counted now)
    move_files(dir_name){
		var t = this;
        //if(!dir_name) { alert(lp("no_dir_sel"));return;} commented for SEL_FOL_ROOT
        var files = t.find_selection().files;
        if( !files.length) {alert (lp("no_file_sel")); return;}
        if(!confirm(lpp("$move$ $1 $files$ $to_folder$ '$2'?", files.length, dir_name))) 
            return;
        t.xhr = $.ajax({
            type: "POST",
            data: {'action' : 'move_files', 'folder' : dir_name, 'files' : JSON.stringify(files), "user_dir": t.get_user_dir(), "table": t.table_files, use_paths: t.use_paths}, 
            url: 'contr/main.php',
            success: function(res){
                alert(lp("files_moved"));
                t.open_root_dir(); 
        }}) 
    }   

    move_folder(path_old, path_new){
		var t = this;
        if(!confirm(lpp("$move$ '$1' $to$ '$2'?", t.unroot(path_old), t.unroot(path_new))))
            return;
        t.xhr = $.ajax({
            type: "POST",
            data: {'action' : 'move_folder', 'path_old' : JSON.stringify(path_old), 'path_new' : JSON.stringify(path_new), "user_dir": t.get_user_dir(), "table": t.table_files, use_paths: t.use_paths}, 
            url: 'contr/main.php',
            success: function(res){
                alert(lp("folder_moved"));
                t.open_root_dir(); // TODO: seems need use rd_run() instead
        }}) 
    }   

	//--------------------------------------------------- DOWNLOAD -------------------------------------------------------------------------------
	// depends on: dlpro, spinner;  utils: download_file, load_file
	make_download_req(paths, files){ return {'paths': JSON.stringify(paths), 'files': JSON.stringify(files), "user_dir": "", "table": this.table_tree, "files_path": this.files_path}; } // TODO: what's the user_dir? from tt? - then use get_user_dir; maybe not used at all in 'space'

	_download_selection(data){
		var xhr;
		var dp = dlpro_create( function(){xhr.abort()}, lp("creating_zip") );
		var t = this;
		//var spinner = new Spinner(); spinner.spin($(dp).find(".ttc_alert_msg"));
		this.xhr = $.ajax(this.acid("cdr1", { 
			data: {data: JSON.stringify(data)}, // CDR 1. save paths in session, get data id
			success: function(res){
				download_file(t.table_tree_path + "download_zip.php?cdr1=" + res); // CDR 2. download by data id ; TODO: or pass the path of table_tree or move download_zip to contr and use this.contr_path
			},
			"complete": function(){
				dlpro_done(dp);
				spinner.stop();
			}
		}))
	}

	download_selection(){
		var sel = this.find_selection(true);
		if(!sel.files.length && !sel.paths.length){
			alert(lp("no_file_sel"));
			return;
		}
		// DEF DOBO DOwnload By One, to avoid create zip
		if(sel.files.length>1 && !confirm(lpp("$download$ $as_single_zip$?")))
			for(var i = 0; i<sel.files.length; i++)
				this._download_selection( this.make_download_req([], [sel.files[i]] ) );
		else
			this._download_selection( this.make_download_req(sel.paths, sel.files) );
	}
	download_all(){
		load_file("contr/download.php?type=" + this.table_tree + "_zip"); // TODO: additional stuff like: &id="+get_camp_id()     is to be deduced from root_dir of add possibility to add custom data to acid
	}
	//

	
	


	// --------------------------------------------------------------------------------------------------------------------------------------------------
	//--------------------------------------------------- SECT INIT -------------------------------------------------------------------------------
	// --------------------------------------------------------------------------------------------------------------------------------------------------

	// TODO: passing search fields here is now useless, while need same fields both in 'build form request' and in 'find' request; see get_filter_fields in contr/main.php; thus at the moment need change get_filter_fields in contr/<project.php>
	//init_table_tree(
	constructor(
			project_name, 
			holder_sel, 
			table_tree,
			type = "details",  //   [thumbs,details] 
			search_fields_html=null, // pass null to use def_search_fields(), "" to not use search
			ac=null
		){ // sets handlers
		this.project_name = project_name;
		this.name = project_name; // NOTE: may happen that in an app there are two instances using same project name (but they need unique names); in this case should call set_name(some_unique_name)
		this.table_tree = table_tree;
		this.alias = table_tree;
		this.table_files = table_tree; // change by set_table_files if diff from table_tree
		this.detail_view = type;
		this.main_form = $(holder_sel);
		var t = this;

		// html
		var resp = call_php_sync(t.contr_path, {'action' : 'render'}, 'POST'); 
		$(holder_sel).html(resp.resp_text);
		// in table-view, the header area contains row table header; the .tt_thumbs_header initially was empty
		// or contained only .musd buttons if explorer was hidden
		// in cm this area contains lbsp, so can't hide it; therefore probably for tree view will need two stripes
		if(t.detail_view=="thumbs"){
			// this.main_form.find(".tt_thumbs_header").removeClass("hidden"); 21.12.22 now always shown
			this.get_thumb_sect().removeClass("hidden"); // TODO 1: and if detail(table)? where are recs shown?
		}
		if(t.detail_view=="detail"){
			this.main_form.find(".lbsp_crud").removeClass("hidden");
		}
		make_clickable( 
			function(sel,id,path){ t.on_row_select(sel,id,path) },  // on select
			function(elem){	t.on_row_focus(elem) }, // on active
			holder_sel + " .tt_thumbs_form", // cont sel
			"."+t.get_detail_class() // elem sel
			/// .... on enter
		);  // SEL_SYNC
		his_init(); // call manually while here html is added by js and may be added before automatic call (when yet no elems added)

		this.search_init(search_fields_html===null? this.def_search_fields() : search_fields_html);

		// TIPS TODO 1: check what is it and if need 
		//$("#sf_path").data("tip", "path_filter"); // TODO: not works! (js works) this only sets data-tip=..
		var sfp = document.getElementById("sf_path");
		if(sfp) sfp.dataset.tip = "path_filter";
		set_tips();

		/// click of the link Esplora cartelle
		this.main_form.find('.tt_explore_btn').on('click', function(){t.open_root_dir()}); // note: wrap in func to avoid pass event obj as param 
		//
		// open/close item
		this.get_tree_form().on('click','.tree-item-dir',function(e){t.dir_click(e);} );   // DEF DBLOPEN  first click on a dir (not yet current) only selects it; second - switches state; thus dbl click on non current element switches its state
		// logic of selecting
		this.get_tree_form().on('click','.tree-elem', function(e){t.on_select_item(e)}); // TODO: better onchange?
		// SHOW DETAILS 
		this.get_tree_form().on('click','.tree-item-file',function(e){t.file_click(e);} );
		// TODO: not used in archive
		this.get_tree_form().on('click', '.download', function(e){
			e.stopPropagation(); // avoid call of tree-item handler
			//$.post(table_tree_path + 'contr/download.php', {'path': get_data($(this), 'path')})
		})

		//
		// thumb of file under cursor  IMG_HINT 
		this.get_tree_form().on('mouseenter','.tree-item-file',function(e){
			var thumb = call_php_sync(t.contr_path, {'action': 'file_thumb', 'id': t.get_data( $(this), 'id'), 'quiet':1} );
			img_hint_show(thumb.resp_text, e.pageX, e.pageY, ".tt_file_popup" );
		});
		this.get_tree_form().on('mouseleave','.tree-item-file',function(e){
			img_hint_hide();
		});

		/* DEF TODO BUG DOUBLE_SEL don'tunderstand why sel logic is both here in tt and in make_clickable (called from here) */
		// DEF SELALL - stuff to select all recs (checkbox in header) TODO: make same for thumbs?
		cbsr_click(this.main_form, this.alias); // CB_SEL_REC - select all // TODO1: check that on_row_select is called

		this.main_form.find(".tt_more_thumbs").click( function(){ t.more_thumbs_click() } );
		this.main_form.find(".tc_download_current").click( function(){ t.download_file()} );

		// hide instrument panel 
		//$("#tt_explore_btn").on("click", function(){ hide_id('tt_left_header'); });  // HIS Hidable Instrument Panel
		//$("#tt_search_btn").on("click", function(){ hide_id('tt_left_header'); });  // HIS
		// this not works, focus is on some inner elems instead // $("#tt_left_header").focusout(function(){ hide_id('tt_left_header'); });  document.getElementById('tt_left_header').focus(); // HIS

		//spinner = new Spinner(); moved to wait_screen TODO 1: wait_screen is in ext file
		 
		//PUMA  this is necessary to show popup (now is done by ctrl-left click); if use - need also add checks opened/closed 
		t.popup_div = create_popup_div("tt_popup_div_"+name); // id is only necessary to add css
		init_popup(t.popup_div, "mc_file"			, function(tr,p){t.set_pu_items(tr,p)}, false, holder_sel);
		init_popup(t.popup_div, "mc_dir"			, function(tr,p){t.set_pu_items(tr,p)}, false, holder_sel); // SELREC
		init_popup(t.popup_div, "ttc_emb_pm_detail"	, function(tr,p){t.set_pu_items(tr,p)}, true , holder_sel); // in MOMO pm is called on special icon click (embedded popup menu fro detail) 
		t.add_popup_item(lp("close_all_folders"), function(item){t.close_dir_recursive(item)}, false, true, false, "mc_tree_only");
		t.add_popup_item(lp("open_all_folders"), function(item){t.open_dir_recursive(item)}, false, true, false, "mc_tree_only");
		t.add_popup_item(lp("search_folder"), function(item){t.show_folder_search(item)}, false, true); // FILTERPATH add button
		
		// RECSUR clear search condition when toggle button unpressed  TODO 1: selector not in html prob used only for archive
		this.main_form.find(".tt_find_recursive").on("change", function(){ 
			if(!$(this).prop("checked")) t.set_where();
		});
		// allow unset both radio buttons
		//add_untoggle( $("#tt_search_modes") );  TODO 1: not in html
		// FIORD sorting by table header click
		this.get_thumb_form().on("click", ".mc_row_order", function(){t.row_order_click($(this))});
		// TABCOL
		t.tabcol_init(ac);
		// TOGSCT buttons < >
		this.main_form.find(".mc_togsect").each( function(){
			var b = $(this); 
			var ts = b.data("ts");
			b.click( function(){ t.set_active_section(ts); }	);
		} );
		// ARROW_MOVE  TODO 1: isn't it duplication of mc_focused in archive.js
		this.main_form.find(".mc_tt_section").on("click", "*", function(){
			var section = $(this).closest(".mc_tt_section");
			$(this).removeClass("mc_focused"); section.addClass("mc_focused");
		}); // need manually track which section is  focused

		t.main_form.find(".tt_toggle_detail").click( function(){ t.get_thumb_form().find(".fh-header").toggleClass('tt_demo_hidden'); } );
		//
		this.add_data = {
			// called each time a result is added to the tree; param = parent element;
			// selects not processed file/dir items - <li> elements which contain visual data; calles user defined handlers; marks elements as processed;
			// then does same thing for folders
			run : function(parent_cont){
				parent_cont.find('.tree-item').each(function(index){
					var elem = $(this);
					var processed = elem.data('processed');
					if( typeof processed == 'undefined' || processed == false){ // not yet processed ~ attr 'processed' not yet exists 
						if( elem.hasClass('tree-item-file') )
							t.add_data.process_file( elem );
						if( elem.hasClass('tree-item-dir') )
							t.add_data.process_dir( elem );
						t.set_data(parent_cont, 'processed', true);
					}
				});
			},
			// THIS IS THE PART THAT USER MUST REDEFINE if necessary to add some additional visual data to html (or somehow process each added file/dir)
			// to get some data use get_data: 
			process_file: function(file){return true},
			process_dir : function(dir ){return true}
		}
		// LIST_VIEW
		if(type=="thumbs"){
			t.main_form.find(".mc_sal").click( function(){t.list_view(); t.list_view_on = true; t.main_form.find(".mc_sal").addClass("hidden"); t.main_form.find(".mc_sat").removeClass("hidden");t.hide_preview();} );
			t.main_form.find(".mc_sat").click( function(){t.thumb_view();t.list_view_on = false;t.main_form.find(".mc_sat").addClass("hidden"); t.main_form.find(".mc_sal").removeClass("hidden");t.hide_preview();} );
		}else{
			t.main_form.find(".mc_sal").addClass("hidden");
		}
		t.get_thumb_form().on("dblclick", ".mc_file,.data-row", function(){  t.show_details( $(this).data("id"), true ) } );
	}
}
//--------------------------------------------------- ESECT INIT -------------------------------------------------------------------------------

