<?php
	
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."utils/db_mysql.php");

	def_ifndef('field_list_brief', 'id, name, path, online');
	def_ifndef('field_list_basic', 'id, name, date_mod, path, online, thumb_small, thumb_medium, pool_code, processed');  // 29.07.20 added pool_code while in ic need indicate state=online or backuped(~pool code <>'')  ; 24.08.20: processed used in show_thumbs
	def_ifndef('paths_field_list_basic', 'id, path');  // DEF MSM modifications made for mailstore but incompatible with archive version
	$data_fields = array("name","path","id","online");  // list of fields that need be added as data-name to the html code; must be within field_list_basic!!!
	
	// 
	$table_tree = "table_tree"; // to allow using different tables - this global is set once and used in all functions; usually it's set by the controller
	$table_files = "files"; // while table_tree may represent some subset of files (depends on html page), sometimes need refere the table containing all recs 

	function table_is_files(){global $table_tree, $table_files; return $table_tree==$table_files;}	

	function get_basic_file_info($ids, $fields=field_list_basic, $order="path"){ // maybe rename to get_file_info
		if(!sizeof($ids))return array();
		global $table_files;
		return db\select_to_array($table_files, $fields, "id in(".implode(',', $ids).")", $order);
	}
	// at the moment it's just a format conversion, used in refresh_cache; maybe will add adding other path info
	function get_basic_path_info($paths){
		$arr = array();
		foreach($paths as $p) $arr[]= array("path" => $p, "id" => 0);
		return $arr;
	}
	function get_open_dir_info_path_list($ids){ // used once for shm
		if(!sizeof($ids)) return array();
		return  db\select_to_array("paths", paths_field_list_basic, "id in (".implode(",", $ids).")", "path");
	}
	// input: where condition
	// output: brief fields/full fields

	function find_files($where, $order){
		global $table_tree;
		db\select($table_tree, field_list_basic, $where , $order);  // NOTE without path sort explode_tree/explode_tree_id not works
		// build result
		return db\response_to_array();
	}

	// version which AGAIN uses 'name' field and works MUCH FASTER
	function open_dir($parentDir, $cond='', $order='', $what="files;folders"){ // normal version which doesn't handle repeated names in a folder
		global $table_tree;
		// list of child files and folders of parentDir; now contains both files and folders - but not same named files in a folder 
		/*$used_table = $cond? $table_tree : "files_um";   // TODO: pass normally files_um - "simple table"; actually better use paths table; 
		$open = db\open_dir_db1($parentDir, $table_tree, $used_table, field_list_basic, $cond, $order, $what);;;; commented - it was a quickfix for MS */
		$open = db\open_dir_db1($parentDir, $table_tree, $table_tree, field_list_basic, $cond, $order, $what);
		$folders = array();
		foreach($open["folders"] as $folder)
			$folders[] = array('id' => 0, 'path' => $parentDir.$folder['child']."/", 'name' => $folder['child']);  
		$open["folders"] = $folders;
		return $open;
	}
	// version of open_dir with uses paths table NOTE: here is used ANOTHER STRUCT of PATHS table: instead of hierarchycal struct id, folder_name is used plain struct id, full_path 
	// tables: the view $table_tree contains data of files+paths, table $table_tree._paths - paths, $table_tree._files - files
	function open_dir_pv($parentDir, $cond='', $order='', $what="files;folders"){ // normal version which doesn't handle repeated names in a folder
		global $table_tree;
		if(!is_array($cond)) $cond = [$cond];
		$open = array();
		// folders
		$folders = array();
		if( strpos($what, "folders")!==false){
			$open_folders = db\open_dir_db1($parentDir, $table_tree."_paths", $table_tree."_paths", "", "", "path", "folders"); // needn't fileld list; no cond (logically cond can't contain restriction to path, it's in $parentDir); order by path; request only folders
			foreach($open_folders["folders"] as $folder)
				$folders[] = array('id' => 0, 'path' => $parentDir.$folder['child']."/", 'name' => $folder['child']);  
		}
		$open["folders"] = $folders;
		// files
		$files = array();
		if( strpos($what, "files")!==false){
			$pde = db\escape($parentDir);
			if($path_id = db\select_field($table_tree."_paths", "id", "path = '$pde'")){ // may happen it not exists; eg exists a/b/c/ but not exists a/ (no files in a/); yet need be able to expore to abc: a->ab->abc
				//$files = db\select_to_array($table_tree, field_list_basic, array($cond, "path_id = $path_id"), $order); // not optimal, uses view
				$fields = join(",", array_diff(preg_split("/[\s,]/", field_list_basic, -1, PREG_SPLIT_NO_EMPTY), ["path"]) ).", '$pde' path"; // NOTE: or may append path here in php
				$files = db\select_to_array($table_tree."_files", $fields, array_add($cond, "path_id = $path_id"), $order);
			}
		}
		$open["files"] = $files;
		return $open;
	}
	// adds additional path info; in/out param = arr(files=>, folders=>) (res of open_dir)
	// NOTE TODO: NEW not checked; should be used instead of open_dir_paths_new like this: $res = open_dir(); add_path_info($res);
	function add_path_info(&$ff){
		$paths = array_column($ff["folders"], "path");
		array_walk($paths, function(&$elem,$key){ $elem = "'".db\escape($elem)."'"; } );
		$paths_info = db\select("paths", paths_field_list_basic, "path in (".join(",", $paths).")", "path");
		array_walk($paths_info, function(&$elem,$key){ $elem["id"] = 0; } ); // id=0 means 'is folder'; yet using this way to distinguish file/folder  // PATH/NAME  is only here (not cutting last elem here)
		$ff["folders"] = $paths_info;
	}

	function where_paths_files(&$paths, &$files){
		$where = array();
		foreach($paths as $path)
			$where[] = "path like '".db\escape($path)."%'";
		if( count( $files ) > 0 )
			$where[] = "id in (".join(',', $files).")";
		//return "$cond and (".join(" or ", $where).")"; // commented while instead of passing cond - use a special view
		return join(" or ", $where);
	}

	// called when user selects files/folders to find out stats about all files matching the selection
	// if group_field defined - the result will be array of stats for each group elem (used to group by tapes)
	function stat_paths_files(&$paths, &$files, $group_field='',$cond=""){ // RECSUR 29.01.19 added $cond; in 'normal' search res contains all files (files are selected, folders - not); while here user will select folders; so need pass additionally the search condition used
		global $table_tree;
		$where = where_paths_files($paths, $files);
		if( empty($where) ) return array("size" => 0,"count" => 0);
		$fields = 'sum(size) as size, count(*) as count';
		if($group_field!='') $fields .= ",$group_field";
		if($cond) $where = "($where) AND ($cond)"; // RECSUR
		db\select($table_tree, $fields, $where, "", $group_field);
		if($group_field=='') // return only the first (single rec)
			return db\fetch();
		else 
			return db\response_to_array();
	}

	// similar to stat_path_files but finds properly files (not stats)
	function find_paths_files(&$paths, &$files, $group_field='',$cond=""){
		global $table_tree;
		$where = where_paths_files($paths, $files);
		$fields = $group_field==''? field_list_brief : field_list_brief.",$group_field";
		if($cond) $where = "($where) AND ($cond)"; // RECSUR
		db\select($table_tree, $fields, $where, "path");
		return db\response_to_array();
	}

	// returns assoc array: path => immediate files ids  for each path that belongs to given $path ; res = arr(path => arr(ids));
	function find_path_ids($path, $cond=""){
		global $table_tree;
		$where = "path LIKE '" . db\escape($path) . "%'";
		if($cond) $where = "($where) AND ($cond)"; 
		db\select($table_tree, "path,id", $where);
		$res = array();
		while($rec = db\fetch()){
			$path = $rec["path"];
			if( isset( $res[ $path ] ) )
				$res[ $path ][] = $rec["id"];
			else
				$res[ $path ] = array($rec["id"]);
		}
		return $res;
	}

	// purpose:
	// user requested to find files, the result - is some subset of files; it's necessary to show the result in tree structrue, but so that all files/folders are shown, while only matching are selected
	// rules: to show the result need start opening folders beginning from the root folder (as if exploring normally whole (not filtered) file system
	// only folders that contain some matching files are opened (or its subfolders contain)
	// matching file are shown as selected; if whole folder matches - it's not opened but shown not-opened and selected
	// algorithm:
	// the recursive fun scans parallel-ly tree struct of whole file sysem and tree struct of matching files branch (being always on same folder) (begins from root folder)
	// it opens the curr folder (of whole fs) and set selected those which are present in filtered fs
	// then recursion goes to process matching folders
	// $branch and $tree - are the current (identical one to other) nodes of original branch and its complete
	// a node is in et format (explode_tree, see utils.php)
	// as initial $tree pass et_folder("")
	// TODO: check empty (folders) is yet a problem; possible outcomes: maybe it will be always false (if choose client side processing of empties) or use cphp; for now optimized a bit by setting it to false when table_tree=files
	function complete_tree(&$files_info, &$tree, &$branch){
		// find all childs of current path
		$childs_all = open_dir($branch["path"], $cond="", $order="path"); // all childs of current branch node (but in open_dir format yet)  TODO: maybe use shm here, while when need check 'path not empty' it's a long story	
		// use info from open_dir; it's not used here, just returned to the caller
		$files_info = merge_maps($files_info, $childs_all); // TODO: with new struct of et can store all info in et
		// iterate child folders; first, need add this elem (converting to et format); secondly need find out if an elem of childs_all is in branch
		foreach($childs_all['folders'] as $elem){ // $elem - is rec in format returned by open_dir
			$tree['folders'][] = et_folder( $elem['path'], $elem["name"], $elem['id'] ); // insert this child; TODO: this is format of explode_tree (less info but with structure) TODO: but id=0 for paths? what is it for?
			$tree_child = &last_of( $tree['folders'] ) ; // ref to current child (elem in $tree['folders'], inserted in prev line)
			$branch_child = &find_array_key_value($branch['folders'], 'path', $elem['path'] ); // ref to correspoinding elem in source branch; is null if not present; also could use name instead path
			$tree_child['selected'] = $branch_child? 2 : 0; // if elem is present in source branch - is selected, otherwise - not; later selected (2) may be changed to indeterminate (1)
			if( !$branch_child ) // if at least one child is not present in branch - that means branch is only half selected
				$tree['selected'] = 1; // make parent (=current) node half-selected
			else{	// this child is in branch - so need open it
				complete_tree($files_info, $tree_child, $branch_child); // open recursively current elem (it's always one that is in branch)
				if($tree_child['selected']==1)
					$tree['selected']=1; // even if branch contains all tree elems - it gots indeterminate if some elem is indeterminate
			}
		}
		// iterate files in similar way
		foreach($childs_all['files'] as $elem){
			$tree['files'][] = et_file( $elem['path'], $elem['name'],  $elem['id'] ); // insert child
			$tree_child = &last_of( $tree['files'] ) ;
			$branch_child = find_array_key_value($branch['files'], 'id', $elem['id'] );
			$tree_child['selected'] = $branch_child? 2 : 0;
			if( !$branch_child ) 
				$tree['selected'] = 1; // half-selected
		}
	}		
	// set selection as: files selected, folders - not;  NOTE: shouldn't select folders, while here is normally search result, so that not all files of folders are shown (selecting all folder would mean including extra files)
	function set_files_selected(&$root_folder){ // et_folder format
		foreach($root_folder['folders'] as &$elem){
			set_files_selected($elem);
			$elem['selected'] = 0;
		}
		foreach($root_folder['files'] as &$elem){ // $elem - is rec in format returned by open_dir
			$elem['selected'] = 2;
		}
	}		
	// extracts plain list of all paths (list elem = paths_field_list_basic) used in the branch TODO: added to solve found bug, maybe should find some other way
	// input: et_folder 
	function extract_paths_info_from_et(&$branch){
		$res = array();
		if($path=$branch['path'])
			$res[] = db\select_record("paths", paths_field_list_basic, "path = '".db\escape($path)."'");
		foreach($branch['folders'] as &$elem)
			$res = array_merge($res, extract_paths_info_from_et($elem));
		return $res;
	}		
	// DEF DEF_TH_DB  ; not to store def thumbs in 'files' table as before, but take them dynamically from 'file_types' table; that allows to change def thumbs without need to update files.thumb_small/medium
	// TODO 4: not used yet, but seems to be usefull; need just add file_type to field_list_basic and uncomment line in show_thumbs.php
	function get_def_thumbs(){
		$types = db\select("file_types", "name, default_thumb");
		$res = array();
		while( db\fetch() )
			$res[ db\get_field("name") ] = db\get_field("default_thumb");
		return $res;
	}


	/// FIND SELECTION  given list of paths, ids - returns list of file-recs
	function tt_find_selection($start_dir, $paths, $files, $fields="id,path", $order=""){
		if(!sizeof($paths) && !sizeof($files))
			return array();
		$where = array();
		foreach($paths as $path)
			$where[] = "path like '".db\escape2($start_dir.$path)."%'";
		$pc = $start_dir? " and path like '".db\escape2($start_dir)."%'" : ""; // condition which ensures that all files are under start_dir (for security and also used in download_zip)
		if( count( $files ) > 0 )
		$where[] = "(id in (".join(',', $files).") $pc)";
		$where = join(" or ", $where);
		global $table_tree;
		return db\select_to_array($table_tree, $fields, $where, $order); // order used in download_zip
	}
	
	// SHARE
	// to be re-written in share
	if(!function_exists("user_dir_allowed")){
		function user_dir_allowed(){return true;}
	}
	if(!function_exists("get_def_user_dir")){
		function get_def_user_dir($user_id){ return ""; }
	}

	//
	function get_path_id($table, $path, $insert_if_not_exists=true){
		$pe = db\escape($path);
		aes($pe);
		if($id = db\select_field($table, "id", "path='$pe'"))
			return $id;
		else if(!$insert_if_not_exists)
			return null;
		db\execute("insert into $table(path) values('$pe')");
		return db\get_last_id();
	}

	/*
	function get_file_path($id){
		global $table_files;
		return db\select_field($table_files, 'path', "id=$id");
	}
	function get_file_basics($id){
		global $table_files;
		db\select($table_files, field_list_basic , "id=$id");
		return db\fetch();
	}
	function get_file_briefs($id){
		global $table_files;
		db\select($table_files, field_list_brief , "id=$id");
		return db\fetch();
	}

	// nice but not quite correct version while not handles repeating files
	function complete_tree_unique(&$check_state, &$files_info, $branch, $branch_path=''){
		//echo "+++$branch_path---";
		$childs_all = open_dir_paths_unique($branch_path); // TODO: now open_dir_paths_unique wants end-slash (PATH/NAME)	
		$files_info = array_merge($files_info, $childs_all);
		$bic = array_keys($branch); // branch immediate childs (file names)
		//var_dump($bic);
		$res = array();
		foreach($childs_all as $child){ // $child = array: basic_fields
			$path = $child['path'];
			$name = $child['name'];
			//echo "$name\n";
			$is_file = $child['id'];
			if( in_array( $name, $bic )){
				$check_state[$path] = 2; // 2 means fully selected NOTE: must have it before next (recursive) call of complete_tree or else this will override "1" state
				$res[$name] = $is_file? $path: complete_tree($check_state, $files_info, $branch[$name], $branch_path.$name.'/');
			}
			else{	// some child not in branch; needn't open it
				$check_state[$branch_path] = 1; // 1 means not complete; if branch not contains some child - it's incomplete
				$res[$name] = $is_file? $path : array(); // TODO: thus here empty arrays mean not opened childs; before empty arrays were impossible, so need check how it works
			}
		}
		return $res;
	}


	// a special version of open dir which uses supplementary paths table
	//
	// one problem here - is that paths caches the whole files table, while often instead of 'files' is used some subset of it (as table_tree) - 
	// - as a consequence - some paths may have no files (so must not show them), therefore need make additional check 'if path have some files'
	// could use corresponding subset-path for each subset-files but the situation is compicated by using $cond which may shorten the table_tree yet more, whereas the same $cond may be not applicable to paths (kind of snap_id=<id>)
	// note: $cond was used only for viewing snaps and will not be used anymore for this but maybe will need it for sms else.
	//
	// check_level: for top level folders it may check very long time to check if no empty, so by default folders of 0-1 level are not checked; TODO: this check is too long, so in case when needed - better use open_dir
	function open_dir_paths_unique($parentDir, $cond='', $check_empty = false){
		global $table_tree;
		$result_array = array();
		$and_cond = $cond==''? '': " and $cond";
		// id of the parent dir
		$parent_id = $parentDir==''? 0 : db\select_field('paths', 'id', "path = '".db\escape($parentDir)."'");
		// insert folders
		db\select("paths", paths_field_list_basic, "parent_id=$parent_id", "path");
		while($rec = db\fetch()){
			if($check_empty && !db\exists($table_tree, "path like '".db\escape($rec['path'])."%' $and_cond") ) continue; // if exists at least one file with such path  PATH/NAME
			$result_array[] = correct_path_info($rec);
		}
		// insert files
		if($parent_id>0) // TODO: seems this prevents from selecting files from the root folder; maybe it's possible that there are some
			$result_array = array_merge($result_array, db\select_to_array( $table_tree, field_list_basic, "parent_id=$parent_id $and_cond","path"));
		//
		return $result_array;
	}

	// TODO: this fun is quite obsolete
	function correct_path_info($rec){ 
		$rec['name'] = basename($rec['path']); // TODO: rather ugly; the client should extract name
		if(!isset($rec['id'])) $rec['id'] = 0; // TODO: paths also has id which is also useful; this is just about the old way of distinguishing file from path
		return $rec;
	}

	// version which not uses 'name' field and works much FASTER
	function open_dir($parentDir, $cond=''){ // normal version which doesn't handle repeated names in a folder
		aes($parentDir); // append end slash
		global $table_tree;
		// list of child files and folders of parentDir; now contains both files and folders - but not same named files in a folder 
		db\open_dir_db($parentDir, $table_tree, 'path', $cond); 
		$files_folders = db\response_to_array();
		$folders = array();
		$files = array();
		$ac = $cond? " AND $cond" : ""; // also need apply cond for each sub-path
		foreach($files_folders as $item){
			$path = $parentDir.$item['child']; // need this because escape() takes ref
			$item_files = db\select_to_array($table_tree, field_list_basic, "path = '".db\escape($path)."' $ac", "path"); // if not empty - means item is a file (not just a chunk of some path)
			if($item_files)
				$files = array_merge($files, $item_files); 
			else // TODO may happen that both file and folder with same name exist (then this will be erroneusly omitted); they may no coexist at same time, but table contains all items in history
				//$folders[] = array('name' => $item['child'], 'path' => $parentDir.$item['child'], 'id' => 0, 'archived' => '0'); // no end-slash version
				$folders[] = array('name' => $item['child'], 'path' => $parentDir.$item['child'], 'id' => 0); // no end-slash version TOTEST remove 'archived'; seems it was used only in view/show_dir
		}
		//
		return array("folders" => $folders, "files" => $files);
	}

	// NOTE: removed it 9.01.20; with check_empty=true - it's too slow; otherwise - about same rate
	// now used in show_tree_complete
	// also in controller - but that should be replaced with: all paths are shown and then post-ajax checks are made on folders Ajax Post Empty Check (APEC)
	// guess check_empty is useful only for the SA (Show All, also disabled for selection files); otherwise open_dir 
	// NOTE: new PATH/NAME version 5/11/19
	function open_dir_paths_new($parentDir, $check_empty=false){
		global $table_tree;
		// id of the parent dir
		$parent_id = $parentDir==''? 0 : db\select_field('paths', 'id', "path = '".db\escape($parentDir)."'");
		// insert files
		$files_array = array();
		if($parent_id>0){ // TODO 2: seems this prevents from selecting files from the root folder; maybe it's possible that there are some
			$files_array = db\select_to_array( $table_tree, field_list_basic, "parent_id=$parent_id","path");
			//add_array_key_value($files_array, "file", true); // indicate that those are files  NOT USED while now files/folders are in different arrays
		}
		// insert folders
		$paths_array = array();
		db\select("paths", paths_field_list_basic, "parent_id=$parent_id", "path");
		while($rec = db\fetch()){
			if( $check_empty && !db\exists($table_tree, "path = '".db\escape($rec['path'])."'") ) // if exists at least one file with such path // backup/restore tables are subsets of files
				continue;
			$rec["id"] = 0; // id=0 means 'is folder'; yet using this way to distinguish file/folder  // PATH/NAME  is only here (not cutting last elem here)
			$paths_array[] = $rec;
		}
		//
		return array("folders" => $paths_array, "files" => $files_array);
	}

	// version which uses simpler 'paths' table - without id/parent_id (also 'files' have no 'parent_id')
	function open_dir_paths_simple($parentDir, $order){
		global $table_tree;
		$files_array = db\select_to_array( $table_tree, field_list_basic, "path='$parentDir'", $order);
		$paths_array1 = db\select_to_array("paths", "path", "path like '$parentDir%'", "path"); // find paths: begin with path/  
		$paths_array = array();
		$pl = strlen($parentDir) + 1;
		foreach($paths_array1 as $p){
			$rem = substr($p["path"], $pl); // path remainder
			$elem=parentname($rem);
			log\debug("$p $pl $rem $elem");
			if( !find_array_key_value( $paths_array, "name", $elem ))
				$paths_array[] = array("id"=>0, "path"=>"$parentDir/$elem", "name"=>$elem);
		}
		log\debug(dump($paths_array));
		return array("folders" => $paths_array, "files" => $files_array);
	}

	
	*/

?>
