<?php
	require_once(dirname(__FILE__)."/../path.php");
	require_once(proj_path."model/tape.php"); // get_online_pools  

	// ---------------------------------------------------------------------------
	//		MODEL	
	// ---------------------------------------------------------------------------

	function get_file_types(){
		db\select('file_types','name','clean=1','round(num/10000) desc, name asc');
		return db\response_to_array('name');
	}

	// ---------------------------------------------------------------------------
	//			VIEW
	// ---------------------------------------------------------------------------

	function basic_fields_captions(){
		//return array("id" => "#id", "date_mod" => "data", "subject" => "oggetto"); // FIDE format
		// NOTE: this fields must be in tt/model/db.php field_list_basic
		return array(
			"id" => "#id",
			"date_mod" => "data",
			"name" => "nome"
		); // FIDE format
	}

	// replaces view/show_thumbs/*
	function show_thumbs($files, $thumb_dir, $def_thumbs){
		$online_pools = get_online_pools(); 
		foreach($files as $file){
			$img_path = table_tree_path_rel.'img';
			$id = $file['id'];
			$path_esc = htmlspecialchars( $file['path'], ENT_QUOTES);
			$name_esc = htmlspecialchars( basename($file['path']), ENT_QUOTES);
			$thumb = $file['thumb_small'];
			//if(  !$thumb  ) 	$thumb = get_or_def( $def_thumbs, $file['file_type'], "");  .... //  DEF_TH_DB ups, no file type here
			$online = $file['online'];
			// shorten long paths to aaa...bbb
			//$max_len = 80; $short = $path; if( strlen($short) > $max_len)	$short = substr($path, 0, $max_len/2)."...".substr($path,-$max_len/2); // not use it while do not show full path anymore; instead show it in hint
			// img path: if empty - use def one
			$thumb_full_path = $thumb? table_tree_path_rel.$thumb_dir.$thumb: $img_path."/no_image.png";
			echo '<div data-id="'.$id.'" class="thumb text-center" >';
				echo "<div class='simula_alt'>" . $path_esc . "</div>";
				echo '<div class="contenitore_thumb" style="background-image:url(' . $thumb_full_path . ')" alt="' . $path_esc . '"><img src="' . $thumb_full_path . '" title="'. $path_esc .'" alt="' . $path_esc . '" class="thumb_click mc_thumb_image" ></div>';
				if($online)
					echo "<div class='stato_file online'>ON LINE</div>";
				else
					if(in_array($file['pool_code'], $online_pools))
						echo "<div class='stato_file nearline'>NEAR LINE</div>";
					else
						echo "<div class='stato_file offline'>OFF LINE</div>";
				echo "<div class='nome_file' ><a href='#' title='Visualizza dati files' class='file-ref'>$name_esc</a></div>";
			echo '</div>';
		}
	}

	// replaces view/metadata/*
	function get_filter_fields(){ // when only need compile where - do not need file types // TODO: sometimes (when only build user request) do not need options; in this case no need to read file types; so maybe pass some param here: $req_only=false
		global $table_tree; // from contr
		$file_types = get_file_types();
		$res = array (
			 // NOTE: 'predicative' added 29.11.18 to realize ability to 'and' (instead of usual 'or') the search criterion (for the case when it's an array)
			 array('id' => "sf_path", 	"type" => "text", 	"field" => "path", 	"operation" => "like",	"caption" => 'percorso', 	"string" => 1, 	"class" => "", 	'placeholder' => 'una parte del percorso', 'predicative' => 'and'), 
			 array('id' => "sf_name", 	"type" => "text", 	"field" => "name", 	"operation" => "like",	"caption" => 'nome', 		"string" => 1, 	"class" => "", 	'placeholder' => 'una parte del nome', 	   'predicative' => 'and'),  // PATH/NAME
			 array('id' => "sf_data_from","type" => "date", 	"field" => "date_mod", 	"operation" => ">=", 	"caption" => 'da',		"string" => 1, 	"class" => "ttc_search_datepicker"),
			 array('id' => "sf_data_till","type" => "date", 	"field" => "date_mod", 	"operation" => "<=",	"caption" => 'a',		"string" => 1, 	"class" => "ttc_search_datepicker"),
			 array('id' => "sf_file_type","type" => "select", 	"field" => "file_type",	"operation" => "=",	"caption" => 'tipo file',	"string" => 1, 	"class" => "ttc_search_select", 'options' => $file_types ), // NOTE: 'options' are set dynamically
			 array('id' => "sf_pool", 	"type" => "text", 	"field" => "pool_code", "operation" => "like",	"caption" => 'pool', 	"string" => 1, 		"class" => "", 	'placeholder' => 'pool') 
		);
		if($table_tree=='files_lost'){
			$res[]= array('id' => "sf_lost_from","type" => "date", 	"field" => "date_lost",	"operation" => ">=", 	"caption" => 'perso da', "string" => 1, "class" => "ttc_search_datepicker");
			$res[]= array('id' => "sf_lost_till","type" => "date", 	"field" => "date_lost",	"operation" => "<=", 	"caption" => 'perso a' , "string" => 1, "class" => "ttc_search_datepicker");
			// CHECK_LOST
			$opts = array('controllati', 'non-controllati'); 
			$reps = array(1 => 'controllati', 0 => 'non-controllati'); 
			$res[] = array('id' => "sf_checked",	"type" => "select", 	"field" => "checked",		"operation" => "=",	"caption" => 'controllo',		"string" => 0, "class" => "ttc_search_select", 'options' => $opts, 'replaces' => $reps);
		}
		if($table_tree=="files"){
			$opts = array('online', 'offline');
			$reps = array(1 => 'online', 0 => 'offline'); // the direction is perverted but this is for easier compatibility with 'without reps case'
			$res[] = array('id' => "sf_online",	"type" => "select", 	"field" => "online",		"operation" => "=",	"caption" => 'online',		"string" => 0, "class" => "ttc_search_select", 'options' => $opts, 'replaces' => $reps);
		}
		return $res;
	}
?>
