<?php
/*
	17.11.2017 Alex
	is used structure for folders:
	div
	  li class = 'pft-directory espandi' - onclick expands it, data-path=path (data necessary to expand)
	    input name = 'toRestore[]' class = 'toRestore
	for files:
	div
	  li class = 'file <ext>'
	    input name = filesToRestore[] class = filesToRestore
	    a href='#' data-id=id class='dettagli' (used to show details (both thumbs and tree), so should contain data-id
	
*/
	// TODO 1: move css to css/table_tree.css; class names to same style ttc_<name>
	require_once(dirname(__FILE__)."/../path.php");

	// -----------  COMMON FILES ----------------

	function open_dir_container($child, $is_file=true){
		global $data_fields; // fields that need be added as data-field to html
		$data = '';
		foreach($child as $param => $value)
			if($value!='' && in_array($param, $data_fields) ) // maybe need include also empty... although anyway data('empty') will return emtpy string
				$data .= " data-$param = '".htmlspecialchars($value, ENT_QUOTES)."' ";
		// 1.04.20 NOTE: mc_file mc_dir are used to represent a file/dir elem independently on visual element; now used to show popup menu for any file/folder
		$cl = $is_file? "mc_file" : "mc_dir";
		echo "<div class = '$cl tree-cont' $data>\n"; // TODO 1: ... without this no list indent... how??..
	}
	function close_dir_container(){echo "</div>\n";}
	function show_dir($name, $checked/*, $params=array()*/, $opened=false){ // rest of fields is passed as array in params (to help SHARE)
		$opcl = $opened? "ttc_folder_opened" : "";
		$img_path = table_tree_path_rel.'img';
		$indeterminate = $checked===1?  "indeterminate" : ""; // need this before next statement which overrides $checked
		$checked = $checked && !$indeterminate? "checked" : "";
		echo "<li class='tree-item tree-item-dir $opcl'>";  // pft-directory is from tree_style.css - to display folder icon
			echo "<input type='checkbox' class='tree-elem tree-dir $indeterminate' $checked> &nbsp;".htmlspecialchars($name, ENT_QUOTES); 
				/*  add this by ADD_INFO if( isset($params["archived"]) && $params["archived"] )
			echo "<img class='ttc_img_tape ttc_ii' src='$img_path/tape.png' alt='(archiviato)' title='archiviato'>";  */
			echo "<div class='ttc_add_info' style='display: inline; padding-left: 3px;'></div>";
		echo '</li>';
	}
	function show_file($file_id, $name, $checked){
		$checked = $checked? "checked": "";
		//$img_path = "../img"; // TODO 1: that not works: dirname(__FILE__)."/../img";
		$img_path = table_tree_path_rel.'img';
		$ext = strtolower(pathinfo($name, PATHINFO_EXTENSION));
		echo "<li class='tree-item tree-item-file ext-$ext'>";
			echo "<input type='checkbox' class='tree-elem tree-file id$file_id' $checked>&nbsp;"; // id is used now in synch select of thumbs-tree (otherwise is difficult to select necessary input)
			echo '<a href="#" class="file_ref">'.htmlspecialchars($name, ENT_QUOTES).'</a>&nbsp;';
			echo "<a href='contr/download.php?id=$file_id'>"; // TODO 1: also can pass file status here (online/offline)
			echo "</a>";
			// container (initially empty) which client side may use to add some info (normally via ajax)
			echo "<div class='ttc_add_info' style='display: inline; padding-left: 3px;'></div>";
		echo '</li>';
	}

	// ---------- SHOW PLAIN (open dir) --------------

	function show_childs($childs, $checked=0, $show_files=true){ 
		foreach($childs['folders'] as $folder){	
			open_dir_container($folder, false);
			show_dir(basename($folder['path']), $checked);
			close_dir_container();
		}
		if($show_files)
			foreach($childs['files'] as $file){	
				open_dir_container($file);
				show_file($file['id'], $file['name'], $checked, $file['online']);
				close_dir_container();
			}
		//else commented 10.01.20 ; anyway need file cache in update_parent_selection (although not obligatory)
			print_file_cache($childs["files"]); // DEF PFCA Print File Cache Always? maybe keep it anyway (whether files shown or not); this would allow step-by-step show of files (when too much files)
	}

	// moved to metadata  function print_file_cache($files){ echo "<div style='display: none;' class='ttc_file_cache'>" . join(",", array_column($files, "id") ) . "</div>";} // HIDEFILES_CACHE save file list in a hidden div

	// ------- SHOW TREE (find files) ----------------

	// displays passed tree structure; NOTE: checked: only and all files are checked
	// details: numeric array: elem = assoc array: {path .., id .., ...}
	function show_tree(&$parent_path, &$tree, &$details, $check_state=''){ // $tree and $details represent same set of files; first contains structure, second - details
		foreach($tree as $name => $elem){
			$full_name = $parent_path.$name;
			$full_path = $full_name.'/';
			$is_dir = is_array( $elem );
			$checked = $is_dir? 0: 2;
			if($check_state){
				$p = $is_dir?$full_path:$full_name;
				$checked = isset($check_state[$p])? $check_state[$p] : 0;
			}
			if( $is_dir ){
				open_dir_container(array("path" => $full_path, "name" => $name), false);
				show_dir($name, $checked, $opened=true);
				show_tree($full_path, $elem, $details, $check_state);
				close_dir_container();
				echo "\n";
			}else{
				// get file details// explode tree will return only file names/paths, need a mode to restore full info; instead of going again to db - already have all in $childs
				$file = array();
				foreach($details as $det){
					if($det['path']==$full_name){
						$file = $det;
						break;
					}
				}
				open_dir_container($file);
				show_file($file['id'], $name, $checked, $file['online']);
				close_dir_container();
				echo "\n";
			}
		}
	}
	// this uses new et format
	// $parent path is needed only for a recursive call to know current path; initially it's ""... quite not a nice solution
	/*function show_tree_id(	&$tree, // et_folder
				&$details, // $tree and $details represent same set of files; first contains structure, second - details
				$show_files=true){ // MS - not show files in explorer
		foreach($tree['folders'] as $folder){
			$full_name = $folder['path'];
			$name = basename($full_name);
			open_dir_container(array("path" => $full_name, "name" => $name)); 
			//$full_info = find_array_key_value($details["folders"], 'path', $full_name);
			show_dir($name, get_or_def($folder, 'selected', 0), $opened=true ); 
			show_tree_id($folder, $details, $show_files);
			close_dir_container();
			echo "\n";
		}
		//log\debug("sf in sti: '$show_files'");
		if($show_files)
			foreach($tree['files'] as $file){
				open_dir_container( $full_info = find_array_key_value($details["files"], 'id', $file['id']) ); // when will put all info to et_file - just pass $file
				show_file($file['id'], $file['name'], get_or_def($file, 'selected', 0), $full_info['online']);
				close_dir_container();
				echo "\n";
			}
		else
			//print_file_cache($tree["files"]);
	}*/
	function show_tree_id(	&$tree, // et_folder
				&$details, // $tree and $details represent same set of files; first contains structure, second - details
				$show_files=true, // MS - not show files in explorer
				$show_root=true){ // TODO 3: space, 21.04.20: found a problem that when open_all a folder - also the root is shown (the opened folder); but.. somehow it worked before...
		// print itself
		$full_name = $tree['path'];
		$name = basename(rtrim($full_name, '/'));
		if($show_root){
			open_dir_container(array("path" => $full_name, "name" => $name), false); 
			show_dir($name, get_or_def($tree, 'selected', 0), $opened=true ); 
		}
		// print contents
		foreach($tree['folders'] as $folder)
			show_tree_id($folder, $details, $show_files);
		if($show_files)
			foreach($tree['files'] as $file){
				open_dir_container( $full_info = find_array_key_value($details["files"], 'id', $file['id']) ); // when will put all info to et_file - just pass $file
				show_file($file['id'], $file['name'], get_or_def($file, 'selected', 0), get_or_def($full_info, 'online', 1) );
				close_dir_container();
				echo "\n";
			}
		//else
			print_file_cache($tree["files"]);
		//
		if($show_root)
			close_dir_container();
	}
?>
