<?php
	require_once(dirname(__FILE__)."/log.php");

	function cssc_parse($css){
		$lines = preg_split('/\n/', $css);
		//var_dump($lines);
		// get list of all classes as: name -> [lines]
		$clines = [];
		$clist = [];
		$name = "";
		foreach($lines as $line){
			if(preg_match('/\.(\w+)\{$/', $line, $m) ){ // start of a class
				// may add: if $name - error
				$name = $m[1];
			}else if($name){ // not class start, but already started
				if($line=="}"){ // if was started and finish reached
					$clist[$name] = $clines;
					$name = "";
					$clines = [];
				}else // started, still inside
					$clines[]= $line;
			}
		}
		//var_dump($clist);

		// iterate all definitions and replace references to classes to actual lines
		$res = [];
		$isin = false;
		foreach($lines as $line){
			$line = trim($line);
			if(preg_match('/^[^\{\}]+\{$/', $line) ){ // start of a decl
				$isin = true;
				//log\debug("IN: $line");
			}else if($line=="}")
				$isin = false;
			//
			if($isin && preg_match('/\.(\w+)$/', $line, $m)){ // if inside reference
				$res = array_merge($res, cssc_read_class($m[1], $clist)); // replace with actual lines
			}else 
				$res[] = $line; // just add original line
		}
		return join("\n", $res);
	}

	function cssc_read_class($name, $clist){
		if(!isset($clist[$name])){
			log\error("CSSC error: class not found '$name'");
			return [];
		}
		$res = [];
		$cl = $clist[$name];
		//var_dump($cl);
		foreach($cl as $line){
			if(preg_match('/\.(\w+)$/', $line, $m)) // if nested reference
				$res = array_merge($res, cssc_read_class($m[1], $clist)); // replace with actual lines
			else
				$res[] = $line; // just add original line
		}
		return $res;
	}

?>
