<?php
/*
Exception {
protected string $message ;
protected int $code ;
protected string $file ;
protected int $line ;

public __construct ([ string $message = "" [, int $code = 0 [, Exception $previous = NULL ]]] )
final public string getMessage ( void )
final public Exception getPrevious ( void )
final public mixed getCode ( void )
final public string getFile ( void )
final public int getLine ( void )
final public array getTrace ( void )
final public string getTraceAsString ( void )
public string __toString ( void )
final private void __clone ( void )
}*/

require_once(dirname(__FILE__)."/log.php");

class db_exception extends Exception{}
class undefined_var extends Exception{}

function uncaught_exception_handler($e){
	log\error($e->getMessage(),"  ",$e->getTraceAsString());
	//echo "uncaught exception: {$e->getMessage()}  {$e->getTraceAsString()}\n";
	// TODO: check if mail already initialized and if yes - send it; or rather use alert system
}
// DEF USER_ERROR exceptions which are to be passed (shown) up to user (normal errors)
class user_exception extends Exception{
	protected $user_msg = ''; // code is passed to js and there translated
	protected $gravity = 2; // code is passed to js and there translated
	public function getUserMessage(){return $this->user_msg;}
	public function getGravity(){return $this->gravity;}
	public function __construct($user_msg, $msg="", $gravity=2){
		$this->user_msg = $user_msg;
		$this->gravity = $gravity;
		parent::__construct($msg);
	}
}

set_exception_handler('uncaught_exception_handler');
?>
