
	// FILTER_FIELDS JS; also is used php file

// 	search fields
// check if empty
function ff_empty(form){
	var res = true;
	form.find('.ttc_search_field').each(function(){
	//form.find('input:visible,.select2:visible').each(function() {
		if( $(this).val() ) 
			res = false; // can't use return here - it will exit only each() call
	});
	return res;
}
function ff_params(form, include_empty=false){
	var params = {};
	form.find('.ttc_search_field').each(function(){
		if( $(this).hasClass("ttc_search_checkbox") )
			params[$(this).attr('name')] = this.checked? "1" : "0";
		else if( $(this).hasClass("ttc_search_radio") )
			params[$(this).data('name')] = $(this).find("input:checked").val(); // TODO: not checked
		else if( include_empty || $(this).val()!='' && $(this).val()!=null ) 
			params[$(this).attr('name')] = $(this).val();
	});  
	return params;
}
// sets values to fields TODO: realize for all remaining field types
function ff_set_params(form, params){
	form.find('.ttc_search_field').each( function(){
		var name = $(this).attr("name");
		if( name in params){
			$(this).val(params[name]);
			if( $(this).hasClass("ttc_search_checkbox") )
				this.checked = params[name]=="1";
			if( $(this).hasClass("ttc_search_select")  && $(this).data('select2') )
				//$(this).select2("val", params[name]);
				$(this).select2('data', { id:name, text: params[name] });
		}
	} );
}
var dp_format = 'dd/mm/yyyy'; // format used for datepicker (not db format) NOTE: now it's yet hardcoded while referred in utils/filter_fields ff_add_values() dmy_to_ymd
function add_datepicker(elem){
	if(elem.length)
	elem.datepicker({ 
	    format: dp_format,
	    orientation: "top",
	    language: 'it',
		autoclose: true
	});
}
// DEF CHANGE (dupl def) what is changed in new ver and must be updated when copied to old versions
function ff_init(panel, search_fun=null, search_on_change=true){ // in LB ver is used obj instead of sel
	// filtering
	if(typeof(panel)=="string") panel = $("#"+panel); // old format
	panel.find('.ttc_search_field').keypress( function(e){ 
		if(e.which==13){
			event.preventDefault();
			if(search_fun)
				search_fun();
		}
	} );
	if( panel.find('.ttc_search_select').length )
		panel.find('.ttc_search_select').select2({ 
			placeholder: $(this).data('placeholder'), // same as placeholder='...
			allowClear: true,
			minimumResultsForSearch: -1
			//tags: true
		});
	//$('.ttc_search_select').each( function(){ $(this).select2("val" , ""); } ); //commented 27.01.20 to allow to read def val from db ; ||||| 30.04.20: found bug: 'file type' select in search form has the first option selected; NOTE: when i re-activate this line - it not prevents putting def vals as noted before, so do donno why it was commented; yet, to avoid possible bugs, replaced with following code
	panel.find('.ttc_search_select').each( function(){ 
		var sel = false;
		$(this).find("option").each( function(){ // clear val only if has no option with :selected attr.
			if($(this)[0].hasAttribute("selected"))
				sel = true;
		});
		if(!sel){
			$(this).select2("val" , "");   // TODO: not works
			$(this).val(""); // DEF SNE select not emptied
			$(this).parent().find(".select2-selection__rendered").html("<span class='select2-selection__placeholder'></span>");
		}
	} );
	//$('.ttc_search_field').on('change', search_fun);
	
	// counter init: both html and js are created by a js func from utils
	panel.find('.ttc_search_counter').each( function(){
		var min = $(this).data("min");
		var max = $(this).data("max");
		var id = $(this).data("id");
		var val = $(this).data("default");
		var counter = create_counter(id, search_fun, val, max, min);
		// counter.addClass("col-sm-5"); NOTE: removed it 19/12/19; donno what it was for
		$(counter).find(".uc_value").addClass("ttc_search_field");  // need this class in input for ff_params()
		$(counter).find(".uc_value").attr("name", id); // also for ff_params
		$(this).append(counter);
	});
	//
	add_datepicker( panel.find('.ttc_search_datepicker') );
	// TODO: this part should be called personally for each form, while there may be several forms on same page with different behavior 
	if(search_on_change && search_fun){
		panel.find('.ttc_search_datepicker').datepicker().on('changeDate', search_fun); 
		panel.find('.ttc_search_select').on('change', search_fun); 
		panel.find('.ttc_search_counter').on('change', search_fun); 
		//$('button').on('click', search_fun);  // this is exclusively for counter: buttons change input value but onchange is not invoked automatically, so use this handler instead; commented - now its done on counter create here
	}
		
}
function ff_clear(form){
	form.find("input").val("");
	//form[0].reset();
	form.find(".ttc_search_select").each( function(){ 
		if( $(this).data('select2') )
			$(this).select2("val", "");
		else
			$(this).val("");
	});
	form.find("select").val(""); // in CASS are used select's without ttc_search_select
}
// dynamically selects and option
// TODO: why named add_option? it just selects and option
function ff_add_option(select_id, option_val){
	//$("#"+select_id+" "+"option[value='"+option_val+"']").attr('selected','selected');
	$('#'+select_id).val(option_val);
	$('#'+select_id).select2().trigger('changed');
	// TODO: can use instead $('#'+select_id).val(option_val).trigger('changed');
}
