<?php

	// FILTER_FIELDS PHP; also is used js file

	// this was moved from view/metadata (of archivarius)

	// input: array of field definitions, array of values; output: merged array (definitions+values);
	// field definitions are normally taken from metadata (and passed here in $fields param)
	// TODO: now it's almost trivial (array merge) only need handle that date convert problem
	function ff_add_values($fields, $params){
		if(ff_is_fulltext($params))
			return ff_add_values_dup($fields, $params);
		$where = array();
		foreach($fields as $sf){
			if( checkset( $params, $sf['id'], $value ) || isset($sf['field']) && checkset( $params, $sf['field'], $value ) )  // added 16.01.2022; somehow now table.js passes field names (= input name)
				$where[] = array_merge( $sf, array('value' => ff_correct_value($sf, $value)) ); // $sf contains all necessary params but the value
			if( isset($sf['operation']) && $sf['operation']=="<>" && checkset( $params, $sf['field']."_from", $value) )
				$where[] = array_merge( $sf, array('value' => ff_correct_value($sf, $value), 'operation' => ">=") ); // $sf contains all necessary params but the value
			if( isset($sf['operation']) && $sf['operation']=="<>" && checkset( $params, $sf['field']."_till", $value) )
				$where[] = array_merge( $sf, array('value' => ff_correct_value($sf, $value), 'operation' => "<=") ); // $sf contains all necessary params but the value
		}
		return $where;
	}
	function ff_correct_value($sf, $value){
		if( $sf['type'] == 'date' ) $value = dmy_to_ymd($value); // note if '/' is present php thinks it's a stupid america format d/m/y... fucking pindoses
		if( $sf['type']=='checkbox' && $value=="on") // NOTE: That if FULLTEXT then value = 'some arbitrary string' (maybe avoid op=like for checkboxes)
			$value = "1";
		if( $sf['type']=='checkbox' && $value=="off")
			$value = "0";
		if( checkset( $sf, "explode", $sep) ) // DEF FFEX: ff supports values arrays; if user wants eg to insert a+b pattern to search for 'a or b' - this code makes explosion
			$value = explode($sep, $value);
		return $value;
	}

	// now is internal; similar to ff_add_values, but fills all fields with same value; used for FULLTEXT search
	function ff_add_values_dup($fields, $params){
		$where = array();
		foreach($fields as $sf)
			$where[] = array_merge( $sf, array('operation' => 'like', 'string' => '1', 'value' => /*$sf['type'] == 'dte'? dmy_to_ymd($value) :*/ $params["FULLTEXT"]) ); // $sf contains all necessary params but the value
		return $where;
	}



	// used when ff is used to represent from to ins/edit rec (in this case field name is enough to identificate field); corrects date to ymd
	function correct_date(&$values, $defs){
		foreach($defs as $def)
			if( get_or_def($def, "class")=="ttc_search_datepicker" && isset( $values[ $def["field"] ] ) )
				$values[ $def["field"] ] = dmy_to_ymd( $values[ $def["field"] ] ) ; //  dd/mm/yyyy => yyyy-dd-mm
	}
	// reverse to correct_date
	function ff_format_date(&$values, $defs){
		foreach($defs as $def)
			if( $def["class"]=="ttc_search_datepicker" && isset( $values[ $def["field"] ] ) )
				$values[ $def["field"] ] = date( $dp_format, $values[ $def["field"] ] ) ;
	}
	// NOTE: seems differs from ff_add_values in that $opts are of same struct as $fields, whereas $params are like kv, value (id1->Val1, id2->val2)
	function ff_merge_values(&$fields, $opts){
		if(!$opts) return;
		foreach($fields as &$field)
			foreach($opts as $opt)
				if($field["id"]==$opt["id"])
					foreach($opt as $key => $val)
						$field[$key] = $val;
	}

	function ff_is_fulltext($params){  return  sizeof($params)==1 && isset($params["FULLTEXT"]) ; }
	function ff_get_predicate($params){ return ff_is_fulltext($params)?"OR":"AND"; }


	// TODO: 8.7.20 found out that the "field" is not used, instead us used id (so input.name = id)
	// NOTE: now the function is generalized so that uses 'options' eleme to print options; so when using it to show file types select - need first call
	/* example of fields FFF : array (
			 // NOTE: 'predicative' added 29.11.18 to realize ability to 'and' (instead of usual 'or') the search criterion (for the case when it's an array)
			 array('id' => "sf_path", 	"type" => "text", 	"field" => "path", 	"operation" => "like",	"caption" => 'percorso', 	"string" => 1, 	"class" => "ttc_filter_path", 	'placeholder' => 'inbox/clienti', 'predicative' => 'and'), 
			 array('id' => "sf_subject", 	"type" => "text", 	"field" => "subject", 	"operation" => "like",	"caption" => 'oggetto', 	"string" => 1, 	"class" => "", 	'placeholder' => 'hi+ciao', 'predicative' => 'and'), 
			 array('id' => "sf_data_from","type" => "date", 	"field" => "date_mod", 	"operation" => ">=", 	"caption" => 'da',		"string" => 1, 	"class" => "ttc_search_datepicker"),
			 array('id' => "sf_data_till","type" => "date", 	"field" => "date_mod", 	"operation" => "<=",	"caption" => 'a',		"string" => 1, 	"class" => "ttc_search_datepicker"),
			 array('id' => "sf_attach_exist",  "type" => "select",     "field" => "attach_exist",             "operation" => "=",     "caption" => 'presenza allegati',             "string" => 0, "class" => "ttc_search_select", 'options' => $opts, 'replaces' => $reps)
			 array('id' => "sf_ssl", 	"type" => "checkbox", 	"field" => "ssl", 	"operation" => "=",	"caption" => 'ssl', 	"string" => 0, 	"class" => "ttc_ssl",    "default" => "checked") 
			 array('id' => "sf_ssl", 	"type" => "checkbox", 	"field" => "ssl", 	"operation" => "=",	"caption" => 'ssl', 	"string" => 0, 	"class" => "ttc_ssl",    "default" => "checked") 
			 array('id' => "sf_ssl", 	"type" => "radio", 	"field" => "ssl", 	"operation" => "=",	"caption" => 'ssl', 	"string" => 0, 	"class" => "ttc_ssl",    "default" => "some_value", "items"=>array(array("text"=>,"value"=>),...) ) 
	)*/
	// $fields in FFF (Filter Field Format)
	$ff_layout = "table"; // new 14.01.20 ; allow 2 options to show fields: as table (used td/tr) or as a single column (used div)
	// new 14.01.20 : opts ; with opts may add some variables, like def values or lists of options for comboboxes ; have same struct that $fields
	function render_search_form($fields, $opts=null, $layout="table"){ // layout: table/plane
		global $ff_layout; $ff_layout = $layout;
		$dp_format = 'd/m/Y'; // also defined in filter_fields.js
		ff_merge_values($fields, $opts);
		$res = '';
		foreach( $fields as $crit){
			/* TODO or do it here or in js (and remove input2)*/
			if( get_or_def($crit, 'operation')=='<>'){
				$res .= add_search_field($crit, "input2");
				continue;
			}
			if( $crit['type']=='date' && isset($crit["default"]) ){
				$crit["default"] = str_replace('/', '-', $crit["default"]); // strtotime not parses x/x/xxxx format
				if( isset($crit["default"]) )  $crit["default"] = date( $dp_format, strtotime($crit[ "default" ]) );
			}
			if( $crit['type']=='text' || $crit['type']=='date' || $crit['type']=='number')
				$res .= add_search_field($crit, "input");
			if( $crit['type']=='select' )
				$res .= add_search_select($crit);
			if( $crit['type']=='textarea' )
				$res .= add_search_field($crit, "textarea"); 
			if( $crit['type']=='counter' ) // NOTE: TODO: can't use it inside a form!!! sends automatically on enter press; (happens if a button is present on the form); thus the container for the search form must be 'div' (not form) DEV BUFOR
				$res .= add_search_field($crit, "counter"); 
			if($crit['type']=='checkbox'){
				$crit['default'] = isset( $crit['default'] ) && $crit['default'] ? "checked" : ""; // thus is convenient to read def from db (=0/1)
				//$res .= add_search_field($crit, "checkbox");
				$crit["items"] = [ ["value" => "", "text" => "ANY"], ["value" => "0", "text" =>"OFF"], ["value" => "1", "text" =>"ON"] ];
				$res .= add_search_radio($crit);
			}
			if( $crit['type']=='radio')
				$res .= add_search_radio($crit);
			if( $crit['type']=='hidden') // DEF FF_HIDDEN ; added 9.12.21 to add into a form some hidden field (which is treated specially); it's not shown on the form
				$res .= add_search_field($crit, "hidden");
		}
		return "<table class='ttc_search_table'>$res</table>";
	}
	function add_search_field($sf, $template_name){
		//log\debug($sf, $template_name);
		$template = get_html($template_name);
		return replace_keys($template, $sf, true);
	}
	// new 8.7.0 ; uses utils/view.php which uses css/radio-info.css
        // copied the func instead (needed add class/data-name) require_once(dirname(__FILE__)."/view.php");

	// items: array of array = ("text" => , "value" =>)
	// needs css: radio-info.css
	// possible usage: js: var opt = $("input[name='the_name']:checked").val()
	function render_radio($items, $id, $field, $def=null, $hint=''){ // TODO: $inline not used
		$res = "";
		if(!$def && sizeof($items))
			$def = $items[0]["value"];
		foreach($items as $ind => $item){
			$value = $item['value']; $text = $item['text'];
			$checked = $def==$value? "checked" : "";
			$res .= "<div class='radio radio-info radio-inline' style='margin-right: 20px;'>".  // added margin while justify not works
				"<input id='$id$ind' type='radio' class='' name='$id' value='$value' $checked>".   // id - to attach label (by same id), name (=group name) - to unite in same group, value - is what's selected (id)
				"<label>$text</label>".
				"</div>";
		}
		return "<div id='$id' class='container ttc_search_radio ttc_search_field input-sm' style='width: 100%; display: flex;' data-name='$field' title='$hint'>$res</div>";  //  justify-content: space-between   NOT WORKS THIS SHIT
	}

	function add_search_radio($sf){
		$id = $sf["id"];
		$sf["radio"] = render_radio($sf["items"], $sf["id"], $sf["field"], $sf["default"], $sf["hint"]); // used in template
		$template = get_html("radio");
		//log\debug( dump($sf) );
		return replace_keys($template, $sf, true);
	}

	function add_search_select($sf){
		//$template = file_get_contents(proj_path.table_tree_path."html/search_select.html");
		$template = get_html("select");
		$options_html = '';
		$default = get_or_def($sf, "default");
		if( $keyval = get_or_def($sf, "keyval") ) // 18.01.20 new format; instead of options/replaces use 'keyval'
			foreach($keyval as $key => $val)
				$options_html .= render_option($key, $val, $default);
		else if($options = get_or_def($sf, "options") ) // old, to reduce to using just $options without replaces 
			foreach($options as $option)
				$options_html .= render_option(get_or_def2($sf, "replaces", $option, $option), $option, $default); // TODO: strange that here text used as the key
				//$options_html .= "<option value='".get_or_def2($sf, "replaces", $option, $option)."' $selected $data>$option</option>\n";  // if sf["replaces"] is defined and contains key=$option - take the value; else - use option itself
		else if($options = get_or_def($sf, "items") ) // most general format: items = arr; item = arr('text'=>text, 'value'=>val, 'data'=>data)
			foreach($options as $option)
				$options_html .= render_option($option["value"], $option["text"], $default, get_or_def($option, "data") );
		/*unset($sf['replaces']); // or else replace_keys gives warning that $value is array; in template only $sf['caption'] is used
		unset($sf['keyval']);
		unset($sf['options']);  replaced with RK_ARR*/
		return replace_keys($template, array_merge($sf, array('options'=>$options_html) ) , true);
	}
	function render_option($val, $text, $default, $data=""){
		if(!is_array($default))
			$selected = $default==$val? "selected" : "";
		else
			$selected = in_array($val, $default)? "selected" : ""; // multiple select
		return "<option value='$val' $selected $data>$text</option>\n";
	}

	function get_html($name){ // reads this file and finds text surrounded with FFF$name ... FFF and returns it
		preg_match("/FFF$name(.+?)FFF/s", file_get_contents(__FILE__), $matches);
		$html = $matches[1];
		global $ff_layout;
		$e1 = $ff_layout = "table"? "td" : "div";
		$e2 = $ff_layout = "table"? "tr" : "div";
		$html = replace_keys($html, array("ls" => "<$e1 class='mc_sf_caption'>", "le" => "</$e1>", "vs" => "<$e1 class='mc_sf_value'>", "ve" => "</$e1>") );
		return "<$e2 class='mc_sf_row'>$html</$e2>";
	}


// TODO: this is used for check val messages (placed after val div): <div class="col-sm-4 messages"></div>
// TODO: htmls differ only by single line, insert the rest to get_html

/* DO NOT DELETE THIS - used by get_html() 

	FFFhidden
		<input type="hidden" class="ttc_search_field form-control input-sm $class$" id="$id$" name="$field$" placeholder="$placeholder$" data-operation="$operation$" data-string="$string$" value="$default$" title='$hint$'>
	FFF
	
	FFFinput
		$ls$
		<label for="$id$" class="col-sm-$LW$ control-label">$caption$</label>
		$le$
		$vs$
		<input type="text" class="ttc_search_field form-control input-sm $class$" id="$id$" name="$field$" placeholder="$placeholder$" data-operation="$operation$" data-string="$string$" value="$default$" title='$hint$'>
		$ve$
	FFF
	
	FFFinput2
		$ls$
			<label class="col-sm-$LW$ control-label">$caption$</label>
		$le$
		$vs$
			<input type="text" class="ttc_search_field form-control input-sm $class$ mc_from" id="$id$_from" name="$field$_from" placeholder="from" data-operation=">=" data-string="$string$" value="$default$" title='$from$'>
			<input type="text" class="ttc_search_field form-control input-sm $class$ mc_till" id="$id$_till" name="$field$_till" placeholder="till" data-operation="<=" data-string="$string$" value="$default$" title='$till$'>
		$ve$
	FFF
	
	FFFtextarea
		$ls$
		<label for="$id$" class="col-sm-$LW$ control-label">$caption$</label>
		$le$
		$vs$
		<textarea class="ttc_search_field form-control input-sm $class$" id="$id$" name="$field$" placeholder="$placeholder$" data-operation="$operation$" data-string="$string$" title='$hint$'>$default$</textarea>
		$ve$
	</div> 
	FFF
	
	FFFcheckbox
		$ls$
		<label for="$id$" class="col-sm-$LW$ control-label">$caption$</label>
		$le$
		$vs$
		<div class='input-sm ttc_cb_div'> <input type="checkbox" $default$ class="ttc_search_field ttc_search_checkbox $class$" id="$id$" name="$field$" title='$hint$'></div>
		$ve$
	</div> 
	FFF

	FFFselect
		$ls$
		<label for="$id$" class="col-sm-$LW$ control-label">$caption$</label>
		$le$
		$vs$
		<select class="ttc_search_field  form-control input-sm $class$" id="$id$"name="$field$"  style="width: 100%;" data-placeholder="$placeholder$" data-operation="$operation$" data-string="$string$" $multiple$ title='$hint$'> 
		$options$
		</select>
		$ve$
	FFF

	FFFcounter
		$ls$
		<label for="$id$" class="col-sm-$LW$ control-label">$caption$</label>
		$le$
		$vs$
		<div class="ttc_search_counter" data-id="$id$" data-default = "$default$" data-min="$min$" data-max="$max$"  title='$hint$'> </div>
		$ve$
	</div>
	FFF

	FFFradio
		$ls$
			<label for="$id$" class="col-sm-$LW$ control-label">$caption$</label>
		$le$
		$vs$
			$radio$
		$ve$
	</div>
	FFF
*/
?>
