<?php
	function render_ref($name, $url){
		return "<a href='$url'>$name</a> ";
	}
	// $menu = {'item name' => 'scalar', 'submenu name' => <submenu>}
	// submenu has same struct as $menu
	// scalar may be a ref to another page and also used as id - li class is set to this (adding 'mc_');
	function render_menu($menu, $level=0){
		$base_url = base_url.proj_path_rel;
		$tab_len = 8;
		$indent = str_repeat(" ",$tab_len*$level); $indent1=str_repeat(" ",$tab_len);
		$html = "$indent<ul>\n";
		foreach($menu as $caption => $item){
			$submenu='';
			$liclass = '';
			if( !is_array($item) ){ // item is just reference
				$ref = render_ref($caption, '#');
				$liclass = "mc_item";  // mc_item means that it's an item, not submenu; maybe need a class to denote that item onclick is standard, that is need to call contr/main.php?action=<handler> // handler is that from data-handler
				$lihandler = starts_with($item, "#")? "data-handler='".trim($item, "#")."'" : "data-handler='$base_url$item'";
			}
			else{ // item is submenu
				$ref = render_ref($caption, "#");
				$submenu = render_menu($item,$level+2)."\n";
				$liclass = 'mc_submenu'; //$liclass = 'has-sub'; 
				$lihandler = "";
			}
			// here menu item built
			$html .= "$indent$indent1<li style='z-index: 10;' class='$liclass' $lihandler data-caption='$caption'>\n";
			$html .= "$indent$indent1$indent1$ref\n";
			$html .= $submenu;
			$html .= "$indent$indent1</li>\n";
		}
		$html .= "$indent</ul>\n";
		return $html;
	}
	// used in LB, renders simple one-level vertical menu
	// $menu - arr of elems, elem = ass arr (title,icon(fa class),class (to identify) )
	function render_menu_ver($menu){
		$base_url = base_url.proj_path_rel;
		$html = "";
		foreach($menu as $item){
			$t = $item["title"]; $i = $item["icon"]; $c = $item["class"];
			$url = $item["url"];
			$html .= "<div class='mc_vm_item mc_item $c' title='$t' data-handler='$base_url$url'><i class='$i'></i></div>";
		}
		return "<div class = 'mc_vm_menu'> $html </div>";
	}
	// hyphen-like menu
	function render_menu_hl($menu){
		$base_url = base_url.proj_path_rel;
		$html = "";
		foreach($menu as $item){
			$t = $item["title"]; $i = $item["icon"]; $c = $item["class"];
			$url = $item["url"];
			$html .= "<li><a class='mc_item $c' title='$t' data-handler='$base_url$url'><i class='$i' aria-hidden='true'></i><span>$t</span></a></li>";
		}
		return 
			'<nav class="mc_vm_menu navbar navbar-inverse navbar-fixed-top" id="sidebar-wrapper" role="navigation" style="overflow: hidden;">'.
				'<ul class="nav sidebar-nav">'.
					$html.
				'</ul>'.
			'</nav>';
	}
	//echo render_menu( array('main' => 'browse', 'tables' => array('Backups' => 'traffic'), 'tasks' => 'tasks') );
?>
