<?php
/* DEF FDEF stuff to avoid duplications when providing a table fields metadata 
	each field of table is described by array in FIDE format; additionally are used keys: 
		"data": same func as "#" in field caption; indicates if need add field val as data-name in html
		"hidden": if present - menas not show field; correction: now used $usage field which contains letters LNS each corresp to usage in list/new rec/search
	
	funcs from here allow to extract data from FDEF to other usages:
		list field (what is to be shown in the table on the page)
		search fields (what is to shown in the search form)
		also TODO: should use it for table def for funcs compile_insert/compile_update

	also stuff to extract FDEF from metadata-table 
*/

	function fdef_fd_to_list($fdefs,$cb=true,$det=false){
		$res = [];
		if($cb)
			$res["RES_checked"] = "C"; // CB_SEL_REC
		if($det)
			$res["RES_detail"] = "Details"; // 
		foreach($fdefs as $f){
			$usage = isset($f["usage"])? $f["usage"] : "LNS";
			if(strpos($usage, "L")!==false)
				$res[$f["field"]] = (isset($f["data"])?"#":"").$f["caption"];
			else if(isset($f["data"]))
				$res[$f["field"]] = "#"; // just insert data without showing it
		}
		return $res;
	}
	// field def which is in db contains names allowed in dbms (eg can't use 'type' as field name); here convert db metadata name to more convenient (used in field def FDEF format)
	function fdef_db_to_fd($field){
		$ftype = $field["ftype"];
		$ttt = array("string" => "text", "text" => "textarea", "list" => "select");
		if(isset($ttt[$ftype]))
			$field["ftype"] = $ttt[$ftype]; // user-friendly type names to usual fide names
		$field["options"] = preg_split("/;/", $field["vlist"]); // only for lists; note: db always contains simple pick list, while fd may contain kv format
		// TODO: sort by order
		return array_replace_keys($field, array("fname" => "field", "ftype" => "type", "forder" => "order", "vdef" => "default", "vmin" => "min", "vmax" => "max", "fdata" => "data", "fusage" => "usage"));
	}
	function fdef_db_to_fd_all($fields){$res=[]; foreach($fields as $f) $res[]=fdef_db_to_fd($f); return $res;}
	// convert FDEF format to FIDE format; calculation field options basing on its type	
	function fdef_fd_to_fide($fd, $prefix, &$res, $usg="S"){
	//log\debug($fd);
		$usage = isset($fd["usage"])? $fd["usage"] : "LNS";
		if($x=strpos($usage, $usg)===false) return; // filter shown fields by usage; TODO: small snl means that present but not visible
		$tto = array("text" => "like", "textarea" => "like", "number" => "=", "date" => "<>", "select" => "=", "checkbox" => "=");
		$ttc = array("text" => "", "textarea" => "", "number" => "", "date" => "ttc_search_datepicker", "select" => "ttc_search_select", "checkbox" => "");
		extract($fd); // $type got from here
		/// TODO: why params from $fd not used? if eg operation is passed&
		$fide = array_merge($fd, array("id" => $prefix.$field, "operation" => get_or_def($fd, "operation", $tto[$type]), "string" => $type=="number"||$type=="checkbox"?0:1,  "class" => get_or_def($fd, "class", $ttc[$type]))); // MDFID
		if($usg=="S")
			unset($fide["default"]);
		//log\debug("SSS", $usg, " ", $op, $fd["field"], " ", $usage);
		if( isset($res["multiple"])  && $res["multiple"] ) $res["multiple"] = "multiple";
		$res[]= $fide;
		//log\debug($res);
	}
	function fdef_fd_to_fide_all($fields, $prefix, $usage="S"){$res=[]; foreach($fields as $f) fdef_fd_to_fide($f, $prefix, $res, $usage); return $res; }

?>
